var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { DataSourceManager } from "./components/data-sources.manager";
import { DataSourceService } from "./services/data-source.service";
import { AnalyticRoutingModule } from "./analytic.routing.module";
import { QueueModule } from '../queue/queue.module';
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule, WjInputDateTime } from 'wijmo/wijmo.angular2.input';
import { WjGridDetailModule } from 'wijmo/wijmo.angular2.grid.detail';
import { WjChartModule } from 'wijmo/wijmo.angular2.chart';
//Azteca
import { CoreModule, ReportService } from "../core";
import { EditorsModule } from "../editors";
import { SearchModule } from "../search";
import { GeneralModule } from "../general";
import { ControlsModule } from "../controls";
import { SecurityModule } from "../security";
import { DataSourcesEditor } from "./components/data-sources.editor";
import { DataSourceTypeService } from "./services/data-source-type.service";
import { DataSourceTypeManager } from "./components/data-sources-type.manager";
import { DataSourceTypeEditor } from "./components/data-sources-type.editor";
import { QueriesManager } from "./components/queries.manager";
import { QueriesService } from "./services/queries.service";
import { ParametersTypeManager } from "./components/parameters-type.manager";
import { ParameterTypeService } from "./services/parameter-type.service";
import { QueriesEditor } from "./components/queries.editor";
import { ParametersTypeEditor } from "./components/parameters-type.editor";
import { ParametersList } from "./components/controls/parameters-list.component";
import { ParameterItem } from "./components/controls/parameter-item.component";
import { ParameterService } from "./services/parameters.service";
import { DashboardEditorComponent } from './maintenance/dashboard-editor.component';
import { AngularDraggableModule } from 'angular2-draggable';
import { QueriesSelectorComponent } from './controls/queries-selector.component';
import { GraphParametroComponent } from './maintenance/parts/graph-parameter.component';
import { MessageComponent } from './maintenance/parts/message.component';
import { DashboardService } from './services/dashboard.service';
import { GraphService } from './services/graph.service';
import { ReportsManager } from './components/reports.manager';
import { ReportsEditor } from './components/reports.editor';
import { ReportService as ReportServiceAnalytic } from './services/report.service';
import { TableDefinicion } from './components/controls/table-definicion.component';
var COMPONENTES = [DataSourceManager, DataSourcesEditor, DataSourceTypeManager, DataSourceTypeEditor, QueriesManager,
    QueriesEditor, ParametersTypeManager, ParametersTypeEditor, ParametersList, ParameterItem, DashboardEditorComponent, QueriesSelectorComponent,
    GraphParametroComponent, MessageComponent, ReportsManager, ReportsEditor, TableDefinicion
];
var SERVICIOS = [DataSourceService, DataSourceTypeService, QueriesService, ParameterTypeService, ParameterService, DashboardService, GraphService, ReportService, ReportServiceAnalytic];
var AnalyticModule = /** @class */ (function () {
    function AnalyticModule() {
    }
    AnalyticModule = __decorate([
        NgModule({
            imports: [
                CommonModule, FormsModule, ReactiveFormsModule,
                TabsModule.forRoot(), ModalModule.forRoot(),
                CoreModule, EditorsModule, SearchModule, GeneralModule, ControlsModule, SecurityModule, AnalyticRoutingModule,
                QueueModule, WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, WjGridDetailModule, AngularDraggableModule, WjChartModule
            ],
            declarations: COMPONENTES,
            providers: SERVICIOS,
            exports: COMPONENTES,
            entryComponents: [MessageComponent, WjInputDateTime]
        })
    ], AnalyticModule);
    return AnalyticModule;
}());
export { AnalyticModule };
