var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from "@angular/core";
import { RouterModule } from "@angular/router";
import { DataSourceManager } from "./components/data-sources.manager";
import { DataSourcesEditor } from "./components/data-sources.editor";
import { DataSourceTypeManager } from "./components/data-sources-type.manager";
import { DataSourceTypeEditor } from "./components/data-sources-type.editor";
import { QueriesManager } from "./components/queries.manager";
import { QueriesEditor } from "./components/queries.editor";
import { ParametersTypeManager } from "./components/parameters-type.manager";
import { ParametersTypeEditor } from "./components/parameters-type.editor";
import { AuthGuard } from "../core";
import { ReportsManager } from "./components/reports.manager";
import { ReportsEditor } from "./components/reports.editor";
import { DashboardEditorComponent } from './maintenance/dashboard-editor.component';
import { AngularDraggableModule } from 'angular2-draggable';
var routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'datasource/:proceso', component: DataSourceManager },
            { path: 'datasource/:proceso/:id', component: DataSourcesEditor },
            { path: 'datasourcetype/:proceso', component: DataSourceTypeManager },
            { path: 'datasourcetype/:proceso/:id', component: DataSourceTypeEditor },
            { path: 'queries/:proceso', component: QueriesManager },
            { path: 'queries/:proceso/:id', component: QueriesEditor },
            { path: 'parameters/:proceso', component: ParametersTypeManager },
            { path: 'parameters/:proceso/:id', component: ParametersTypeEditor },
            { path: 'datasource/:proceso', component: DataSourceManager },
            { path: 'dashboard-editor/:proceso', component: DashboardEditorComponent },
            { path: 'dashboard', component: DashboardEditorComponent },
            { path: 'reports/:proceso', component: ReportsManager },
            { path: 'reports/:proceso/:id', component: ReportsEditor }
        ]
    }
];
var AnalyticRoutingModule = /** @class */ (function () {
    function AnalyticRoutingModule() {
    }
    AnalyticRoutingModule = __decorate([
        NgModule({
            imports: [
                AngularDraggableModule,
                RouterModule.forChild(routes)
            ],
            exports: [
                RouterModule
            ]
        })
    ], AnalyticRoutingModule);
    return AnalyticRoutingModule;
}());
export { AnalyticRoutingModule };
