var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from "@angular/core";
import { ParameterInfo } from "../../models/parameter";
import { FormBuilder, Validators } from "@angular/forms";
import { BaseControl } from "../../../controls";
var ParameterItem = /** @class */ (function (_super) {
    __extends(ParameterItem, _super);
    function ParameterItem(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.parameterDeleted = new EventEmitter();
        _this.validChange = new EventEmitter();
        _this.catalogForm = formBuilder.group({
            'codigoParameter': ['', Validators.required],
            'nombreParameter': ['', Validators.required],
            'defaultValue': [''],
            'parameterTypeCBO': ['', Validators.required]
        });
        return _this;
    }
    ParameterItem.prototype.writeValue = function (obj) {
    };
    ParameterItem.prototype.registerOnChange = function (fn) {
    };
    ParameterItem.prototype.registerOnTouched = function (fn) {
    };
    ParameterItem.prototype.setDisabledState = function (isDisabled) {
    };
    ParameterItem.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.catalogForm.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.catalogForm.valid);
        });
    };
    ParameterItem.prototype.OnDeleteParameter = function () {
        this.parameterDeleted.emit();
    };
    __decorate([
        Input(),
        __metadata("design:type", ParameterInfo)
    ], ParameterItem.prototype, "parameter", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ParameterItem.prototype, "parameterType", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ParameterItem.prototype, "readOnly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ParameterItem.prototype, "autogeneratedCode", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ParameterItem.prototype, "parameterDeleted", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ParameterItem.prototype, "validChange", void 0);
    ParameterItem = __decorate([
        Component({
            selector: 'parameter-item',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <az-panel [header]=\"'Parametro'\">\n              <div class=\"row\">\n                  <div class=\"col-12 text-center\" >\n                      <div class=\"text-right\">\n                          <button class=\"btn btn-danger glyphicon glyphicon-trash\" (click)=\"OnDeleteParameter()\" type=\"button\" [disabled]=\"readOnly\"></button>\n                      </div>\n                      <label class=\"text-lg-center\">Tag: {{parameter.tag}}</label>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-6\" >\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigoParameter\" [(ngModel)]=\"parameter.code\" [automatic]=\"autogeneratedCode\" ></catalog-code>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-lg-6\" >\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombreParameter\" [(ngModel)]=\"parameter.nombre\" ></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-6\" >\n                      <azteca-form-field [label]=\"'Default Value:'\" >\n                          <az-textbox formControlName=\"defaultValue\" [(ngModel)]=\"parameter.defaultValue\" ></az-textbox>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-lg-6\" >\n                      <azteca-form-field [label]=\"'Tipo de parametro'\">\n                          <az-combobox formControlName=\"parameterTypeCBO\"\n                                       [(ngModel)]=\"parameter.idParameterType\"\n                                       [items]=\"parameterType\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                      >\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n          </az-panel>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], ParameterItem);
    return ParameterItem;
}(BaseControl));
export { ParameterItem };
