var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, Component, Output, EventEmitter } from "@angular/core";
var ParametersList = /** @class */ (function () {
    function ParametersList() {
        this.parameterDeleted = new EventEmitter();
        this.deleteDataBase = new EventEmitter();
        this.validChange = new EventEmitter();
    }
    ParametersList.prototype.onDeleteParameter = function (parameter) {
        var newParameters = [];
        this.parameters.splice(this.parameters.indexOf(parameter), 1);
        newParameters = this.parameters;
        this.parameterDeleted.emit(newParameters);
        if (parameter.identity != 0)
            this.deleteDataBase.emit(parameter);
    };
    ParametersList.prototype.onValidChange = function (valid) {
        this.validChange.emit(valid);
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ParametersList.prototype, "parameters", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ParametersList.prototype, "parametersType", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ParametersList.prototype, "readOnly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ParametersList.prototype, "autogeneratedCode", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ParametersList.prototype, "parameterDeleted", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ParametersList.prototype, "deleteDataBase", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ParametersList.prototype, "validChange", void 0);
    ParametersList = __decorate([
        Component({
            selector: 'parameter-list',
            template: "\n      <div *ngFor=\"let parameter of parameters\">\n          <div>\n              <parameter-item [parameter]=\"parameter\" [parameterType]=\"parametersType\" [autogeneratedCode]=\"autogeneratedCode\" [readOnly]=\"readOnly\" (parameterDeleted)=\"onDeleteParameter(parameter)\" (validChange)=\"onValidChange($event)\"></parameter-item>\n          </div>\n      </div>\n    "
        })
    ], ParametersList);
    return ParametersList;
}());
export { ParametersList };
