var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder } from '@angular/forms';
//Wijmo
import { Control, CollectionView } from 'wijmo/wijmo';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Local
import { TableInfo, ColumnInfo } from '../../models/table';
var TableDefinicion = /** @class */ (function () {
    function TableDefinicion(formBuilder) {
        this.formBuilder = formBuilder;
        this.table = new TableInfo();
        this.nombre = '';
        this.texto = '';
        this.alineacion = '-1';
        this.color = '#FFFFFF';
        this.alineaciones = [];
        this.columnasCollection = new CollectionView();
        //outputs
        this.definicion = new EventEmitter();
        this.form = formBuilder.group({
            'nombre': [''],
            'texto': [''],
            'alineacion': [''],
            'color': ['']
        });
        this.alineaciones =
            [
                { "id": "-1", "descrip": "izquierda" },
                { "id": "0", "descrip": "centrado" },
                { "id": "1", "descrip": "derecha" }
            ];
    }
    TableDefinicion.prototype.show = function (idTable, definicionIn) {
        this.idTable = idTable;
        this.definicionIn = definicionIn;
        if (definicionIn != '') {
            this.table = JSON.parse(definicionIn);
            this.columnasCollection.sourceCollection = this.table.columns;
            this.columnasCollection.refresh;
        }
        else {
            this.table = new TableInfo();
            this.columnasCollection.sourceCollection = [];
            this.columnasCollection.refresh;
        }
        this.dialog.config.backdrop = false;
        this.dialog.show();
        Control.invalidateAll();
    };
    TableDefinicion.prototype.onAceptar = function () {
        var sRet;
        //this.table.columns.forEach(item => {
        //    if(item.)
        //});
        sRet = JSON.stringify(this.table);
        this.definicion.emit(sRet);
        this.definicionIn = '';
        this.dialog.hide();
    };
    TableDefinicion.prototype.onCancelar = function () {
        //this.definicion.emit('');
        this.dialog.hide();
    };
    TableDefinicion.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            var columnNew = new ColumnInfo();
            columnNew.name = this.nombre;
            columnNew.text = this.texto;
            columnNew.textAlign = +this.alineacion;
            columnNew.color = this.color;
            var columnsSlice = this.table.columns.slice();
            columnsSlice.push(columnNew);
            this.table.columns = columnsSlice;
            this.columnasCollection.sourceCollection = columnsSlice;
            this.columnasCollection.refresh;
        }
    };
    TableDefinicion.prototype.onRemoveCampo = function (item) {
        this.columnasCollection.remove(item);
        this.columnasCollection.refresh();
    };
    __decorate([
        ViewChild('dialog'),
        __metadata("design:type", ModalDirective)
    ], TableDefinicion.prototype, "dialog", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], TableDefinicion.prototype, "definicion", void 0);
    TableDefinicion = __decorate([
        Component({
            selector: 'analytic-table-definicion',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog  modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Definici\u00F3n de la tabla</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-3\">\n                                  <azteca-form-field [label]=\"'Nombre:'\">\n                                      <az-textbox formControlName=\"nombre\" [(ngModel)]=\"nombre\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-md-3\">\n                                  <azteca-form-field [label]=\"'Texto:'\">\n                                      <az-textbox formControlName=\"texto\" [(ngModel)]=\"texto\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n\n                              <div class=\"col-12 col-md-3\">\n                                  <azteca-form-field [label]=\"'Alineaci\u00F3n:'\">\n                                      <az-combobox formControlName=\"alineacion\"\n                                                   [(ngModel)]=\"alineacion\"\n                                                   [items]=\"alineaciones\"\n                                                   [displayMember]=\"'descrip'\"\n                                                   [valueMember]=\"'id'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n\n\n                              <div class=\"col-12 col-md-3\">\n                                  <azteca-form-field [label]=\"'Color:'\">\n                                      <az-textbox formControlName=\"color\" [(ngModel)]=\"color\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"form-inline\">\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar columna'\" [toolTip]=\"'Agregar columna'\" [icon]=\"'glyphicon glyphicon-arrow-down'\" [enabled]=\"nombre!='' && texto!=''\"></az-toolbar-button>\n                              </az-toolbar>\n                          </div>\n                          <div class=\"row\">\n                              <wj-flex-grid #gridDefinicion style=\"height:200px\"\n                                            [itemsSource]=\"columnasCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveCampo(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'name'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Texto'\" [binding]=\"'text'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Alineaci\u00F3n'\" [binding]=\"'textAlign'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Color'\" [binding]=\"'color'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                          </div>\n\n                      </div>\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptar()\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancelar()\">Atr\u00E1s</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], TableDefinicion);
    return TableDefinicion;
}());
export { TableDefinicion };
