import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { DashboardService } from '../services/dashboard.service';
import { DashboardItem } from '../models/dashboard';
export declare class DashboardsManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private dashboardService;
    dashboards: DashboardItem[];
    constructor(context: Context, router: Router, route: ActivatedRoute, dashboardService: DashboardService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
