import { ChangeDetectorRef } from "@angular/core";
import { Context } from "../../core";
import { CatalogEditor, EditorEventArgs } from "../../editors";
import { Router, ActivatedRoute } from "@angular/router";
import { FormBuilder } from "@angular/forms";
import { CatalogOptions } from "../../custom";
import { DataSourceInfo, DataSourceItem } from "../models/data-source";
import { DataSourceService } from "../services/data-source.service";
import { DataSourceTypeService } from "../services/data-source-type.service";
import { Location } from '@angular/common';
export declare class DataSourcesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private dataSourceService;
    private dataSourceTypeService;
    dataSource: DataSourceInfo;
    dataSourceType: DataSourceItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, dataSourceService: DataSourceService, dataSourceTypeService: DataSourceTypeService);
    onConfigureCatalog(options: CatalogOptions): void;
    ngOnInit(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
}
