var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, ChangeDetectorRef } from "@angular/core";
import { BaseComponent, CatalogService, Context } from "../../core";
import { CatalogEditor } from "../../editors";
import { Router, ActivatedRoute } from "@angular/router";
import { FormBuilder, Validators } from "@angular/forms";
import { DataSourceInfo } from "../models/data-source";
import { DataSourceService } from "../services/data-source.service";
import { DataSourceTypeService } from "../services/data-source-type.service";
import { Location } from '@angular/common';
var DataSourcesEditor = /** @class */ (function (_super) {
    __extends(DataSourcesEditor, _super);
    function DataSourcesEditor(router, route, formBuilder, changeDetector, context, location, dataSourceService, dataSourceTypeService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.dataSourceService = dataSourceService;
        _this.dataSourceTypeService = dataSourceTypeService;
        _this.dataSource = new DataSourceInfo();
        _this.dataSourceType = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'cadenaConexion': ['', Validators.required],
            'dataSourceType': ['', Validators.required]
        });
        return _this;
    }
    DataSourcesEditor_1 = DataSourcesEditor;
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DataSourcesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    DataSourcesEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.dataSourceTypeService.loadlist(this.context.app.defaultCompany.identity)
            .then(function (x) { return _this.dataSourceType = x; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DataSourcesEditor.prototype.onCreatingItem = function () {
    };
    DataSourcesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.dataSourceService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dataSource = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DataSourcesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.dataSourceService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dataSource = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DataSourcesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.context.app.showSpinner();
        this.dataSourceService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dataSource = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DataSourcesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.dataSourceService.update(this.dataSource)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.dataSource = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var DataSourcesEditor_1;
    DataSourcesEditor = DataSourcesEditor_1 = __decorate([
        Component({
            selector: 'data-sources-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Data Source'\"\n                                 [info]=\"dataSource\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"dataSource.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"dataSource.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Cadena de Conexi\u00F3n:'\">\n                          <az-textbox formControlName=\"cadenaConexion\" [(ngModel)]=\"dataSource.cadenaConexion\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Tipo de Conexi\u00F3n'\">\n                          <az-combobox formControlName=\"dataSourceType\"\n                                       [(ngModel)]=\"dataSource.idDatasourceType\"\n                                       [items]=\"dataSourceType\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n          </azteca-catalog-editor>\n\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return DataSourcesEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: DataSourceService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, DataSourceService, DataSourceTypeService])
    ], DataSourcesEditor);
    return DataSourcesEditor;
}(CatalogEditor));
export { DataSourcesEditor };
