import { ChangeDetectorRef } from "@angular/core";
import { Context } from "../../core";
import { QueriesService } from "../services/queries.service";
import { CatalogEditor, EditorEventArgs } from "../../editors";
import { Router, ActivatedRoute } from "@angular/router";
import { FormBuilder } from "@angular/forms";
import { Location } from '@angular/common';
import { CatalogOptions } from "../../custom";
import { ParameterTypeService } from "../services/parameter-type.service";
import { ParameterTypeItem } from "../models/parameter-type";
import { ParameterInfo } from "../models/parameter";
import { QueriesInfo } from "../models/queries";
import { ParameterService } from "../services/parameters.service";
import { DataSourceService } from "../services/data-source.service";
export declare class QueriesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private queriesService;
    private parameterTypeService;
    private parameterService;
    private dataSourceService;
    querie: QueriesInfo;
    parametersType: ParameterTypeItem[];
    parametersInfo: ParameterInfo[];
    listTag: string[];
    dataSource: {
        value: number;
        text: string;
    }[];
    readonly: boolean;
    formValid: boolean;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, queriesService: QueriesService, parameterTypeService: ParameterTypeService, parameterService: ParameterService, dataSourceService: DataSourceService);
    onConfigureCatalog(options: CatalogOptions): void;
    ngOnInit(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    OnChange(): void;
    onDeleteParameter(parameters: ParameterInfo[]): void;
    Refresh(): void;
    parametersToArray(): void;
    OnDeleteDataBase(parameter: ParameterInfo): void;
    onValidChange(valid: boolean): void;
}
