var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, ChangeDetectorRef } from "@angular/core";
import { BaseComponent, CatalogService, Context } from "../../core";
import { QueriesService } from "../services/queries.service";
import { CatalogEditor } from "../../editors";
import { Router, ActivatedRoute } from "@angular/router";
import { FormBuilder, Validators } from "@angular/forms";
import { Location } from '@angular/common';
import { ParameterTypeService } from "../services/parameter-type.service";
import { ParameterInfo } from "../models/parameter";
import { QueriesInfo } from "../models/queries";
import { ParameterService } from "../services/parameters.service";
import { DataSourceService } from "../services/data-source.service";
var QueriesEditor = /** @class */ (function (_super) {
    __extends(QueriesEditor, _super);
    function QueriesEditor(router, route, formBuilder, changeDetector, context, location, queriesService, parameterTypeService, parameterService, dataSourceService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.queriesService = queriesService;
        _this.parameterTypeService = parameterTypeService;
        _this.parameterService = parameterService;
        _this.dataSourceService = dataSourceService;
        _this.querie = new QueriesInfo();
        _this.parametersType = [];
        _this.parametersInfo = [];
        _this.listTag = [];
        _this.dataSource = [];
        _this.readonly = false;
        _this.formValid = true;
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'sentence': ['', Validators.required],
            'timeWait': ['', Validators.required],
            'dataSourceCBO': ['', Validators.required]
        });
        return _this;
    }
    QueriesEditor_1 = QueriesEditor;
    ///////////////////////// HANDLERS ///////////////////////////////////////
    QueriesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    QueriesEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.parameterTypeService.loadlist(this.context.app.defaultCompany.identity)
            .then(function (info) { return _this.parametersType = info; })
            .catch(function (error) { return _this.handleError(error); });
        this.dataSourceService.loadlist(this.context.app.defaultCompany.identity)
            .then(function (info) { return _this.dataSource = info; })
            .catch(function (error) { return _this.handleError(error); });
    };
    QueriesEditor.prototype.onCreatingItem = function () {
    };
    QueriesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.queriesService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.querie = info;
            _this.parametersInfo = _this.querie.parameters.slice();
            _this.readonly = true;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    QueriesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.queriesService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.querie = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    QueriesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.queriesService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.querie = info;
            _this.parametersInfo = _this.querie.parameters.slice();
            _this.parametersToArray();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    QueriesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        if (this.formValid) {
            this.context.app.showSpinner();
            this.querie.parameters = this.parametersInfo;
            console.log(this.querie.idDataSource);
            this.queriesService.update(this.querie)
                .then(function (info) {
                _this.context.app.hideSpinner();
                _this.querie = info;
                _this.parametersInfo = _this.querie.parameters.slice();
                _this.reset();
                if (args.closeEditor)
                    _this.location.back();
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    /////////////////////// FUNCTIONS//////////////////////////////////////////
    QueriesEditor.prototype.OnChange = function () {
        var sentence = this.querie.sentence;
        var isVariable = false;
        var variable = "";
        var regExp = /^[0-9a-zA-Z]+$/;
        for (var i = 0; i < sentence.length; i++) {
            if (!isVariable) {
                if (sentence[i] == '@')
                    isVariable = true;
            }
            else {
                if (regExp.test(sentence[i])) {
                    variable = variable + sentence[i];
                }
                else {
                    isVariable = false;
                    if (this.listTag.indexOf(variable) == -1) {
                        var parameter = new ParameterInfo();
                        parameter.tag = variable;
                        this.parametersInfo.push(parameter);
                        this.listTag.push(variable);
                        this.formValid = false;
                    }
                    variable = "";
                }
            }
        }
        if (isVariable && variable.length > 0) {
            if (this.listTag.indexOf(variable) == -1) {
                var parameter = new ParameterInfo();
                parameter.tag = variable;
                this.parametersInfo.push(parameter);
                this.listTag.push(variable);
                this.formValid = false;
            }
        }
    };
    QueriesEditor.prototype.onDeleteParameter = function (parameters) {
        this.parametersInfo = parameters;
    };
    QueriesEditor.prototype.Refresh = function () {
        this.listTag = [];
        this.parametersInfo = this.querie.parameters.slice();
        this.parametersToArray();
        this.OnChange();
    };
    QueriesEditor.prototype.parametersToArray = function () {
        for (var i = 0; i < this.querie.parameters.length; i++) {
            this.listTag.push(this.querie.parameters[i].tag);
        }
    };
    QueriesEditor.prototype.OnDeleteDataBase = function (parameter) {
        var _this = this;
        this.parameterService.delete(parameter.identity)
            .then(function (success) {
            _this.listTag.splice(_this.listTag.indexOf(parameter.tag), 1);
            _this.querie.parameters = [];
            for (var _i = 0, _a = _this.parametersInfo; _i < _a.length; _i++) {
                var param = _a[_i];
                if (param.identity != 0)
                    _this.querie.parameters.push(param);
            }
            console.log("Query: " + JSON.stringify(_this.querie.parameters) + " Parameters: " + JSON.stringify(_this.parametersInfo) + " List" + JSON.stringify(_this.listTag));
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    QueriesEditor.prototype.onValidChange = function (valid) {
        this.formValid = valid;
        this.changeDetector.detectChanges();
    };
    var QueriesEditor_1;
    QueriesEditor = QueriesEditor_1 = __decorate([
        Component({
            selector: 'queries-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Querie'\"\n                                 [info]=\"querie\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"querie.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"querie.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Tiempo de espera:'\">\n                          <az-input-number formControlName=\"timeWait\" [(ngModel)]=\"querie.timeWait\" ></az-input-number>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Tipo de fuente de datos'\">\n                          <az-combobox formControlName=\"dataSourceCBO\"\n                                       [(ngModel)]=\"querie.idDataSource\"\n                                       [items]=\"dataSource\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Sentence:'\">\n                          <az-textarea #txtSentence formControlName=\"sentence\" [(ngModel)]=\"querie.sentence\" (change)=\"OnChange()\"></az-textarea>\n                      </azteca-form-field>\n                      <div class=\"text-right\">\n                          <button class=\"btn btn-primary glyphicon glyphicon-refresh\" (click)=\"Refresh()\" type=\"button\" [disabled]=\"readonly\">Actualizar Parametros</button>\n                      </div>\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <parameter-list [parameters]=\"parametersInfo\" [parametersType]=\"parametersType\" [readOnly]=\"readonly\" (parameterDeleted)=\"onDeleteParameter($event)\" (deleteDataBase)=\"OnDeleteDataBase($event)\" (validChange)=\"onValidChange($event)\"></parameter-list>\n                  </div>\n              </div>\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return QueriesEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: QueriesService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, QueriesService, ParameterTypeService,
            ParameterService, DataSourceService])
    ], QueriesEditor);
    return QueriesEditor;
}(CatalogEditor));
export { QueriesEditor };
