import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { ToolbarButton } from '../../controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from '../../editors';
import { ReportService as ReportServiceAnalytic } from '../services/report.service';
import { ReportInfo } from '../models/report';
import { QueriesSelectorComponent } from '../controls/queries-selector.component';
import { DataSourceItem } from '../models/data-source';
import { ParameterTypeItem } from '../models/parameter-type';
import { ParameterTypeService } from '../services/parameter-type.service';
import { DataSourceService } from "../services/data-source.service";
import { ParametersTypeInfo } from '../models/parameter-type';
import { TableDefinicion } from './controls/table-definicion.component';
import { QueriesInfo } from '../models/queries';
export declare class ReportsEditor extends CatalogEditor {
    protected router: Router;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private reportService;
    private dataSourceService;
    private parameterTypeService;
    report: ReportInfo;
    definicion: string;
    idDatasource: number;
    idDatasourceParametroGlobal: number;
    idDatasourceParametroReporte: number;
    dataSources: DataSourceItem[];
    parameterType: ParameterTypeItem[];
    codigoParametroGlobal: string;
    nombreParametroGlobal: string;
    codigoParametroReporte: string;
    nombreParametroReporte: string;
    fieldLabelGlobal: string;
    fieldValueGlobal: string;
    defaultValueGlobal: string;
    fieldLabelReporte: string;
    fieldValueReporte: string;
    defaultValueReporte: string;
    idParameterTypeGlobal: number;
    ParameterTypeGlobal: ParametersTypeInfo;
    ParameterTypeReporte: ParametersTypeInfo;
    idParameterGlobalRelacion: number;
    tagGlobal: string;
    tagReporte: string;
    parameterToRelacionar: {
        id: number;
        nombre: string;
    };
    parametersToRelacionar: {
        id: number;
        nombre: string;
    }[];
    tablesCollection: TrackableCollection;
    selectorQuery: QueriesSelectorComponent;
    parametrosGlobalesCollection: TrackableCollection;
    selectorQueryParametroGlobal: QueriesSelectorComponent;
    parametrosReporteCollection: TrackableCollection;
    selectorQueryParametroReporte: QueriesSelectorComponent;
    tableDefinidor: TableDefinicion;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, reportService: ReportServiceAnalytic, dataSourceService: DataSourceService, parameterTypeService: ParameterTypeService);
    ladDatasources(): void;
    loadParametersTypes(): void;
    llenaToRelacionar(): void;
    onConfirmar(definicion: string): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onSelectedItemChanged(id: number): void;
    onSelectedItemChangedDeReporte(id: number): void;
    onSelectedItemChangedGlobalRelacion(id: number): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onRemoveTabla(item: any): void;
    onEditTabla(item: any): void;
    onRemoveGlobal(item: any): void;
    onRemoveDeReporte(item: any): void;
    onQuerieParametroRepSelected(querie: QueriesInfo): void;
    onSelectTab(args: any): void;
}
