var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogEditor, TrackableCollection } from '../../editors';
//Wijmo
import { Control } from 'wijmo/wijmo';
//Features
import { ReportService as ReportServiceAnalytic } from '../services/report.service';
import { ReportInfo, ReportTableItem, ReportParameterItem } from '../models/report';
import { QueriesSelectorComponent } from '../controls/queries-selector.component';
import { ParameterTypeService } from '../services/parameter-type.service';
import { DataSourceService } from "../services/data-source.service";
import { ParametersTypeInfo } from '../models/parameter-type';
import { TableDefinicion } from './controls/table-definicion.component';
var ReportsEditor = /** @class */ (function (_super) {
    __extends(ReportsEditor, _super);
    function ReportsEditor(router, route, formBuilder, changeDetector, context, location, reportService, dataSourceService, parameterTypeService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.reportService = reportService;
        _this.dataSourceService = dataSourceService;
        _this.parameterTypeService = parameterTypeService;
        _this.report = new ReportInfo();
        _this.definicion = '';
        _this.dataSources = [];
        _this.parameterType = [];
        _this.ParameterTypeGlobal = new ParametersTypeInfo();
        _this.ParameterTypeReporte = new ParametersTypeInfo();
        _this.parameterToRelacionar = { id: 0, nombre: '' };
        _this.parametersToRelacionar = [];
        //
        _this.tablesCollection = new TrackableCollection();
        _this.parametrosGlobalesCollection = new TrackableCollection();
        _this.parametrosReporteCollection = new TrackableCollection();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'descripcion': ['', Validators.required],
            'idQuery': [0],
            'definicion': [''],
            'idDatasource': [0],
            'idQueryParametroGlobal': [0],
            'idDatasourceParametroGlobal': [0],
            'codigoParametroGlobal': [''],
            'nombreParametroGlobal': [''],
            'fieldLabelGlobal': [''],
            'fieldValueGlobal': [''],
            'defaultValueGlobal': [''],
            'idParameterTypeGlobal': [0],
            'idQueryParametroReporte': [0],
            'idDatasourceParametroReporte': [0],
            'codigoParametroReporte': [''],
            'nombreParametroReporte': [''],
            'fieldLabelReporte': [''],
            'fieldValueReporte': [''],
            'defaultValueReporte': [''],
            'idParameterTypeReporte': [0],
            'idParameterGlobalRelacion': [0],
            'tagGlobal': [''],
            'tagReporte': ['']
        });
        return _this;
    }
    ReportsEditor_1 = ReportsEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ReportsEditor.prototype.ladDatasources = function () {
        var _this = this;
        this.dataSourceService.loadlist(this.context.app.defaultCompany.identity)
            .then(function (info) { return _this.dataSources = info; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsEditor.prototype.loadParametersTypes = function () {
        var _this = this;
        this.parameterTypeService.loadlist(this.context.app.defaultCompany.identity)
            .then(function (info) { return _this.parameterType = info; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsEditor.prototype.llenaToRelacionar = function () {
        var _this = this;
        this.report.parametersGlobales.forEach(function (i) {
            _this.parameterToRelacionar.id = i.id;
            _this.parameterToRelacionar.nombre = i.fieldLabel + ' ' + i.parameter.nombre;
            _this.parametersToRelacionar.push(_this.parameterToRelacionar);
        });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ReportsEditor.prototype.onConfirmar = function (definicion) {
        this.definicion = definicion;
        var current = this.tablesCollection.currentItem;
        current.definicion = definicion;
        current.state = 'MODIFIED';
        this.tablesCollection.refresh();
    };
    ReportsEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.ladDatasources();
        this.loadParametersTypes();
        this.applyPolicies();
    };
    ReportsEditor.prototype.onSelectedItemChanged = function (id) {
        var _this = this;
        this.parameterTypeService.getDetailByID(id)
            .then(function (item) {
            _this.ParameterTypeGlobal = item;
        })
            .catch(function (error) {
            _this.handleError(error);
        });
    };
    ReportsEditor.prototype.onSelectedItemChangedDeReporte = function (id) {
        var _this = this;
        this.parameterTypeService.getDetailByID(id)
            .then(function (item) {
            _this.ParameterTypeReporte = item;
        })
            .catch(function (error) {
            _this.handleError(error);
        });
    };
    ReportsEditor.prototype.onSelectedItemChangedGlobalRelacion = function (id) {
    };
    ReportsEditor.prototype.onCreatingItem = function () {
    };
    ReportsEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.reportService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.report = info;
            _this.tablesCollection.sourceCollection = info.tables;
            _this.tablesCollection.refresh;
            _this.parametrosGlobalesCollection.sourceCollection = info.parametersGlobales;
            _this.parametrosGlobalesCollection.refresh;
            _this.parametrosReporteCollection.sourceCollection = info.parameters;
            _this.parametrosReporteCollection.refresh;
            _this.llenaToRelacionar();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.reportService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.report = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.reportService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.report = info;
            _this.tablesCollection.sourceCollection = info.tables;
            _this.tablesCollection.refresh;
            _this.parametrosGlobalesCollection.sourceCollection = info.parametersGlobales;
            _this.parametrosGlobalesCollection.refresh;
            _this.parametrosReporteCollection.sourceCollection = info.parameters;
            _this.parametrosReporteCollection.refresh;
            _this.llenaToRelacionar();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.reportService.update(this.report)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.report.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.report = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsEditor.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'ADD-TABLA') {
            var exist = [];
            exist = this.report.tables.filter(function (items) { return items.idDatasource == _this.idDatasource && items.idQuery == _this.selectorQuery.selectedItem.identity; });
            if (exist.length > 0) {
                this.showAlert('Ya existe una tabla con el mismo origen de datos y query', 'success');
            }
            else {
                var tableNew = new ReportTableItem();
                tableNew.idQuery = this.selectorQuery.selectedItem.identity;
                tableNew.query = this.selectorQuery.selectedItem;
                tableNew.idDatasource = this.idDatasource;
                tableNew.definicion = this.definicion;
                var tableSlice = this.report.tables.slice();
                tableSlice.push(tableNew);
                this.report.tables = tableSlice;
                this.tablesCollection.sourceCollection = tableSlice;
                this.tablesCollection.refresh;
            }
        }
        if (button.name == 'ADD-GLOBAL') {
            var existGlobal = [];
            existGlobal = this.report.parametersGlobales.filter(function (items) { return items.idDatasource == _this.idDatasourceParametroGlobal && items.idQuery == _this.selectorQueryParametroGlobal.selectedItem.identity; });
            if (existGlobal.length > 0) {
                this.showAlert('Ya existe un parámetro global con el mismo origen de datos y query', 'success');
            }
            else {
                var paramGlobalNew = new ReportParameterItem();
                paramGlobalNew.idQuery = this.selectorQueryParametroGlobal.selectedItem.identity;
                paramGlobalNew.query = this.selectorQueryParametroGlobal.selectedItem;
                paramGlobalNew.idDatasource = this.idDatasourceParametroGlobal;
                paramGlobalNew.fieldLabel = this.fieldLabelGlobal;
                paramGlobalNew.fieldValue = this.fieldValueGlobal;
                paramGlobalNew.parameter.nombre = this.nombreParametroGlobal;
                paramGlobalNew.parameter.code = this.codigoParametroGlobal;
                paramGlobalNew.parameter.defaultValue = this.defaultValueGlobal;
                paramGlobalNew.parameter.parameterType = this.ParameterTypeGlobal;
                paramGlobalNew.parameter.idParameterType = this.ParameterTypeGlobal.identity;
                paramGlobalNew.parameter.label = this.fieldLabelGlobal;
                paramGlobalNew.parameter.tag = this.tagGlobal;
                var globalSlice = this.report.parametersGlobales.slice();
                globalSlice.push(paramGlobalNew);
                this.report.parametersGlobales = globalSlice;
                this.parametrosGlobalesCollection.sourceCollection = globalSlice;
                this.parametrosGlobalesCollection.refresh;
            }
        }
        if (button.name == 'ADD-DE-REPORTE') {
            var existDeReporte = [];
            existDeReporte = this.report.parameters.filter(function (items) { return items.idDatasource == _this.idDatasourceParametroReporte && items.idQuery == _this.selectorQueryParametroReporte.selectedItem.identity; });
            if (existDeReporte.length > 0) {
                this.showAlert('Ya existe un parámetro para el reporte con el mismo origen de datos y query', 'success');
            }
            else {
                var paramReporteNew = new ReportParameterItem();
                paramReporteNew.idQuery = this.selectorQueryParametroReporte.selectedItem.identity;
                paramReporteNew.query = this.selectorQueryParametroReporte.selectedItem;
                paramReporteNew.idDatasource = this.idDatasourceParametroReporte;
                paramReporteNew.fieldLabel = this.fieldLabelReporte;
                paramReporteNew.fieldValue = this.fieldValueReporte;
                paramReporteNew.parameter.nombre = this.nombreParametroReporte;
                paramReporteNew.parameter.code = this.codigoParametroReporte;
                paramReporteNew.parameter.defaultValue = this.defaultValueReporte;
                paramReporteNew.parameter.parameterType = this.ParameterTypeReporte;
                paramReporteNew.parameter.idParameterType = this.ParameterTypeReporte.identity;
                paramReporteNew.parameter.label = this.fieldLabelReporte;
                paramReporteNew.parameter.tag = this.tagReporte;
                paramReporteNew.idReferencia = this.idParameterGlobalRelacion;
                var reporteSlice = this.report.parameters.slice();
                reporteSlice.push(paramReporteNew);
                this.report.parameters = reporteSlice;
                this.parametrosReporteCollection.sourceCollection = reporteSlice;
                this.parametrosReporteCollection.refresh;
            }
        }
    };
    ReportsEditor.prototype.onRemoveTabla = function (item) {
        this.tablesCollection.remove(item);
        this.tablesCollection.refresh();
    };
    ReportsEditor.prototype.onEditTabla = function (item) {
        this.tableDefinidor.show(1, item.definicion);
    };
    ReportsEditor.prototype.onRemoveGlobal = function (item) {
        this.parametrosGlobalesCollection.remove(item);
        this.parametrosGlobalesCollection.refresh();
    };
    ReportsEditor.prototype.onRemoveDeReporte = function (item) {
        this.parametrosReporteCollection.remove(item);
        this.parametrosReporteCollection.refresh();
    };
    ReportsEditor.prototype.onQuerieParametroRepSelected = function (querie) {
        var _this = this;
        querie.parameters.forEach(function (param) {
            var paramReporteNew = new ReportParameterItem();
            paramReporteNew.idQuery = _this.selectorQueryParametroReporte.selectedItem.identity;
            paramReporteNew.query = _this.selectorQueryParametroReporte.selectedItem;
            paramReporteNew.idDatasource = _this.idDatasourceParametroReporte;
            paramReporteNew.fieldLabel = param.label;
            paramReporteNew.fieldValue = param.tag;
            paramReporteNew.parameter.nombre = param.nombre;
            paramReporteNew.parameter.code = param.code;
            paramReporteNew.parameter.defaultValue = param.defaultValue;
            paramReporteNew.parameter.parameterType = param.parameterType;
            paramReporteNew.parameter.idParameterType = param.idParameterType;
            paramReporteNew.parameter.label = param.label;
            paramReporteNew.parameter.tag = param.tag;
            paramReporteNew.idReferencia = _this.idParameterGlobalRelacion;
            var reporteSlice = _this.report.parameters.slice();
            reporteSlice.push(paramReporteNew);
            _this.report.parameters = reporteSlice;
            _this.parametrosReporteCollection.sourceCollection = reporteSlice;
            _this.parametrosReporteCollection.refresh;
        });
    };
    ReportsEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            Control.invalidateAll();
        }
    };
    var ReportsEditor_1;
    __decorate([
        ViewChild('selectorQuery'),
        __metadata("design:type", QueriesSelectorComponent)
    ], ReportsEditor.prototype, "selectorQuery", void 0);
    __decorate([
        ViewChild('selectorQueryParametroGlobal'),
        __metadata("design:type", QueriesSelectorComponent)
    ], ReportsEditor.prototype, "selectorQueryParametroGlobal", void 0);
    __decorate([
        ViewChild('selectorQueryParametroReporte'),
        __metadata("design:type", QueriesSelectorComponent)
    ], ReportsEditor.prototype, "selectorQueryParametroReporte", void 0);
    __decorate([
        ViewChild(TableDefinicion),
        __metadata("design:type", TableDefinicion)
    ], ReportsEditor.prototype, "tableDefinidor", void 0);
    ReportsEditor = ReportsEditor_1 = __decorate([
        Component({
            selector: 'analytic-report-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Report'\"\n                                 [info]=\"report\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-12\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"report.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"report.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-12\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-12\">\n\n                                      <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"report.descripcion\"></az-textarea>\n                                      </azteca-form-field>\n\n\n                                  </div>\n                              </div>\n                          </tab>\n                          <tab heading=\"Tablas\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n\n\n                                      <azteca-form-field [label]=\"'Origen de datos'\">\n                                          <az-combobox formControlName=\"idDatasource\"\n                                                       [(ngModel)]=\"idDatasource\"\n                                                       [items]=\"dataSources\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Querie:'\">\n                                          <analytic-queries-selector #selectorQuery formControlName=\"idQuery\" [(ngModel)]=\"idQuery\"></analytic-queries-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD-TABLA'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar nueva tabla'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"selectorQuery.selectedItem && selectorQuery.selectedItem.identity>0 && idDatasource>0\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridTablas style=\"height:550px\"\n                                            [itemsSource]=\"tablesCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveTabla(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'query.nombre'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Definici\u00F3n'\" [binding]=\"'definicion'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onEditTabla(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-pencil\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                              </wj-flex-grid>\n\n\n                          </tab>\n                          <tab heading=\"Par\u00E1metros globales\" (select)=\"onSelectTab($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n\n                                      <azteca-form-field [label]=\"'Origen de datos'\">\n                                          <az-combobox formControlName=\"idDatasourceParametroGlobal\"\n                                                       [(ngModel)]=\"idDatasourceParametroGlobal\"\n                                                       [items]=\"dataSources\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Querie:'\">\n                                          <analytic-queries-selector #selectorQueryParametroGlobal formControlName=\"idQueryParametroGlobal\" [(ngModel)]=\"idQueryParametroGlobal\"></analytic-queries-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo de parametro'\">\n                                          <az-combobox formControlName=\"idParameterTypeGlobal\"\n                                                       [(ngModel)]=\"idParameterTypeGlobal\"\n                                                       [items]=\"parameterType\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                                          <az-textbox formControlName=\"codigoParametroGlobal\" [(ngModel)]=\"codigoParametroGlobal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Nombre:'\">\n                                          <az-textbox formControlName=\"nombreParametroGlobal\" [(ngModel)]=\"nombreParametroGlobal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Field Label:'\">\n                                          <az-textbox formControlName=\"fieldLabelGlobal\" [(ngModel)]=\"fieldLabelGlobal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Field Value:'\">\n                                          <az-textbox formControlName=\"fieldValueGlobal\" [(ngModel)]=\"fieldValueGlobal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'TAG:'\">\n                                          <az-textbox formControlName=\"tagGlobal\" [(ngModel)]=\"tagGlobal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Default Value:'\">\n                                          <az-textbox formControlName=\"defaultValueGlobal\" [(ngModel)]=\"defaultValueGlobal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD-GLOBAL'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar nueva par\u00E1metro global'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"selectorQueryParametroGlobal.selectedItem && selectorQueryParametroGlobal.selectedItem.identity>0 && idDatasourceParametroGlobal>0 && codigoParametroGlobal != '' && nombreParametroGlobal != '' && fieldLabelGlobal != '' && fieldValueGlobal\"></az-toolbar-button>\n                              </az-toolbar>\n\n\n                              <wj-flex-grid #gridTablas style=\"height:550px\"\n                                            [itemsSource]=\"parametrosGlobalesCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveGlobal(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'parameter.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'parameter.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'parameter.parameterType.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden'\" [binding]=\"'orderParam'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'M\u00FAltiple'\" [binding]=\"'onlyOne'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'TAG'\" [binding]=\"'parameter.tag'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                          </tab>\n                          <tab heading=\"Par\u00E1metros del reporte\" (select)=\"onSelectTab($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n\n                                      <azteca-form-field [label]=\"'Origen de datos'\">\n                                          <az-combobox formControlName=\"idDatasourceParametroReporte\"\n                                                       [(ngModel)]=\"idDatasourceParametroReporte\"\n                                                       [items]=\"dataSources\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Querie:'\">\n                                          <analytic-queries-selector #selectorQueryParametroReporte formControlName=\"idQueryParametroReporte\" \n                                                                     [(ngModel)]=\"idQueryParametroReporte\"\n                                                                     (selectedItemChanged)=\"onQuerieParametroRepSelected($event)\">\n                                          </analytic-queries-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo de parametro'\">\n                                          <az-combobox formControlName=\"idParameterTypeReporte\"\n                                                       [(ngModel)]=\"idParameterTypeReporte\"\n                                                       [items]=\"parameterType\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onSelectedItemChangedDeReporte($event)\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                                          <az-textbox formControlName=\"codigoParametroReporte\" [(ngModel)]=\"codigoParametroReporte\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Nombre:'\">\n                                          <az-textbox formControlName=\"nombreParametroReporte\" [(ngModel)]=\"nombreParametroReporte\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Field Label:'\">\n                                          <az-textbox formControlName=\"fieldLabelReporte\" [(ngModel)]=\"fieldLabelReporte\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Field Value:'\">\n                                          <az-textbox formControlName=\"fieldValueReporte\" [(ngModel)]=\"fieldValueReporte\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'TAG:'\">\n                                          <az-textbox formControlName=\"tagReporte\" [(ngModel)]=\"tagReporte\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Default Value:'\">\n                                          <az-textbox formControlName=\"defaultValueReporte\" [(ngModel)]=\"defaultValueReporte\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Relacionar con el par\u00E1metro global'\">\n                                          <az-combobox formControlName=\"idParameterGlobalRelacion\"\n                                                       [(ngModel)]=\"idParameterGlobalRelacion\"\n                                                       [items]=\"parametersToRelacionar\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onSelectedItemChangedGlobalRelacion($event)\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD-DE-REPORTE'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar nueva par\u00E1metro de reporte'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"selectorQueryParametroReporte.selectedItem && selectorQueryParametroReporte.selectedItem.identity>0 && idDatasourceParametroReporte>0 && codigoParametroReporte != '' && nombreParametroReporte != '' && fieldLabelReporte != '' && fieldValueReporte\"></az-toolbar-button>\n                              </az-toolbar>\n\n\n                              <wj-flex-grid #gridTablas style=\"height:550px\"\n                                            [itemsSource]=\"parametrosReporteCollection\">\n\n                                  <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveDeReporte(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Codigo'\" [binding]=\"'parameter.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'parameter.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'parameter.parameterType.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden'\" [binding]=\"'orderParam'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'M\u00FAltiple'\" [binding]=\"'onlyOne'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'TAG'\" [binding]=\"'parameter.tag'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n\n      <analytic-table-definicion (definicion)=\"onConfirmar($event)\">    </analytic-table-definicion>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ReportsEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: ReportServiceAnalytic
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, ReportServiceAnalytic, DataSourceService, ParameterTypeService])
    ], ReportsEditor);
    return ReportsEditor;
}(CatalogEditor));
export { ReportsEditor };
