import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { ReportService as ReportServiceAnalytic } from '../services/report.service';
import { ReportItem } from '../models/report';
export declare class ReportsManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private reportService;
    reports: ReportItem[];
    constructor(context: Context, router: Router, route: ActivatedRoute, reportService: ReportServiceAnalytic);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
