var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogManager } from '../../editors';
//Features
import { ReportService as ReportServiceAnalytic } from '../services/report.service';
var ReportsManager = /** @class */ (function (_super) {
    __extends(ReportsManager, _super);
    //    
    function ReportsManager(context, router, route, reportService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.reportService = reportService;
        _this.reports = [];
        return _this;
    }
    ReportsManager_1 = ReportsManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ReportsManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    ReportsManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.reportService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.reports = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    ReportsManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    ReportsManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    ReportsManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.reportService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReportsManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    ReportsManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.reportService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var ReportsManager_1;
    ReportsManager = ReportsManager_1 = __decorate([
        Component({
            selector: 'analytic-reports-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Analytic - Reports</div>\n          <div class=\"card-block\">\n\n      \t\t<azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n      \t\t\t\t\t\t\t\t(addingItem)=\"onAddingItem()\"\n      \t\t\t\t\t\t\t\t(viewingItem)=\"onViewingItem($event)\"\n      \t\t\t\t\t\t\t\t(editingItem)=\"onEditingItem($event)\"\n      \t\t\t\t\t\t\t\t(deletingItem)=\"onDeletingItem($event)\"\n      \t\t\t\t\t\t\t\t(cloningItem)=\"onCloningItem($event)\"\n      \t\t\t\t\t\t\t\t(changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n      \t\t\t\t\t\t\t\t[enabled]=\"enabled\"\n      \t\t\t\t\t\t\t\t[allowNew]=\"allowNew\"\n      \t\t\t\t\t\t\t\t[allowView]=\"allowView\"\n      \t\t\t\t\t\t\t\t[allowEdit]=\"allowEdit\"\n      \t\t\t\t\t\t\t\t[allowDelete]=\"allowDelete\"\n      \t\t\t\t\t\t\t\t[allowClone]=\"allowClone\"\n      \t\t\t\t\t\t\t\t[allowChangeState]=\"allowChangeState\"\n      \t\t\t\t\t\t\t\t[allowAudit]=\"allowAudit\"\n      \t\t\t\t\t\t\t\t[catalogList]=\"reports\"\n      \t\t\t\t\t\t\t\t[totalRows]=\"totalRows\"\n      \t\t\t\t\t\t\t\t[pageIndex]=\"pageIndex\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Columnas del listado ----------------------------->\n    \n      \t\t\t<azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n      \t\t\t<azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\t\t\t\n\n      \t\t</azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ReportsManager_1; })
                },
                {
                    provide: CatalogService, useExisting: ReportServiceAnalytic
                }
            ]
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute, ReportServiceAnalytic])
    ], ReportsManager);
    return ReportsManager;
}(CatalogManager));
export { ReportsManager };
