import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from '../../core';
import { SearchRequest, CatalogSelector } from '../../search/index';
import { QueriesInfo, QueriesItem } from '../models/queries';
import { QueriesService } from '../services/queries.service';
export declare class QueriesSelectorComponent extends CatalogSelector {
    protected context: Context;
    private queriesSvc;
    queries: QueriesItem[];
    selectedItem: QueriesInfo;
    selectedItemChanged: EventEmitter<QueriesInfo>;
    constructor(context: Context, queriesSvc: QueriesService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
}
