import { Renderer2, OnDestroy } from "@angular/core";
import { FormBuilder, FormGroup } from "@angular/forms";
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import './dashboard-editor.component.css';
import './resizable.min.css';
import { ProcessComponent, PolicyInfo, Context } from '../../core';
import { AsyncTaskService } from "../../queue/services/async-task.service";
import { QueriesService } from "../services/queries.service";
import { QueriesInfo, QueryColumnInfo } from "../models/queries";
import { DashboardInfo, DashboardGraphInfo } from '../models/dashboard';
import { GraphParametroComponent } from './parts/graph-parameter.component';
import { DashboardService } from '../services/dashboard.service';
import { GraphService } from "../services/graph.service";
export declare class DashboardEditorComponent extends ProcessComponent implements OnDestroy {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private querySvc;
    private asyncTaskSvc;
    private dashboardSvc;
    private graphSvc;
    private rd;
    dashboards: DashboardInfo[];
    dashboard: DashboardInfo;
    graph: DashboardGraphInfo;
    dashboardEdit: DashboardInfo;
    formDashboard: FormGroup;
    validDashboard: boolean;
    formGraph: FormGroup;
    validGraph: boolean;
    timerDashboard: any;
    allowEdithDashboard: boolean;
    allowEdithGraph: boolean;
    dlgGraph: ModalDirective;
    dlgDashboard: ModalDirective;
    dlgParameter: ModalDirective;
    dlgGraphParameter: GraphParametroComponent;
    graphTypes: {
        "name": string;
        "type": string;
    }[];
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, querySvc: QueriesService, asyncTaskSvc: AsyncTaskService, dashboardSvc: DashboardService, graphSvc: GraphService, rd: Renderer2);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    onSelectedDashboard(dashboard: DashboardInfo): void;
    onClikcSave(): void;
    onAddDashboard(): void;
    onEditDashboard(): void;
    onCancelarDashboard(): void;
    onAceptarDashboard(): void;
    onResizeDashboardStop(event: any): void;
    onDeleteGraph(graph: DashboardGraphInfo): void;
    onEditGraph(graph: DashboardGraphInfo): void;
    onClikcAddGraph(): void;
    onCancelarGraph(): void;
    onAceptarGraph(): void;
    onQuerySelected(info: QueriesInfo): void;
    onRefreshInfo(graph: DashboardGraphInfo): void;
    onUpdateInfo(graph: DashboardGraphInfo): void;
    awaitAsyncTaskInfo(idAsyncTask: number): void;
    awaitAsyncTaskDataResultInfo(graph: DashboardGraphInfo, idAsyncTask: number): void;
    onColumnSelected(value: boolean, column: QueryColumnInfo): boolean;
    onMoveEnd(event: any, graph: DashboardGraphInfo): void;
    onResizeGraphStop(event: any, graph: DashboardGraphInfo): void;
    getParametersGraph(graph: DashboardGraphInfo): string;
    onCancelarParameter(): void;
    onUpdateParameter(graph: DashboardGraphInfo): void;
    onAceptarParameter(): void;
    loadTimer(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(reason: any): void;
}
