var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild, Renderer2 } from "@angular/core";
import { FormBuilder, Validators } from "@angular/forms";
import { Router, ActivatedRoute } from '@angular/router';
//
import { ChangeState } from '../../editors';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';
import './dashboard-editor.component.css';
import './resizable.min.css';
import { ProcessComponent, Context } from '../../core';
import { AztecaValidators } from "../../controls";
import { AsyncTaskService } from "../../queue/services/async-task.service";
import { QueriesService } from "../services/queries.service";
import { Control } from "wijmo/wijmo";
import { DashboardInfo, DashboardGraphInfo } from '../models/dashboard';
import { GraphMeasureInfo, GraphParameterInfo } from '../models/graph';
import { GraphParametroComponent } from './parts/graph-parameter.component';
import { DashboardService } from '../services/dashboard.service';
import { GraphService } from "../services/graph.service";
// TODO: Falta implementar componente MessageBox
var DashboardEditorComponent = /** @class */ (function (_super) {
    __extends(DashboardEditorComponent, _super);
    function DashboardEditorComponent(context, router, route, formBuilder, querySvc, asyncTaskSvc, dashboardSvc, graphSvc, rd) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.querySvc = querySvc;
        _this.asyncTaskSvc = asyncTaskSvc;
        _this.dashboardSvc = dashboardSvc;
        _this.graphSvc = graphSvc;
        _this.rd = rd;
        _this.dashboards = [];
        _this.dashboard = new DashboardInfo();
        _this.graph = new DashboardGraphInfo();
        // Edit
        _this.dashboardEdit = new DashboardInfo();
        _this.validDashboard = false;
        _this.validGraph = false;
        // Policies
        _this.allowEdithDashboard = false;
        _this.allowEdithGraph = false;
        _this.graphTypes = [
            { "name": "Column", "type": "Column" },
            { "name": "Bar", "type": "Bar" },
            { "name": "Scatter", "type": "Scatter" },
            { "name": "Line", "type": "Line" },
            { "name": "LineSymbols", "type": "LineSymbols" },
            { "name": "Area", "type": "Area" },
            { "name": "Spline", "type": "Spline" },
            { "name": "SplineSymbols", "type": "SplineSymbols" },
            { "name": "SplineArea", "type": "SplineArea" }
        ];
        _this.formGraph = formBuilder.group({
            'graphName': ['', Validators.required],
            'graphQuery': [0, AztecaValidators.selected],
            'graphDimension': ['', Validators.required],
            'graphType': [],
            'graphColumn': []
        });
        _this.formDashboard = formBuilder.group({
            'dashboardName': ['', Validators.required],
            'dashboardDescription': ['']
        });
        _this.formGraph.statusChanges.subscribe(function (value) {
            _this.validGraph = _this.formGraph.valid;
        });
        _this.formDashboard.statusChanges.subscribe(function (value) {
            _this.validDashboard = _this.formDashboard.valid;
        });
        return _this;
    }
    DashboardEditorComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.dashboardSvc.loadDashboardsUsuario(this.context.session.user.identity).then(function (info) {
            _this.dashboards = info;
            _this.dashboards.forEach(function (itemDashboard) {
                itemDashboard.graphs.forEach(function (item) {
                    item.graph.dataResult.resultJson = JSON.parse(item.graph.dataResult.content);
                });
            });
            //
            if (_this.dashboards && _this.dashboards.length > 0) {
                _this.dashboard = _this.dashboards[0];
            }
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.ngOnDestroy = function () {
        if (this.timerDashboard != null) {
            clearInterval(this.timerDashboard);
        }
    };
    DashboardEditorComponent.prototype.ngAfterViewInit = function () {
        this.applyPolicies();
    };
    ///////////////// General Managment /////////////////////
    DashboardEditorComponent.prototype.onSelectedDashboard = function (dashboard) {
        this.dashboard = dashboard;
    };
    ///////////////// Dashboard /////////////////////
    DashboardEditorComponent.prototype.onClikcSave = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.dashboardSvc.update(this.dashboard).then(function (info) {
            _this.dashboards.forEach(function (item) {
                if (item.identity == info.identity) {
                    item = info;
                    _this.dashboard = info;
                    _this.dashboard.graphs.forEach(function (itemGraph) {
                        itemGraph.graph.dataResult.resultJson = JSON.parse(itemGraph.graph.dataResult.content);
                    });
                }
            });
            _this.context.app.hideSpinner();
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.onAddDashboard = function () {
        this.dashboardEdit = new DashboardInfo();
        //
        this.dlgDashboard.config.backdrop = false;
        this.dlgDashboard.config.ignoreBackdropClick = true;
        this.dlgDashboard.show();
    };
    DashboardEditorComponent.prototype.onEditDashboard = function () {
        var _this = this;
        this.dashboardSvc.getDetailByID(this.dashboard.identity).then(function (info) {
            _this.dashboardEdit = info;
            //
            _this.dlgDashboard.config.backdrop = false;
            _this.dlgDashboard.config.ignoreBackdropClick = true;
            _this.dlgDashboard.show();
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.onCancelarDashboard = function () {
        this.dlgDashboard.hide();
    };
    DashboardEditorComponent.prototype.onAceptarDashboard = function () {
        var _this = this;
        this.dashboardSvc.update(this.dashboardEdit).then(function (info) {
            var exist = false;
            _this.dashboards.forEach(function (item) {
                if (item.identity == info.identity) {
                    item = info;
                    exist = true;
                }
            });
            if (!exist) {
                _this.dashboards.push(info);
                _this.dashboard = info;
            }
            _this.dlgDashboard.hide();
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.onResizeDashboardStop = function (event) {
        this.dashboard.width = event.size.width;
        this.dashboard.height = event.size.height;
        Control.invalidateAll();
    };
    ///////////////// Graph     ////////////////////
    DashboardEditorComponent.prototype.onDeleteGraph = function (graph) {
        var _this = this;
        this.dashboardSvc.deleteDashboardGraph(graph).then(function (result) {
            if (result) {
                var index = _this.dashboard.graphs.findIndex(function (element) {
                    return element === graph;
                });
                _this.dashboard.graphs.splice(index, 1);
            }
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.onEditGraph = function (graph) {
        this.graph = JSON.parse(JSON.stringify(graph));
        this.dlgGraph.config.backdrop = false;
        this.dlgGraph.show();
    };
    DashboardEditorComponent.prototype.onClikcAddGraph = function () {
        this.graph = new DashboardGraphInfo();
        this.graph.idDashboard = this.dashboard.identity;
        this.dlgGraph.config.backdrop = false;
        this.dlgGraph.show();
    };
    DashboardEditorComponent.prototype.onCancelarGraph = function () {
        this.dlgGraph.hide();
    };
    DashboardEditorComponent.prototype.onAceptarGraph = function () {
        var _this = this;
        this.context.app.showSpinner();
        // Actualizar grafica
        var promiseGraph = this.graphSvc.update(this.graph.graph).then(function (infoGraph) {
            _this.graph.graph = infoGraph;
            _this.graph.idGraph = infoGraph.identity;
            // Actualizar la grafica del tablero
            _this.dashboardSvc.updateDashboardGraph(_this.graph).then(function (info) {
                var position = 0;
                _this.dashboard.graphs.forEach(function (itemGraph) {
                    if (itemGraph.id == info.id) {
                        _this.dashboard.graphs.splice(position, 1);
                    }
                    position += 1;
                });
                info.graph.dataResult.resultJson = JSON.parse(info.graph.dataResult.content);
                _this.dashboard.graphs.push(info);
                _this.dlgGraph.hide();
                _this.context.app.hideSpinner();
            }).catch(function (error) { return _this.handleError(error); });
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.onQuerySelected = function (info) {
        var _this = this;
        this.graph.graph.query = info;
        if (info != null) {
            this.graph.graph.parameters = [];
            info.parameters.forEach(function (item) {
                var parameter = new GraphParameterInfo();
                parameter.label = item.label;
                parameter.name = item.tag;
                parameter.type = item.parameterType.type;
                parameter.default = item.defaultValue;
                parameter.value = item.defaultValue;
                _this.graph.graph.parameters.push(parameter);
            });
        }
    };
    DashboardEditorComponent.prototype.onRefreshInfo = function (graph) {
        var _this = this;
        var params = this.getParametersGraph(graph);
        //
        this.context.app.showSpinner();
        this.graphSvc.loadAsyncDataResult(graph.graph.identity, params).then(function (info) {
            _this.awaitAsyncTaskDataResultInfo(graph, info.idAsyncTask);
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.onUpdateInfo = function (graph) {
        var _this = this;
        var params = [];
        graph.graph.parameters.forEach(function (item) {
            var param = {};
            param[item.name] = item.value;
            params.push(param);
        });
        //
        this.context.app.showSpinner();
        this.querySvc.getAsyncDatasource(graph.graph.query.identity, graph.graph.query.idDataSource, JSON.stringify(params)).then(function (info) {
            _this.awaitAsyncTaskInfo(info.idAsyncTask);
        }).catch(function (error) { return _this.handleError(error); });
    };
    DashboardEditorComponent.prototype.awaitAsyncTaskInfo = function (idAsyncTask) {
        var _this = this;
        this.asyncTaskSvc.subscribeTask(idAsyncTask).subscribe(function (info) {
            _this.graph.graph.asyncTask = info;
            _this.graph.graph.asyncTask.resultJson = JSON.parse(_this.graph.graph.asyncTask.result);
            _this.context.app.hideSpinner();
            //
            _this.graph.graph.query.columns.forEach(function (itemColumn) {
                itemColumn.checked = false;
                _this.graph.graph.measures.forEach(function (itemMeasure) {
                    if (itemMeasure.measure == itemColumn.name) {
                        itemColumn.checked = true;
                    }
                });
            });
            //
            Control.invalidateAll();
        });
    };
    DashboardEditorComponent.prototype.awaitAsyncTaskDataResultInfo = function (graph, idAsyncTask) {
        var _this = this;
        this.asyncTaskSvc.subscribeTask(idAsyncTask).subscribe(function (info) {
            var dataResult = JSON.parse(info.result);
            graph.graph.dataResult.idGraphDataResult = dataResult.idGraphDataResult;
            graph.graph.dataResult.fecha = dataResult.fecha;
            graph.graph.dataResult.hora = dataResult.hora;
            graph.graph.dataResult.parameters = dataResult.parameters;
            graph.graph.dataResult.content = dataResult.content;
            graph.graph.dataResult.resultJson = JSON.parse(dataResult.content);
            _this.context.app.hideSpinner();
            Control.invalidateAll();
        });
    };
    DashboardEditorComponent.prototype.onColumnSelected = function (value, column) {
        if (value) {
            var indexItem = -1;
            this.graph.graph.measures.forEach(function (item, index) {
                if (item.measure == column.name)
                    indexItem = index;
            });
            if (indexItem >= 0) {
                this.graph.graph.measures[indexItem].state = ChangeState.MODIFIED;
            }
            else {
                var measure = new GraphMeasureInfo();
                measure.idGraph = this.graph.graph.identity;
                measure.measure = column.name;
                measure.state = ChangeState.ADDED;
                this.graph.graph.measures.push(measure);
            }
        }
        else {
            var indexItem = -1;
            this.graph.graph.measures.forEach(function (item, index) {
                if (item.measure == column.name)
                    indexItem = index;
            });
            if (indexItem >= 0) {
                this.graph.graph.measures[indexItem].state = ChangeState.DELETED;
            }
        }
        return value;
    };
    DashboardEditorComponent.prototype.onMoveEnd = function (event, graph) {
        graph.x = event.x;
        graph.y = event.y;
        graph.state = ChangeState.MODIFIED;
    };
    DashboardEditorComponent.prototype.onResizeGraphStop = function (event, graph) {
        graph.state = ChangeState.MODIFIED;
        graph.width = event.size.width;
        graph.height = event.size.height;
        Control.invalidateAll();
    };
    DashboardEditorComponent.prototype.getParametersGraph = function (graph) {
        var params = [];
        graph.graph.parameters.forEach(function (item) {
            var param = {};
            param[item.name] = item.value;
            params.push(param);
        });
        return JSON.stringify(params);
    };
    ///////////////// Graph Parameters  ////////////////////
    DashboardEditorComponent.prototype.onCancelarParameter = function () {
        this.dlgParameter.hide();
    };
    DashboardEditorComponent.prototype.onUpdateParameter = function (graph) {
        this.dlgGraphParameter.loadComponents(graph.graph.parameters);
        this.dlgParameter.config.backdrop = false;
        this.dlgParameter.show();
    };
    DashboardEditorComponent.prototype.onAceptarParameter = function () {
        this.onUpdateInfo(this.graph);
        this.dlgParameter.hide();
    };
    //////////////////////////////////////////////
    DashboardEditorComponent.prototype.loadTimer = function () {
        var _this = this;
        var self = this;
        this.timerDashboard = setInterval(function () {
            self.dashboards.forEach(function (dashboard) {
                dashboard.graphs.forEach(function (graph) {
                    var params = self.getParametersGraph(graph);
                    self.graphSvc.getDataResult(graph.graph.identity, params).then(function (info) {
                        _this.graph.graph.dataResult = info;
                        _this.context.app.hideSpinner();
                    }).catch(function (error) { return _this.handleError(error); });
                });
            });
        }, 300000);
    };
    //////////////////////////////////////////////
    DashboardEditorComponent.prototype.applyPolicy = function (policy) {
        if (policy.nombre == "allowEdithDashboard") {
            this.allowEdithDashboard = policy.valor == "true";
        }
        else if (policy.nombre == "allowEdithGraph") {
            this.allowEdithGraph = policy.valor == "true";
        }
    };
    DashboardEditorComponent.prototype.handleError = function (reason) {
        this.context.app.hideSpinner();
        console.log(reason);
    };
    __decorate([
        ViewChild('dlgGraph'),
        __metadata("design:type", ModalDirective)
    ], DashboardEditorComponent.prototype, "dlgGraph", void 0);
    __decorate([
        ViewChild('dlgDashboard'),
        __metadata("design:type", ModalDirective)
    ], DashboardEditorComponent.prototype, "dlgDashboard", void 0);
    __decorate([
        ViewChild('dlgParameter'),
        __metadata("design:type", ModalDirective)
    ], DashboardEditorComponent.prototype, "dlgParameter", void 0);
    __decorate([
        ViewChild('dlgGraphParameters'),
        __metadata("design:type", GraphParametroComponent)
    ], DashboardEditorComponent.prototype, "dlgGraphParameter", void 0);
    DashboardEditorComponent = __decorate([
        Component({
            selector: 'app-dashboard-editor',
            template: "\n      <div class=\"d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom\">\n          <h1 class=\"h2\" *ngIf=\"dashboard != null\">{{ dashboard.nombre }}</h1>\n          <h1 class=\"h2\" *ngIf=\"dashboard == null\">Administrador de Tableros</h1>\n          <div class=\"btn-toolbar mb-2 mb-md-0\">\n              <div class=\"btn-group mr-2\" *ngIf=\"dashboard != null\">\n                  <ng-container *ngIf=\"allowEdithDashboard\">\n                      <button class=\"btn btn-sm btn-outline-secondary\" (click)=\"onClikcSave()\">\n                          <span class=\"glyphicon glyphicon-floppy-disk\" aria-hidden=\"true\"></span>\n                      </button>\n                  </ng-container>\n                  <ng-container *ngIf=\"allowEdithGraph\">\n                      <button class=\"btn btn-sm btn-outline-secondary\" (click)=\"onClikcAddGraph()\">\n                          <span class=\"glyphicon glyphicon-stats\" aria-hidden=\"true\"></span>\n                      </button>\n                  </ng-container>\n                  <ng-container *ngIf=\"allowEdithDashboard\">\n                      <button class=\"btn btn-sm btn-outline-secondary\">\n                          <span class=\"glyphicon glyphicon-cog\" aria-hidden=\"true\" (click)=\"onEditDashboard()\"></span>\n                      </button>\n                      <button class=\"btn btn-sm btn-outline-secondary\">\n                          <span class=\"glyphicon glyphicon-plus\" aria-hidden=\"true\" (click)=\"onAddDashboard()\"></span>\n                      </button>\n                  </ng-container>\n              </div>\n              <div class=\"dropdown\">\n                  <button class=\"btn btn-lg btn-outline-secondary dropdown-toggle\" type=\"button\" id=\"dropdownMenuButton\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\">\n                      <span *ngIf=\"dashboard != null\">{{ dashboard.nombre }}</span>\n                      <span *ngIf=\"dashboard == null\">Agregar Tablero</span>\n                  </button>\n                  <div class=\"dropdown-menu\" aria-labelledby=\"dropdownMenuButton\">\n                      <button class=\"dropdown-item\" *ngFor=\"let dashboard of dashboards\" (click)=\"onSelectedDashboard(dashboard)\">{{dashboard.nombre}}</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n      <div #myBounds\n           *ngIf=\"dashboard.identity > 0\"\n           class=\"container-fluid\"\n           style=\"background-color: aliceblue;\"\n           [ngResizable]=\"allowEdithDashboard\"\n           (rzStop)=\"onResizeDashboardStop($event)\"\n           [ngStyle]=\"{'width': dashboard.width + 'px', 'height': dashboard.height + 'px'}\">\n\n          <div rzHandles=\"all\"\n               class=\"drag-block\"\n               [ngDraggable]=\"allowEdithGraph\"\n               [ngResizable]=\"allowEdithGraph\"\n               [handle]=\"myHandle\"\n               [ngStyle]=\"{'width': graph.width + 'px', 'height': graph.height + 'px'}\"\n               [bounds]=\"myBounds\"\n               [inBounds]=\"true\"\n               [preventDefaultEvent]=\"true\"\n               (endOffset)=\"onMoveEnd($event, graph)\"\n               [position]=\"{ 'x': graph.x, 'y': graph.y }\"\n               (rzStop)=\"onResizeGraphStop($event, graph)\"\n               *ngFor=\"let graph of dashboard.graphs\">\n\n              <div #myHandle class=\"drag-block-handle\">{{ graph.graph.nombre }}</div>\n\n              <wj-flex-chart style=\"display:block; height:90%\"\n                             *ngIf=\"graph.graph.dataResult != null\"\n                             [itemsSource]=\"graph.graph.dataResult.resultJson\"\n                             [chartType]=\"graph.graph.graphType\"\n                             [bindingX]=\"graph.graph.dimension\">\n                  <wj-flex-chart-series *ngFor=\"let measure of graph.graph.measures\" \n                                        [name]=\"measure.measure\" [binding]=\"measure.measure\"></wj-flex-chart-series>\n              </wj-flex-chart>\n\n              <div class=\"btn-group mr-2\">\n                  <button class=\"btn btn-sm btn-outline-secondary\" (click)=\"onUpdateParameter(graph)\">\n                      <span class=\"glyphicon glyphicon-list-alt\" aria-hidden=\"true\"></span>\n                  </button>\n                  <button class=\"btn btn-sm btn-outline-secondary\" (click)=\"onRefreshInfo(graph)\">\n                      <span class=\"glyphicon glyphicon-refresh\" aria-hidden=\"true\"></span>\n                  </button>\n                  <button class=\"btn btn-sm btn-outline-secondary\">\n                      <span class=\"glyphicon glyphicon-new-window\" aria-hidden=\"true\"></span>\n                  </button>\n                  <ng-container *ngIf=\"allowEdithGraph\">\n                      <button class=\"btn btn-sm btn-outline-secondary\" (click)=\"onEditGraph(graph)\">\n                          <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>\n                      </button>\n                      <button class=\"btn btn-sm btn-outline-secondary\" (click)=\"onDeleteGraph(graph)\">\n                          <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span>\n                      </button>\n                  </ng-container>\n              </div>\n\n          </div>\n      </div>\n\n      <!--DIALOG  DASHBOARD-->\n      <div bsModal #dlgDashboard=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Configuraci&oacute;n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarDashboard()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <form [formGroup]=\"formDashboard\">\n                          <!-- Name -->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Nombre:'\">\n                                      <az-textbox formControlName=\"dashboardName\"\n                                                  [(ngModel)]=\"dashboardEdit.nombre\">\n                                      </az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <!-- Description -->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                      <az-textarea formControlName=\"dashboardDescription\"\n                                                   [(ngModel)]=\"dashboardEdit.descripcion\">\n                                      </az-textarea>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarDashboard()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarDashboard()\" [disabled]=\"!validDashboard\">Aceptar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n      <!--DIALOG  GRAPH-->\n      <div bsModal #dlgGraph=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Gr&aacute;fica</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarGraph()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <form [formGroup]=\"formGraph\" *ngIf=\"graph != null && graph.graph != null\">\n                          <!-- Name -->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Nombre:'\">\n                                      <az-textbox formControlName=\"graphName\"\n                                                  [(ngModel)]=\"graph.graph.nombre\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <!-- Query -->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Consulta:'\">\n                                      <analytic-queries-selector formControlName=\"graphQuery\"\n                                                                 (selectedItemChanged)=\"onQuerySelected($event)\"\n                                                                 [(ngModel)]=\"graph.graph.idQuery\"></analytic-queries-selector>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <!-- Actualizar informacion -->\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdateInfo(graph)\">\n                                      <span aria-hidden=\"true\" class=\"glyphicon glyphicon-refresh\"></span>\n                                      Actualizar\n                                  </button>\n                              </div>\n                          </div>\n\n                          <!-- Actualizar informacion -->\n                          <div *ngIf=\"graph.graph.parameters != null\" class=\"row\">\n                              <!--\n                              <graph-parameters [itemsSource]=\"graph.graph.parameters\"></graph-parameters>\n                              -->\n                          </div>\n\n\n                          <!-- Graph -->\n                          <div *ngIf=\"graph.graph.asyncTask != null && graph.graph.asyncTask.resultJson != null\" class=\"row\" style=\"height: 500px; background-color:lightgray\">\n                              <div class=\"col-12\">\n                                  <wj-flex-chart [itemsSource]=\"graph.graph.asyncTask.resultJson\"\n                                                 [chartType]=\"graph.graph.graphType\"\n                                                 [bindingX]=\"graph.graph.dimension\"\n                                                 [header]=\"graph.graph.nombre\">\n                                      <ng-container *ngFor=\"let measure of graph.graph.measures\">\n                                          <wj-flex-chart-series *ngIf=\"measure.state != 'DELETED'\" [name]=\"measure.measure\" [binding]=\"measure.measure\"></wj-flex-chart-series>\n                                      </ng-container>\n                                  </wj-flex-chart>\n                              </div>\n                          </div>\n\n                          <!-- Graph Type -->\n                          <div *ngIf=\"graph.graph.asyncTask != null && graph.graph.asyncTask.resultJson != null\" class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Tipo de Grafica:'\">\n                                      <az-combobox formControlName=\"graphType\"\n                                                   [(ngModel)]=\"graph.graph.graphType\"\n                                                   [items]=\"graphTypes\"\n                                                   [displayMember]=\"'name'\"\n                                                   [valueMember]=\"'type'\"></az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <!-- Dimension -->\n                          <div *ngIf=\"graph.graph.asyncTask != null && graph.graph.asyncTask.resultJson != null\" class=\"row\">\n                              <div class=\"col-12\" *ngIf=\"graph.graph.query != null\">\n                                  <azteca-form-field [label]=\"'Dimension:'\">\n                                      <az-combobox formControlName=\"graphDimension\"\n                                                   [(ngModel)]=\"graph.graph.dimension\"\n                                                   [items]=\"graph.graph.query.columns\"\n                                                   [displayMember]=\"'name'\"\n                                                   [valueMember]=\"'name'\"></az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <!-- Measure -->\n                          <div *ngIf=\"graph.graph.query != null && graph.graph.asyncTask != null && graph.graph.asyncTask.resultJson != null\" class=\"row\">\n                              <div class=\"col-12\">\n                                  <ng-container *ngFor=\"let column of graph.graph.query.columns\">\n                                      <input type=\"checkbox\" [checked]=\"column.checked\" (change)=\"column.checked = onColumnSelected(!column.checked, column)\" /> {{column.name}}\n                                  </ng-container>\n                              </div>\n                          </div>\n                      </form>\n\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarGraph()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarGraph()\" [disabled]=\"!validGraph\">Aceptar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n\n      <!-- Dialogo de Parametros -->\n      <div bsModal #dlgParameter=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">Gr&aacute;fica</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarParameter()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <!-- Parametros de la grafica -->\n                      <graph-parameters #dlgGraphParameters *ngIf=\"graph.graph.parameters != null\"></graph-parameters>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarParameter()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarParameter()\">Aceptar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [Context,
            Router, ActivatedRoute,
            FormBuilder,
            QueriesService,
            AsyncTaskService,
            DashboardService,
            GraphService,
            Renderer2])
    ], DashboardEditorComponent);
    return DashboardEditorComponent;
}(ProcessComponent));
export { DashboardEditorComponent };
