var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild, ViewContainerRef, Input, ComponentFactoryResolver } from "@angular/core";
import { WjInputDateTime } from 'wijmo/wijmo.angular2.input';
import { GraphParameterType } from '../../models/graph';
import { MessageComponent } from './message.component';
var GraphParametroComponent = /** @class */ (function () {
    function GraphParametroComponent(resolver) {
        this.resolver = resolver;
    }
    Object.defineProperty(GraphParametroComponent.prototype, "itemsSource", {
        set: function (info) {
            this._Parameters = info;
            //this.loadComponents();
        },
        enumerable: true,
        configurable: true
    });
    //////////////////////////////// METODOS ////////////////////////////////////////
    GraphParametroComponent.prototype.loadComponents = function (parameters) {
        var _this = this;
        if (parameters) {
            this._Parameters = parameters;
        }
        this.dynamicContent.clear();
        if (this._Parameters != null) {
            this._Parameters.forEach(function (item) {
                if (item.type == GraphParameterType.DateTime || item.type == GraphParameterType.DatetTimeOffSet) {
                    // Label
                    var factoryMsg = _this.resolver.resolveComponentFactory(MessageComponent);
                    var componentMsgRef = _this.dynamicContent.createComponent(factoryMsg);
                    componentMsgRef.instance.message = item.label;
                    // InputDate
                    var factory = _this.resolver.resolveComponentFactory(WjInputDateTime);
                    var componentRef_1 = _this.dynamicContent.createComponent(factory);
                    if (item.default && item.default != '') {
                        componentRef_1.instance.value = new Date(item.default);
                    }
                    else if (item.value && item.value != '') {
                        componentRef_1.instance.value = new Date(item.value);
                    }
                    // Handled change value
                    componentRef_1.instance.onValueChanged = function (e) {
                        item.value = componentRef_1.instance.value.toLocaleString();
                    };
                }
                else if (item.type == GraphParameterType.Bool) {
                }
            });
        }
    };
    GraphParametroComponent.prototype.onAgregar = function () {
        var factory = this.resolver.resolveComponentFactory(MessageComponent);
        var componentRef = this.dynamicContent.createComponent(factory);
        componentRef.instance.message = "Hola! " + new Date().getTime();
    };
    //////////////////////////////// IMPLEMNTATION ////////////////////////////////////////
    GraphParametroComponent.prototype.ngOnInit = function () {
    };
    GraphParametroComponent.prototype.ngOnDestroy = function () {
    };
    __decorate([
        Input(),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], GraphParametroComponent.prototype, "itemsSource", null);
    __decorate([
        ViewChild('dynamicContent', { read: ViewContainerRef }),
        __metadata("design:type", ViewContainerRef)
    ], GraphParametroComponent.prototype, "dynamicContent", void 0);
    GraphParametroComponent = __decorate([
        Component({
            template: "\n      <div #dynamicContent>\n      </div>\n    ",
            selector: 'graph-parameters'
        }),
        __metadata("design:paramtypes", [ComponentFactoryResolver])
    ], GraphParametroComponent);
    return GraphParametroComponent;
}());
export { GraphParametroComponent };
