import { CatalogInfo, CatalogItem } from '../../core';
import { TrackableItem } from "../../core";
import { QueriesInfo } from "../models/queries";
import { AsyncTaskInfo } from "../../queue/models/async-task";
export declare class GraphInfo extends CatalogInfo {
    nombre: string;
    descripcion: string;
    idQuery: number;
    graphType: string;
    dimension: string;
    dataResult: GraphDataResultInfo;
    asyncTask: AsyncTaskInfo;
    query: QueriesInfo;
    parameters: GraphParameterInfo[];
    measures: GraphMeasureInfo[];
    constructor();
}
export declare class GraphItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class GraphMeasureInfo extends TrackableItem {
    idGraph: number;
    measure: string;
    constructor();
}
export declare class GraphParameterInfo extends TrackableItem {
    label: string;
    name: string;
    type: string;
    default: string;
    value: string;
    idQuery: number;
    idGraph: number;
    constructor();
}
export declare class GraphDataResultInfo {
    idGraphDataResult: number;
    fecha: Date;
    hora: Date;
    idGraph: number;
    parameters: string;
    content: string;
    resultJson?: any;
    constructor();
    getJsonResul(): any;
}
export declare enum GraphParameterType {
    DateTime = "DateTime",
    String = "String",
    Bool = "Bool",
    Integer = "Integer",
    Decimal = "Decimal",
    DatetTimeOffSet = "DatetTimeOffSet"
}
