import { CatalogInfo, CatalogItem, TrackableItem } from '../../core';
import { QueriesInfo } from './queries';
import { ParameterInfo } from './parameter';
import { DataSourceInfo } from './data-source';
export declare class ReportInfo extends CatalogInfo {
    nombre: string;
    descripcion: string;
    parameters: ReportParameterItem[];
    parametersRef: ReportParameterItem[];
    parametersGlobales: ReportParameterItem[];
    tables: ReportTableItem[];
    constructor();
}
export declare class ReportItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class ReportTableItem extends TrackableItem {
    iD: number;
    definicion: string;
    idDatasource: number;
    idQuery: number;
    query: QueriesInfo;
    dataSource: DataSourceInfo;
    constructor();
}
export declare class ReportParameterItem extends TrackableItem {
    iD: number;
    idParameter: number;
    idDatasource: number;
    idQuery: number;
    fieldValue: string;
    fieldLabel: string;
    onlyOne: boolean;
    orderParam: number;
    idReferencia: number;
    parameter: ParameterInfo;
    query: QueriesInfo;
    constructor();
}
