var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { GraphInfo } from '../models/graph';
var GraphService = /** @class */ (function (_super) {
    __extends(GraphService, _super);
    function GraphService(http, context) {
        return _super.call(this, http, context, 'api/analytic/graphs') || this;
    }
    GraphService.prototype.create = function () {
        return Promise.resolve(new GraphInfo());
    };
    /*
    //Sample method
    sampleMethod(param1: number, param2: string): Promise<GraphInfo> {
        let params = new HttpParams()
            .set('param1', param1.toString())
            .set('param2', param2);
        //
        return this.apiService.get<GraphInfo>('sample-method', params)
            .toPromise();
    }
    */
    GraphService.prototype.getDataResult = function (idGraph, values) {
        var params = new HttpParams()
            .set('idGraph', idGraph.toString())
            .set('values', values);
        //
        return this.apiService.get('get-data-result', params)
            .toPromise();
    };
    GraphService.prototype.loadAsyncDataResult = function (idGraph, values) {
        var params = new HttpParams()
            .set('idGraph', idGraph.toString())
            .set('values', values);
        //
        return this.apiService.get('load-async-data-result', params)
            .toPromise();
    };
    GraphService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], GraphService);
    return GraphService;
}(CatalogService));
export { GraphService };
