var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Wijmo
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Bootstrap
import { AlertModule, ModalModule, TabsModule, AccordionModule, SortableModule, CarouselModule, TypeaheadModule } from 'ngx-bootstrap';
//Modulos
import { SecurityModule } from '../security/security.module';
import { SearchModule } from '../search/search.module';
import { UtilsModule } from '../utils/utils.module';
import { ControlsModule } from '../controls/controls.module';
import { EditorsModule } from '../editors/editors.module';
import { GeolocationModule } from '../geolocation/geolocation.module';
import { DrawingModule } from '../drawing/drawing.module';
import { CustomModule } from '../custom/custom.module';
import { BpmRoutingModule } from './bpm.routing.module';
//Componentes
import { FormGeneratorComponent } from './components/form-generator.component';
import { DocumentosManager } from './components/documentos.manager';
import { DocumentosEditor } from './components/documentos.editor';
import { VersionesManager } from './components/versiones.manager';
import { VersionesEditor } from './components/versiones.editor';
import { CamposManager } from './components/campos.manager';
import { DatasetsManager } from './components/datasets.manager';
import { DatasetsEditor } from './components/datasets.editor';
import { FormulariosManager } from './components/formularios.manager';
import { FormulariosEditor } from './components/formularios.editor';
import { ContenedoresManager } from './components/contenedores.manager';
import { FormularioControlesComponent } from './components/formulario-controles.component';
import { GridColumnsEditor } from './components/grid-columns.editor';
import { InstanceManager } from './components/instance.manager';
import { WorkflowEditor } from './components/workflow.editor';
//Controls
import { CampoSelectorComponent } from './components/controls/campo-selector.component';
import { DatasetSelectorComponent } from './components/controls/dataset-selector.component';
import { DatasetSearchComponent } from './components/controls/dataset-search.component';
import { CamposTreeComponent } from './components/controls/campos-tree.component';
import { ContenedoresTreeComponent } from './components/controls/contenedores-tree.component';
import { CamposAutocompleteCellComponent } from './components/controls/campos-autocomplete-cell.component';
//Parts
import { DatasetValueEditor } from './components/parts/dataset-value.editor';
import { DatasetParameterEditor } from './components/parts/dataset-parameter.editor';
import { DatasetCampoEditor } from './components/parts/dataset-campo.editor';
import { DatasetFiltroEditor } from './components/parts/dataset-filtro.editor';
import { AddControlEditor } from './components/parts/add-control.editor';
import { FormControlEditor } from './components/parts/form-control.editor';
import { CarouselEditor } from './components/parts/carousel.editor';
import { MapEditor } from './components/parts/map.editor';
import { GridColumnEditor } from './components/parts/grid-column.editor';
import { InstanceListComponent } from './components/parts/instance-list.component';
import { ActivityEditor } from './components/parts/activity.editor';
import { ConditionsEditor } from './components/parts/conditions.editor';
//Servicios
import { FormDeactivateGuard } from './services/form-deactivate-guard.service';
import { TypeBuilderService } from './services/type-builder.service';
import { DocumentoService } from './services/documento.service';
import { CampoService } from './services/campo.service';
import { DatasetService } from './services/dataset.service';
import { FormularioService } from './services/formulario.service';
import { TipoDatoService } from './services/tipo-dato.service';
import { ContenedorService } from './services/contenedor.service';
import { ControlService } from './services/control.service';
import { WorkflowService } from './services/workflow.service';
var COMPONENTS = [DocumentosManager, DocumentosEditor, VersionesManager, VersionesEditor, CamposManager, DatasetsManager, DatasetsEditor,
    FormulariosManager, FormulariosEditor, CampoSelectorComponent, DatasetSelectorComponent, DatasetValueEditor, DatasetParameterEditor,
    DatasetCampoEditor, DatasetFiltroEditor, ContenedoresManager, CamposTreeComponent, FormularioControlesComponent, ContenedoresTreeComponent,
    CamposAutocompleteCellComponent, AddControlEditor, FormControlEditor, GridColumnsEditor, GridColumnEditor, FormGeneratorComponent,
    CarouselEditor, InstanceListComponent, InstanceManager, MapEditor, WorkflowEditor, ActivityEditor, ConditionsEditor, DatasetSearchComponent];
var SERVICES = [FormDeactivateGuard, DocumentoService, CampoService, DatasetService, FormularioService, TipoDatoService, ContenedorService, ControlService,
    TypeBuilderService, WorkflowService];
var BpmModule = /** @class */ (function () {
    function BpmModule() {
    }
    BpmModule = __decorate([
        NgModule({
            imports: [
                CommonModule, FormsModule, ReactiveFormsModule,
                WjInputModule, WjGridModule, WjGridFilterModule,
                AlertModule.forRoot(), ModalModule.forRoot(), TabsModule.forRoot(), AccordionModule.forRoot(), SortableModule.forRoot(),
                CarouselModule.forRoot(), TypeaheadModule.forRoot(),
                SecurityModule, SearchModule, UtilsModule, ControlsModule, BpmRoutingModule, EditorsModule, GeolocationModule, DrawingModule,
                CustomModule
            ],
            declarations: COMPONENTS,
            providers: SERVICES,
            exports: COMPONENTS
        })
    ], BpmModule);
    return BpmModule;
}());
export { BpmModule };
