var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
//Componentes
import { FormGeneratorComponent } from './components/form-generator.component';
import { DocumentosManager } from './components/documentos.manager';
import { DocumentosEditor } from './components/documentos.editor';
import { VersionesManager } from './components/versiones.manager';
import { VersionesEditor } from './components/versiones.editor';
import { CamposManager } from './components/campos.manager';
import { DatasetsManager } from './components/datasets.manager';
import { DatasetsEditor } from './components/datasets.editor';
import { FormulariosManager } from './components/formularios.manager';
import { FormulariosEditor } from './components/formularios.editor';
import { ContenedoresManager } from './components/contenedores.manager';
import { FormularioControlesComponent } from './components/formulario-controles.component';
import { GridColumnsEditor } from './components/grid-columns.editor';
import { InstanceManager } from './components/instance.manager';
import { WorkflowEditor } from './components/workflow.editor';
//
import { AuthGuard } from '../core/services/auth-guard.service';
import { EditorDeactivateGuard } from '../editors/index';
import { FormDeactivateGuard } from './services/form-deactivate-guard.service';
var routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'form-generator/:formulario', component: FormGeneratorComponent, canDeactivate: [FormDeactivateGuard] },
            { path: 'documentos/:proceso', component: DocumentosManager },
            { path: 'documentos/:proceso/:id', component: DocumentosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'documentos/:proceso/:id/versiones', component: VersionesManager },
            { path: 'documentos/:proceso/:id/versiones/:ver', component: VersionesEditor },
            { path: 'campos/:proceso', component: CamposManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'datasets/:proceso', component: DatasetsManager },
            { path: 'datasets/:proceso/:id', component: DatasetsEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'formularios/:proceso', component: FormulariosManager },
            { path: 'formularios/:proceso/:id', component: FormulariosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'formularios/:proceso/:id/contenedores', component: ContenedoresManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'formularios/:proceso/:id/controles', component: FormularioControlesComponent, canDeactivate: [EditorDeactivateGuard] },
            { path: 'formularios/:proceso/:id/controles/:idFormControl/columnas', component: GridColumnsEditor },
            { path: 'instancias/:proceso', component: InstanceManager },
            { path: 'workflow/:proceso', component: WorkflowEditor }
        ]
    },
];
var BpmRoutingModule = /** @class */ (function () {
    function BpmRoutingModule() {
    }
    BpmRoutingModule = __decorate([
        NgModule({
            imports: [
                RouterModule.forChild(routes)
            ],
            exports: [
                RouterModule
            ]
        })
    ], BpmRoutingModule);
    return BpmRoutingModule;
}());
export { BpmRoutingModule };
