import { QueryList, ChangeDetectorRef, ElementRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { CollectionView } from 'wijmo/wijmo';
import { TreeNode } from 'angular-tree-component';
import { TabDirective } from 'ngx-bootstrap';
import { Context, HierarchyChanges } from '../../core';
import { CatalogOptions } from '../../custom';
import { HierarchyManager } from '../../editors';
import { CampoInfo, CampoItem } from '../models/campo';
import { CampoService } from '../services/campo.service';
import { TipoDatoService } from '../services/tipo-dato.service';
import { TipoDatoItem } from '../models/tipo-dato';
import { DatasetInfo } from '../models/dataset';
export declare class CamposManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    private campoService;
    private tipoDatoService;
    campos: CampoInfo[];
    campoEdicion: CampoInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    idDocumento: number;
    version: number;
    fnAllowDrop: Function;
    parametersCollection: CollectionView;
    loading: boolean;
    currentNodeType: number;
    readonly COMPLEX_TYPE: number;
    readonly COLLECTION_TYPE: number;
    readonly SIMPLE_TYPE: number;
    currentDataset: DatasetInfo;
    tiposCampo: {
        id: number;
        tipo: string;
    }[];
    tiposDato: TipoDatoItem[];
    chkRequerido: ElementRef;
    chkOcurrenciaMin: ElementRef;
    chkOcurrenciaMax: ElementRef;
    tabs: QueryList<TabDirective>;
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, campoService: CampoService, tipoDatoService: TipoDatoService);
    ngOnInit(): void;
    loadHierarchy(): void;
    loadTiposDato(): void;
    setValidators(tipoCampo: number): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(campos: CampoInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<CampoInfo>): void;
    onFieldTypeChanged(idTipo: any): void;
    onSelectedDatasetChanged(dataset: DatasetInfo): void;
    clearLoadingFlag(): void;
    onSelectTabDS(args: any): void;
    allowDropHandler(element: any, to: {
        parent: TreeNode;
        index: number;
    }): any;
    onSelectParamField(item: CampoItem, cell: any): void;
}
