var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, ViewChildren, QueryList, forwardRef, ChangeDetectorRef, ElementRef } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
//Wijmo
import { Control, CollectionView } from 'wijmo/wijmo';
//ngx bootstrap
import { TabDirective } from 'ngx-bootstrap';
//
import { Context, BaseComponent, CatalogService } from '../../core';
import { HierarchyManager } from '../../editors';
import { AztecaValidators } from '../../controls';
//
import { CampoInfo } from '../models/campo';
import { CampoService } from '../services/campo.service';
import { TipoDatoService } from '../services/tipo-dato.service';
import { DatasetInfo } from '../models/dataset';
import { CampoParametro } from '../models/campo-parametro';
var CamposManager = /** @class */ (function (_super) {
    __extends(CamposManager, _super);
    function CamposManager(context, changeDetector, formBuilder, router, route, campoService, tipoDatoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.campoService = campoService;
        _this.tipoDatoService = tipoDatoService;
        _this.campos = [];
        _this.campoEdicion = new CampoInfo();
        _this.parametersCollection = new CollectionView([], {
            getError: function (item, property) {
                switch (property) {
                    case 'idCampoOrigen':
                        return item[property] <= 0 ? 'Valor de parámetro no establecido' : null;
                } //switch
                return null;
            } //getError
        });
        _this.loading = false;
        //
        _this.currentNodeType = 1;
        _this.COMPLEX_TYPE = 1;
        _this.COLLECTION_TYPE = 2;
        _this.SIMPLE_TYPE = 3;
        _this.currentDataset = new DatasetInfo();
        _this.tiposCampo = [];
        _this.tiposDato = [];
        _this.nodeForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'tipoCampo': [0, AztecaValidators.selected],
            'xmlTag': ['', Validators.required],
            'etiqueta': [''],
            'descripcion': [''],
            'idTipoDato': [0, AztecaValidators.selected],
            'longitud': [0],
            'idDataset': [0],
            'displayMember': [''],
            'valueMember': [''],
            'limiteInferior': [0],
            'limiteSuperior': [0],
            'regularExpression': [''],
            'campoCorrelacion': [0],
            'expresionCorrelacion': [''],
            'ocurrenciaMinima': [0],
            'ocurrenciaMaxima': [1]
        });
        _this.tiposCampo.push({ id: 1, tipo: 'Tipo complejo' }, { id: 2, tipo: 'Colección' }, { id: 3, tipo: 'Tipo simple' });
        return _this;
    }
    CamposManager_1 = CamposManager;
    CamposManager.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idDocumento = +params['idDocumento'];
            _this.version = +params['version'];
        });
        //Asignar handler que determina a que nodos se puede hacer drop
        this.fnAllowDrop = function (element, to) { return _this.allowDropHandler(element, to); };
        this.applyPolicies();
    };
    ////////////////////// METODOS //////////////////////////////////////////////
    CamposManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.campoService.loadVersionFields(this.idDocumento, this.version, 0)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.campos = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CamposManager.prototype.loadTiposDato = function () {
        var _this = this;
        this.tipoDatoService.loadList(this.context.app.defaultSite.identity)
            .then(function (tipos) { return _this.tiposDato = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CamposManager.prototype.setValidators = function (tipoCampo) {
        var formControls = this.nodeForm.controls;
        if (tipoCampo == this.SIMPLE_TYPE) {
            formControls.etiqueta.setValidators(Validators.required);
            formControls.idTipoDato.setValidators(AztecaValidators.selected);
            if (this.campoEdicion.idDataset > 0) {
                formControls.displayMember.setValidators(Validators.required);
                formControls.valueMember.setValidators(Validators.required);
            }
            else {
                formControls.displayMember.setValidators(null);
                formControls.valueMember.setValidators(null);
            }
        }
        else {
            formControls.etiqueta.setValidators(null);
            formControls.idTipoDato.setValidators(null);
            formControls.displayMember.setValidators(null);
            formControls.valueMember.setValidators(null);
        }
        Object.keys(formControls).forEach(function (key) { return formControls[key].updateValueAndValidity(); });
    };
    //////////////////// HANDLERS //////////////////////////////////////
    CamposManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        //
        this.loadTiposDato();
    };
    CamposManager.prototype.onNodesChanged = function (campos) {
        this.campos = campos;
    };
    CamposManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    CamposManager.prototype.onCreatingNode = function (parentNode) {
        this.loading = true;
        this.campoEdicion = new CampoInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset({ longitud: 0, limiteInferior: 0, limiteSuperior: 0, ocurrenciaMinima: 0, ocurrenciaMaxima: 0 });
        this.campoEdicion = new CampoInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        this.parametersCollection.sourceCollection = this.campoEdicion.parametros;
        //Inicializar valores del nodo
        this.campoEdicion.idBranch = this.context.app.defaultSite.identity;
        this.campoEdicion.idCompany = this.context.app.defaultCompany.identity;
        this.campoEdicion.idDocumento = this.idDocumento;
        this.campoEdicion.version = this.version;
        //
        this.currentParent = parentNode;
        this.tabs.toArray()[0].active = true;
        this.showEditor();
    };
    CamposManager.prototype.onEditingNode = function (node) {
        var _this = this;
        this.loading = true; //Establecer bandera que indica que se está haciendo carga de información (utilizada principalmente para el mapeo de parametros del dataset)
        this.campoEdicion = this.campoService.copy(node.data);
        this.parametersCollection.sourceCollection = this.campoEdicion.parametros;
        //Determinar el tipo de nodo
        if (this.campoEdicion.complexType) {
            if (this.campoEdicion.coleccion) {
                this.currentNodeType = this.COLLECTION_TYPE;
                //Establecer checkboxes para ocurrencias
                this.chkOcurrenciaMin.nativeElement.checked = this.campoEdicion.ocurrenciaMinima > 0;
                this.chkOcurrenciaMax.nativeElement.checked = this.campoEdicion.ocurrenciaMaxima > 0;
            }
            else {
                this.currentNodeType = this.COMPLEX_TYPE;
            }
        }
        else {
            this.currentNodeType = this.SIMPLE_TYPE;
        }
        setTimeout(function (_) { return _this.setValidators(_this.currentNodeType); });
        this.tabs.toArray()[0].active = true;
        this.showEditor();
    };
    CamposManager.prototype.onSavingNode = function () {
        //Si es un campo simple y el campo es requerido, establecer ocurrencia mínima = 1
        if (!this.campoEdicion.complexType) {
            this.campoEdicion.ocurrenciaMinima = this.chkRequerido.nativeElement.checked ? 1 : 0;
        }
        //Si es una colección, establecer ocurrencias máximas y mínimas
        else if (this.campoEdicion.coleccion) {
            if (!this.chkOcurrenciaMin.nativeElement.checked) {
                this.campoEdicion.ocurrenciaMinima = 0;
            }
            if (!this.chkOcurrenciaMax.nativeElement.checked) {
                this.campoEdicion.ocurrenciaMaxima = 0;
            }
        }
        //Si es un nuevo nodo
        if (this.campoEdicion.clientID == 0) {
            this.addNode(this.campoEdicion, this.currentParent);
        }
        //Si se estaba editando un nodo existente
        else {
            this.updateNode(this.campoEdicion);
        }
        this.campoEdicion = new CampoInfo();
        this.hideEditor();
    };
    CamposManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    CamposManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.campoService.saveHierarchy(changes)
            .then(function (campos) {
            _this.campos = campos;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Actualizar información del modelo con base al tipo seleccionado
    CamposManager.prototype.onFieldTypeChanged = function (idTipo) {
        //Tanto "Tipo Complejo" como "colección" son complejos
        this.campoEdicion.complexType = (idTipo == this.COMPLEX_TYPE || idTipo == this.COLLECTION_TYPE);
        this.campoEdicion.coleccion = idTipo == this.COLLECTION_TYPE;
        this.currentNodeType = idTipo;
        this.setValidators(idTipo);
    };
    CamposManager.prototype.onSelectedDatasetChanged = function (dataset) {
        var _this = this;
        if (dataset) {
            this.currentDataset = dataset;
        }
        else {
            this.currentDataset = new DatasetInfo();
        }
        //Realizar mapeo de parámetros del dataset sólo si se cambió el dataset por acción del usuario
        if (!this.loading) {
            this.campoEdicion.parametros = [];
            this.currentDataset.parametros.forEach(function (dsParam) {
                var fieldParam = new CampoParametro();
                fieldParam.nombre = dsParam.nombre;
                _this.campoEdicion.parametros.push(fieldParam);
            });
            this.parametersCollection.sourceCollection = this.campoEdicion.parametros;
        }
        //Reestablecer validadores
        this.setValidators(this.currentNodeType);
    };
    CamposManager.prototype.clearLoadingFlag = function () {
        //Al cambiar un dataset por acción del usuario, limpiar bandera de carga, 
        //ésta bandera evita que se haga el mapeo de parámetros sólo cuando el dataset se cambia por acción del usuario
        this.loading = false;
    };
    CamposManager.prototype.onSelectTabDS = function (args) {
        if (args.heading) {
            Control.invalidateAll();
        }
    };
    CamposManager.prototype.allowDropHandler = function (element, to) {
        //Sólo se permite hacer drop a un complex type
        return to.parent.data.complexType;
    };
    CamposManager.prototype.onSelectParamField = function (item, cell) {
        if (item) {
            cell.item.campoOrigen.namedPath = item.nombre;
        }
        else {
            cell.item.campoOrigen.namedPath = '';
        }
    };
    var CamposManager_1;
    __decorate([
        ViewChild('chkRequerido'),
        __metadata("design:type", ElementRef)
    ], CamposManager.prototype, "chkRequerido", void 0);
    __decorate([
        ViewChild('chkOcurrenciaMin'),
        __metadata("design:type", ElementRef)
    ], CamposManager.prototype, "chkOcurrenciaMin", void 0);
    __decorate([
        ViewChild('chkOcurrenciaMax'),
        __metadata("design:type", ElementRef)
    ], CamposManager.prototype, "chkOcurrenciaMax", void 0);
    __decorate([
        ViewChildren(TabDirective),
        __metadata("design:type", QueryList)
    ], CamposManager.prototype, "tabs", void 0);
    CamposManager = CamposManager_1 = __decorate([
        Component({
            selector: 'bpm-campos-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                [allowDropHandler]=\"fnAllowDrop\"\n                                [title]=\"'Administraci\u00F3n de campos'\"\n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"                          \n                                [nodes]=\"campos\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n\n          <!------------------- Formulario de edici\u00F3n  --------------------->\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"campoEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"campoEdicion.namedPath\"></az-label>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"campoEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <tabset>\n                          <!---------------------GENERALES--------------------->\n                          <tab [heading]=\"'Generales'\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Tipo de nodo:'\">\n                                          <az-combobox formControlName=\"tipoCampo\" [(ngModel)]=\"currentNodeType\" (selectedItemChanged)=\"onFieldTypeChanged($event)\" [items]=\"tiposCampo\" [valueMember]=\"'id'\" [displayMember]=\"'tipo'\" [enabled]=\"campoEdicion.clientID == 0\"></az-combobox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Etiqueta XML:'\">\n                                          <az-textbox formControlName=\"xmlTag\" [(ngModel)]=\"campoEdicion.xmlTag\"></az-textbox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Etiqueta UI:'\">\n                                          <az-textbox formControlName=\"etiqueta\" [(ngModel)]=\"campoEdicion.etiqueta\"></az-textbox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"campoEdicion.nombreLargo\"></az-textarea>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field *ngIf=\"!campoEdicion.complexType\" [label]=\"'Tipo de dato:'\">\n                                          <az-combobox formControlName=\"idTipoDato\" [(ngModel)]=\"campoEdicion.idTipoDato\" [items]=\"tiposDato\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>                                \n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field *ngIf=\"!campoEdicion.complexType\" [label]=\"'Longitud:'\">\n                                          <wj-input-number formControlName=\"longitud\" [(value)]=\"campoEdicion.longitud\" [format]=\"'n0'\"></wj-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n                          <!---------------------DATASET--------------------->\n                          <tab [heading]=\"'Dataset'\" (select)=\"onSelectTabDS($event)\" [disabled]=\"campoEdicion.complexType == true\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Dataset:'\">\n                                          <bpm-dataset-selector formControlName=\"idDataset\" [(ngModel)]=\"campoEdicion.idDataset\" \n                                                                (selectedItemChanged)=\"onSelectedDatasetChanged($event)\"\n                                                                (userSelectionChanged)=\"clearLoadingFlag($event)\"\n                                                                [showListButton]=\"false\"></bpm-dataset-selector>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Miembro visible:'\">\n                                          <az-combobox formControlName=\"displayMember\" [(ngModel)]=\"campoEdicion.displayMember\" [items]=\"currentDataset.columnas\">                                                                                \n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Miembro valor:'\">\n                                          <az-combobox formControlName=\"valueMember\" [(ngModel)]=\"campoEdicion.valueMember\" [items]=\"currentDataset.columnas\">                                        \n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <az-panel [header]=\"'Par\u00E1metros'\">\n                                          <div class=\"row\">\n                                              <div class=\"col-12\">\n                                                  <wj-flex-grid style=\"height:200px; width:100%\" [itemsSource]=\"parametersCollection\">                                                                                                \n                                                      <wj-flex-grid-column [header]=\"'Par\u00E1metro'\" [binding]=\"'nombre'\" [width]=\"'3*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                      <wj-flex-grid-column [header]=\"'Campo Valor'\" [binding]=\"'idCampoOrigen'\" [width]=\"'6*'\" [align]=\"'left'\">\n                                                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                              {{ cell.item.campoOrigen ? cell.item.campoOrigen.namedPath : '' }}\n                                                          </ng-template>\n                                                          <ng-template wjFlexGridCellTemplate [cellType]=\"'CellEdit'\" let-cell=\"cell\">\n                                                              <bpm-campos-autocomplete-cell [cell]=\"cell\" [(value)]=\"cell.value\" [idDocumento]=\"idDocumento\" [version]=\"version\" (selectedItemChanged)=\"onSelectParamField($event, cell)\"></bpm-campos-autocomplete-cell>\n                                                          </ng-template>\n                                                      </wj-flex-grid-column>\n                                                  </wj-flex-grid>\n                                              </div>\n                                          </div>\n                                      </az-panel>\n\n                                  </div> <!--Col-->\n                              </div> <!--Row-->\n                          </tab>\n                          <!---------------------VALIDACIOINES--------------------->\n                          <tab [heading]=\"'Validaciones'\" [disabled]=\"campoEdicion.complexType == true\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <div class=\"checkbox\">\n                                          <label>\n                                              <input type=\"checkbox\" #chkRequerido [checked]=\"campoEdicion.ocurrenciaMinima > 0\"/>Requerido\n                                          </label>\n                                      </div>                                \n                                      <azteca-form-field [label]=\"'L\u00EDmite Inferior:'\">\n                                          <wj-input-number formControlName=\"limiteInferior\" [(value)]=\"campoEdicion.limiteInferior\" [format]=\"'n0'\"></wj-input-number>\n                                      </azteca-form-field>\n                                \n                                      <azteca-form-field [label]=\"'L\u00EDmite Superior:'\">\n                                          <wj-input-number formControlName=\"limiteSuperior\" [(value)]=\"campoEdicion.limiteSuperior\" [format]=\"'n0'\"></wj-input-number>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Expresi\u00F3n Regular:'\">\n                                          <az-textarea formControlName=\"regularExpression\" [(ngModel)]=\"campoEdicion.regularExpression\"></az-textarea>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Campo de correlaci\u00F3n:'\">\n                                          <bpm-campo-selector formControlName=\"campoCorrelacion\" [(ngModel)]=\"campoEdicion.campoCorrelacion\"\n                                                              [showListButton]=\"false\" [showTreeButton]=\"false\" [idDocumento]=\"idDocumento\" [version]=\"version\">\n                                          </bpm-campo-selector>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Valor de correlaci\u00F3n (indique m\u00FAltiples valores separados por un pipe |):'\">\n                                          <az-textarea formControlName=\"expresionCorrelacion\" [(ngModel)]=\"campoEdicion.expresionCorrelacion\"></az-textarea>\n                                      </azteca-form-field>\n                                \n                                  </div>\n                              </div>\n                          </tab>\n                          <!---------------------MULTIPLICIDAD--------------------->\n                          <tab [heading]=\"'Multiplicidad'\" [disabled]=\"campoEdicion.coleccion == false\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <div class=\"checkbox\">\n                                          <label><input type=\"checkbox\" #chkOcurrenciaMin />Definir cantidad m\u00EDnima de elementos</label>\n                                      </div>\n                                      <azteca-form-field  *ngIf=\"chkOcurrenciaMin.checked\" [label]=\"'Ocurrencia m\u00EDnima:'\">\n                                          <wj-input-number formControlName=\"ocurrenciaMinima\" [(value)]=\"campoEdicion.ocurrenciaMinima\" [format]=\"'n0'\"></wj-input-number>\n                                      </azteca-form-field>\n\n                                      <div class=\"checkbox\">\n                                          <label><input type=\"checkbox\" #chkOcurrenciaMax />Definir cantidad m\u00E1xima de elementos</label>\n                                      </div>\n                                      <azteca-form-field  *ngIf=\"chkOcurrenciaMax.checked\" [label]=\"'Ocurrencia m\u00E1xima:'\">\n                                          <wj-input-number formControlName=\"ocurrenciaMaxima\" [(value)]=\"campoEdicion.ocurrenciaMaxima\" [format]=\"'n0'\"></wj-input-number>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n\n              </div>\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return CamposManager_1; })
                },
                {
                    provide: CatalogService, useExisting: CampoService
                }
            ]
        }),
        __metadata("design:paramtypes", [Context, ChangeDetectorRef, FormBuilder,
            Router, ActivatedRoute,
            CampoService, TipoDatoService])
    ], CamposManager);
    return CamposManager;
}(HierarchyManager));
export { CamposManager };
