import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder, FormControl } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from '../../core';
import { CatalogOptions } from '../../custom';
import { HierarchyManager } from '../../editors';
import { ContenedorInfo } from '../models/contenedor';
import { ContenedorService } from '../services/contenedor.service';
export declare class ContenedoresManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private contenedorService;
    protected router: Router;
    protected route: ActivatedRoute;
    contenedores: ContenedorInfo[];
    contenedorEdicion: ContenedorInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    idFormulario: number;
    labelNombre: string;
    tipoControl: FormControl;
    fnAllowDrop: Function;
    readonly CONTAINER: string;
    readonly SECTION: string;
    readonly ACCORDION: number;
    readonly TAB_SET: number;
    readonly GROUP_BOX: number;
    readonly ACCORDION_SECTION: number;
    readonly TAB_PAGE: number;
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, contenedorService: ContenedorService, router: Router, route: ActivatedRoute);
    ngOnInit(): void;
    loadHierarchy(): void;
    setNameLabel(tipoControl: number): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(contenedores: ContenedorInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<ContenedorInfo>): void;
    onValidatingMenu(node: TreeNode): void;
    allowDropHandler(element: TreeNode, to: {
        parent: TreeNode;
        index: number;
    }): boolean;
}
