var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, ChangeDetectorRef } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
//
import { Context, BaseComponent, CatalogService } from '../../core';
import { HierarchyManager } from '../../editors';
//
import { ContenedorInfo } from '../models/contenedor';
import { ContenedorService } from '../services/contenedor.service';
var ContenedoresManager = /** @class */ (function (_super) {
    __extends(ContenedoresManager, _super);
    function ContenedoresManager(context, changeDetector, formBuilder, contenedorService, router, route) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.contenedorService = contenedorService;
        _this.router = router;
        _this.route = route;
        _this.contenedores = [];
        _this.contenedorEdicion = new ContenedorInfo();
        _this.labelNombre = '';
        //
        _this.CONTAINER = 'C';
        _this.SECTION = 'S';
        _this.ACCORDION = 1;
        _this.TAB_SET = 2;
        _this.GROUP_BOX = 3;
        _this.ACCORDION_SECTION = 4;
        _this.TAB_PAGE = 5;
        _this.nodeForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'tipoControl': [1],
            'columnas': [1]
        });
        _this.tipoControl = _this.nodeForm.controls['tipoControl'];
        return _this;
    }
    ContenedoresManager_1 = ContenedoresManager;
    ContenedoresManager.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idFormulario = +params['id'];
        });
        this.tipoControl.valueChanges.subscribe(function (tipo) {
            _this.setNameLabel(+tipo);
        });
        //Asignar handler que determina a que nodos se puede hacer drop
        this.fnAllowDrop = function (element, to) { return _this.allowDropHandler(element, to); };
        this.applyPolicies();
    };
    ////////////////////// METODOS //////////////////////////////////////////////
    ContenedoresManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.contenedorService.loadFormContainers(this.idFormulario, 0)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.contenedores = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContenedoresManager.prototype.setNameLabel = function (tipoControl) {
        switch (tipoControl) {
            case this.ACCORDION:
                this.labelNombre = 'Nombre del acordeón';
                break;
            case this.TAB_SET:
                this.labelNombre = 'Nombre del Tab';
                break;
            case this.GROUP_BOX:
                this.labelNombre = 'Nombre del grupo';
                break;
            case this.ACCORDION_SECTION:
                this.labelNombre = 'Nombre de la sección';
                break;
            case this.TAB_PAGE:
                this.labelNombre = 'Nombre de la página';
                break;
        }
    };
    //////////////////// HANDLERS //////////////////////////////////////
    ContenedoresManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        //Hacer llamadas de carga inicial de datos aquí
    };
    ContenedoresManager.prototype.onNodesChanged = function (contenedores) {
        this.contenedores = contenedores;
    };
    ContenedoresManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    ContenedoresManager.prototype.onCreatingNode = function (parentNode) {
        this.contenedorEdicion = new ContenedorInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset({ 'columnas': 1 });
        this.contenedorEdicion = new ContenedorInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        //Inicializar valores del nodo
        this.contenedorEdicion.idFormulario = this.idFormulario;
        this.contenedorEdicion.idBranch = this.context.app.defaultSite.identity;
        this.contenedorEdicion.idCompany = this.context.app.defaultCompany.identity;
        this.currentParent = parentNode;
        //Determinar el tipo de nodo que se creará basado en el padre
        if (parentNode) {
            //Si el padre es un contenedor, el nodo nuevo deberá ser una sección del tipo de contenedor del padre
            if (parentNode.data.tipo == this.CONTAINER) {
                this.contenedorEdicion.tipo = this.SECTION;
                //El padre es un contenedor de tipo acordeón
                if (parentNode.data.tipoContenedor == 'A') {
                    this.tipoControl.setValue(this.ACCORDION_SECTION);
                }
                //El padre es un contenedor de tipo Tab Set
                if (parentNode.data.tipoContenedor == 'T') {
                    this.tipoControl.setValue(this.TAB_PAGE);
                }
            }
            else {
                this.contenedorEdicion.tipo = this.CONTAINER;
                this.tipoControl.setValue(this.ACCORDION);
            }
        }
        //Si es un nodo raíz
        else {
            this.contenedorEdicion.tipo = this.CONTAINER;
            this.tipoControl.setValue(this.ACCORDION);
        }
        this.showEditor();
    };
    ContenedoresManager.prototype.onEditingNode = function (node) {
        this.contenedorEdicion = this.contenedorService.copy(node.data);
        if (this.contenedorEdicion.tipo == this.CONTAINER) {
            if (this.contenedorEdicion.tipoContenedor == 'A') {
                this.tipoControl.setValue(this.ACCORDION);
            }
            else if (this.contenedorEdicion.tipoContenedor == 'T') {
                this.tipoControl.setValue(this.TAB_SET);
            }
        }
        else {
            if (this.contenedorEdicion.tipoSeccion == 'A') {
                this.tipoControl.setValue(this.ACCORDION_SECTION);
            }
            else if (this.contenedorEdicion.tipoSeccion == 'T') {
                this.tipoControl.setValue(this.TAB_PAGE);
            }
            else {
                this.tipoControl.setValue(this.GROUP_BOX);
            }
        }
        this.showEditor();
    };
    ContenedoresManager.prototype.onSavingNode = function () {
        //Determinar el tipo de contenedor o sección elegida
        switch (+this.tipoControl.value) {
            case this.ACCORDION:
                this.contenedorEdicion.tipoContenedor = 'A';
                break;
            case this.TAB_SET:
                this.contenedorEdicion.tipoContenedor = 'T';
                break;
            case this.ACCORDION_SECTION:
                this.contenedorEdicion.tipoSeccion = 'A';
                break;
            case this.TAB_PAGE:
                this.contenedorEdicion.tipoSeccion = 'T';
                break;
            case this.GROUP_BOX:
                this.contenedorEdicion.tipo = 'S';
                this.contenedorEdicion.tipoSeccion = 'G';
                break;
        }
        //Si es un nuevo nodo
        if (this.contenedorEdicion.clientID == 0) {
            this.addNode(this.contenedorEdicion, this.currentParent);
        }
        //Si se estaba editando un nodo existente
        else {
            this.updateNode(this.contenedorEdicion);
        }
        this.contenedorEdicion = new ContenedorInfo();
        this.hideEditor();
    };
    ContenedoresManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    ContenedoresManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.contenedorService.saveHierarchy(changes)
            .then(function (contenedores) {
            _this.contenedores = contenedores;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContenedoresManager.prototype.onValidatingMenu = function (node) {
        if (node) {
            var container = node.data;
            var mnuChild = this.menuItems.find(function (item) { return item.name == "CHILD"; });
            //Si el nodo actual es un grupo, no permitir crear hijos
            mnuChild.enabled = container.tipoSeccion != 'G';
        }
    };
    ContenedoresManager.prototype.allowDropHandler = function (element, to) {
        //Sólo se permite hacer drop a contenedores del mismo tipo
        return element && to.parent.data && to.parent.data.tipo == 'C' && element.data.tipo == 'S' && (to.parent.data.tipoContenedor == element.data.tipoSeccion);
    };
    var ContenedoresManager_1;
    ContenedoresManager = ContenedoresManager_1 = __decorate([
        Component({
            selector: 'kernel.bpm-contenedores-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                (validatingMenu)=\"onValidatingMenu($event)\"\n                                [allowDropHandler]=\"fnAllowDrop\"\n                                [title]=\"'Administraci\u00F3n de contenedores'\"                          \n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"                          \n                                [nodes]=\"contenedores\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n\t\n          <!------------------- Formulario de edici\u00F3n  --------------------->\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"contenedorEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"contenedorEdicion.namedPath\"></az-label>\n\n                      <az-panel *ngIf=\"contenedorEdicion.tipo=='C' && contenedorEdicion.clientID == 0\" [header]=\"'Tipo de Nodo'\">\n                          <div class=\"form-check\">\n                              <label class=\"form-check-label\">\n                                  <input type=\"radio\" formControlName=\"tipoControl\" class=\"form-check-input\" name=\"tipoControl\" [checked]=\"tipoControl.value==1\" value=\"1\" /> Acorde\u00F3n\n                              </label>\n                          </div>\n                          <div class=\"form-check\">\n                              <label class=\"form-check-label\">\n                                  <input type=\"radio\" formControlName=\"tipoControl\" class=\"form-check-input\" name=\"tipoControl\" [checked]=\"tipoControl.value==2\" value=\"2\" /> Pesta\u00F1as\n                              </label>\n                          </div>\n                          <div class=\"form-check\">\n                              <label class=\"form-check-label\">\n                                  <input type=\"radio\" formControlName=\"tipoControl\" class=\"form-check-input\" name=\"tipoControl\" [checked]=\"tipoControl.value==3\" value=\"3\" /> Grupo\n                              </label>\n                          </div>\n                      </az-panel>                \n\n                  </div>\n              </div>\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"labelNombre\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"contenedorEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n            \n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Columnas:'\">\n                          <az-input-number formControlName=\"columnas\" [(ngModel)]=\"contenedorEdicion.columnas\" [format]=\"'n0'\" [min]=\"1\" [max]=\"3\" [enabled]=\"contenedorEdicion.tipo == 'S'\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n            \n              </div>\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ContenedoresManager_1; })
                },
                {
                    provide: CatalogService, useExisting: ContenedorService
                }
            ]
        }),
        __metadata("design:paramtypes", [Context, ChangeDetectorRef, FormBuilder, ContenedorService,
            Router, ActivatedRoute])
    ], ContenedoresManager);
    return ContenedoresManager;
}(HierarchyManager));
export { ContenedoresManager };
