import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context } from '../../../core';
import { SearchRequest, HierarchySelector, ITreeHost } from '../../../search/index';
import { CampoInfo, CampoItem } from '../../models/campo';
import { CampoService } from '../../services/campo.service';
export declare class CampoSelectorComponent extends HierarchySelector implements ITreeHost {
    protected context: Context;
    private campoService;
    campos: CampoItem[];
    nodes: CampoInfo[];
    selectedItem: CampoInfo;
    idDocumento: number;
    version: number;
    idPadre: number;
    selectedItemChanged: EventEmitter<CampoInfo>;
    constructor(context: Context, campoService: CampoService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CampoItem[]>;
    onKeywordSearch(keyword: string): void;
    onLoadingHierarchy(): void;
    loadChildren(parent: CampoInfo): Promise<CampoInfo[]>;
}
