var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, forwardRef } from '@angular/core';
//
import { BaseComponent, Context } from '../../../core';
import { AutocompleteCell } from '../../../search';
import { CampoService } from '../../services/campo.service';
var CamposAutocompleteCellComponent = /** @class */ (function (_super) {
    __extends(CamposAutocompleteCellComponent, _super);
    function CamposAutocompleteCellComponent(context, campoService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.campoService = campoService;
        //Inputs
        _this.idDocumento = 0;
        _this.version = 0;
        _this.idPadre = 0;
        return _this;
    }
    CamposAutocompleteCellComponent_1 = CamposAutocompleteCellComponent;
    CamposAutocompleteCellComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.itemsSourceHandler = function (keyword, max, callback) { return _this.searchKeyword(keyword, max, callback); };
    };
    CamposAutocompleteCellComponent.prototype.searchKeyword = function (keyword, max, callback) {
        if (keyword && keyword != '') {
            this.campoService.searchKeywordByDocument(this.idDocumento, this.version, this.idPadre, keyword)
                .toPromise()
                .then(function (items) { return callback(items); })
                .catch(function (_) { return callback(null); });
        }
        else {
            callback(null);
        }
    };
    var CamposAutocompleteCellComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CamposAutocompleteCellComponent.prototype, "idDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CamposAutocompleteCellComponent.prototype, "version", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CamposAutocompleteCellComponent.prototype, "idPadre", void 0);
    CamposAutocompleteCellComponent = CamposAutocompleteCellComponent_1 = __decorate([
        Component({
            selector: 'bpm-campos-autocomplete-cell',
            template: "\n      <azteca-autocomplete-cell\n                                [cell]=\"cell\"\n                                [itemsSourceHandler]=\"itemsSourceHandler\"\n                                [maxItems]=\"maxItems\"\n                                [minLength]=\"minLength\"\n                                [displayMember]=\"displayMember\"\n                                [valueMember]=\"valueMember\"\n                                (selectedItemChanged)=\"onSelectedItemChanged($event)\">\n\n      </azteca-autocomplete-cell>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return CamposAutocompleteCellComponent_1; })
                }]
        }),
        __metadata("design:paramtypes", [Context, CampoService])
    ], CamposAutocompleteCellComponent);
    return CamposAutocompleteCellComponent;
}(AutocompleteCell));
export { CamposAutocompleteCellComponent };
