var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, Input } from '@angular/core';
//
//Kernel
import { Context } from '../../../core';
import { ITreeHost, HierarchyTree } from '../../../search/index';
import { CampoService } from '../../services/campo.service';
var CamposTreeComponent = /** @class */ (function (_super) {
    __extends(CamposTreeComponent, _super);
    function CamposTreeComponent(context, campoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.campoService = campoService;
        //
        _this.idDocumento = 0;
        _this.version = 0;
        return _this;
    }
    CamposTreeComponent_1 = CamposTreeComponent;
    CamposTreeComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.idDocumento > 0 && this.version > 0) {
            setTimeout(function (_) { return _this.loadRoots(); });
        }
    };
    CamposTreeComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (changes['idDocumento'] || changes['version']) {
            if (this.idDocumento > 0 && this.version > 0) {
                setTimeout(function (_) { return _this.loadRoots(); });
            }
        }
    };
    CamposTreeComponent.prototype.loadRoots = function () {
        var _this = this;
        this.campoService.loadVersionFields(this.idDocumento, this.version, 0)
            .then(function (campos) {
            _this.campos = campos;
            _this.nodesLoaded.emit(_this.campos);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CamposTreeComponent.prototype.loadChildren = function (parent) {
        return this.campoService.loadChildren(this.context.app.defaultCompany.identity, parent.identity);
    };
    var CamposTreeComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CamposTreeComponent.prototype, "idDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CamposTreeComponent.prototype, "version", void 0);
    CamposTreeComponent = CamposTreeComponent_1 = __decorate([
        Component({
            selector: 'bpm-campos-tree',
            template: "\n      <azteca-hierarchy-tree \n                              [nodes]=\"campos\"\n                              (currentNodeChanged)=\"onCurrentNodeChanged($event)\">\n\n      </azteca-hierarchy-tree>\n    ",
            providers: [{ provide: ITreeHost, useExisting: forwardRef(function () { return CamposTreeComponent_1; }) }]
        }),
        __metadata("design:paramtypes", [Context, CampoService])
    ], CamposTreeComponent);
    return CamposTreeComponent;
}(HierarchyTree));
export { CamposTreeComponent };
