var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, Input } from '@angular/core';
//
//Kernel
import { Context } from '../../../core';
import { ITreeHost, HierarchyTree } from '../../../search/index';
import { ContenedorService } from '../../services/contenedor.service';
var ContenedoresTreeComponent = /** @class */ (function (_super) {
    __extends(ContenedoresTreeComponent, _super);
    function ContenedoresTreeComponent(context, contenedorService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.contenedorService = contenedorService;
        //
        _this.idFormulario = 0;
        return _this;
    }
    ContenedoresTreeComponent_1 = ContenedoresTreeComponent;
    ContenedoresTreeComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.idFormulario > 0) {
            setTimeout(function (_) { return _this.loadRoots(); });
        }
    };
    ContenedoresTreeComponent.prototype.loadRoots = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.contenedorService.loadFormContainers(this.idFormulario, 0)
            .then(function (contenedores) {
            _this.contenedores = contenedores;
            _this.nodesLoaded.emit(_this.contenedores);
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ContenedoresTreeComponent.prototype.loadChildren = function (parent) {
        return this.contenedorService.loadChildren(this.context.app.defaultCompany.identity, parent.identity);
    };
    var ContenedoresTreeComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], ContenedoresTreeComponent.prototype, "idFormulario", void 0);
    ContenedoresTreeComponent = ContenedoresTreeComponent_1 = __decorate([
        Component({
            selector: 'bpm-contenedores-tree',
            template: "\n      <azteca-hierarchy-tree \n                              [nodes]=\"contenedores\"\n                              (currentNodeChanged)=\"onCurrentNodeChanged($event)\">\n\n      </azteca-hierarchy-tree>\n    ",
            providers: [{ provide: ITreeHost, useExisting: forwardRef(function () { return ContenedoresTreeComponent_1; }) }]
        }),
        __metadata("design:paramtypes", [Context, ContenedorService])
    ], ContenedoresTreeComponent);
    return ContenedoresTreeComponent;
}(HierarchyTree));
export { ContenedoresTreeComponent };
