import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs';
import { TypeaheadMatch } from 'ngx-bootstrap';
import { Context } from '../../../core/services/context';
import { BaseControl } from '../../../controls';
import { DatasetService } from '../../services/dataset.service';
export declare class DatasetSearchComponent extends BaseControl implements ControlValueAccessor {
    private context;
    private datasetService;
    private _selectedID;
    private keywordSearchSource;
    private keyword;
    private selectedItem;
    selectedID: number;
    idDataset: number;
    displayMember: string;
    valueMember: string;
    parameters: {
        [name: string]: string;
    };
    constructor(context: Context, datasetService: DatasetService);
    loadItem(itemID: number): void;
    findKeyword(keyword: string): Observable<any[]>;
    typeaheadOnSelect(args: TypeaheadMatch): void;
    changeTypeaheadLoading(loading: boolean): void;
    changeTypeaheadNoResults(noResults: boolean): void;
    markUnselected(): void;
    clear(): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
    handleError(error: any): void;
}
