var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Observable } from 'rxjs';
import { mergeMap } from 'rxjs/operators';
//
import { Context } from '../../../core/services/context';
import { BaseComponent } from '../../../core';
import { BaseControl } from '../../../controls';
import { DatasetService } from '../../services/dataset.service';
var DatasetSearchComponent = /** @class */ (function (_super) {
    __extends(DatasetSearchComponent, _super);
    function DatasetSearchComponent(context, datasetService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.datasetService = datasetService;
        _this.keyword = '';
        _this.selectedItem = null;
        _this.propagateChange = function (_) { };
        _this.keywordSearchSource = Observable.create(function (observer) {
            observer.next(_this.keyword);
        })
            .pipe(mergeMap(function (keyword) { return _this.findKeyword(keyword); }));
        return _this;
    }
    DatasetSearchComponent_1 = DatasetSearchComponent;
    Object.defineProperty(DatasetSearchComponent.prototype, "selectedID", {
        get: function () {
            return this._selectedID;
        },
        set: function (value) {
            if (value != this._selectedID) {
                this._selectedID = value ? value : 0;
                this.loadItem(this._selectedID);
            }
        },
        enumerable: true,
        configurable: true
    });
    DatasetSearchComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.datasetService.getSearchEntry(this.idDataset, this.parameters, this.valueMember, itemID)
                .then(function (info) {
                _this.keyword = info[_this.displayMember];
                _this.selectedItem = info;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.keyword = '';
            this.selectedItem = null;
        }
    };
    DatasetSearchComponent.prototype.findKeyword = function (keyword) {
        return this.datasetService.searchDataset(this.idDataset, this.parameters, this.displayMember, this.keyword);
    };
    DatasetSearchComponent.prototype.typeaheadOnSelect = function (args) {
        if (args.item != null) {
            var value = args.item[this.valueMember];
            this._selectedID = value;
            this.selectedItem = args.item;
            this.propagateChange(value);
            this.keyword = args.item[this.displayMember];
        }
        else {
            this._selectedID = 0;
            this.propagateChange(0);
            this.keyword = '';
            this.selectedItem = null;
        }
    };
    DatasetSearchComponent.prototype.changeTypeaheadLoading = function (loading) {
    };
    DatasetSearchComponent.prototype.changeTypeaheadNoResults = function (noResults) {
    };
    DatasetSearchComponent.prototype.markUnselected = function () {
        this._selectedID = 0;
        this.propagateChange(0);
    };
    DatasetSearchComponent.prototype.clear = function () {
        this.selectedID = 0;
        this.selectedItem = null;
        this.propagateChange(0);
    };
    DatasetSearchComponent.prototype.writeValue = function (value) {
        this.selectedID = value ? value : 0;
    };
    DatasetSearchComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    DatasetSearchComponent.prototype.registerOnTouched = function () { };
    DatasetSearchComponent.prototype.handleError = function (error) {
        console.log(error);
    };
    var DatasetSearchComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], DatasetSearchComponent.prototype, "selectedID", null);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], DatasetSearchComponent.prototype, "idDataset", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DatasetSearchComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DatasetSearchComponent.prototype, "valueMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DatasetSearchComponent.prototype, "parameters", void 0);
    DatasetSearchComponent = DatasetSearchComponent_1 = __decorate([
        Component({
            selector: 'bpm-dataset-search',
            template: "\n      <div class=\"input-group\">\n          <input type=\"text\" class=\"form-control\" [(ngModel)]=\"keyword\" [disabled]=\"!enabled\"\n                 [typeahead]=\"keywordSearchSource\"\n                 (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n                 (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n                 (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n                 typeaheadOptionsLimit=\"20\"\n                 [typeaheadOptionField]=\"displayMember\"\n                 typeaheadMinLength=\"2\"\n                 typeaheadWaitMs=\"500\"\n                 placeholder=\"Introduzca b\u00FAsqueda...\" />\n\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"clear()\" *ngIf=\"selectedItem != null && enabled\">\n                  <span class=\"glyphicon glyphicon-remove\"></span>\n              </button>\n          </span>\n\n      </div>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return DatasetSearchComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return DatasetSearchComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Context, DatasetService])
    ], DatasetSearchComponent);
    return DatasetSearchComponent;
}(BaseControl));
export { DatasetSearchComponent };
