import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from '../../../core';
import { SearchRequest, CatalogSelector } from '../../../search/index';
import { DatasetInfo, DatasetItem } from '../../models/dataset';
import { DatasetService } from '../../services/dataset.service';
export declare class DatasetSelectorComponent extends CatalogSelector {
    protected context: Context;
    private datasetService;
    datasets: DatasetItem[];
    selectedItem: DatasetInfo;
    selectedItemChanged: EventEmitter<DatasetInfo>;
    constructor(context: Context, datasetService: DatasetService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
}
