import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { ToolbarButton } from '../../controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from '../../editors';
import { DatasetService } from '../services/dataset.service';
import { DatasetInfo } from '../models/dataset';
import { DatasetValor } from '../models/dataset-valor';
import { DatasetParametro } from '../models/dataset-parametro';
import { DatasetValueEditor } from './parts/dataset-value.editor';
import { DatasetCampo } from '../models/dataset-campo';
import { DatasetFiltro } from '../models/dataset-filtro';
import { DatasetCampoEditor } from './parts/dataset-campo.editor';
import { DatasetFiltroEditor } from './parts/dataset-filtro.editor';
import { DatasetParameterEditor } from './parts/dataset-parameter.editor';
import { DocumentoService } from '../services/documento.service';
import { DocumentoItem } from '../models/documento';
export declare class DatasetsEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private datasetService;
    private documentoService;
    dataset: DatasetInfo;
    tiposDataset: any[];
    documentos: DocumentoItem[];
    staticValuesCollection: TrackableCollection;
    parametersCollection: TrackableCollection;
    camposCollection: TrackableCollection;
    filtrosCollection: TrackableCollection;
    newStaticValue: DatasetValor;
    newParametro: DatasetParametro;
    newCampoEntidad: DatasetCampo;
    newFiltroEntidad: DatasetFiltro;
    valueEditor: DatasetValueEditor;
    parameterEditor: DatasetParameterEditor;
    campoEditor: DatasetCampoEditor;
    filtroEditor: DatasetFiltroEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, datasetService: DatasetService, documentoService: DocumentoService);
    loadDocumentos(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onStaticToolbar(button: ToolbarButton): void;
    onStaticValueUpdated(newValue: DatasetValor): void;
    onStaticRowDelete(row: DatasetValor): void;
    onCamposToolbar(button: ToolbarButton): void;
    onCampoDelete(campo: DatasetCampo): void;
    onCampoUpdated(campo: DatasetCampo): void;
    onFiltrosToolbar(button: ToolbarButton): void;
    onFiiltroDelete(filtro: DatasetFiltro): void;
    onFiltroUpdated(filtro: DatasetFiltro): void;
    onParametersToolbar(button: ToolbarButton): void;
    onParameterDelete(parametro: DatasetParametro): void;
    onParameterUpdated(parametro: DatasetParametro): void;
    onSelectTab(args: any): void;
}
