import { OnInit } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, BaseComponent, Deferred, PolicyInfo } from '../../core';
import { ToolbarButton, AlertsBarComponent } from '../../controls';
import { IEditor } from '../../editors';
import { ContenedorInfo } from '../models/contenedor';
import { FormularioService } from '../services/formulario.service';
import { FormularioInfo, FormularioItem } from '../models/formulario';
import { FormControl } from '../models/form-control';
import { AddControlEditor } from '../components/parts/add-control.editor';
import { FormControlEditor } from '../components/parts/form-control.editor';
import { CarouselEditor } from '../components/parts/carousel.editor';
import { MapEditor } from '../components/parts/map.editor';
export declare class FormularioControlesComponent extends BaseComponent implements OnInit, IEditor {
    private context;
    private router;
    private route;
    private formularioService;
    title: string;
    idFormulario: number;
    formulario: FormularioInfo;
    controles: FormControl[];
    contenedores: ContenedorInfo[];
    formularios: FormularioItem[];
    currentContainer: ContenedorInfo;
    currentFormControl: FormControl;
    dirty: boolean;
    canceled: boolean;
    defDiscardChanges: Deferred<boolean>;
    newControlDialog: AddControlEditor;
    controlEditor: FormControlEditor;
    carouselEditor: CarouselEditor;
    mapEditor: MapEditor;
    alerts: AlertsBarComponent;
    confirmDelDialog: ModalDirective;
    discardDialog: ModalDirective;
    confirmSaveDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, formularioService: FormularioService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadFormularios(): void;
    loadFormulario(): void;
    loadControls(): void;
    saveControls(): Promise<any>;
    setContainerControls(contenedores: ContenedorInfo[]): void;
    getControls(contenedores: ContenedorInfo[]): FormControl[];
    findField(idCampo: number, contenedores: ContenedorInfo[]): FormControl;
    copy(control: FormControl): FormControl;
    showAlert(message: string, type: string): void;
    confirmDiscard(): Promise<boolean>;
    discardChanges(): void;
    cancelDiscard(): void;
    onCurrentContainerChanged(node: ContenedorInfo): void;
    onMainToolbar(button: ToolbarButton): void;
    onControlToolbar(button: ToolbarButton): void;
    onContainersLoaded(nodes: ContenedorInfo[]): void;
    onControlAdded(control: FormControl): void;
    onEditControl(formControl: FormControl): boolean;
    onControlUpdated(control: FormControl): void;
    onDeleteControl(formControl: FormControl): boolean;
    onConfirmDelete(): void;
    onChangeControls(controls: FormControl[]): void;
    onEditColumns(formControl: FormControl): boolean;
    onConfirmSaveChanges(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
