var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Azteca Kernel
import { Context, BaseComponent, Deferred } from '../../core';
import { AlertsBarComponent } from '../../controls';
import { ChangeState } from '../../editors';
//Features
import { ContenedorInfo } from '../models/contenedor';
import { FormularioService } from '../services/formulario.service';
import { FormularioInfo } from '../models/formulario';
import { FormControl } from '../models/form-control';
import { ControlType } from '../models/control-type';
import { AddControlEditor } from '../components/parts/add-control.editor';
import { FormControlEditor } from '../components/parts/form-control.editor';
import { CarouselEditor } from '../components/parts/carousel.editor';
import { MapEditor } from '../components/parts/map.editor';
var FormularioControlesComponent = /** @class */ (function (_super) {
    __extends(FormularioControlesComponent, _super);
    function FormularioControlesComponent(context, router, route, formularioService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formularioService = formularioService;
        _this.title = '';
        _this.idFormulario = 0;
        _this.formulario = new FormularioInfo();
        _this.controles = [];
        _this.contenedores = [];
        _this.formularios = [];
        _this.currentContainer = new ContenedorInfo();
        _this.currentFormControl = new FormControl();
        //Implementación de IEditor
        _this.dirty = false;
        _this.canceled = false;
        return _this;
    }
    FormularioControlesComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idFormulario = +params['id'];
        });
    };
    FormularioControlesComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadFormulario(); });
    };
    ///////////// METODOS /////////////////////////////////////////////////////////////////////////////
    FormularioControlesComponent.prototype.loadFormularios = function () {
        var _this = this;
        this.formularioService.loadList(this.formulario.idDocumento, this.formulario.version)
            .then(function (formularios) {
            //Excluir el formulario actual
            if (formularios) {
                _this.formularios = formularios.filter(function (form) { return form.id != _this.idFormulario; });
            }
            else {
                _this.formularios = [];
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormularioControlesComponent.prototype.loadFormulario = function () {
        var _this = this;
        this.formularioService.getDetailByID(this.idFormulario)
            .then(function (form) {
            _this.formulario = form;
            _this.title = 'Contenedores - ' + _this.formulario.nombre;
            //Cargar la lista de formularios
            _this.loadFormularios();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormularioControlesComponent.prototype.loadControls = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.formularioService.loadFormControls(this.idFormulario)
            .then(function (controls) {
            _this.controles = controls;
            _this.context.app.hideSpinner();
            //Recorrer árbol de contenedores y asignar contrles
            _this.setContainerControls(_this.contenedores);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormularioControlesComponent.prototype.saveControls = function () {
        var _this = this;
        var controls = this.getControls(this.contenedores);
        this.context.app.showSpinner();
        return this.formularioService.saveFormControls(this.idFormulario, controls)
            .then(function (controles) {
            _this.controles = controles;
            _this.context.app.hideSpinner();
            //Recorrer árbol de contenedores y asignar contrles
            _this.setContainerControls(_this.contenedores);
            _this.dirty = false;
            _this.alerts.showAlert('La información ha sido guardada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormularioControlesComponent.prototype.setContainerControls = function (contenedores) {
        var _this = this;
        contenedores.forEach(function (contenedor) {
            contenedor.controles = _this.controles.filter(function (control) { return control.idContenedor == contenedor.identity; });
            if (contenedor.children && contenedor.children.length > 0) {
                _this.setContainerControls(contenedor.children);
            }
        });
    };
    FormularioControlesComponent.prototype.getControls = function (contenedores) {
        var _this = this;
        var controls = [];
        contenedores.forEach(function (contenedor) {
            controls = controls.concat(contenedor.controles);
            if (contenedor.children && contenedor.children.length > 0) {
                controls = controls.concat(_this.getControls(contenedor.children));
            }
        });
        return controls;
    };
    FormularioControlesComponent.prototype.findField = function (idCampo, contenedores) {
        var _this = this;
        var control = null;
        contenedores.forEach(function (contenedor) {
            if (!control) {
                control = contenedor.controles.find(function (c) { return c.field.identity == idCampo && c.state != ChangeState.DELETED; });
                if (!control && contenedor.children && contenedor.children.length > 0) {
                    control = _this.findField(idCampo, contenedor.children);
                }
            }
        });
        return control;
    };
    FormularioControlesComponent.prototype.copy = function (control) {
        return JSON.parse(JSON.stringify(control));
    };
    //Implementación de IEditor
    FormularioControlesComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    FormularioControlesComponent.prototype.confirmDiscard = function () {
        this.discardDialog.config.backdrop = false;
        this.discardDialog.show();
        this.defDiscardChanges = new Deferred();
        return this.defDiscardChanges.promise;
    };
    FormularioControlesComponent.prototype.discardChanges = function () {
        this.discardDialog.hide();
        this.defDiscardChanges.resolve(true);
    };
    FormularioControlesComponent.prototype.cancelDiscard = function () {
        this.discardDialog.hide();
        this.defDiscardChanges.resolve(false);
    };
    ///////////// HANDLERS //////////////////////////////////////////////////////////////
    FormularioControlesComponent.prototype.onCurrentContainerChanged = function (node) {
        this.currentContainer = node;
    };
    FormularioControlesComponent.prototype.onMainToolbar = function (button) {
        if (button.name == 'SAVE') {
            this.saveControls();
        }
        else if (button.name == 'CLOSE') {
            this.canceled = true;
            this.router.navigate(['../../'], { relativeTo: this.route });
        }
    };
    FormularioControlesComponent.prototype.onControlToolbar = function (button) {
        if (button.name == 'ADD') {
            this.newControlDialog.show();
        }
    };
    FormularioControlesComponent.prototype.onContainersLoaded = function (nodes) {
        var _this = this;
        this.contenedores = nodes;
        setTimeout(function (_) { return _this.loadControls(); });
    };
    FormularioControlesComponent.prototype.onControlAdded = function (control) {
        //Verificar que no exista ya un control enlazado al campo que se intenta agregar
        var existingControl = this.findField(control.field.identity, this.contenedores);
        if (!existingControl) {
            control.idContenedor = this.currentContainer.identity;
            var newControls = this.currentContainer.controles.slice();
            newControls.push(control);
            this.currentContainer.controles = newControls;
            this.dirty = true;
        }
        else {
            this.alerts.showAlert('El campo que intenta agregar ya existe en el formulario.', 'warning');
        }
    };
    FormularioControlesComponent.prototype.onEditControl = function (formControl) {
        this.currentFormControl = this.copy(formControl);
        if (formControl.control.tag == ControlType.CAROUSEL) {
            this.carouselEditor.show();
        }
        else if (formControl.control.tag == ControlType.MULTI_POINT_MAP) {
            this.mapEditor.show();
        }
        else {
            this.controlEditor.show();
        }
        return false;
    };
    FormularioControlesComponent.prototype.onControlUpdated = function (control) {
        var index = this.currentContainer.controles.findIndex(function (c) { return c.idCampo == control.field.identity && c.state != ChangeState.DELETED; });
        var newControls = this.currentContainer.controles.slice();
        newControls[index] = control;
        this.currentContainer.controles = newControls;
        this.dirty = true;
    };
    FormularioControlesComponent.prototype.onDeleteControl = function (formControl) {
        this.currentFormControl = formControl;
        this.confirmDelDialog.config.backdrop = false;
        this.confirmDelDialog.show();
        return false;
    };
    FormularioControlesComponent.prototype.onConfirmDelete = function () {
        this.currentFormControl.state = ChangeState.DELETED;
        this.confirmDelDialog.hide();
        this.dirty = true;
    };
    FormularioControlesComponent.prototype.onChangeControls = function (controls) {
        controls.forEach(function (c) {
            if (c.state == ChangeState.UNCHANGED) {
                c.state = ChangeState.MODIFIED;
            }
        });
        this.currentContainer.controles = controls;
    };
    FormularioControlesComponent.prototype.onEditColumns = function (formControl) {
        this.currentFormControl = formControl;
        //Si no hay cambios pendientes por guardar, enviar directamente a editor de columnas. En caso contrario confirmar si quiere guardar
        if (!this.dirty) {
            this.router.navigate([formControl.id + '/columnas'], { relativeTo: this.route });
        }
        else {
            this.confirmSaveDialog.config.backdrop = false;
            this.confirmSaveDialog.show();
        }
        return false;
    };
    FormularioControlesComponent.prototype.onConfirmSaveChanges = function () {
        this.saveControls();
        this.confirmSaveDialog.hide();
    };
    FormularioControlesComponent.prototype.applyPolicy = function (policy) {
    };
    FormularioControlesComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        ViewChild(AddControlEditor),
        __metadata("design:type", AddControlEditor)
    ], FormularioControlesComponent.prototype, "newControlDialog", void 0);
    __decorate([
        ViewChild(FormControlEditor),
        __metadata("design:type", FormControlEditor)
    ], FormularioControlesComponent.prototype, "controlEditor", void 0);
    __decorate([
        ViewChild(CarouselEditor),
        __metadata("design:type", CarouselEditor)
    ], FormularioControlesComponent.prototype, "carouselEditor", void 0);
    __decorate([
        ViewChild(MapEditor),
        __metadata("design:type", MapEditor)
    ], FormularioControlesComponent.prototype, "mapEditor", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], FormularioControlesComponent.prototype, "alerts", void 0);
    __decorate([
        ViewChild('confirmDelDialog'),
        __metadata("design:type", ModalDirective)
    ], FormularioControlesComponent.prototype, "confirmDelDialog", void 0);
    __decorate([
        ViewChild('discardChangesDialog'),
        __metadata("design:type", ModalDirective)
    ], FormularioControlesComponent.prototype, "discardDialog", void 0);
    __decorate([
        ViewChild('confirmSaveDialog'),
        __metadata("design:type", ModalDirective)
    ], FormularioControlesComponent.prototype, "confirmSaveDialog", void 0);
    FormularioControlesComponent = __decorate([
        Component({
            selector: 'bpm-formulario-controles',
            template: "\n      <alerts-bar></alerts-bar>\n      <!--------------------------TEMPLATE PARA SORTABLE DE CONTROLES --------------------------------------->\n      <ng-template #itemTemplate let-item=\"item\" let-index=\"index\">\n          <div *ngIf=\"item.initData.state != 'DELETED'\" class=\"card-body\">\n              <div class=\"row\">\n                  <div class=\"col-10\">\n                      <b>{{item.initData.control.nombre}}</b>\n                      <br />\n                      <i>{{item.initData.field.namedPath}}</i>\n                  </div>\n                  <div class=\"col-2\">\n                      <div class=\"dropdown pull-right\">\n                          <button class=\"btn btn-secondary dropdown-toggle\" type=\"button\" id=\"dropdownMenuButton\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\">\n                              <span class=\"glyphicon glyphicon-cog\"></span>\n                          </button>\n                          <div class=\"dropdown-menu dropdown-menu-right\">\n                              <a class=\"dropdown-item\" href=\"#\" (click)=\"onEditControl(item.initData)\">Editar control</a>\n                              <a *ngIf=\"item.initData.control.tag == 'GRID'\" class=\"dropdown-item\" (click)=\"onEditColumns(item.initData)\" href=\"#\">Editar columnas</a>\n                              <div class=\"dropdown-divider\"></div>\n                              <a class=\"dropdown-item\" href=\"#\" (click)=\"onDeleteControl(item.initData)\">Eliminar</a>\n                          </div>\n                      </div>\n                  </div>\n              </div>\n          </div>\n      </ng-template>\n\n      <div class=\"row\">\n\n          <!-----------------------------PANEL CON \u00C1RBOL DE CONTENEDORES DEL FORMULARIO------------------------------------>\n          <div class=\"col-12\">\n\n              <az-toolbar (buttonClick)=\"onMainToolbar($event)\">\n                  <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\"></az-toolbar-button>\n                  <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Cerrar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n              </az-toolbar>\n\n          </div>\n      </div>\n      <div class=\"row\">\n          <div class=\"col-12 col-md-6\">\n              <az-panel [header]=\"title\">\n                  <bpm-contenedores-tree [idFormulario]=\"idFormulario\" \n                                         (currentNodeChanged)=\"onCurrentContainerChanged($event)\"\n                                         (nodesLoaded)=\"onContainersLoaded($event)\"></bpm-contenedores-tree>\n              </az-panel>\n          </div>\n\n          <!------------------------------PANEL CON LISTA DE CONTROLES DEL CONTENEDOR ACTUAL----------------------------------->\n          <div class=\"col-12 col-md-6\">\n              <az-panel [header]=\"'Controles'\">\n\n                  <az-toolbar (buttonClick)=\"onControlToolbar($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar control'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"currentContainer && currentContainer.tipo == 'S'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'LIST'\" [toolTip]=\"'Agregar a trav\u00E9s de listado'\" [icon]=\"'glyphicon glyphicon-list-alt'\" [enabled]=\"currentContainer && currentContainer.tipo == 'S'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <bs-sortable\n                              (onChange)=\"onChangeControls($event)\"\n                              [(ngModel)]=\"currentContainer.controles\"\n                              [itemTemplate]=\"itemTemplate\"\n                              itemClass=\"card\"\n                              itemActiveClass=\"card card-outline-primary\"\n                              placeholderItem=\"Contenedor vac\u00EDo...\">\n                  </bs-sortable>\n              </az-panel>\n          </div>\n      </div>\n\n\n      <!----------------------------DIALOGO PARA CONFIRMAR ELIMINACI\u00D3N DE CONTROLES------------------------------------->\n      <div bsModal #confirmDelDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <div>\u00BFEst\u00E1 seguro que desea eliminar el control?</div>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"confirmDelDialog.hide()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"onConfirmDelete()\">Aceptar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n\n      <!-----------------------------DIALOGO PARA ALTA DE NUEVOS CONTROLES------------------------------------>\n      <bpm-add-control-editor \n                              [idDocumento]=\"formulario.idDocumento\" \n                              [version]=\"formulario.version\" \n                              [idPadre]=\"formulario.idCampoDominio\"\n                              (controlAdded)=\"onControlAdded($event)\">\n      </bpm-add-control-editor>\n\n      <!-----------------------------DIALOGO DE EDICI\u00D3N DE CONTROLES------------------------------------>\n\n      <bpm-form-control-editor \n                                  [idDocumento]=\"formulario.idDocumento\" \n                                  [version]=\"formulario.version\" \n                                  [control]=\"currentFormControl\" \n                                  [childForms]=\"formularios\"\n                                  [containerColumns]=\"currentContainer.columnas\" \n                                  (controlUpdated)=\"onControlUpdated($event)\">\n      </bpm-form-control-editor>\n\n\n      <!-----------------------------DIALOGO DE EDICI\u00D3N DE CAROUSEL ------------------------------------>\n      <bpm-carousel-editor [idDocumento]=\"formulario.idDocumento\"\n                               [version]=\"formulario.version\"\n                               [control]=\"currentFormControl\"\n                               [childForms]=\"formularios\"\n                               [containerColumns]=\"currentContainer.columnas\"\n                               (controlUpdated)=\"onControlUpdated($event)\">\n      </bpm-carousel-editor>\n\n      <!-----------------------------DIALOGO DE EDICI\u00D3N DE CAROUSEL ------------------------------------>\n      <bpm-map-editor [idDocumento]=\"formulario.idDocumento\"\n                           [version]=\"formulario.version\"\n                           [control]=\"currentFormControl\"\n                           [childForms]=\"formularios\"\n                           [containerColumns]=\"currentContainer.columnas\"\n                           (controlUpdated)=\"onControlUpdated($event)\">\n      </bpm-map-editor>\n\n\n      <!-----------------------------DIALOGO DE CONFIRMACI\u00D3N PARA DESCARTAR CAMBIOS ------------------------------------>\n      <div bsModal #discardChangesDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <p>Existen cambios sin guardar. \u00BFDesea descartarlos?</p>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"cancelDiscard()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"discardChanges()\">Descartar</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n\n      <!--------------------------DIALOGO DE CONFIRMACI\u00D3N PARA GUARDAR CAMBIOS ANTES DE ABRIR EDITOR DE COLUMNAS ------------>\n      <div bsModal #confirmSaveDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <p>Debe guardar los cambios hasta el momento antes de abrir el editor de columnas</p>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onConfirmSaveChanges()\">Guardar</button>\n                      <button type=\"button\" class=\"btn btn-secondary\" (click)=\"confirmSaveDialog.hide()\">Canclear</button>\n                  </div> <!--Modal Footer-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute,
            FormularioService])
    ], FormularioControlesComponent);
    return FormularioControlesComponent;
}(BaseComponent));
export { FormularioControlesComponent };
