import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { MenuItem } from '../../controls';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { FormularioService } from '../services/formulario.service';
import { FormularioInfo } from '../models/formulario';
import { DocumentoService } from '../services/documento.service';
import { CampoItem } from '../models/campo';
export declare class FormulariosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private formularioService;
    private documentoService;
    idDocumento: number;
    version: number;
    formulario: FormularioInfo;
    dominios: CampoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, formularioService: FormularioService, documentoService: DocumentoService);
    ngOnInit(): void;
    loadDominios(idDocumento: number, version: number): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(item: MenuItem): void;
}
