import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { MenuItem } from '../../controls';
import { FormularioService } from '../services/formulario.service';
import { FormularioItem } from '../models/formulario';
export declare class FormulariosManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private formularioService;
    formularios: FormularioItem[];
    idDocumento: number;
    version: number;
    constructor(router: Router, route: ActivatedRoute, context: Context, formularioService: FormularioService);
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(item: MenuItem): void;
}
