import { OnInit } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, BaseComponent, PolicyInfo } from '../../core';
import { ToolbarButton, AlertsBarComponent } from '../../controls';
import { FormularioService } from '../services/formulario.service';
import { GridControl } from '../models/grid-control';
import { GridColumn } from '../models/grid-column';
import { GridColumnEditor } from './parts/grid-column.editor';
export declare class GridColumnsEditor extends BaseComponent implements OnInit {
    private context;
    private router;
    private route;
    private formularioService;
    title: string;
    idFormulario: number;
    idControlGrid: number;
    gridControl: GridControl;
    currentColumn: GridColumn;
    private _lastColID;
    columnEditor: GridColumnEditor;
    confirmDelDialog: ModalDirective;
    alerts: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formularioService: FormularioService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadGridControl(): void;
    save(): void;
    copy(original: GridColumn): GridColumn;
    onMainToolbarClick(button: ToolbarButton): void;
    onChangeColumns(columns: GridColumn[]): void;
    onEditColumn(column: GridColumn): boolean;
    onDeleteColumn(column: GridColumn): boolean;
    onConfirmDelete(): void;
    onColumnUpdated(column: GridColumn): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
