import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, ProcessComponent, PolicyInfo } from '../../core';
import { AlertsBarComponent, ToolbarButton } from '../../controls';
import { DocumentoService } from '../services/documento.service';
import { DocumentoItem } from '../models/documento';
import { InstanceItem } from '../models/instance-item';
import { InstanceListComponent } from './parts/instance-list.component';
import { WorkflowStep } from '../models/workflow-step';
export declare class InstanceManager extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private documentService;
    form: FormGroup;
    documentTypes: DocumentoItem[];
    instanceList: InstanceItem[];
    idTipoDocumento: number;
    selectedDocType: DocumentoItem;
    fechaInicial: Date;
    fechaFinal: Date;
    alerts: AlertsBarComponent;
    listComponent: InstanceListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, documentService: DocumentoService);
    ngAfterViewInit(): void;
    onParamsToolbar(button: ToolbarButton): void;
    onOpeningInstance(instance: InstanceItem): void;
    onActionExecuted(): void;
    onDocumentReturned(instance: InstanceItem): void;
    onCreatingInstance(step: WorkflowStep): void;
    onSelectedDocumentChanged(idDocumento: number): void;
    loadTiposDocumento(): void;
    loadInstanceList(): void;
    applyPolicy(policy: PolicyInfo): void;
    handlerError(error: any): void;
}
