var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Kernel
import { Context } from '../../../core';
//
import { Activity } from '../../models/activity';
import { FormularioService } from '../../services/formulario.service';
var ActivityEditor = /** @class */ (function () {
    function ActivityEditor(context, formularioService, formBuilder) {
        this.context = context;
        this.formularioService = formularioService;
        this.formBuilder = formBuilder;
        this.formularios = [];
        this.activityCopy = new Activity();
        this.activity = new Activity();
        //Outputs
        this.activityUpdated = new EventEmitter();
        this.form = formBuilder.group({
            'tag': ['', Validators.required],
            'actionText': [''],
            'statusText': [''],
            'idFormulario': [0],
            'duracion': [0],
            'offline': [false],
            'isEnd': [false]
        });
    }
    ActivityEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadFormularios(); });
    };
    //////////////////////////////////// METODOS /////////////////////////////////////////////
    ActivityEditor.prototype.loadFormularios = function () {
        var _this = this;
        this.formularioService.loadList(this.idDocumento, this.version)
            .then(function (formularios) { return _this.formularios = formularios; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ActivityEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.load(); });
    };
    ActivityEditor.prototype.load = function () {
        this.activityCopy = this.copy(this.activity);
    };
    ActivityEditor.prototype.copy = function (activity) {
        return JSON.parse(JSON.stringify(activity));
    };
    //////////////////////////////////// HANDLERS /////////////////////////////////////////////
    ActivityEditor.prototype.onUpdate = function () {
        this.activityUpdated.emit(this.activityCopy);
        this.dialog.hide();
    };
    ActivityEditor.prototype.handleError = function (error) {
        console.log(error);
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], ActivityEditor.prototype, "idDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], ActivityEditor.prototype, "version", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ActivityEditor.prototype, "activity", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ActivityEditor.prototype, "activityUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], ActivityEditor.prototype, "dialog", void 0);
    ActivityEditor = __decorate([
        Component({
            selector: 'bpm-activity-editor',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n\n                      <div class=\"modal-header\"> <!--Modal Header-->\n                          <h4>Editar informaci\u00F3n de la actividad</h4>\n                          <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div> <!--Modal Header-->\n                      <div class=\"modal-body\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n\n                                  <azteca-form-field [label]=\"'Etiqueta (ID):'\">\n                                      <az-textbox formControlName=\"tag\" [(ngModel)]=\"activityCopy.tag\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Nombre de la acci\u00F3n:'\">\n                                      <az-textbox formControlName=\"actionText\" [(ngModel)]=\"activityCopy.actionText\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Nombre del estatus:'\">\n                                      <az-textbox formControlName=\"statusText\" [(ngModel)]=\"activityCopy.statusText\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Formulario:'\">\n                                      <az-combobox formControlName=\"idFormulario\" [(ngModel)]=\"activityCopy.idFormulario\" [items]=\"formularios\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Duraci\u00F3n (horas):'\">\n                                      <az-input-number formControlName=\"duracion\" [(ngModel)]=\"activityCopy.duracion\" [format]=\"'n2'\"></az-input-number>\n                                  </azteca-form-field>\n\n                                  <az-checkbox [label]=\"'El paso se ejecuta fuera de l\u00EDnea'\" formControlName=\"offline\" [(ngModel)]=\"activityCopy.offline\"></az-checkbox>\n                                  <az-checkbox [label]=\"'El flujo termina en \u00E9ste paso'\" formControlName=\"isEnd\" [(ngModel)]=\"activityCopy.isEnd\"></az-checkbox>\n                              </div>\n                          </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!form.valid\">Aceptar</button>    \n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"dialog.hide()\">Cancelar</button>                    \n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div> <!--Modal directive-->\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [Context, FormularioService, FormBuilder])
    ], ActivityEditor);
    return ActivityEditor;
}());
export { ActivityEditor };
