var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, Input, Output, EventEmitter } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Features
import { DatasetFiltro } from '../../models/dataset-filtro';
var DatasetFiltroEditor = /** @class */ (function () {
    function DatasetFiltroEditor(formBuilder) {
        this.formBuilder = formBuilder;
        //Inputs
        this.data = new DatasetFiltro();
        //outputs
        this.dataUpdated = new EventEmitter();
        this.editorForm = formBuilder.group({
            'parametro': ['', Validators.required],
            'xmlPath': ['', Validators.required]
        });
    }
    DatasetFiltroEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
    };
    DatasetFiltroEditor.prototype.onUpdate = function () {
        this.dataUpdated.emit(this.data);
        this.dialog.hide();
    };
    __decorate([
        Input(),
        __metadata("design:type", DatasetFiltro)
    ], DatasetFiltroEditor.prototype, "data", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DatasetFiltroEditor.prototype, "dataUpdated", void 0);
    __decorate([
        ViewChild('dialog'),
        __metadata("design:type", ModalDirective)
    ], DatasetFiltroEditor.prototype, "dialog", void 0);
    DatasetFiltroEditor = __decorate([
        Component({
            selector: 'bpm-dataset-filtro-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Nuevo filtro de entidad</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n\n                                  <azteca-form-field [label]=\"'XML Path:'\">\n                                      <az-textbox formControlName=\"xmlPath\" [(ngModel)]=\"data.xmlPath\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Par\u00E1metro:'\">\n                                      <az-textbox formControlName=\"parametro\" [(ngModel)]=\"data.parametro\"></az-textbox>\n                                  </azteca-form-field>\n\n                              </div>\n                          </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], DatasetFiltroEditor);
    return DatasetFiltroEditor;
}());
export { DatasetFiltroEditor };
