var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, Input, Output, EventEmitter } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//Bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Features
import { DatasetValor } from '../../models/dataset-valor';
var DatasetValueEditor = /** @class */ (function () {
    function DatasetValueEditor(formBuilder) {
        this.formBuilder = formBuilder;
        //Inputs
        this.data = new DatasetValor();
        //outputs
        this.dataUpdated = new EventEmitter();
        this.editorForm = formBuilder.group({
            'etiqueta': ['', Validators.required],
            'valor': ['', Validators.required]
        });
    }
    DatasetValueEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
    };
    DatasetValueEditor.prototype.onCancel = function () {
        this.dialog.hide();
    };
    DatasetValueEditor.prototype.onUpdate = function () {
        this.dataUpdated.emit(this.data);
        this.dialog.hide();
    };
    __decorate([
        Input(),
        __metadata("design:type", DatasetValor)
    ], DatasetValueEditor.prototype, "data", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DatasetValueEditor.prototype, "dataUpdated", void 0);
    __decorate([
        ViewChild('dialog'),
        __metadata("design:type", ModalDirective)
    ], DatasetValueEditor.prototype, "dialog", void 0);
    DatasetValueEditor = __decorate([
        Component({
            selector: 'bpm-dataset-value-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Nuevo valor est\u00E1tico</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n\n                              <azteca-form-field [label]=\"'Etiqueta:'\">\n                                  <az-textbox formControlName=\"etiqueta\" [(ngModel)]=\"data.etiqueta\"></az-textbox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Valor:'\">\n                                  <az-textbox formControlName=\"valor\" [(ngModel)]=\"data.valor\"></az-textbox>\n                              </azteca-form-field>\n\n                          </div>\n                      </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancel()\">Cancelar</button>                    \n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form> \n    "
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], DatasetValueEditor);
    return DatasetValueEditor;
}());
export { DatasetValueEditor };
