var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder } from '@angular/forms';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//
import { Context } from '../../../core';
import { AztecaValidators } from '../../../controls';
import { ChangeState } from '../../../editors';
//
import { ControlService } from '../../services/control.service';
import { FormularioService } from '../../services/formulario.service';
import { FormControl } from '../../models/form-control';
var FormControlEditor = /** @class */ (function () {
    function FormControlEditor(context, formBuilder, controlService, formularioService) {
        var _this = this;
        this.context = context;
        this.formBuilder = formBuilder;
        this.controlService = controlService;
        this.formularioService = formularioService;
        this.controles = [];
        this.valid = true;
        //Inputs
        this.childForms = [];
        this.control = new FormControl();
        this.idDocumento = 0;
        this.version = 0;
        this.containerColumns = 1;
        //Outputs
        this.controlUpdated = new EventEmitter();
        this.form = this.formBuilder.group({
            'idControl': [0, AztecaValidators.selected],
            'width': [0],
            'height': [0],
            'idChildForm': [0],
            'readonly': [false],
            'formato': ['']
        });
        //
        this.form.statusChanges.subscribe(function () {
            setTimeout(function (_) { return _this.changeFormStatus(); });
        });
    }
    //////////// METODOS //////////////////////////
    FormControlEditor.prototype.changeFormStatus = function () {
        this.valid = this.form.valid;
    };
    FormControlEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.loadControls(); });
    };
    FormControlEditor.prototype.loadControls = function () {
        var _this = this;
        //Si el campo es una colección, cargar controles especializados, si no, cargar controles configurados para el tipo de datos
        if (this.control.field.complexType && this.control.field.coleccion) {
            this.controles = this.controlService.getCollectionControls();
        }
        else if (!this.control.field.complexType && this.control.field.idDataset > 0) {
            this.controles = this.controlService.getDatasetControls();
        }
        else if (!this.control.field.complexType) {
            this.controlService.loadListByTipoDato(this.control.field.idTipoDato)
                .then(function (controles) { return _this.controles = controles; })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.controles = [];
        }
    };
    FormControlEditor.prototype.loadControl = function () {
        var _this = this;
        this.controlService.getDetailByID(this.control.idControl)
            .then(function (control) {
            _this.control.control = control;
            _this.controlUpdated.emit(_this.control);
            _this.dialog.hide();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////// HANDLERS //////////////////////////
    FormControlEditor.prototype.onUpdate = function () {
        this.control.state = ChangeState.MODIFIED;
        //Cargar información del control seleccionado y notificar sobre control agregado
        this.loadControl();
    };
    FormControlEditor.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], FormControlEditor.prototype, "childForms", void 0);
    __decorate([
        Input(),
        __metadata("design:type", FormControl)
    ], FormControlEditor.prototype, "control", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], FormControlEditor.prototype, "idDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], FormControlEditor.prototype, "version", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], FormControlEditor.prototype, "containerColumns", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], FormControlEditor.prototype, "controlUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], FormControlEditor.prototype, "dialog", void 0);
    FormControlEditor = __decorate([
        Component({
            selector: 'bpm-form-control-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n\n                          <label>Campo:</label>\n                          <az-label [text]=\"control.field.namedPath\"></az-label>\n\n                          <azteca-form-field [label]=\"'Control:'\">\n                              <az-combobox \n                                          [enabled]=\"!control.field.coleccion\"\n                                          formControlName=\"idControl\"\n                                          [(ngModel)]=\"control.idControl\"\n                                          [items]=\"controles\"\n                                          [valueMember]=\"'id'\"\n                                          [displayMember]=\"'nombre'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                    \n                          <azteca-form-field [label]=\"'Ancho:'\">\n                              <az-input-number formControlName=\"width\" [(ngModel)]=\"control.width\" [min]=\"1\" [max]=\"containerColumns\"></az-input-number>\n                          </azteca-form-field>\n\n                          <azteca-form-field *ngIf=\"control.field.coleccion\" [label]=\"'Alto:'\">\n                              <az-input-number formControlName=\"height\" [(ngModel)]=\"control.height\"></az-input-number>\n                          </azteca-form-field>                                       \n\n                          <azteca-form-field *ngIf=\"control.field.coleccion\" [label]=\"'Formulario de edici\u00F3n:'\">\n                              <az-combobox \n                                              formControlName=\"idChildForm\" \n                                              [(ngModel)]=\"control.idChildForm\" \n                                              [items]=\"childForms\" \n                                              [valueMember]=\"'id'\"\n                                              [displayMember]=\"'nombre'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Formato:'\">\n                              <az-textbox formControlName=\"formato\" [(ngModel)]=\"control.formato\"></az-textbox>\n                          </azteca-form-field>\n\n                          <az-checkbox [label]=\"'S\u00F3lo lectura'\" formControlName=\"readonly\" [(ngModel)]=\"control.readOnly\"></az-checkbox>\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate($event)\" [disabled]=\"!valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div>\n      </form> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder, ControlService, FormularioService])
    ], FormControlEditor);
    return FormControlEditor;
}());
export { FormControlEditor };
