import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from '../../../core';
import { CampoSelectorComponent } from '../controls/campo-selector.component';
import { GridColumn } from '../../models/grid-column';
import { CampoInfo } from '../../models/campo';
export declare class GridColumnEditor {
    private context;
    private formBuilder;
    private changeDetector;
    editForm: FormGroup;
    alignments: {
        id: string;
        name: string;
    }[];
    column: GridColumn;
    idDocumento: number;
    version: number;
    idPadre: number;
    columnUpdated: EventEmitter<GridColumn>;
    dialog: ModalDirective;
    campoSelector: CampoSelectorComponent;
    constructor(context: Context, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef);
    show(): void;
    selectAction(): void;
    onUpdate(): void;
    onCampoSelected(campo: CampoInfo): void;
    handleError(error: any): void;
}
