import { EventEmitter, SimpleChange } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { CollectionView } from 'wijmo/wijmo';
import { Context, BaseComponent, PolicyInfo } from '../../../core';
import { MenuItem, ContentViewerComponent } from '../../../controls';
import { WorkflowService } from '../../services/workflow.service';
import { WorkflowStep } from '../../models/workflow-step';
import { DocumentoService } from '../../services/documento.service';
import { DocumentoInfo } from '../../models/documento';
import { VersionInfo } from '../../models/version';
import { InstanceItem } from '../../models/instance-item';
export declare class InstanceListComponent extends BaseComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private documentService;
    private workflowService;
    menuItems: MenuItem[];
    _list: InstanceItem[];
    instanceCollection: CollectionView;
    documento: DocumentoInfo;
    activeVersion: VersionInfo;
    instanceVersion: VersionInfo;
    currentInstance: InstanceItem;
    currentWorkflow: WorkflowStep[];
    activeWorkflow: WorkflowStep[];
    idDocumento: number;
    allowNew: boolean;
    list: InstanceItem[];
    readonly pageSize: number;
    pagetSize: number;
    creatingInstance: EventEmitter<WorkflowStep>;
    openingInstance: EventEmitter<InstanceItem>;
    executingAction: EventEmitter<{
        action: string;
        instance: InstanceItem;
    }>;
    actionExecuted: EventEmitter<{
        action: string;
        instance: InstanceItem;
    }>;
    documentReturned: EventEmitter<InstanceItem>;
    contentViewer: ContentViewerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, documentService: DocumentoService, workflowService: WorkflowService);
    ngOnChanges(changes: SimpleChange): void;
    private gridInitialized;
    private onToolbarButtonClick;
    private menuClick;
    private selectMenuAction;
    private onOpeningMenu;
    createMenu(): void;
    createInstance(idStartForm: number): void;
    loadInstanceVersion(): void;
    loadActiveWorkflow(): void;
    loadDocumentTypeInfo(): void;
    openInstance(instance: InstanceItem): void;
    executeAction(idDocumento: number, version: number, actionTag: string, folio: string): void;
    previousStep(): void;
    applyPolicy(policy: PolicyInfo): void;
    toPascalCase(s: string): string;
    handleError(error: any): void;
}
