var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//
import { Context } from '../../../core';
import { AztecaValidators } from '../../../controls';
import { ChangeState } from '../../../editors';
//
import { ControlService } from '../../services/control.service';
import { FormularioService } from '../../services/formulario.service';
import { CarouselControl } from '../../models/carousel-control';
import { ControlType } from '../../models/control-type';
var MapEditor = /** @class */ (function () {
    function MapEditor(context, formBuilder, controlService, formularioService, changeDetector) {
        var _this = this;
        this.context = context;
        this.formBuilder = formBuilder;
        this.controlService = controlService;
        this.formularioService = formularioService;
        this.changeDetector = changeDetector;
        this.controles = [];
        this.valid = true;
        //Inputs
        this.childForms = [];
        this.control = new CarouselControl();
        this.idDocumento = 0;
        this.version = 0;
        this.containerColumns = 1;
        //Outputs
        this.controlUpdated = new EventEmitter();
        this.form = this.formBuilder.group({
            'idLocationField': [0, AztecaValidators.selected],
            'idTitleField': [0],
            'idLegendField': [0],
            'iconIndex': [0],
            'width': [0],
            'height': [0],
            'idChildForm': [0],
            'readonly': [false]
        });
        //
        this.form.statusChanges.subscribe(function () {
            setTimeout(function (_) { return _this.changeFormStatus(); });
        });
    }
    //////////// METODOS //////////////////////////
    MapEditor.prototype.changeFormStatus = function () {
        this.valid = this.form.valid;
    };
    MapEditor.prototype.show = function () {
        this.dialog.config.backdrop = false;
        this.dialog.show();
    };
    MapEditor.prototype.loadControlInfo = function () {
        var _this = this;
        //Obtener el id del control mapa
        var item = this.controlService.getCollectionControls()
            .find(function (c) { return c.tag == ControlType.MULTI_POINT_MAP; });
        //Cargar información del control carousel
        this.controlService.getDetailByID(item.id)
            .then(function (control) {
            _this.control.control = control;
            _this.controlUpdated.emit(_this.control);
            _this.dialog.hide();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////// HANDLERS //////////////////////////
    MapEditor.prototype.onUpdate = function () {
        this.control.state = ChangeState.MODIFIED;
        //Cargar información del control seleccionado y notificar sobre control agregado
        this.loadControlInfo();
    };
    MapEditor.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], MapEditor.prototype, "childForms", void 0);
    __decorate([
        Input(),
        __metadata("design:type", CarouselControl)
    ], MapEditor.prototype, "control", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapEditor.prototype, "idDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapEditor.prototype, "version", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapEditor.prototype, "containerColumns", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], MapEditor.prototype, "controlUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], MapEditor.prototype, "dialog", void 0);
    MapEditor = __decorate([
        Component({
            selector: 'bpm-map-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n\n                          <label>Campo:</label>\n                          <az-label [text]=\"control.field.namedPath\"></az-label>\n\n                          <label>Control:</label>\n                          <az-label [text]=\"'Mapa multi puntos'\"></az-label>\n\n                          <azteca-form-field [label]=\"'Campo de ubicaci\u00F3n:'\">\n                              <bpm-campo-selector formControlName=\"idLocationField\"\n                                                  [(ngModel)]=\"control.idLocationField\"\n                                                  [idDocumento]=\"idDocumento\"\n                                                  [version]=\"version\"\n                                                  [idPadre]=\"control.field.identity\"\n                                                  [showListButton]=\"false\"\n                                                  [showTreeButton]=\"false\">\n                              </bpm-campo-selector>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Campo de t\u00EDtulo:'\">\n                              <bpm-campo-selector formControlName=\"idTitleField\"\n                                                  [(ngModel)]=\"control.idTitleField\"\n                                                  [idDocumento]=\"idDocumento\"\n                                                  [version]=\"version\"\n                                                  [idPadre]=\"control.field.identity\"\n                                                  [showListButton]=\"false\"\n                                                  [showTreeButton]=\"false\">\n                              </bpm-campo-selector>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Campo de descripci\u00F3n:'\">\n                              <bpm-campo-selector formControlName=\"idLegendField\"\n                                                  [(ngModel)]=\"control.idLegendField\"\n                                                  [idDocumento]=\"idDocumento\"\n                                                  [version]=\"version\"\n                                                  [idPadre]=\"control.field.identity\"\n                                                  [showListButton]=\"false\"\n                                                  [showTreeButton]=\"false\">\n                              </bpm-campo-selector>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'\u00CDndice de icono:'\">\n                              <bpm-campo-selector formControlName=\"iconIndex\"\n                                                  [(ngModel)]=\"control.iconIndex\"\n                                                  [idDocumento]=\"idDocumento\"\n                                                  [version]=\"version\"\n                                                  [idPadre]=\"control.field.identity\"\n                                                  [showListButton]=\"false\"\n                                                  [showTreeButton]=\"false\">\n                              </bpm-campo-selector>\n                          </azteca-form-field>\n\n\n                          <azteca-form-field [label]=\"'Ancho:'\">\n                              <az-input-number formControlName=\"width\" [(ngModel)]=\"control.width\" [min]=\"1\" [max]=\"containerColumns\"></az-input-number>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Alto:'\">\n                              <az-input-number formControlName=\"height\" [(ngModel)]=\"control.height\"></az-input-number>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Formulario de edici\u00F3n:'\">\n                              <az-combobox formControlName=\"idChildForm\"\n                                           [(ngModel)]=\"control.idChildForm\"\n                                           [items]=\"childForms\"\n                                           [valueMember]=\"'id'\"\n                                           [displayMember]=\"'nombre'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate($event)\" [disabled]=\"!valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div>\n      </form> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder, ControlService, FormularioService,
            ChangeDetectorRef])
    ], MapEditor);
    return MapEditor;
}());
export { MapEditor };
