import { FormBuilder, FormGroup } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, ProcessComponent, PolicyInfo, EnsambladoService, EnsambladoItem } from '../../core';
import { ToolbarButton } from '../../controls';
import { TrackableCollection } from '../../editors';
import { DocumentoService } from '../services/documento.service';
import { VersionInfo } from '../models/version';
import { VersionColumn } from '../models/version-column';
import { CampoInfo } from '../models/campo';
import { CampoSelectorComponent } from '../components/controls/campo-selector.component';
export declare class VersionesEditor extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private documentoService;
    private ensambladoService;
    info: VersionInfo;
    editorForm: FormGroup;
    ensamblados: EnsambladoItem[];
    columnsCollection: TrackableCollection;
    idDocumento: number;
    currentColumn: VersionColumn;
    addColumnDialog: ModalDirective;
    columnField: CampoSelectorComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, documentoService: DocumentoService, ensambladoService: EnsambladoService);
    ngAfterViewInit(): void;
    loadEnsamblados(): void;
    loadVersion(version: number): void;
    saveVersion(): void;
    applyPolicy(policy: PolicyInfo): void;
    onMainToolbarClick(button: ToolbarButton): void;
    onColumnsToolbarClick(button: ToolbarButton): void;
    onRowDelete(row: VersionColumn): void;
    addColumn(): void;
    onCampoSelected(campo: CampoInfo): void;
    onColumnsSelect(args: any): void;
    handleError(error: any): void;
}
