var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, Input } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//WIjmo
import { CollectionView } from 'wijmo/wijmo';
import { CellRange } from 'wijmo/wijmo.grid';
//Azteca Kernel
import { Context, BaseComponent, ProcessComponent } from '../../core';
import { DocumentoService } from '../services/documento.service';
var VersionesManager = /** @class */ (function (_super) {
    __extends(VersionesManager, _super);
    function VersionesManager(context, router, route, documentoService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.documentoService = documentoService;
        _this.idDocumento = 0;
        _this.versiones = [];
        _this.collectionView = new CollectionView();
        _this.menuItems = [];
        //
        _this.enabled = true;
        return _this;
    }
    VersionesManager_1 = VersionesManager;
    VersionesManager.prototype.ngOnInit = function () {
        this.collectionView.pageSize = 10;
    };
    VersionesManager.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.createMenu(); });
        setTimeout(function (_) { return _this.loadVersiones(); });
        this.applyPolicies();
    };
    //////////////// Metodos ///////////////////////
    VersionesManager.prototype.initialized = function (sender, args) {
        var self = this;
        //Agregar manejador para menú contextual        
        sender.addEventListener(sender.hostElement, "contextmenu", function (e) {
            var ht = sender.hitTest(e);
            sender.select(new CellRange(ht.row, ht.col), true);
        });
    };
    VersionesManager.prototype.loadVersiones = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idDocumento = +params['id'];
        });
        if (this.idDocumento > 0) {
            this.documentoService.loadVersiones(this.idDocumento)
                .then(function (versiones) {
                _this.versiones = versiones;
                _this.collectionView.sourceCollection = _this.versiones;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    VersionesManager.prototype.createMenu = function () {
        //Agregar opciones estándar del catálogo
        var mnuEdit = { icon: "glyphicon glyphicon-pencil", text: "Editar", name: "EDIT", smallText: "abrir en modo de edición" };
        var mnuFields = { icon: "fa fa-sitemap", text: "Campos...", name: "FIELDS", smallText: "abrir editor de campos" };
        var mnuForms = { icon: "glyphicon glyphicon-modal-window", text: "Formularios...", name: "FORMS", smallText: "abrir editor de formularios" };
        var mnuWorkflow = { icon: "glyphicon glyphicon-random", text: "Flujo...", name: "WORKFLOW", smallText: "editar flujo de trabajo" };
        this.menuItems.push(mnuEdit, mnuFields, mnuForms, mnuWorkflow);
        //
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    VersionesManager.prototype.selecteItem = function (item) {
        if (!this.collectionView.currentItem)
            return;
        var version = this.collectionView.currentItem.version;
        if (item.name == 'EDIT') {
            this.router.navigate([version], { relativeTo: this.route });
        }
        if (item.name == 'FIELDS') {
            this.router.navigate(['kernel/bpm/campos', this.process.id, { idDocumento: this.idDocumento, version: version }]);
        }
        if (item.name == 'FORMS') {
            this.router.navigate(['kernel/bpm/formularios', this.process.id, { idDocumento: this.idDocumento, version: version }]);
        }
        if (item.name == 'WORKFLOW') {
            this.router.navigate(['kernel/bpm/workflow', this.process.id, { idDocumento: this.idDocumento, version: version }]);
        }
    };
    /////////////// HANDLERS ////////////////////
    VersionesManager.prototype.onMenuItemClick = function (menu) {
        var item = this.menuItems[menu.selectedIndex];
        //
        this.selecteItem(item);
    };
    VersionesManager.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.router.navigate([0], { relativeTo: this.route });
        }
    };
    VersionesManager.prototype.applyPolicy = function (policy) {
    };
    VersionesManager.prototype.handleError = function (error) {
        console.error(error);
    };
    var VersionesManager_1;
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], VersionesManager.prototype, "enabled", void 0);
    VersionesManager = VersionesManager_1 = __decorate([
        Component({
            selector: 'bpm-versiones-manager',
            template: "\n      <wj-menu #ctxMenu (itemClicked)=\"onMenuItemClick(ctxMenu, $event)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuItems\">\n              <div *ngIf=\"enabled && item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n\n\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"'Administrador de versiones'\">\n\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\" (menuItemClick)=\"selecteItem($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Nueva'\" [toolTip]=\"'Agregar nueva versi\u00F3n'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-menu [name]=\"'OPT'\" [header]=\"'Opciones'\" [menuItems]=\"menuItems\"></az-toolbar-menu>\n                  </az-toolbar>\n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <wj-flex-grid #grid style=\"height:500px\"\n                                        (initialized)=\"initialized(grid, $event)\"\n                                        [itemsSource]=\"collectionView\"\n                                        [selectionMode]=\"'Row'\"\n                                        [isReadOnly]=\"true\"\n                                        [wjContextMenu]=\"ctxMenu\">\n\n                              <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                              <wj-flex-grid-column [header]=\"'Versi\u00F3n'\" [binding]=\"'version'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Fecha Creaci\u00F3n'\" [binding]=\"'fecha'\" dataType=\"Date\" [format]=\"'dd/MM/yyyy'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Creador'\" [binding]=\"'creador'\" [width]=\"'40*'\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'20*'\"></wj-flex-grid-column>\n\n                          </wj-flex-grid>\n                      </div>\n                  </div>\n\n                  <!--Pager-->\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <az-pager [totalRows]=\"collectionView.totalItemCount\"\n                                    [pageSize]=\"collectionView.pageSize\"\n                                    [pageIndex]=\"collectionView.pageIndex\"\n                                    (moveToPage)=\"collectionView.moveToPage($event)\">\n\n                          </az-pager>\n                      </div>\n                  </div>\n\n              </az-panel>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return VersionesManager_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute, DocumentoService])
    ], VersionesManager);
    return VersionesManager;
}(ProcessComponent));
export { VersionesManager };
