import { HierarchyInfo, CatalogItem } from '../../core';
import { CampoParametro } from '../models/campo-parametro';
import { TipoDatoInfo } from '../models/tipo-dato';
export declare class CampoInfo extends HierarchyInfo<CampoInfo> {
    idDocumento: number;
    version: number;
    etiqueta: string;
    xmlTag: string;
    nombreLargo: string;
    idTipoDato: number;
    longitud: number;
    idDataset: number;
    displayMember: string;
    valueMember: string;
    complexType: boolean;
    coleccion: boolean;
    classPath: string;
    memberPath: string;
    xmlPath: string;
    ocurrenciaMaxima: number;
    ocurrenciaMinima: number;
    limiteInferior: number;
    limiteSuperior: number;
    regularExpression: string;
    campoCorrelacion: number;
    expresionCorrelacion: string;
    expresionValidacion: string;
    readonly icon: string;
    tipoDato: TipoDatoInfo;
    parametros: CampoParametro[];
    constructor();
}
export declare class CampoItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    selected: boolean;
    estatus?: string;
}
