var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, Output, EventEmitter, ViewChildren, QueryList } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Control } from 'wijmo/wijmo';
import { PositionComponent } from '../../geolocation';
import { CollectionEventArgs } from './collection-event-args';
//
var DynamicComponent = /** @class */ (function () {
    function DynamicComponent() {
        this.parameters = {};
        this.datasets = {};
        this.correlaciones = {};
        this.mapIcons = [];
        //
        this.initialiezed = new EventEmitter();
        this.addingCollectionItem = new EventEmitter();
        this.editingCollectionItem = new EventEmitter();
        this.deletingCollectionItem = new EventEmitter();
        this.formStateChange = new EventEmitter();
    }
    DynamicComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.initialiezed.emit();
        //Lanzar estatus inicial de la forma y suscribirse a cambios de estatus posteriores
        setTimeout(function (_) { return _this.formStateChange.emit(_this.form.valid); });
        this.form.statusChanges.subscribe(function () {
            _this.formStateChange.emit(_this.form.valid);
        });
    };
    DynamicComponent.prototype.onTabPageSelected = function (args) {
        //Al seleccionar una página de un tab, refrescar controles
        if (args.heading) {
            Control.invalidateAll();
            //Si existen mapas, recargarlos (optimizar evitando llamar a refresh si previamente ya se visitó la pestaña)
            this.maps.forEach(function (map) { return map.refresh(); });
        }
    };
    DynamicComponent.prototype.onCollectionToolbar = function (button, idCollectionField, collectionMember) {
        var args = new CollectionEventArgs();
        args.action = button.name;
        args.idCampo = idCollectionField;
        args.memberPath = collectionMember;
        if (button.name == 'ADD') {
            this.addingCollectionItem.emit(args);
        }
        else if (button.name == 'EDIT') {
        }
        else if (button.name == 'DELETE') {
        }
    };
    DynamicComponent.prototype.onEditCollectionItem = function (colItem, idCollectionField, collectionMember) {
        var args = new CollectionEventArgs();
        args.action = 'EDIT';
        args.idCampo = idCollectionField;
        args.memberPath = collectionMember;
        args.item = colItem;
        this.editingCollectionItem.emit(args);
    };
    DynamicComponent.prototype.onDeleteCollectionItem = function (colItem, idCollectionField, collectionMember) {
        var args = new CollectionEventArgs();
        args.action = 'DELETE';
        args.idCampo = idCollectionField;
        args.memberPath = collectionMember;
        args.item = colItem;
        this.deletingCollectionItem.emit(args);
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "model", void 0);
    __decorate([
        Input(),
        __metadata("design:type", FormGroup)
    ], DynamicComponent.prototype, "form", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "parameters", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "datasets", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "correlaciones", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], DynamicComponent.prototype, "mapIcons", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "initialiezed", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "addingCollectionItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "editingCollectionItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "deletingCollectionItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DynamicComponent.prototype, "formStateChange", void 0);
    __decorate([
        ViewChildren(PositionComponent),
        __metadata("design:type", QueryList)
    ], DynamicComponent.prototype, "maps", void 0);
    return DynamicComponent;
}());
export { DynamicComponent };
