var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { ControlInfo } from '../models/control';
import { ControlType } from '../models/control-type';
var ControlService = /** @class */ (function (_super) {
    __extends(ControlService, _super);
    function ControlService(http, context) {
        return _super.call(this, http, context, "api/kernel/bpm/controles") || this;
    }
    ControlService.prototype.create = function () {
        return Promise.resolve(new ControlInfo());
    };
    ControlService.prototype.loadListByTipoDato = function (idTipoDato) {
        var params = new HttpParams()
            .set('idTipoDato', idTipoDato.toString());
        //
        return this.apiService.get('controles-tipo-dato', params)
            .toPromise();
    };
    ControlService.prototype.getCollectionControls = function () {
        var controls = [];
        controls.push({ id: 6, codigo: '6', nombre: 'Tabla', tag: ControlType.GRID, activo: true });
        controls.push({ id: 16, codigo: '16', nombre: 'Galería de imágenes', tag: ControlType.CAROUSEL, activo: true });
        controls.push({ id: 17, codigo: '17', nombre: 'Mapa', tag: ControlType.MULTI_POINT_MAP, activo: true });
        return controls;
    };
    ControlService.prototype.getDatasetControls = function () {
        var controls = [];
        controls.push({ id: 4, codigo: '4', nombre: 'Lista desplegable', tag: ControlType.COMBOBOX, activo: true });
        controls.push({ id: 15, codigo: '15', nombre: 'Autocompletable', tag: ControlType.AUTOCOMPLETE, activo: true });
        return controls;
    };
    ControlService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], ControlService);
    return ControlService;
}(CatalogService));
export { ControlService };
