var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { DatasetInfo } from '../models/dataset';
var DatasetService = /** @class */ (function (_super) {
    __extends(DatasetService, _super);
    function DatasetService(http, context) {
        return _super.call(this, http, context, "api/kernel/bpm/datasets") || this;
    }
    DatasetService.prototype.create = function () {
        return Promise.resolve(new DatasetInfo());
    };
    DatasetService.prototype.getDataset = function (idDataset, parametros) {
        var params = new HttpParams()
            .set("idDataset", idDataset.toString());
        //
        return this.apiService.post('result', params, parametros)
            .toPromise();
    };
    DatasetService.prototype.searchDataset = function (idDataset, parametros, searchField, keyword) {
        var params = new HttpParams()
            .set("idDataset", idDataset.toString())
            .set("searchField", searchField)
            .set("keyword", keyword);
        //
        return this.apiService.post('search-dataset', params, parametros);
    };
    DatasetService.prototype.getSearchEntry = function (idDataset, parameters, valueField, id) {
        var params = new HttpParams()
            .set("idDataset", idDataset.toString())
            .set("valueField", valueField)
            .set("id", id.toString());
        //
        return this.apiService.post('search-entry', params, parameters)
            .toPromise();
    };
    DatasetService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], DatasetService);
    return DatasetService;
}(CatalogService));
export { DatasetService };
