import { HttpClient } from '@angular/common/http';
import { Context, CatalogService } from '../../core';
import { DocumentoInfo, DocumentoItem } from '../models/documento';
import { VersionInfo, VersionItem } from '../models/version';
import { CampoItem } from '../models/campo';
import { DocumentInstance } from '../models/document-instance';
import { InstanceItem } from '../models/instance-item';
export declare class DocumentoService extends CatalogService<DocumentoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<DocumentoInfo>;
    loadVersiones(idDocumento: number): Promise<VersionItem[]>;
    loadVersion(idDocumento: number, version: number): Promise<VersionInfo>;
    saveVersion(idDocumento: number, version: VersionInfo): Promise<VersionInfo>;
    loadActiveVersion(idDocumento: number): Promise<VersionInfo>;
    loadDominios(idDocumento: number, version: number): Promise<CampoItem[]>;
    loadList(idSucursal: number): Promise<DocumentoItem[]>;
    loadListByUser(idSucursal: number, idUsuario: number): Promise<DocumentoItem[]>;
    createInstance(idDocumento: number, version: number): Promise<DocumentInstance>;
    loadInstance(folio: string): Promise<DocumentInstance>;
    createCollectionItem(idDocumento: number, version: number, idCollectionField: number): Promise<any>;
    updateCollectionItem(idDocumento: number, version: number, idCollectionField: number, collectionItem: any): Promise<any>;
    loadInstanceList(idDocumento: number, fechaInicial: Date, fechaFinal: Date): Promise<InstanceItem[]>;
    saveInstance(instance: DocumentInstance): Promise<DocumentInstance>;
    nextStep(instance: DocumentInstance, idNextStep: number): Promise<DocumentInstance>;
    previousStep(folio: string): Promise<DocumentInstance>;
    executeUnboundAction(idDocumento: number, version: number, actionTag: string, folio: string): Promise<string>;
}
