var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import { map } from 'rxjs/operators';
//
import * as moment from 'moment';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { DocumentoInfo } from '../models/documento';
var DocumentoService = /** @class */ (function (_super) {
    __extends(DocumentoService, _super);
    function DocumentoService(http, context) {
        return _super.call(this, http, context, 'api/kernel/bpm/documentos') || this;
    }
    DocumentoService.prototype.create = function () {
        return Promise.resolve(new DocumentoInfo());
    };
    DocumentoService.prototype.loadVersiones = function (idDocumento) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString());
        //
        return this.apiService.get('versiones', params)
            .pipe(map(function (versiones) {
            //Convertir campo de fecha
            versiones.forEach(function (version) {
                version.fecha = new Date(version.fecha);
            });
            return versiones;
        }))
            .toPromise();
    };
    DocumentoService.prototype.loadVersion = function (idDocumento, version) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString());
        //
        return this.apiService.get('version', params)
            .toPromise();
    };
    DocumentoService.prototype.saveVersion = function (idDocumento, version) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString());
        //
        return this.apiService.post('save-version', params, version)
            .toPromise();
    };
    DocumentoService.prototype.loadActiveVersion = function (idDocumento) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString());
        //
        return this.apiService.get('active-version', params)
            .toPromise();
    };
    DocumentoService.prototype.loadDominios = function (idDocumento, version) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString());
        //
        return this.apiService.get('dominios', params)
            .toPromise();
    };
    DocumentoService.prototype.loadList = function (idSucursal) {
        var params = new HttpParams()
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.get('list', params)
            .toPromise();
    };
    DocumentoService.prototype.loadListByUser = function (idSucursal, idUsuario) {
        var params = new HttpParams()
            .set('idSucursal', idSucursal.toString())
            .set('idUsuario', idUsuario.toString());
        //
        return this.apiService.get('user-list', params)
            .toPromise();
    };
    DocumentoService.prototype.createInstance = function (idDocumento, version) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString());
        //
        return this.apiService.get('create-instance-json', params)
            .toPromise();
    };
    DocumentoService.prototype.loadInstance = function (folio) {
        var params = new HttpParams()
            .set('folio', folio);
        //
        return this.apiService.get('load-instance-json', params)
            .toPromise();
    };
    DocumentoService.prototype.createCollectionItem = function (idDocumento, version, idCollectionField) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString())
            .set('idCollectionField', idCollectionField.toString());
        //
        return this.apiService.get('create-collection-item', params)
            .toPromise();
    };
    DocumentoService.prototype.updateCollectionItem = function (idDocumento, version, idCollectionField, collectionItem) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString())
            .set('idCollectionField', idCollectionField.toString());
        //
        return this.apiService.post('update-collection-item', params, collectionItem)
            .toPromise();
    };
    DocumentoService.prototype.loadInstanceList = function (idDocumento, fechaInicial, fechaFinal) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('fechaInicial', moment(fechaInicial).format())
            .set('fechaFinal', moment(fechaFinal).format());
        //
        return this.apiService.get('instance-list', params).pipe(map(function (items) {
            items.forEach(function (item) {
                item.fecha = moment(item.fecha).toDate();
                item.hora = moment(item.hora).toDate();
            });
            return items;
        }))
            .toPromise();
    };
    DocumentoService.prototype.saveInstance = function (instance) {
        var params = new HttpParams();
        //
        return this.apiService.post('save-instance-json', params, instance)
            .toPromise();
    };
    DocumentoService.prototype.nextStep = function (instance, idNextStep) {
        var params = new HttpParams()
            .set('idNextStep', idNextStep.toString());
        //
        return this.apiService.post('next-step', params, instance)
            .toPromise();
    };
    DocumentoService.prototype.previousStep = function (folio) {
        var params = new HttpParams()
            .set('folio', folio);
        //
        return this.apiService.get('previous-step', params)
            .toPromise();
    };
    DocumentoService.prototype.executeUnboundAction = function (idDocumento, version, actionTag, folio) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString())
            .set('actionTag', actionTag)
            .set('folio', folio);
        //
        return this.apiService.getText('execute-unbound-action', params)
            .toPromise();
    };
    DocumentoService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], DocumentoService);
    return DocumentoService;
}(CatalogService));
export { DocumentoService };
