import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from '../../core';
import { FormularioInfo, FormularioItem } from '../models/formulario';
import { FormControl } from '../models/form-control';
import { MapIcon } from '../../geolocation/models/map-icon';
export declare class FormularioService extends CatalogService<FormularioInfo> {
    private _mapIconsBuffer;
    constructor(http: HttpClient, context: Context);
    create(): Promise<FormularioInfo>;
    loadFormControls(idFormulario: number): Promise<FormControl[]>;
    loadFormControl(id: number): Promise<FormControl>;
    saveFormControls(idFormulario: number, controls: FormControl[]): Promise<FormControl[]>;
    saveFormControl(idFormulario: number, control: FormControl): Promise<FormControl>;
    loadList(idDocumento: number, version: number): Promise<FormularioItem[]>;
    loadHtmlUI(idFormulario: number): Promise<string>;
    loadMapIcons(): Promise<MapIcon[]>;
}
