var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { FormularioInfo } from '../models/formulario';
var FormularioService = /** @class */ (function (_super) {
    __extends(FormularioService, _super);
    function FormularioService(http, context) {
        return _super.call(this, http, context, "api/kernel/bpm/formularios") || this;
    }
    FormularioService.prototype.create = function () {
        return Promise.resolve(new FormularioInfo());
    };
    FormularioService.prototype.loadFormControls = function (idFormulario) {
        var params = new HttpParams()
            .set('idFormulario', idFormulario.toString());
        //
        return this.apiService.get('form-controls', params)
            .toPromise();
    };
    FormularioService.prototype.loadFormControl = function (id) {
        var params = new HttpParams()
            .set('id', id.toString());
        //
        return this.apiService.get('form-control', params)
            .toPromise();
    };
    FormularioService.prototype.saveFormControls = function (idFormulario, controls) {
        var params = new HttpParams()
            .set('idFormulario', idFormulario.toString());
        //
        return this.apiService.post('save-controls', params, controls)
            .toPromise();
    };
    FormularioService.prototype.saveFormControl = function (idFormulario, control) {
        var params = new HttpParams()
            .set('idFormulario', idFormulario.toString());
        //
        return this.apiService.post('save-control', params, control)
            .toPromise();
    };
    FormularioService.prototype.loadList = function (idDocumento, version) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento.toString())
            .set('version', version.toString());
        //
        return this.apiService.get('document-forms', params)
            .toPromise();
    };
    FormularioService.prototype.loadHtmlUI = function (idFormulario) {
        var params = new HttpParams()
            .set('idFormulario', idFormulario.toString());
        //
        return this.apiService.getText('html', params)
            .toPromise();
    };
    FormularioService.prototype.loadMapIcons = function () {
        if (this._mapIconsBuffer) {
            return Promise.resolve(this._mapIconsBuffer);
        }
        else {
            return this.apiService.get('map-icons', null)
                .toPromise();
        }
    };
    FormularioService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], FormularioService);
    return FormularioService;
}(CatalogService));
export { FormularioService };
