var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, NgModule, Injectable, Compiler } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Wijmo
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Bootstrap
import { AlertModule, ModalModule, TabsModule, AccordionModule, SortableModule, CarouselModule } from 'ngx-bootstrap';
//Azteca
import { BpmModule } from '../bpm.module';
import { ControlsModule } from '../../controls/controls.module';
import { GeolocationModule } from '../../geolocation/geolocation.module';
//
import { DynamicComponent } from '../models/dynamic-component';
var TypeBuilderService = /** @class */ (function () {
    function TypeBuilderService(compiler) {
        this.compiler = compiler;
        this._cacheOfFactories = {};
    }
    TypeBuilderService.prototype.createComponentFactory = function (template) {
        var _this = this;
        var factory = this._cacheOfFactories[template];
        //Si el template ya se encuentra en caché, utilizarlo
        if (factory) {
            return new Promise(function (resolve) {
                resolve(factory);
            });
        }
        //Si el template no existía, crear un factory
        var type = this.createNewComponent(template);
        var module = this.createComponentModule(type);
        return new Promise(function (resolve) {
            _this.compiler
                .compileModuleAndAllComponentsAsync(module)
                .then(function (moduleWithFactories) {
                factory = moduleWithFactories.componentFactories.find(function (factory) { return factory.componentType === type; });
                _this._cacheOfFactories[template] = factory;
                resolve(factory);
            });
        });
    };
    TypeBuilderService.prototype.createNewComponent = function (tmpl) {
        var NewDynamicComponent = /** @class */ (function (_super) {
            __extends(NewDynamicComponent, _super);
            function NewDynamicComponent() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            NewDynamicComponent = __decorate([
                Component({
                    selector: 'bpm-dynamic-component',
                    template: tmpl,
                })
            ], NewDynamicComponent);
            return NewDynamicComponent;
        }(DynamicComponent));
        ;
        return NewDynamicComponent;
    };
    TypeBuilderService.prototype.createComponentModule = function (componentType) {
        var RuntimeComponentModule = /** @class */ (function () {
            function RuntimeComponentModule() {
            }
            RuntimeComponentModule = __decorate([
                NgModule({
                    imports: [
                        CommonModule, FormsModule, ReactiveFormsModule,
                        ControlsModule, GeolocationModule, BpmModule,
                        WjInputModule, WjGridModule, WjGridFilterModule,
                        AlertModule.forRoot(), ModalModule.forRoot(), TabsModule.forRoot(), AccordionModule.forRoot(),
                        SortableModule.forRoot(), CarouselModule.forRoot()
                    ],
                    declarations: [
                        componentType
                    ],
                })
            ], RuntimeComponentModule);
            return RuntimeComponentModule;
        }());
        return RuntimeComponentModule;
    };
    TypeBuilderService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Compiler])
    ], TypeBuilderService);
    return TypeBuilderService;
}());
export { TypeBuilderService };
