var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
var AlertsBarComponent = /** @class */ (function () {
    function AlertsBarComponent() {
        this.alerts = [];
        this.dismissTimeout = 5000;
        //
        this.alertsUpdated = new EventEmitter();
    }
    AlertsBarComponent.prototype.addAlert = function (message, type) {
        var newAlert = { msg: message, type: type, dismissOnTimeout: this.dismissTimeout, closable: true };
        var newAlerts = this.alerts.slice();
        newAlerts.push(newAlert);
        this.alerts = newAlerts;
        this.alertsUpdated.emit(newAlerts);
    };
    //
    AlertsBarComponent.prototype.showAlert = function (message, type) {
        var _this = this;
        setTimeout(function (_) { return _this.addAlert(message, type); });
    };
    AlertsBarComponent.prototype.closeAlert = function (i) {
        var newAlerts = this.alerts.slice();
        newAlerts.splice(i, 1);
        this.alerts = newAlerts;
        this.alertsUpdated.emit(newAlerts);
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], AlertsBarComponent.prototype, "alerts", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AlertsBarComponent.prototype, "dismissTimeout", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], AlertsBarComponent.prototype, "alertsUpdated", void 0);
    AlertsBarComponent = __decorate([
        Component({
            selector: 'alerts-bar',
            template: "\n      <alert *ngFor=\"let alert of alerts;let i = index\" [type]=\"alert.type\" dismissible=\"true\" [dismissOnTimeout]=\"alert.dismissOnTimeout\" (close)=\"closeAlert(i)\">\n          {{ alert?.msg }}\n      </alert>\n    "
        })
    ], AlertsBarComponent);
    return AlertsBarComponent;
}());
export { AlertsBarComponent };
