var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef, Renderer, ElementRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseControl } from '../models/base-control';
import { BaseComponent } from '../../core/models/base-component';
var AzCheckboxComponent = /** @class */ (function (_super) {
    __extends(AzCheckboxComponent, _super);
    function AzCheckboxComponent(renderer) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        //
        _this.checkedChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzCheckboxComponent_1 = AzCheckboxComponent;
    AzCheckboxComponent.prototype.onChange = function (args) {
        this.checkedChanged.emit(args.target.checked);
        this.propagateChange(args.target.checked);
    };
    //Implementación de control value accesor
    AzCheckboxComponent.prototype.writeValue = function (value) {
        this.checked = value ? true : false;
    };
    AzCheckboxComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzCheckboxComponent.prototype.registerOnTouched = function () { };
    var AzCheckboxComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AzCheckboxComponent.prototype, "checked", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzCheckboxComponent.prototype, "label", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzCheckboxComponent.prototype, "checkedChanged", void 0);
    __decorate([
        ViewChild('checkbox'),
        __metadata("design:type", ElementRef)
    ], AzCheckboxComponent.prototype, "checkbox", void 0);
    AzCheckboxComponent = AzCheckboxComponent_1 = __decorate([
        Component({
            selector: 'az-checkbox',
            template: "\n      <div class=\"form-check\" *ngIf=\"visible\">\n          <label class=\"form-check-label\">\n              <input #checkbox type=\"checkbox\" class=\"form-check-input\" [(ngModel)]=\"checked\" (change)=\"onChange($event)\" [disabled]=\"!enabled\" />\n              {{label}}\n          </label>\n    \n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzCheckboxComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzCheckboxComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [Renderer])
    ], AzCheckboxComponent);
    return AzCheckboxComponent;
}(BaseControl));
export { AzCheckboxComponent };
