var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, Input, EventEmitter, Output } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../models/base-control';
import 'brace/theme/chrome';
import 'brace/mode/xml';
import 'brace/mode/csharp';
import 'brace/worker/javascript';
var AzCodeEditor = /** @class */ (function (_super) {
    __extends(AzCodeEditor, _super);
    function AzCodeEditor() {
        var _this = _super.call(this) || this;
        _this.language = "xml";
        _this.theme = "chrome";
        _this.value = "";
        _this.visible = true;
        _this.valueChange = new EventEmitter();
        _this.options = { maxLines: 1000, printMargin: false };
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzCodeEditor_1 = AzCodeEditor;
    AzCodeEditor.prototype.onChange = function (code) {
        var _this = this;
        this.valueChange.emit(code);
        setTimeout(function (_) { return _this.propagateChange(code); });
    };
    //Implementación de control value accesor
    AzCodeEditor.prototype.writeValue = function (value) {
        if (value) {
            if (typeof value == 'string') {
                this.value = value;
            }
            else {
                this.value = value.toString();
            }
        }
        else {
            this.value = '';
        }
    };
    AzCodeEditor.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzCodeEditor.prototype.registerOnTouched = function () { };
    var AzCodeEditor_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzCodeEditor.prototype, "language", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzCodeEditor.prototype, "theme", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzCodeEditor.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AzCodeEditor.prototype, "visible", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzCodeEditor.prototype, "valueChange", void 0);
    AzCodeEditor = AzCodeEditor_1 = __decorate([
        Component({
            selector: 'az-code-editor',
            template: "\n      <div ace-editor [(text)]=\"value\"\n              [mode]=\"language\"\n              [theme]=\"theme\"\n              [autoUpdateContent]=\"true\"\n              [durationBeforeCallback]=\"1000\"\n              [options]=\"options\"\n              (textChanged)=\"onChange($event)\"\n              style=\"min-height: 200px; width:100%; height:100%; overflow: auto;\">\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzCodeEditor_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzCodeEditor_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [])
    ], AzCodeEditor);
    return AzCodeEditor;
}(BaseControl));
export { AzCodeEditor };
