var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../models/base-control';
var AzComboboxComponent = /** @class */ (function (_super) {
    __extends(AzComboboxComponent, _super);
    function AzComboboxComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.items = [];
        _this.displayMember = '';
        _this.valueMember = '';
        _this.selectedItem = null;
        //
        _this.selectedItemChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzComboboxComponent_1 = AzComboboxComponent;
    AzComboboxComponent.prototype.getValue = function () {
        var value = '';
        if (typeof this.selectedItem == 'object') {
            value = this.selectedItem[this.valueMember];
        }
        else {
            value = this.selectedItem;
        }
        return value;
    };
    AzComboboxComponent.prototype.onChange = function (args) {
        var value = this.getValue();
        //
        if (this.selectedValue != value) {
            this.selectedItemChanged.emit(value);
            this.propagateChange(value);
            this.selectedValue = value;
        }
    };
    AzComboboxComponent.prototype.ngOnChanges = function (changes) {
        if (changes['items'] && this.items) {
            this.selectedItem = this.findItem(this.selectedValue);
            //Si no estaba seleccionado un elemento y solo existe un elemento en el listado, seleccionarlo
            if (!this.selectedItem && this.items.length == 1) {
                this.selectedItem = this.items[0];
                var value = this.getValue();
                this.selectedItemChanged.emit(value);
                this.propagateChange(value);
                this.selectedValue = value;
            }
        }
        //
        if (changes['selectedValue'] && this.selectedValue && this.items) {
            this.selectedItem = this.findItem(this.selectedValue);
        }
    };
    AzComboboxComponent.prototype.findItem = function (value) {
        var _this = this;
        return this.items.find(function (item) {
            if (typeof item == 'object') {
                return item[_this.valueMember] == value;
            }
            else {
                return item == value;
            }
        });
    };
    //Implementación de control value accesor
    AzComboboxComponent.prototype.writeValue = function (value) {
        this.selectedValue = value;
        //Encontrar elemento con el valor que se está escribiendo
        this.selectedItem = this.findItem(value);
    };
    AzComboboxComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzComboboxComponent.prototype.registerOnTouched = function () { };
    var AzComboboxComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], AzComboboxComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzComboboxComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzComboboxComponent.prototype, "valueMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AzComboboxComponent.prototype, "selectedItem", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AzComboboxComponent.prototype, "selectedValue", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzComboboxComponent.prototype, "selectedItemChanged", void 0);
    AzComboboxComponent = AzComboboxComponent_1 = __decorate([
        Component({
            selector: 'az-combobox',
            template: "\n      <div *ngIf=\"visible\">\n      \t<select #combobox [(ngModel)]=\"selectedItem\" (change)=\"onChange($event)\" [disabled]=\"!enabled\" class=\"form-control\">\n              <option *ngFor=\"let item of items\" [ngValue]=\"item\">{{displayMember != '' ? item[displayMember] : item }}</option>\n      \t\t<ng-content></ng-content>\n      \t</select>    \n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzComboboxComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzComboboxComponent_1; }), multi: true
                }
            ]
        })
    ], AzComboboxComponent);
    return AzComboboxComponent;
}(BaseControl));
export { AzComboboxComponent };
