var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../models/base-control';
import * as moment from 'moment';
var AzInputDateTime = /** @class */ (function (_super) {
    __extends(AzInputDateTime, _super);
    function AzInputDateTime() {
        var _this = _super.call(this) || this;
        _this.value = new Date();
        _this.format = 'dd-MM-yyyy hh:mm';
        _this.min = null;
        _this.max = null;
        //
        _this.valueChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzInputDateTime_1 = AzInputDateTime;
    AzInputDateTime.prototype.onValueChanged = function (inputControl) {
        var _this = this;
        this.valueChange.emit(this.value);
        setTimeout(function (_) { return _this.propagateChange(inputControl.value); });
    };
    //Implementación de control value accesor
    AzInputDateTime.prototype.writeValue = function (value) {
        if (value) {
            if (typeof value == 'string') {
                this.value = moment(value).toDate();
            }
            else {
                this.value = value;
            }
        }
        else {
            this.value = new Date();
        }
    };
    AzInputDateTime.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzInputDateTime.prototype.registerOnTouched = function () { };
    var AzInputDateTime_1;
    __decorate([
        Input(),
        __metadata("design:type", Date)
    ], AzInputDateTime.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzInputDateTime.prototype, "format", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Date)
    ], AzInputDateTime.prototype, "min", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Date)
    ], AzInputDateTime.prototype, "max", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzInputDateTime.prototype, "valueChange", void 0);
    AzInputDateTime = AzInputDateTime_1 = __decorate([
        Component({
            selector: 'az-input-date-time',
            template: "\n      <div *ngIf=\"visible\">\n          <wj-input-date-time #inputDate\n                         (valueChanged)=\"onValueChanged(inputDate)\"\n                         [(value)]=\"value\"\n                         [isDisabled]=\"!enabled\"\n                         [format]=\"format\"\n                         [min]=\"min\"\n                         [max]=\"max\">\n\n          </wj-input-date-time>\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzInputDateTime_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzInputDateTime_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [])
    ], AzInputDateTime);
    return AzInputDateTime;
}(BaseControl));
export { AzInputDateTime };
