var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../models/base-control';
var AzInputNumber = /** @class */ (function (_super) {
    __extends(AzInputNumber, _super);
    function AzInputNumber() {
        var _this = _super.call(this) || this;
        _this.value = 0;
        _this.format = 'n0';
        _this.min = null;
        _this.max = null;
        //
        _this.valueChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzInputNumber_1 = AzInputNumber;
    AzInputNumber.prototype.onValueChanged = function (inputControl) {
        var _this = this;
        this.valueChange.emit(this.value);
        setTimeout(function (_) { return _this.propagateChange(inputControl.value); });
    };
    //Implementación de control value accesor
    AzInputNumber.prototype.writeValue = function (value) {
        if (value) {
            this.value = value;
        }
        else {
            this.value = 0;
        }
    };
    AzInputNumber.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzInputNumber.prototype.registerOnTouched = function () { };
    var AzInputNumber_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzInputNumber.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzInputNumber.prototype, "format", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzInputNumber.prototype, "min", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzInputNumber.prototype, "max", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzInputNumber.prototype, "valueChange", void 0);
    AzInputNumber = AzInputNumber_1 = __decorate([
        Component({
            selector: 'az-input-number',
            template: "\n      <div *ngIf=\"visible\">\n          <wj-input-number #inputNumber \n                           (valueChanged)=\"onValueChanged(inputNumber)\" \n                           [(value)]=\"value\"\n                           [isDisabled]=\"!enabled\"\n                           [format]=\"format\"\n                           [min]=\"min\"\n                           [max]=\"max\">\n\n          </wj-input-number>\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzInputNumber_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzInputNumber_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [])
    ], AzInputNumber);
    return AzInputNumber;
}(BaseControl));
export { AzInputNumber };
