var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
var AzPagerComponent = /** @class */ (function () {
    function AzPagerComponent() {
        this.moveToFirst = new EventEmitter();
        this.moveToLast = new EventEmitter();
        this.moveToNext = new EventEmitter();
        this.moveToPrevious = new EventEmitter();
        this.moveToPage = new EventEmitter();
    }
    Object.defineProperty(AzPagerComponent.prototype, "pageCount", {
        get: function () {
            return Math.ceil(this.totalRows / this.pageSize);
        },
        enumerable: true,
        configurable: true
    });
    AzPagerComponent.prototype.moveFirst = function () {
        this.moveToFirst.emit();
        this.moveToPage.emit(0);
    };
    AzPagerComponent.prototype.movePrevious = function () {
        this.moveToPrevious.emit();
        this.moveToPage.emit(this.pageIndex - 1);
    };
    AzPagerComponent.prototype.moveNext = function () {
        this.moveToNext.emit();
        this.moveToPage.emit(this.pageIndex + 1);
    };
    AzPagerComponent.prototype.moveLast = function () {
        this.moveToLast.emit();
        this.moveToPage.emit(this.pageCount);
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzPagerComponent.prototype, "pageIndex", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzPagerComponent.prototype, "totalRows", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzPagerComponent.prototype, "pageSize", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzPagerComponent.prototype, "moveToFirst", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzPagerComponent.prototype, "moveToLast", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzPagerComponent.prototype, "moveToNext", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzPagerComponent.prototype, "moveToPrevious", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzPagerComponent.prototype, "moveToPage", void 0);
    AzPagerComponent = __decorate([
        Component({
            selector: 'az-pager',
            template: "\n      <div class=\"btn-group\">\n          <button type=\"button\" class=\"btn btn-default\"\n                  (click)=\"moveFirst()\"\n                  [disabled]=\"pageIndex <= 0\">\n              <span class=\"glyphicon glyphicon-fast-backward\"></span>\n          </button>\n          <button type=\"button\" class=\"btn btn-default\"\n                  (click)=\"movePrevious()\"\n                  [disabled]=\"pageIndex <= 0\">\n              <span class=\"glyphicon glyphicon-step-backward\"></span>\n          </button>\n          <button type=\"button\" class=\"btn btn-default\" disabled style=\"width:100px\">\n              {{pageIndex + 1}} de {{pageCount}}\n          </button>\n          <button type=\"button\" class=\"btn btn-default\"\n                  (click)=\"moveNext()\"\n                  [disabled]=\"pageIndex >= pageCount -1\">\n              <span class=\"glyphicon glyphicon-step-forward\"></span>\n          </button>\n          <button type=\"button\" class=\"btn btn-default\"\n                  (click)=\"moveLast()\"\n                  [disabled]=\"pageIndex >= pageCount -1\">\n              <span class=\"glyphicon glyphicon-fast-forward\"></span>\n          </button>\n      </div>\n    "
        })
    ], AzPagerComponent);
    return AzPagerComponent;
}());
export { AzPagerComponent };
