var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef, Renderer, ElementRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../models/base-control';
var AzTextareaComponent = /** @class */ (function (_super) {
    __extends(AzTextareaComponent, _super);
    function AzTextareaComponent(renderer) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        _this.rows = 3;
        //
        _this.textChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzTextareaComponent_1 = AzTextareaComponent;
    AzTextareaComponent.prototype.onTextChanged = function (args) {
        this.textChanged.emit(args.target.value);
        this.propagateChange(args.target.value);
    };
    //Implementación de control value accesor
    AzTextareaComponent.prototype.writeValue = function (value) {
        this.text = value ? value : '';
    };
    AzTextareaComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzTextareaComponent.prototype.registerOnTouched = function () { };
    var AzTextareaComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzTextareaComponent.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AzTextareaComponent.prototype, "rows", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzTextareaComponent.prototype, "textChanged", void 0);
    __decorate([
        ViewChild('textarea'),
        __metadata("design:type", ElementRef)
    ], AzTextareaComponent.prototype, "textbox", void 0);
    AzTextareaComponent = AzTextareaComponent_1 = __decorate([
        Component({
            selector: 'az-textarea',
            template: "\n      <div *ngIf=\"visible\">\n      \t<textarea #textarea [(ngModel)]=\"text\" (keyup)=\"onTextChanged($event)\" [disabled]=\"!enabled\" [rows]=\"rows\"></textarea>\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzTextareaComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzTextareaComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [Renderer])
    ], AzTextareaComponent);
    return AzTextareaComponent;
}(BaseControl));
export { AzTextareaComponent };
