var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef, Renderer, ElementRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseControl } from '../models/base-control';
import { BaseComponent } from '../../core/models/base-component';
var AzTextboxComponent = /** @class */ (function (_super) {
    __extends(AzTextboxComponent, _super);
    function AzTextboxComponent(renderer) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        //
        _this.textChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    AzTextboxComponent_1 = AzTextboxComponent;
    AzTextboxComponent.prototype.onTextChanged = function (args) {
        this.textChange.emit(args.target.value);
        this.propagateChange(args.target.value);
    };
    //Implementación de control value accesor
    AzTextboxComponent.prototype.writeValue = function (value) {
        this.text = value ? value : '';
    };
    AzTextboxComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    AzTextboxComponent.prototype.registerOnTouched = function () { };
    var AzTextboxComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AzTextboxComponent.prototype, "text", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzTextboxComponent.prototype, "textChange", void 0);
    __decorate([
        ViewChild('textbox'),
        __metadata("design:type", ElementRef)
    ], AzTextboxComponent.prototype, "textbox", void 0);
    AzTextboxComponent = AzTextboxComponent_1 = __decorate([
        Component({
            selector: 'az-textbox',
            template: "\n      <div *ngIf=\"visible\">\n          <input type=\"text\" #textbox [(ngModel)]=\"text\" (keyup)=\"onTextChanged($event)\" [disabled]=\"!enabled\" />\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AzTextboxComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return AzTextboxComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [Renderer])
    ], AzTextboxComponent);
    return AzTextboxComponent;
}(BaseControl));
export { AzTextboxComponent };
