var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Output, EventEmitter, ContentChildren, forwardRef, QueryList } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { ToolbarButtonDirective } from '../directives/toolbar-button.directive';
import { ToolbarMenuDirective } from '../directives/toolbar-menu.directive';
var AzToolbarComponent = /** @class */ (function (_super) {
    __extends(AzToolbarComponent, _super);
    function AzToolbarComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        //
        _this.buttonClick = new EventEmitter();
        _this.menuItemClick = new EventEmitter();
        _this.openingMenu = new EventEmitter();
        return _this;
    }
    AzToolbarComponent_1 = AzToolbarComponent;
    AzToolbarComponent.prototype.onButtonClick = function (button) {
        this.buttonClick.emit(button);
    };
    AzToolbarComponent.prototype.onMenuItemClicked = function (menu, wijMenu) {
        var item = menu.menuItems[wijMenu.selectedIndex];
        this.menuItemClick.emit(item);
    };
    AzToolbarComponent.prototype.onIsDroppedDown = function (menu, wijMenu) {
        this.openingMenu.emit(wijMenu);
    };
    //Implementación de políticas
    AzToolbarComponent.prototype.applyPolicy = function (policy) {
        if (this.allowPolicies && !this.isPolicyApplied(policy.nombre)) {
            if (policy.nombre == this.ENABLED_POLICY) {
                //this.isEnabled = policy.valor.toLowerCase() == 'true' ? true : false;
                this.appliedPolicies.push(policy);
            }
        }
    };
    var AzToolbarComponent_1;
    __decorate([
        ContentChildren(ToolbarButtonDirective),
        __metadata("design:type", QueryList)
    ], AzToolbarComponent.prototype, "buttons", void 0);
    __decorate([
        ContentChildren(ToolbarMenuDirective),
        __metadata("design:type", QueryList)
    ], AzToolbarComponent.prototype, "menus", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzToolbarComponent.prototype, "buttonClick", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzToolbarComponent.prototype, "menuItemClick", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AzToolbarComponent.prototype, "openingMenu", void 0);
    AzToolbarComponent = AzToolbarComponent_1 = __decorate([
        Component({
            selector: 'az-toolbar',
            template: "\n      <div class=\"btn-group btn-module-primary\">\n          <button *ngFor=\"let btn of buttons\" type=\"button\" [ngClass]=\"btn.buttonClass\" [title]=\"btn.toolTip\" (click)=\"onButtonClick(btn)\" [disabled]=\"!btn.enabled\">\n              <span [class]=\"btn.icon\" aria-hidden=\"true\"></span> {{btn.text}}\n          </button>\n\n          <wj-menu *ngFor=\"let menu of menus\"\n                   #wijMenu\n                   (itemClicked)=\"onMenuItemClicked(menu, wijMenu)\"\n                   (isDroppedDownChanging)=\"onIsDroppedDown(menu, wijMenu)\"                     \n                   [isDisabled]=\"!menu.enabled\"\n                   [header]=\"menu.header\">\n\n              <wj-menu-item *ngFor=\"let item of menu.menuItems\">\n                  <div *ngIf=\"menu.enabled && item.enabled\">\n                      <span [class]=\"item.icon\"></span>\n                      <b>{{item.text}}</b>\n                      <br>\n                      <small><i>{{item.smallText}}</i></small>\n                  </div>\n              </wj-menu-item>\n          </wj-menu>\n\n      </div>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return AzToolbarComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return AzToolbarComponent_1; }),
                    multi: true
                }]
        })
    ], AzToolbarComponent);
    return AzToolbarComponent;
}(BaseComponent));
export { AzToolbarComponent };
