var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef, Renderer, ElementRef, ContentChild } from '@angular/core';
import { FormControlName, Validators, NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../models/base-control';
var CatalogCodeComponent = /** @class */ (function (_super) {
    __extends(CatalogCodeComponent, _super);
    function CatalogCodeComponent(renderer) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        //
        _this.textChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    CatalogCodeComponent_1 = CatalogCodeComponent;
    CatalogCodeComponent.prototype.ngOnChanges = function (changes) {
        if (changes['automatic']) {
            this.updateValidators();
        }
    };
    CatalogCodeComponent.prototype.updateValidators = function () {
        if (this.state && this.state.control) {
            if (this.automatic) {
                this.state.control.setValidators(null);
                this.state.control.updateValueAndValidity();
            }
            else {
                this.state.control.setValidators(Validators.required);
                this.state.control.updateValueAndValidity();
            }
        }
    };
    CatalogCodeComponent.prototype.onTextChanged = function (args) {
        this.textChanged.emit(args.target.value);
        this.propagateChange(args.target.value);
    };
    //Implementación de control value accesor
    CatalogCodeComponent.prototype.writeValue = function (value) {
        this.text = value ? value : '';
    };
    CatalogCodeComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    CatalogCodeComponent.prototype.registerOnTouched = function () { };
    var CatalogCodeComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CatalogCodeComponent.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogCodeComponent.prototype, "automatic", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], CatalogCodeComponent.prototype, "textChanged", void 0);
    __decorate([
        ViewChild('textbox'),
        __metadata("design:type", ElementRef)
    ], CatalogCodeComponent.prototype, "textbox", void 0);
    __decorate([
        ContentChild(FormControlName),
        __metadata("design:type", FormControlName)
    ], CatalogCodeComponent.prototype, "state", void 0);
    CatalogCodeComponent = CatalogCodeComponent_1 = __decorate([
        Component({
            selector: 'catalog-code',
            template: "\n      <div *ngIf=\"visible\">\n          <input type=\"text\" #textbox [value]=\"text\" (keyup)=\"onTextChanged($event)\" [disabled]=\"!enabled\" [readonly]=\"automatic ? 'true': null\" />\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return CatalogCodeComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return CatalogCodeComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [Renderer])
    ], CatalogCodeComponent);
    return CatalogCodeComponent;
}(BaseControl));
export { CatalogCodeComponent };
