var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild, Input } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { ModalDirective } from 'ngx-bootstrap';
var ContentViewerComponent = /** @class */ (function () {
    function ContentViewerComponent(sanitizer) {
        this.sanitizer = sanitizer;
        this.title = 'Archivo generado';
        this.fileName = 'archivo';
        this.view = false;
        this.content = null;
    }
    ContentViewerComponent.prototype.sanitize = function (url) {
        if (!this.view) {
            this.content = this.sanitizer.bypassSecurityTrustResourceUrl(this.fileContent);
        }
        return this.content;
    };
    ContentViewerComponent.prototype.show = function (content) {
        this.view = false;
        if (content) {
            this.fileContent = content;
        }
        this.dialog.config.backdrop = false;
        this.dialog.show();
    };
    ContentViewerComponent.prototype.viewContent = function () {
        this.view = true;
        return false;
    };
    __decorate([
        ViewChild('dialog'),
        __metadata("design:type", ModalDirective)
    ], ContentViewerComponent.prototype, "dialog", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ContentViewerComponent.prototype, "title", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ContentViewerComponent.prototype, "fileName", void 0);
    ContentViewerComponent = __decorate([
        Component({
            selector: 'azteca-content-viewer',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\">{{title}}</h5>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <a [href]=\"sanitize(fileContent)\" [download]=\"fileName\" class=\"btn btn-secondary\" role=\"button\" aria-pressed=\"true\">\n                          <span class=\"glyphicon glyphicon-save\"></span> Descargar\n                      </a>\n                      <a href=\"#\" class=\"btn btn-secondary\" role=\"button\" aria-pressed=\"true\" (click)=\"viewContent()\">\n                          <span class=\"glyphicon glyphicon-new-window\"></span> Abrir\n                      </a>\n                      <iframe *ngIf=\"view\" width=\"800\" height=\"600\" [src]=\"sanitize(fileContent)\"></iframe>\n                  </div> <!--Modal Body-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [DomSanitizer])
    ], ContentViewerComponent);
    return ContentViewerComponent;
}());
export { ContentViewerComponent };
