import { EventEmitter, Renderer, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Context } from '../../core/services/context';
import { BaseControl } from '../models/base-control';
import { FileInfo } from '../../general/models/file';
export declare class FileBoxComponent extends BaseControl implements ControlValueAccessor {
    private renderer;
    private context;
    selectedFile: FileInfo;
    allowedExtensions: string[];
    showSelectButton: boolean;
    showDownloadButton: boolean;
    fileChanged: EventEmitter<FileInfo>;
    fileInput: ElementRef;
    constructor(renderer: Renderer, context: Context);
    private validExtension;
    private fileChangedHandler;
    selectFile(): void;
    removeFile(): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
