var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef, Renderer, ElementRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { Context } from '../../core/services/context';
import { BaseControl } from '../models/base-control';
import { FileInfo } from '../../general/models/file';
var FileBoxComponent = /** @class */ (function (_super) {
    __extends(FileBoxComponent, _super);
    function FileBoxComponent(renderer, context) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        _this.context = context;
        _this.allowedExtensions = [];
        _this.showSelectButton = true;
        _this.showDownloadButton = true;
        //Outputs
        _this.fileChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    FileBoxComponent_1 = FileBoxComponent;
    FileBoxComponent.prototype.validExtension = function (extension) {
        var valid = false;
        if (this.allowedExtensions.length == 0) {
            valid = true;
        }
        else {
            valid = this.allowedExtensions.find(function (s) { return s == extension; }) ? true : false;
        }
        return valid;
    };
    FileBoxComponent.prototype.fileChangedHandler = function (e) {
        var _this = this;
        var self = this;
        var file = this.fileInput.nativeElement.files[0];
        if (this.fileInput.nativeElement.files && this.fileInput.nativeElement.files[0]) {
            var info_1 = new FileInfo();
            info_1.originalFileName = file.name;
            // Obtener extensión del archivo
            var pointIndex = info_1.originalFileName.lastIndexOf('.');
            if (pointIndex >= 0) {
                info_1.extension = info_1.originalFileName.substring(pointIndex + 1);
            }
            info_1.contentType = info_1.extension;
            if (this.validExtension(info_1.extension)) {
                var reader = new FileReader();
                reader.onload = function (args) {
                    info_1.content = args.target.result;
                    _this.selectedFile = info_1;
                    self.fileChanged.emit(info_1);
                    _this.propagateChange(info_1);
                };
                reader.readAsDataURL(file);
            }
        }
    };
    FileBoxComponent.prototype.selectFile = function () {
        var event = new MouseEvent('click', { bubbles: true });
        this.renderer.invokeElementMethod(this.fileInput.nativeElement, 'dispatchEvent', [event]);
    };
    FileBoxComponent.prototype.removeFile = function () {
        this.fileChanged.emit(null);
        this.propagateChange(null);
        this.selectedFile = null;
    };
    //Implementación de control value accesor
    FileBoxComponent.prototype.writeValue = function (value) {
        this.selectedFile = value ? value : null;
    };
    FileBoxComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    FileBoxComponent.prototype.registerOnTouched = function () { };
    var FileBoxComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", FileInfo)
    ], FileBoxComponent.prototype, "selectedFile", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], FileBoxComponent.prototype, "allowedExtensions", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], FileBoxComponent.prototype, "showSelectButton", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], FileBoxComponent.prototype, "showDownloadButton", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], FileBoxComponent.prototype, "fileChanged", void 0);
    __decorate([
        ViewChild('fileInput'),
        __metadata("design:type", ElementRef)
    ], FileBoxComponent.prototype, "fileInput", void 0);
    FileBoxComponent = FileBoxComponent_1 = __decorate([
        Component({
            selector: 'azteca-file-box',
            template: "\n      <div class=\"input-group\">\n          <input type=\"text\" class=\"form-control\" [disabled]=\"true\" [value]=\"selectedFile ? selectedFile.originalFileName : ''\" />\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"selectFile()\" title=\"Subir archivo\" *ngIf=\"enabled && showSelectButton\">\n                  <span class=\"glyphicon glyphicon-open\"></span>\n              </button>\n          </span>\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"downloadFile()\" title=\"Descargar archivo\" *ngIf=\"enabled && selectedFile && (selectedFile.content != '' || selectedFile.fileUri != '') && showDownloadButton\">\n                  <span class=\"glyphicon glyphicon-save\"></span>\n              </button>\n          </span>\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"removeFile()\" *ngIf=\"selectedFile && (selectedFile.content != '' || selectedFile.fileUri != '') && enabled\">\n                  <span class=\"glyphicon glyphicon-remove\"></span>\n              </button>\n          </span>\n          <input type=\"file\" #fileInput (change)=\"fileChangedHandler($event)\" style=\"visibility:hidden; width:10px;height:1px;\" />\n      </div>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return FileBoxComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return FileBoxComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Renderer, Context])
    ], FileBoxComponent);
    return FileBoxComponent;
}(BaseControl));
export { FileBoxComponent };
