var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef, Renderer, ElementRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
import { Context } from '../../core/services/context';
import { BaseControl } from '../models/base-control';
import { FileInfo } from '../../general/models/file';
var ImageBoxComponent = /** @class */ (function (_super) {
    __extends(ImageBoxComponent, _super);
    function ImageBoxComponent(renderer, context) {
        var _this = _super.call(this) || this;
        _this.renderer = renderer;
        _this.context = context;
        _this.allowedExtensions = ["jpg", "bmp", "png", "gif", "jpeg"];
        _this.defaultImage = 'assets/img/kernel/camera.png';
        _this.imageSrc = _this.defaultImage;
        //
        _this.fileChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    ImageBoxComponent_1 = ImageBoxComponent;
    ImageBoxComponent.prototype.validExtension = function (extension) {
        var valid = false;
        this.allowedExtensions.forEach(function (validExt) {
            if (extension.toLowerCase().trim() == validExt) {
                valid = true;
                return false;
            }
        });
        return valid;
    };
    ImageBoxComponent.prototype.updateImageSrc = function () {
        if (this.imageFile && (this.imageFile.content || this.imageFile.fileUri != '')) {
            if (this.imageFile.fileUri == '')
                this.imageSrc = this.imageFile.content;
            else
                this.imageSrc = this.context.fileServerPath + this.imageFile.fileUri;
        }
        else
            this.imageSrc = this.defaultImage;
    };
    ImageBoxComponent.prototype.ngOnChanges = function (changes) {
        if (changes['imageFile']) {
            this.updateImageSrc();
        }
    };
    ImageBoxComponent.prototype.fileChangedHandler = function (e) {
        var _this = this;
        var self = this;
        var selectedFile = this.fileInput.nativeElement.files[0];
        if (this.fileInput.nativeElement.files && this.fileInput.nativeElement.files[0]) {
            var info_1 = new FileInfo();
            info_1.contentType = 'images';
            info_1.originalFileName = selectedFile.name;
            // Obtener extensión del archivo
            var pointIndex = info_1.originalFileName.lastIndexOf('.');
            if (pointIndex >= 0) {
                info_1.extension = info_1.originalFileName.substring(pointIndex + 1);
            }
            if (this.validExtension(info_1.extension)) {
                var reader = new FileReader();
                reader.onload = function (args) {
                    info_1.content = args.target.result;
                    _this.imageFile = info_1;
                    self.fileChanged.emit(info_1);
                    _this.propagateChange(info_1);
                    self.updateImageSrc();
                };
                reader.readAsDataURL(selectedFile);
            }
        }
    };
    ImageBoxComponent.prototype.selectFile = function () {
        if (!this.enabled)
            return;
        var event = new MouseEvent('click', { bubbles: true });
        this.renderer.invokeElementMethod(this.fileInput.nativeElement, 'dispatchEvent', [event]);
    };
    ImageBoxComponent.prototype.removeFile = function () {
        this.fileChanged.emit(null);
        this.propagateChange(null);
        this.imageFile = null;
        this.updateImageSrc();
    };
    //Implementación de control value accesor
    ImageBoxComponent.prototype.writeValue = function (value) {
        this.imageFile = value ? value : null;
        this.updateImageSrc();
    };
    ImageBoxComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ImageBoxComponent.prototype.registerOnTouched = function () { };
    var ImageBoxComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", FileInfo)
    ], ImageBoxComponent.prototype, "imageFile", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], ImageBoxComponent.prototype, "fileChanged", void 0);
    __decorate([
        ViewChild('fileInput'),
        __metadata("design:type", ElementRef)
    ], ImageBoxComponent.prototype, "fileInput", void 0);
    ImageBoxComponent = ImageBoxComponent_1 = __decorate([
        Component({
            selector: 'azteca-image-box',
            template: "\n      <img class=\"img-fluid img-thumbnail\" [src]=\"imageSrc\" style=\"cursor:pointer;\" (click)=\"selectFile()\" />\n      <br />\n      <button type=\"button\" class=\"btn btn-default\" title=\"Quitar im\u00E1gen\" (click)=\"removeFile()\" *ngIf=\"enabled && imageFile && (imageFile.content || imageFile.fileUri != '')\">\n          <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Eliminar\n      </button>\n      <input type=\"file\" #fileInput (change)=\"fileChangedHandler($event)\" style=\"visibility:hidden; width:10px;height:1px;\" />\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return ImageBoxComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return ImageBoxComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Renderer, Context])
    ], ImageBoxComponent);
    return ImageBoxComponent;
}(BaseControl));
export { ImageBoxComponent };
