var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { Context } from '../../core/services/context';
var ReportViewerComponent = /** @class */ (function () {
    function ReportViewerComponent(context, sanitizer) {
        this.context = context;
        this.sanitizer = sanitizer;
        this._reportPath = '';
        this.height = 800;
        this.context.app.showSpinner();
    }
    Object.defineProperty(ReportViewerComponent.prototype, "reportPath", {
        get: function () {
            return this._reportPath;
        },
        set: function (value) {
            if (value && this._reportPath != value) {
                this._reportPath = value;
                this.safeUrl = this.sanitizeUrl();
            }
        },
        enumerable: true,
        configurable: true
    });
    ReportViewerComponent.prototype.onReportLoaded = function () {
        this.context.app.hideSpinner();
    };
    ReportViewerComponent.prototype.sanitizeUrl = function () {
        var url = this.context.reportViewerUrl + '?';
        url += 'idEmpresa=' + this.context.app.defaultCompany.identity.toString();
        url += '&idSucursal=' + this.context.app.defaultSite.identity.toString();
        url += '&idUsuario=' + this.context.session.user.identity.toString();
        url += '&sessionID=' + this.context.session.sessionID;
        url += '&reportPath=' + this.reportPath;
        var safeUrl = this.sanitizer.bypassSecurityTrustResourceUrl(url);
        return safeUrl;
    };
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], ReportViewerComponent.prototype, "reportPath", null);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], ReportViewerComponent.prototype, "height", void 0);
    ReportViewerComponent = __decorate([
        Component({
            selector: 'report-viewer',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <iframe style=\"width:100%\" [height]=\"height\" [src]=\"safeUrl\" (load)=\"onReportLoaded()\"></iframe>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [Context, DomSanitizer])
    ], ReportViewerComponent);
    return ReportViewerComponent;
}());
export { ReportViewerComponent };
