import { EventEmitter } from '@angular/core';
import { Subject } from 'rxjs';
import { CalendarEventTimesChangedEvent } from 'angular-calendar';
import { ScheduleEvent } from '../models/schedule-event';
import { ScheduleDayEventArgs } from '../models/schedule-day-event-args';
import { ScheduleHourEventArgs } from '../models/schedule-hour-event-args';
import { Period } from '../models/period';
import { WeekDay } from '../models/week-day';
export declare class ScheduleComponent {
    view: string;
    viewDate: Date;
    activeDayIsOpen: boolean;
    refresh: Subject<any>;
    locale: string;
    events: ScheduleEvent[];
    viewMonthVisible: boolean;
    viewWeekVisible: boolean;
    viewDayVisible: boolean;
    activeDayOpened: EventEmitter<Date>;
    dayClicked: EventEmitter<ScheduleDayEventArgs>;
    dayHeaderClicked: EventEmitter<WeekDay>;
    hourSegmentClicked: EventEmitter<ScheduleHourEventArgs>;
    eventClicked: EventEmitter<ScheduleEvent<any>>;
    periodChanged: EventEmitter<Period>;
    headerConfig: {
        left: string;
        center: string;
        right: string;
    };
    constructor();
    private getStartOfPeriod;
    private getEndOfPeriod;
    getPeriod(): Period;
    onDayClicked({ date, events }: {
        date: Date;
        events: ScheduleEvent[];
    }): void;
    onDayHeaderClicked(day: WeekDay): void;
    onHourSegmentClicked(date: Date): void;
    eventTimesChanged({ event, newStart, newEnd }: CalendarEventTimesChangedEvent): void;
    onViewChanged(view: string): void;
    onViewDateChanged(): void;
    handleEvent(event: ScheduleEvent): void;
}
