var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Bootstrap
import { AlertModule, ModalModule, TypeaheadModule } from 'ngx-bootstrap';
//Wijmo
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Calendar
import { CalendarModule } from 'angular-calendar';
//Modulos Kernel
import { UtilsModule } from '../utils/utils.module';
//Code Editor
import { AceEditorModule } from 'ng2-ace-editor';
//Directivas
import { BootstrapInputDirective } from './directives/bootstrap-input.directive';
import { ToolbarButtonDirective } from './directives/toolbar-button.directive';
import { ToolbarMenuDirective } from './directives/toolbar-menu.directive';
import { GridColumn } from './directives/grid-column';
import { MenuItemDirective } from './directives/menu-item.directive';
//Componentes
import { AzLabelComponent } from './components/az-label.component';
import { AzTextboxComponent } from './components/az-textbox.component';
import { AzAutocompleteComponent } from './components/az-autocomplete.component';
import { AzButtonComponent } from './components/az-button.component';
import { AzPagerComponent } from './components/az-pager.component';
import { AzToolbarComponent } from './components/az-toolbar.component';
import { AzPanelComponent } from './components/az-panel.component';
import { FormFieldComponent } from './components/form-field.component';
import { ImageBoxComponent } from './components/image-box.component';
import { CatalogCodeComponent } from './components/catalog-code.component';
import { AlertsBarComponent } from './components/alerts-bar.component';
import { AzTextareaComponent } from './components/az-textarea.component';
import { AzComboboxComponent } from './components/az-combobox.component';
import { AzCheckboxComponent } from './components/az-checkbox.component';
import { AzInputNumber } from './components/az-input-number.component';
import { AzPasswordComponent } from './components/az-input-password.component';
import { FileBoxComponent } from './components/file-box.component';
import { AzInputDate } from './components/az-input-date.component';
import { AzInputTime } from './components/az-input-time.component';
import { AzInputDateTime } from './components/az-input-date-time.component';
import { ContentViewerComponent } from './components/content-viewer.component';
import { DownloadPopupComponent } from './components/download-popup.component';
import { ReportViewerComponent } from './components/report-viewer.component';
import { ScheduleComponent } from './components/schedule.component';
import { AzCodeEditor } from './components/az-code-editor.component';
var COMPONENTES = [BootstrapInputDirective, ToolbarButtonDirective, MenuItemDirective, GridColumn, AzTextareaComponent,
    FormFieldComponent, ImageBoxComponent, AzLabelComponent, AzButtonComponent, AzTextboxComponent, AzToolbarComponent,
    CatalogCodeComponent, AzPagerComponent, AzPanelComponent, AlertsBarComponent, AzComboboxComponent,
    ToolbarMenuDirective, AzCheckboxComponent, AzInputNumber, FileBoxComponent, AzPasswordComponent, AzAutocompleteComponent,
    AzInputDate, AzInputTime, AzInputDateTime, ContentViewerComponent, DownloadPopupComponent, ReportViewerComponent,
    ScheduleComponent, AzCodeEditor];
var SERVICIOS = [];
var ControlsModule = /** @class */ (function () {
    function ControlsModule() {
    }
    ControlsModule = __decorate([
        NgModule({
            imports: [
                FormsModule, CommonModule, AceEditorModule,
                WjInputModule,
                AlertModule.forRoot(), ModalModule.forRoot(), TypeaheadModule.forRoot(),
                CalendarModule.forRoot(),
                UtilsModule
            ],
            declarations: COMPONENTES,
            providers: SERVICIOS,
            exports: COMPONENTES
        })
    ], ControlsModule);
    return ControlsModule;
}());
export { ControlsModule };
