var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, ContentChild } from '@angular/core';
import { FormControlName } from '@angular/forms';
//
import { BaseComponent } from '../../core/models/base-component';
var BaseControl = /** @class */ (function (_super) {
    __extends(BaseControl, _super);
    function BaseControl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.VISIBLE_POLICY = 'visible';
        _this.REQUIRED_POLICY = 'required';
        _this.isEnabled = true;
        _this.isVisible = true;
        return _this;
    }
    Object.defineProperty(BaseControl.prototype, "enabled", {
        //
        get: function () {
            return this.isEnabled;
        },
        set: function (value) {
            if (!this.isPolicyApplied(this.ENABLED_POLICY)) {
                this.isEnabled = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseControl.prototype, "visible", {
        get: function () {
            return this.isVisible;
        },
        set: function (value) {
            if (!this.isPolicyApplied(this.VISIBLE_POLICY)) {
                this.isVisible = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    BaseControl.prototype.ngAfterViewInit = function () {
        if (this.state && this.state.valueAccessor && this.state.valueAccessor instanceof BaseComponent) {
            if (!this.state.valueAccessor.name)
                this.state.valueAccessor.name = this.state.name;
        }
    };
    //Implementación de políticas
    BaseControl.prototype.applyPolicy = function (policy) {
        if (this.allowPolicies && !this.isPolicyApplied(policy.nombre)) {
            if (policy.nombre == this.ENABLED_POLICY) {
                this.isEnabled = policy.valor == 'true' ? true : false;
                this.appliedPolicies.push(policy);
            }
            if (policy.nombre == this.VISIBLE_POLICY) {
                this.isVisible = policy.valor == 'true' ? true : false;
                this.appliedPolicies.push(policy);
            }
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], BaseControl.prototype, "enabled", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], BaseControl.prototype, "visible", null);
    __decorate([
        ContentChild(FormControlName),
        __metadata("design:type", FormControlName)
    ], BaseControl.prototype, "state", void 0);
    return BaseControl;
}(BaseComponent));
export { BaseControl };
