import { WorkflowStep } from './workflow-step';
/**
 * Modelo básico de un documento con workflow
 */
export declare abstract class DocumentInfo<TDetail> {
    identity: string;
    fechaSys: Date;
    fechaCreacion: Date;
    fechaAfectacion: Date;
    idSucursal: number;
    details: TDetail[];
    status: number;
    statusDescription: string;
    currentStep: WorkflowStep;
    createDate: number;
    lastUpdate: number;
    pcUpdate: string;
    userUpdate: number;
    activateDate: number;
    deactivateDate: number;
    constructor();
}
export declare class DocumentItem {
    id: string;
    fechaCreacion: Date;
    idStatus: number;
    status: string;
    idWorkflowStep: number;
    workflowStep: string;
    selected?: boolean;
    constructor();
}
