import { CatalogInfo, CatalogItem } from '../../core/models/catalog';
import { PolicyInfo } from './policy';
import { PolicyAccess } from './policy-access';
import { SubProceso } from './sub-proceso';
export declare class ProcesoInfo extends CatalogInfo {
    nombre: string;
    idModulo: number;
    descripcion: string;
    idTipoProceso: number;
    url: string;
    parametros: string;
    orden: number;
    imageFile: string;
    politicas: PolicyInfo[];
    subProcesos: SubProceso[];
    constructor();
}
export declare class ProcesoItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    url: string;
    parametros: string;
    orden: number;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
    constructor();
}
export declare class ProcesoAcceso extends ProcesoItem {
    idSucursal: number;
    idModulo: number;
    politicas: PolicyAccess[];
    subProcesos: SubProceso[];
    state: string;
    _clientID: number;
    constructor();
}
export declare class TipoProceso {
    idProcesoTipo: number;
    Tipo: string;
}
