var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { BaseComponent } from './base-component';
var ProcessComponent = /** @class */ (function (_super) {
    __extends(ProcessComponent, _super);
    function ProcessComponent(context, router, route) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this._idProceso = 0;
        //Obtener id de proceso
        _this.route.params.forEach(function (params) {
            _this._idProceso = +params['proceso'];
        });
        //Obtener el proceso que pertenece a éste componente        
        if (_this._idProceso && _this._idProceso > 0) {
            _this.context.access.forEach(function (m) {
                if (!_this.process) {
                    _this.process = m.procesos.find(function (p) { return p.id == _this._idProceso; });
                }
            });
        }
        else {
            console.error('No se encontró ID de proceso en la ruta del componente. Eso podría ocasionar que no se carguen las políticas y que fallen los procesos de carga inicial');
        }
        return _this;
    }
    ProcessComponent.prototype.applyPolicies = function () {
        var _this = this;
        if (this.process) {
            //Aplicar políticas que pertenecen a éste componente (políticas raíz)
            this.process.politicas.filter(function (pol) { return pol.componente == '<ROOT>'; }).forEach(function (pol) {
                _this.applyPolicy(pol);
            });
        }
    };
    return ProcessComponent;
}(BaseComponent));
export { ProcessComponent };
