var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
//
import { Context } from './context';
var AuthGuard = /** @class */ (function () {
    function AuthGuard(context, router) {
        this.context = context;
        this.router = router;
    }
    AuthGuard.prototype.canActivate = function (route, state) {
        var url = state.url;
        var valid = false;
        //Verificar si el usuario ya hizo login
        valid = this.checkLogin(url);
        //Si es un proceso, verificar que el usuario tiene acceso y que la ruta corresponde con el proceso mismo        
        if (valid && route.params['proceso']) {
            var idProceso = +route.params['proceso'];
            valid = this.hasProcessAccess(idProceso);
            if (!valid) {
                this.router.navigate(['kernel/security/unauthorized']);
            }
        }
        return valid;
    };
    AuthGuard.prototype.canActivateChild = function (route, state) {
        return this.canActivate(route, state);
    };
    AuthGuard.prototype.checkLogin = function (url) {
        if (this.context.session && this.context.app.defaultSite) {
            return true;
        }
        this.context.redirectUrl = url;
        if (this.context.session)
            this.router.navigate(['/select-company']);
        else
            this.router.navigate(['/login']);
        return false;
    };
    AuthGuard.prototype.getUrlPath = function (route) {
        var url = '';
        route.url.forEach(function (segment) {
            url += '/' + segment.path;
        });
        if (route.parent) {
            url = this.getUrlPath(route.parent) + url;
        }
        return url;
    };
    AuthGuard.prototype.hasProcessAccess = function (idProceso) {
        var access = false;
        this.context.access.forEach(function (modulo) {
            if (modulo.procesos.find(function (p) { return p.id == idProceso; })) {
                access = true;
            }
        });
        return access;
    };
    AuthGuard = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Context, Router])
    ], AuthGuard);
    return AuthGuard;
}());
export { AuthGuard };
