import { Router, UrlTree } from '@angular/router';
import { SessionInfo } from '../models/session';
import { EmpresaInfo } from '../models/empresa';
import { SucursalInfo } from '../models/sucursal';
import { ModuloItem } from '../models/modulo';
export declare class Context {
    private router;
    private _session;
    private _application;
    private _navigator;
    private _access;
    private _reportViewerUrl;
    readonly app: Application;
    readonly navigator: Navigator;
    readonly session: SessionInfo;
    readonly access: ModuloItem[];
    redirectUrl: string;
    readonly kernelImagesPath: string;
    readonly fileServerPath: string;
    readonly reportViewerUrl: string;
    constructor(router: Router);
    setSession(session: SessionInfo): void;
    setAccess(access: ModuloItem[]): void;
    clearSession(): void;
    setReportViewerUrl(url: string): void;
    getExceptionMessage(ex: any): string;
}
export declare class Application {
    private _defaultCompany;
    private _defaultSite;
    private _isLoading;
    private _rootModules;
    currentModule: number;
    readonly isLoading: boolean;
    readonly defaultCompany: EmpresaInfo;
    readonly defaultSite: SucursalInfo;
    readonly rootModules: ModuloItem[];
    showSpinner(): void;
    hideSpinner(): void;
    setDefaultCompany(company: EmpresaInfo): void;
    setDefaultSite(site: SucursalInfo): void;
    setRootModules(modules: ModuloItem[]): void;
    clear(): void;
    readonly defaultWidth: string;
}
export declare class Navigator {
    previousUrl: UrlTree;
    lastNavigatedUrl: UrlTree;
    checkPoint: UrlTree;
}
