var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { Router, NavigationEnd } from '@angular/router';
import { pairwise, filter } from 'rxjs/operators';
var Context = /** @class */ (function () {
    function Context(router) {
        var _this = this;
        this.router = router;
        this._session = null;
        this._application = new Application();
        this._navigator = new Navigator();
        this._access = [];
        this._reportViewerUrl = '';
        this.router.events
            .pipe(filter(function (e) { return e instanceof NavigationEnd; }), pairwise())
            .subscribe(function (urls) {
            var url1 = urls[0];
            var url2 = urls[1];
            _this.navigator.previousUrl = _this.router.parseUrl(url1.url);
            _this.navigator.lastNavigatedUrl = _this.router.parseUrl(url2.url);
        });
    }
    Object.defineProperty(Context.prototype, "app", {
        get: function () {
            return this._application;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "navigator", {
        get: function () {
            return this._navigator;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "session", {
        get: function () {
            if (this._session != null) {
                return this._session;
            }
            else {
                var storedSession = sessionStorage.getItem('session');
                if (storedSession != null) {
                    this._session = JSON.parse(storedSession);
                    return this._session;
                }
                else {
                    return null;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "access", {
        get: function () {
            if (this._access.length > 0) {
                return this._access;
            }
            else {
                var storedAccess = sessionStorage.getItem('access');
                if (storedAccess != null) {
                    this._access = JSON.parse(storedAccess);
                    return this._access;
                }
                else {
                    return [];
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "kernelImagesPath", {
        get: function () {
            return "img/kernel/";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "fileServerPath", {
        get: function () {
            return 'file-server/';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "reportViewerUrl", {
        get: function () {
            if (this._reportViewerUrl != '') {
                return this._reportViewerUrl;
            }
            else {
                var storedUrl = sessionStorage.getItem('reportViewerUrl');
                if (storedUrl != null) {
                    this._reportViewerUrl = storedUrl;
                    return this._reportViewerUrl;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    //
    Context.prototype.setSession = function (session) {
        this._session = session;
        sessionStorage.setItem('session', JSON.stringify(session));
    };
    Context.prototype.setAccess = function (access) {
        this._access = access;
        sessionStorage.setItem('access', JSON.stringify(access));
    };
    Context.prototype.clearSession = function () {
        this._session = null;
        sessionStorage.removeItem('session');
        this.app.clear();
    };
    Context.prototype.setReportViewerUrl = function (url) {
        this._reportViewerUrl = url;
        sessionStorage.setItem('reportViewerUrl', url);
    };
    Context.prototype.getExceptionMessage = function (ex) {
        var response = ex;
        if (response.error) {
            return response.error.message;
        }
        else {
            return response.message;
        }
    };
    Context = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Router])
    ], Context);
    return Context;
}());
export { Context };
var Application = /** @class */ (function () {
    function Application() {
        this._defaultCompany = null;
        this._defaultSite = null;
        this._isLoading = false;
        this._rootModules = [];
        this.currentModule = 0;
    }
    Object.defineProperty(Application.prototype, "isLoading", {
        get: function () {
            return this._isLoading;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Application.prototype, "defaultCompany", {
        get: function () {
            if (this._defaultCompany != null) {
                return this._defaultCompany;
            }
            else {
                var storedCompany = sessionStorage.getItem('defaultCompany');
                if (storedCompany != null) {
                    this._defaultCompany = JSON.parse(storedCompany);
                    return this._defaultCompany;
                }
                else {
                    return null;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Application.prototype, "defaultSite", {
        get: function () {
            if (this._defaultSite != null) {
                return this._defaultSite;
            }
            else {
                var storedSite = sessionStorage.getItem('defaultSite');
                if (storedSite != null) {
                    this._defaultSite = JSON.parse(storedSite);
                    return this._defaultSite;
                }
                else {
                    return null;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Application.prototype, "rootModules", {
        get: function () {
            if (this._rootModules.length > 0) {
                return this._rootModules;
            }
            else {
                var storedRoots = sessionStorage.getItem('rootModules');
                if (storedRoots != null) {
                    this._rootModules = JSON.parse(storedRoots);
                    return this._rootModules;
                }
                else {
                    return [];
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Application.prototype.showSpinner = function () {
        this._isLoading = true;
    };
    Application.prototype.hideSpinner = function () {
        this._isLoading = false;
    };
    Application.prototype.setDefaultCompany = function (company) {
        this._defaultCompany = company;
        sessionStorage.setItem('defaultCompany', JSON.stringify(company));
    };
    Application.prototype.setDefaultSite = function (site) {
        this._defaultSite = site;
        sessionStorage.setItem('defaultSite', JSON.stringify(site));
    };
    Application.prototype.setRootModules = function (modules) {
        this._rootModules = modules;
        sessionStorage.setItem('rootModules', JSON.stringify(modules));
    };
    Application.prototype.clear = function () {
        this._defaultCompany = null;
        sessionStorage.removeItem('defaultCompany');
        this._defaultSite = null;
        sessionStorage.removeItem('defaultSite');
    };
    Object.defineProperty(Application.prototype, "defaultWidth", {
        get: function () {
            return "col-12 col-lg-10";
        },
        enumerable: true,
        configurable: true
    });
    return Application;
}());
export { Application };
var Navigator = /** @class */ (function () {
    function Navigator() {
    }
    return Navigator;
}());
export { Navigator };
