var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { map } from 'rxjs/operators';
import * as moment from 'moment';
//Azteca Kernel
import { CatalogService } from '../services/catalog.service';
import { Context } from '../services/context';
//Locales
import { DocumentTypeInfo } from '../models/document-type';
var DocumentTypeService = /** @class */ (function (_super) {
    __extends(DocumentTypeService, _super);
    function DocumentTypeService(http, context) {
        return _super.call(this, http, context, 'api/business/document-type') || this;
    }
    DocumentTypeService.prototype.create = function () {
        return Promise.resolve(new DocumentTypeInfo());
    };
    DocumentTypeService.prototype.saveWorkflow = function (idTipoDocumento, workflow) {
        var params = new HttpParams()
            .set('idTipoDocumento', idTipoDocumento.toString());
        //
        return this.apiService.post('save-workflow', params, workflow)
            .toPromise();
    };
    DocumentTypeService.prototype.loadWorkflowHistory = function (idDocumento) {
        var params = new HttpParams()
            .set('idDocumento', idDocumento);
        //
        return this.apiService.get('workflow-history', params)
            .pipe(map(function (history) {
            //Convertir las fechas
            history.forEach(function (row) {
                row.fecha = moment(row.fecha).toDate();
                row.startStep = moment(row.startStep).toDate();
                row.endStep = moment(row.endStep).toDate();
            });
            return history;
        }))
            .toPromise();
    };
    DocumentTypeService.prototype.loadOrigenId = function (codigoTipo, tagOrigen) {
        var params = new HttpParams()
            .set('codigoTipo', codigoTipo)
            .set('tagOrigen', tagOrigen);
        return this.apiService.get('origen-id', params)
            .toPromise();
    };
    DocumentTypeService.prototype.loadList = function () {
        var params = new HttpParams();
        return this.apiService.get('load-list', params)
            .toPromise();
    };
    DocumentTypeService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], DocumentTypeService);
    return DocumentTypeService;
}(CatalogService));
export { DocumentTypeService };
