var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { CatalogService } from '../services/catalog.service';
import { Context } from '../services/context';
import { GrupoInfo } from '../models/grupo';
var GrupoService = /** @class */ (function (_super) {
    __extends(GrupoService, _super);
    function GrupoService(http, context) {
        return _super.call(this, http, context, 'api/kernel/security/grupos') || this;
    }
    GrupoService.prototype.create = function () {
        return Promise.resolve(new GrupoInfo());
    };
    ///////////////////////////// USUARIOS ////////////////////////////////////////////////
    GrupoService.prototype.getMembers = function (idGrupo) {
        var params = new HttpParams()
            .set('idGrupo', idGrupo.toString());
        //
        return this.apiService.get('get-members', params)
            .toPromise();
    };
    GrupoService.prototype.addMembers = function (idGrupo, usuarios) {
        var params = new HttpParams()
            .set('idGrupo', idGrupo.toString());
        //
        return this.apiService.post('add-members', params, usuarios)
            .toPromise();
    };
    GrupoService.prototype.removeMember = function (idGrupo, idUsuario) {
        var params = new HttpParams()
            .set('idGrupo', idGrupo.toString())
            .set('idUsuario', idUsuario.toString());
        //
        return this.apiService.delete('remove-member', params)
            .toPromise();
    };
    ///////////////////////////// ACCESO A PROCESOS /////////////////////////////////////////////
    GrupoService.prototype.loadProcesos = function (idGrupo) {
        var params = new HttpParams()
            .set('idGrupo', idGrupo.toString());
        //
        return this.apiService.get('procesos', params)
            .toPromise();
    };
    GrupoService.prototype.saveProcesos = function (idGrupo, procesos) {
        var params = new HttpParams()
            .set('idGrupo', idGrupo.toString());
        //
        return this.apiService.post('save-procesos', params, procesos)
            .toPromise();
    };
    GrupoService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], GrupoService);
    return GrupoService;
}(CatalogService));
export { GrupoService };
