var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//
import { CatalogService } from './catalog.service';
var HierarchyService = /** @class */ (function (_super) {
    __extends(HierarchyService, _super);
    function HierarchyService(http, context, serviceUrl) {
        var _this = _super.call(this, http, context, serviceUrl) || this;
        _this.http = http;
        _this.context = context;
        _this.serviceUrl = serviceUrl;
        return _this;
    }
    HierarchyService.prototype.loadChildren = function (idCompany, idParent) {
        var params = new HttpParams()
            .set('idCompany', idCompany.toString())
            .set('idParent', idParent.toString());
        //
        return this.apiService.get('children', params)
            .toPromise();
    };
    HierarchyService.prototype.moveNode = function (idNode, idTargetParent, order) {
        var params = new HttpParams()
            .set('idNode', idNode.toString())
            .set('idTargetParent', idTargetParent.toString())
            .set('order', order.toString());
        //
        return this.apiService.put('move-node', params)
            .toPromise();
    };
    HierarchyService.prototype.loadHierarchy = function (idCompany, idParent) {
        var params = new HttpParams()
            .set('idCompany', idCompany.toString())
            .set('idParent', idParent.toString());
        return this.apiService.get('load-hierarchy', params)
            .toPromise();
    };
    HierarchyService.prototype.saveHierarchy = function (changes) {
        var params = new HttpParams();
        //
        return this.apiService.post('save-hierarchy', params, changes)
            .toPromise();
    };
    return HierarchyService;
}(CatalogService));
export { HierarchyService };
