var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//
import { CatalogService } from '../services/catalog.service';
import { Context } from '../services/context';
//
import { SucursalInfo } from '../models/sucursal';
var SucursalService = /** @class */ (function (_super) {
    __extends(SucursalService, _super);
    function SucursalService(http, context) {
        return _super.call(this, http, context, "api/kernel/security/sucursales") || this;
    }
    SucursalService.prototype.create = function () {
        return Promise.resolve(new SucursalInfo());
    };
    SucursalService.prototype.getMembers = function (idBranch) {
        var params = new HttpParams()
            .set('idBranch', idBranch.toString());
        //
        return this.apiService.get('members', params)
            .toPromise();
    };
    SucursalService.prototype.addMembers = function (idBranch, users) {
        var params = new HttpParams()
            .set('idBranch', idBranch.toString());
        //
        return this.apiService.post('add-members', params, users)
            .toPromise();
    };
    SucursalService.prototype.removeMember = function (idBranch, idUser) {
        var params = new HttpParams()
            .set('idBranch', idBranch.toString())
            .set('idUser', idUser.toString());
        //
        return this.apiService.delete('remove-member', params)
            .toPromise();
    };
    SucursalService.prototype.loadListByUserCompany = function (idEmpresa, idUsuario) {
        var params = new HttpParams()
            .set('idEmpresa', idEmpresa.toString())
            .set('idUsuario', idUsuario.toString());
        return this.apiService.get('load-list-by-user-company', params)
            .toPromise();
    };
    SucursalService.prototype.loadCbo = function () {
        return this.apiService.get('load-cbo')
            .toPromise();
    };
    SucursalService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], SucursalService);
    return SucursalService;
}(CatalogService));
export { SucursalService };
