import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { CatalogService } from '../services/catalog.service';
import { Context } from '../services/context';
import { SessionInfo } from '../models/session';
import { SucursalItem } from '../models/sucursal';
import { UsuarioInfo } from '../models/usuario';
import { ProcesoAcceso } from '../models/proceso';
export declare class UsuarioService extends CatalogService<UsuarioInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<UsuarioInfo>;
    login(userName: string, password: string, workStation: string): Promise<SessionInfo>;
    logout(idUsuario: number, workStation: string): Promise<void>;
    loadBranchAccess(idUsuario: number): Promise<SucursalItem[]>;
    addBranches(idUsuario: number, sucursales: SucursalItem[]): Promise<any>;
    removeBranch(idUsuario: number, idSucursal: number): Promise<any>;
    changePassword(idUsuario: number, passwordActual: string, nuevoPassword: string): Promise<any>;
    resetPassword(idUsuario: number): Promise<any>;
    loadProcesos(idUsuario: number, idSucursal: number): Promise<ProcesoAcceso[]>;
    saveProcesos(idUsuario: number, idSucursal: number, procesos: ProcesoAcceso[]): Promise<any>;
}
