var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { CatalogService } from '../services/catalog.service';
import { Context } from '../services/context';
import { UsuarioInfo } from '../models/usuario';
var UsuarioService = /** @class */ (function (_super) {
    __extends(UsuarioService, _super);
    function UsuarioService(http, context) {
        return _super.call(this, http, context, "api/kernel/security/usuarios") || this;
    }
    UsuarioService.prototype.create = function () {
        return Promise.resolve(new UsuarioInfo());
    };
    UsuarioService.prototype.login = function (userName, password, workStation) {
        var params = new HttpParams()
            .set('userName', userName)
            .set('password', password)
            .set('workstation', workStation);
        //
        return this.apiService.get('login', params)
            .toPromise();
    };
    UsuarioService.prototype.logout = function (idUsuario, workStation) {
        this.context.clearSession();
        return Promise.resolve();
    };
    UsuarioService.prototype.loadBranchAccess = function (idUsuario) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString());
        //
        return this.apiService.get('load-branch-access', params)
            .toPromise();
    };
    UsuarioService.prototype.addBranches = function (idUsuario, sucursales) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString());
        //
        return this.apiService.post('add-branches', params, sucursales)
            .toPromise();
    };
    UsuarioService.prototype.removeBranch = function (idUsuario, idSucursal) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.delete('remove-branch', params)
            .toPromise();
    };
    UsuarioService.prototype.changePassword = function (idUsuario, passwordActual, nuevoPassword) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('passwordActual', passwordActual)
            .set('nuevoPassword', nuevoPassword);
        //
        return this.apiService.put('change-password', params, null)
            .toPromise();
    };
    UsuarioService.prototype.resetPassword = function (idUsuario) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString());
        //
        return this.apiService.put('reset-password', params, null)
            .toPromise();
    };
    ///////////////////////////// ACCESO A PROCESOS /////////////////////////////////////////////
    UsuarioService.prototype.loadProcesos = function (idUsuario, idSucursal) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.get('procesos', params)
            .toPromise();
    };
    UsuarioService.prototype.saveProcesos = function (idUsuario, idSucursal, procesos) {
        var params = new HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.post('save-procesos', params, procesos)
            .toPromise();
    };
    UsuarioService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], UsuarioService);
    return UsuarioService;
}(CatalogService));
export { UsuarioService };
