import { HttpClient, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import { Context } from './context';
export declare class WebService {
    private http;
    url: string;
    private context;
    readonly _sessionHeaderTag: string;
    constructor(http: HttpClient, url: string, context: Context);
    query<T>(params?: HttpParams): Observable<T>;
    get<T>(action: string, params?: HttpParams): Observable<T>;
    getText(action: string, params?: HttpParams): Observable<string>;
    post<T>(action: string, params?: HttpParams, body?: any): Observable<T>;
    postText<T>(action: string, params?: HttpParams, body?: string): Observable<T>;
    put<T>(action: string, params?: HttpParams, body?: any): Observable<T>;
    patch<T>(action: string, params?: HttpParams, body?: any): Observable<T>;
    delete<T>(action: string, params?: HttpParams): Observable<T>;
}
