var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context } from './context';
var WebService = /** @class */ (function () {
    function WebService(http, url, context) {
        this.http = http;
        this.url = url;
        this.context = context;
        this._sessionHeaderTag = 'Azteca-sessionID';
    }
    WebService.prototype.query = function (params) {
        return this.http.get(this.url, { params: params });
    };
    WebService.prototype.get = function (action, params) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.get(this.url + '/' + action, { headers: headers, params: params });
    };
    WebService.prototype.getText = function (action, params) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.get(this.url + '/' + action, { headers: headers, params: params, responseType: 'text' });
    };
    WebService.prototype.post = function (action, params, body) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.post(this.url + '/' + action, body, { headers: headers, params: params });
    };
    WebService.prototype.postText = function (action, params, body) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.post(this.url + '/' + action, JSON.stringify(body), { headers: headers, params: params });
    };
    WebService.prototype.put = function (action, params, body) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.put(this.url + '/' + action, body, { headers: headers, params: params });
    };
    WebService.prototype.patch = function (action, params, body) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.patch(this.url + '/' + action, body, { headers: headers, params: params });
    };
    WebService.prototype.delete = function (action, params) {
        var headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Accept', 'q=0.8;application/json;q=0.9');
        //Si el contexto ya tiene una sesión, agrear encabezado con el Session ID
        if (this.context.session) {
            headers = headers.set(this._sessionHeaderTag, this.context.session.sessionID);
        }
        return this.http.delete(this.url + '/' + action, { headers: headers, params: params });
    };
    WebService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, String, Context])
    ], WebService);
    return WebService;
}());
export { WebService };
