import { Router } from '@angular/router';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, DataMap } from 'wijmo/wijmo.grid';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from '../../core/services/context';
import { EnsambladoService } from '../../core/services/ensamblado.service';
import { EnsambladoItem } from '../../core/models/ensamblado';
import { ToolbarButtonDirective } from '../../controls/directives/toolbar-button.directive';
import { Alert } from '../../controls/models/alert';
import { CatalogOptions } from '../models/catalog-options';
import { CustomCatalogService } from '../services/custom-catalog.service';
export declare class CustomCatalogManager {
    private context;
    private customService;
    private router;
    private location;
    private ensambladoService;
    alerts: Alert[];
    collectionView: CollectionView;
    ensamblados: EnsambladoItem[];
    ensambladosMap: DataMap;
    currentItem: CatalogOptions;
    detailsDialog: ModalDirective;
    grid: FlexGrid;
    constructor(context: Context, customService: CustomCatalogService, router: Router, location: Location, ensambladoService: EnsambladoService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadData(): void;
    loadEnsamblados(): void;
    saveData(): void;
    mainToolbarHandler(button: ToolbarButtonDirective): void;
    detailsToolbarHandler(button: ToolbarButtonDirective): void;
    onRowEdit(item: CatalogOptions): void;
    hideDetailsDialog(): void;
    showAlert(message: string, type: string): void;
    closeAlert(i: number): void;
    handleError(error: any): void;
}
