import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core/services/context';
import { EnsambladoItem } from '../../core/models/ensamblado';
import { EnsambladoService } from '../../core/services/ensamblado.service';
import { CatalogOptions } from '../../custom/models/catalog-options';
import { ToolbarButton } from '../../controls/models/toolbar-button';
import { MenuItem } from '../../controls/models/menu-item';
import { CatalogEditor } from '../../editors/models/catalog-editor';
import { EditorEventArgs } from '../../editors/models/editor-event-args';
import { TrackableCollection } from '../../editors/components/trackable-collection';
import { DocumentTypeService } from '../../core/services/document-type.service';
import { DocumentTypeInfo } from '../../core/models/document-type';
import { Activity } from '../../core/models/activity';
import { ActividadEditor } from './parts/actividad.editor';
export declare class DocumentTypeEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private documentTypeService;
    private ensambladoService;
    documentType: DocumentTypeInfo;
    ensamblados: EnsambladoItem[];
    actividadesCollection: TrackableCollection;
    currentActivity: Activity;
    private _lastActivity;
    activityEditor: ActividadEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, documentTypeService: DocumentTypeService, ensambladoService: EnsambladoService);
    cargarEnsamblados(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(option: MenuItem): void;
    onActividadesToolbar(button: ToolbarButton): void;
    onActivityUpated(actividad: Activity): void;
    onRowDelete(actividad: Activity): void;
    onTabSelected(args: any): void;
}
