var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//ngx bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//
import { Context } from '../../../core/services/context';
import { ChangeState } from '../../../core/models/change-tracking';
//
import { Activity } from '../../../core/models/activity';
//
var ActividadEditor = /** @class */ (function () {
    function ActividadEditor(context, formBuilder) {
        this.context = context;
        this.formBuilder = formBuilder;
        //Inputs
        this.actividad = new Activity();
        //Outputs
        this.activityUpdated = new EventEmitter();
        this.form = this.formBuilder.group({
            'tag': ['', Validators.required],
            'orden': [0],
            'descripcion': ['', Validators.required]
        });
    }
    //////////// METODOS //////////////////////////
    ActividadEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.load(); });
    };
    ActividadEditor.prototype.load = function () {
        if (this.actividad._clientID == 0) {
            this.form.reset({ tag: '', orden: 0 });
        }
    };
    //////////// HANDLERS //////////////////////////
    ActividadEditor.prototype.onUpdate = function () {
        if (this.actividad.state == ChangeState.UNCHANGED) {
            this.actividad.state = ChangeState.MODIFIED;
        }
        this.dialog.hide();
        this.activityUpdated.emit(this.actividad);
    };
    ActividadEditor.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ActividadEditor.prototype, "actividad", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ActividadEditor.prototype, "activityUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], ActividadEditor.prototype, "dialog", void 0);
    ActividadEditor = __decorate([
        Component({
            selector: 'custom-activity-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title pull-left\">Editar actividad</h4>\n                          <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div>\n                      <div class=\"modal-body\">\n\n                          <azteca-form-field [label]=\"'ID:'\">\n                              <az-textbox formControlName=\"tag\" [(ngModel)]=\"actividad.tag\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                              <az-textbox formControlName=\"descripcion\" [(ngModel)]=\"actividad.descripcion\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Orden:'\">\n                              <az-input-number formControlName=\"orden\" [(ngModel)]=\"actividad.orden\"></az-input-number>\n                          </azteca-form-field>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate($event)\" [disabled]=\"!form.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div>\n      </form> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder])
    ], ActividadEditor);
    return ActividadEditor;
}());
export { ActividadEditor };
