var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
//ngx bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Kernel
import { Context } from '../../../core/services/context';
import { GrupoService } from '../../../core/services/grupo.service';
//
import { AccessGroupInfo } from '../../models/access-group';
import { EditableListComponent } from '../../../editors/components/editable-list.component';
import { WorkflowActivity } from '../../models/workflow-activity';
import { GrupoSelectorComponent } from '../../../security/components/controls/grupo-selector.component';
var WorkflowAccessGroupEditor = /** @class */ (function () {
    function WorkflowAccessGroupEditor(context, grupoSvc) {
        this.context = context;
        this.grupoSvc = grupoSvc;
        this.idGrupo = 0;
        this.activityCopy = new WorkflowActivity();
        this.accessGroups = [];
        //Inputs
        this.activity = new WorkflowActivity();
        //Outputs
        this.accessGroupUpdated = new EventEmitter();
    }
    WorkflowAccessGroupEditor.prototype.ngAfterViewInit = function () {
    };
    //////////////////////////////////// METODOS /////////////////////////////////////////////
    WorkflowAccessGroupEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.load(); });
    };
    WorkflowAccessGroupEditor.prototype.load = function () {
        this.activityCopy = this.copy(this.activity);
        this.accessGroups = this.activityCopy.groups;
    };
    WorkflowAccessGroupEditor.prototype.copy = function (activity) {
        return JSON.parse(JSON.stringify(activity));
    };
    WorkflowAccessGroupEditor.prototype.copyGroups = function (activity) {
        return JSON.parse(JSON.stringify(activity));
    };
    //////////////////////////////////// HANDLERS /////////////////////////////////////////////
    WorkflowAccessGroupEditor.prototype.onUpdate = function () {
        this.activityCopy.groups = this.copyGroups(this.accessGroups);
        this.accessGroupUpdated.emit(this.activityCopy);
        this.dialog.hide();
    };
    WorkflowAccessGroupEditor.prototype.handleError = function (error) {
        console.log(error);
    };
    //////////////////////////////////// Groups /////////////////////////////////////////////
    WorkflowAccessGroupEditor.prototype.onClickAddGroup = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoSvc.getDetailByID(this.idGrupo).then(function (info) {
            var accessGroup = new AccessGroupInfo();
            accessGroup._clientID = info.identity;
            accessGroup.idGroup = info.identity;
            accessGroup.apply = true;
            accessGroup.cancel = true;
            accessGroup.group = info;
            _this.editListAccessGroup.updateItem(accessGroup);
            _this.groupSelector.clear();
            _this.context.app.hideSpinner();
        }).catch(function (error) { return _this.handleError(error); });
    };
    WorkflowAccessGroupEditor.prototype.onUpdatedAccessGroup = function (item) {
    };
    WorkflowAccessGroupEditor.prototype.onDeletingAccessGroup = function (item) {
        this.editListAccessGroup.deleteItem(item);
    };
    WorkflowAccessGroupEditor.prototype.onItemsUpdatedAccessGroup = function (items) {
        this.accessGroups = items;
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], WorkflowAccessGroupEditor.prototype, "activity", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], WorkflowAccessGroupEditor.prototype, "accessGroupUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], WorkflowAccessGroupEditor.prototype, "dialog", void 0);
    __decorate([
        ViewChild(GrupoSelectorComponent),
        __metadata("design:type", GrupoSelectorComponent)
    ], WorkflowAccessGroupEditor.prototype, "groupSelector", void 0);
    __decorate([
        ViewChild('editListAccessGroup'),
        __metadata("design:type", EditableListComponent)
    ], WorkflowAccessGroupEditor.prototype, "editListAccessGroup", void 0);
    WorkflowAccessGroupEditor = __decorate([
        Component({
            selector: 'custom-workflow-access-group-editor',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>Editar acceso a grupo</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n                  <div class=\"modal-body\">\n\n                      <security-grupo-selector [(ngModel)]=\"idGrupo\"></security-grupo-selector>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickAddGroup($event)\" [disabled]=\"idGrupo == 0\">Agregar</button>\n                      <azteca-editable-list #editListAccessGroup\n                                            [allowNew]=\"false\"\n                                            [allowEdit]=\"true\"\n                                            [listItems]=\"accessGroups\"\n                                            (listItemsUpdated)=\"onItemsUpdatedAccessGroup($event)\"\n                                            (deletingItem)=\"onDeletingAccessGroup($event)\">\n\n                          <!-- OPCIONES DEL MENU-->\n                          <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                          <!-- COLUMNAS DEL GRID-->\n                          <azteca-grid-column [header]=\"'Grupo'\" [binding]=\"'group.code'\" [width]=\"90\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'group.nombre'\" [width]=\"'80*'\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Aplicar'\" [binding]=\"'apply'\" [width]=\"70\" [isReadOnly]=\"false\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Cancelar'\" [binding]=\"'cancel'\" [width]=\"70\" [isReadOnly]=\"false\"></azteca-grid-column>\n                      </azteca-editable-list>\n\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, GrupoService])
    ], WorkflowAccessGroupEditor);
    return WorkflowAccessGroupEditor;
}());
export { WorkflowAccessGroupEditor };
