import { EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from '../../../core/services/context';
import { UsuarioService } from '../../../core/services/usuario.service';
import { EmpresaItem } from '../../../core/models/empresa';
import { SucursalItem } from '../../../core/models/sucursal';
import { AccessUserInfo } from '../../models/access-user';
import { EditableListComponent } from '../../../editors/components/editable-list.component';
import { WorkflowActivity } from '../../models/workflow-activity';
import { UsuarioSelectorComponent } from '../../../security/components/controls/usuario-selector.component';
export declare class WorkflowAccessUserEditor {
    private context;
    private userSvc;
    idUsuario: number;
    activityCopy: WorkflowActivity;
    accessUsers: AccessUserInfo[];
    companiesCopy: EmpresaItem[];
    branchesCopy: SucursalItem[];
    companySelected: number;
    branchSelected: number;
    activity: WorkflowActivity;
    companies: EmpresaItem[];
    branches: SucursalItem[];
    accessUsersUpdated: EventEmitter<WorkflowActivity>;
    dialog: ModalDirective;
    usuarioSelector: UsuarioSelectorComponent;
    editListAccessUser: EditableListComponent;
    constructor(context: Context, userSvc: UsuarioService);
    ngAfterViewInit(): void;
    show(): void;
    load(): void;
    copy(activity: WorkflowActivity): WorkflowActivity;
    copyUsers(activity: AccessUserInfo[]): AccessUserInfo[];
    selectEmpresa(idEmpresa: number): void;
    onUpdate(): void;
    handleError(error: any): void;
    onClickAddUser(args: any): void;
    onUpdatedAccessUser(item: any): void;
    onDeletingAccessUser(item: any): void;
    onItemsUpdatedAccessUser(items: AccessUserInfo[]): void;
    createClientID(): number;
}
