var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
//ngx bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//moment
import * as moment from 'moment';
//Kernel
import { Context } from '../../../core/services/context';
import { UsuarioService } from '../../../core/services/usuario.service';
//
import { AccessUserInfo } from '../../models/access-user';
import { EditableListComponent } from '../../../editors/components/editable-list.component';
import { WorkflowActivity } from '../../models/workflow-activity';
import { UsuarioSelectorComponent } from '../../../security/components/controls/usuario-selector.component';
var WorkflowAccessUserEditor = /** @class */ (function () {
    function WorkflowAccessUserEditor(context, userSvc) {
        this.context = context;
        this.userSvc = userSvc;
        this.idUsuario = 0;
        this.activityCopy = new WorkflowActivity();
        this.accessUsers = [];
        this.companiesCopy = [];
        this.branchesCopy = [];
        //Inputs
        this.activity = new WorkflowActivity();
        //Outputs
        this.accessUsersUpdated = new EventEmitter();
    }
    WorkflowAccessUserEditor.prototype.ngAfterViewInit = function () {
    };
    //////////////////////////////////// METODOS /////////////////////////////////////////////
    WorkflowAccessUserEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.load(); });
    };
    WorkflowAccessUserEditor.prototype.load = function () {
        this.activityCopy = this.copy(this.activity);
        this.accessUsers = this.activityCopy.users;
        this.companiesCopy = this.companies.slice();
    };
    WorkflowAccessUserEditor.prototype.copy = function (activity) {
        return JSON.parse(JSON.stringify(activity));
    };
    WorkflowAccessUserEditor.prototype.copyUsers = function (activity) {
        return JSON.parse(JSON.stringify(activity));
    };
    WorkflowAccessUserEditor.prototype.selectEmpresa = function (idEmpresa) {
        this.branchesCopy = this.branches.filter(function (sucursal, index, sucursales) { return sucursal.idEmpresa == idEmpresa; });
        this.branchesCopy.unshift({ id: null, idEmpresa: 0, codigo: '', nombre: '[Seleccione una sucursal]', activo: true });
        this.branchSelected = null;
    };
    //////////////////////////////////// HANDLERS /////////////////////////////////////////////
    WorkflowAccessUserEditor.prototype.onUpdate = function () {
        this.activityCopy.users = this.copyUsers(this.accessUsers);
        this.accessUsersUpdated.emit(this.activityCopy);
        this.dialog.hide();
    };
    WorkflowAccessUserEditor.prototype.handleError = function (error) {
        console.log(error);
    };
    //////////////////////////////////// Users /////////////////////////////////////////////
    WorkflowAccessUserEditor.prototype.onClickAddUser = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        var branchesList = this.branches.filter(function (sucursal, index, sucursales) { return sucursal.id == _this.branchSelected; });
        var clientID = 0;
        this.accessUsers.forEach(function (item) {
            if (item.idUser == _this.idUsuario && item.idBranch == _this.branchSelected) {
                clientID = item._clientID;
            }
        });
        if (clientID == 0) {
            clientID = this.createClientID();
        }
        this.userSvc.getDetailByID(this.idUsuario).then(function (info) {
            var accessUser = new AccessUserInfo();
            accessUser._clientID = clientID;
            accessUser.idUser = info.identity;
            accessUser.idBranch = _this.branchSelected;
            accessUser.branch = (branchesList != null && branchesList.length > 0 ? branchesList[0].nombre : "");
            accessUser.apply = true;
            accessUser.cancel = true;
            accessUser.user = info;
            _this.editListAccessUser.updateItem(accessUser);
            _this.usuarioSelector.clear();
            _this.context.app.hideSpinner();
        }).catch(function (error) { return _this.handleError(error); });
    };
    WorkflowAccessUserEditor.prototype.onUpdatedAccessUser = function (item) {
    };
    WorkflowAccessUserEditor.prototype.onDeletingAccessUser = function (item) {
        this.editListAccessUser.deleteItem(item);
    };
    WorkflowAccessUserEditor.prototype.onItemsUpdatedAccessUser = function (items) {
        this.accessUsers = items;
    };
    WorkflowAccessUserEditor.prototype.createClientID = function () {
        return parseInt((Math.random() * 1000).toString()) * 1000 + parseInt(moment().format("HHmmss"));
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], WorkflowAccessUserEditor.prototype, "activity", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], WorkflowAccessUserEditor.prototype, "companies", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], WorkflowAccessUserEditor.prototype, "branches", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], WorkflowAccessUserEditor.prototype, "accessUsersUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], WorkflowAccessUserEditor.prototype, "dialog", void 0);
    __decorate([
        ViewChild(UsuarioSelectorComponent),
        __metadata("design:type", UsuarioSelectorComponent)
    ], WorkflowAccessUserEditor.prototype, "usuarioSelector", void 0);
    __decorate([
        ViewChild('editListAccessUser'),
        __metadata("design:type", EditableListComponent)
    ], WorkflowAccessUserEditor.prototype, "editListAccessUser", void 0);
    WorkflowAccessUserEditor = __decorate([
        Component({
            selector: 'custom-workflow-access-user-editor',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>Editar actividad acceso a usuarios</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n                  <div class=\"modal-body\">\n\n                      <div class=\"form-group\">\n                          <label for=\"cboEmpresa\">Empresa:</label>\n                          <select #empresa \n                                  id=\"cboEmpresa\"\n                                  name=\"cboEmrpesa\"\n                                  [(ngModel)]=\"companySelected\"\n                                  (change)=\"selectEmpresa(empresa.value)\"\n                                  class=\"form-control\">\n                              <option *ngFor=\"let e of companiesCopy\" [value]=\"e.id\">{{e.nombre}}</option>\n                          </select>\n                      </div>\n                      <div class=\"form-group\">\n                          <label for=\"cboSucursal\">Sucursal:</label>\n                          <select id=\"cboSucursal\"\n                                  name=\"cboSucursal\"\n                                  [(ngModel)]=\"branchSelected\" class=\"form-control\" \n                                  required>\n                              <option *ngFor=\"let s of branchesCopy\" [value]=\"s.id\">{{s.nombre}}</option>\n                          </select>\n                      </div>\n\n                      <usuario-selector [(ngModel)]=\"idUsuario\"></usuario-selector>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onClickAddUser($event)\" [disabled]=\"idUsuario == 0\">Agregar</button>\n                      <azteca-editable-list #editListAccessUser\n                                            [allowNew]=\"false\"\n                                            [allowEdit]=\"true\"\n                                            [listItems]=\"accessUsers\"\n                                            (listItemsUpdated)=\"onItemsUpdatedAccessUser($event)\"\n                                            (deletingItem)=\"onDeletingAccessUser($event)\">\n\n                          <!-- OPCIONES DEL MENU-->\n                          <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n                          <!-- COLUMNAS DEL GRID-->\n                          <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'user.code'\" [width]=\"90\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Sucursal'\" [binding]=\"'branch'\" [width]=\"90\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'user.persona.nombre'\" [width]=\"'80*'\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Ap. Paterno'\" [binding]=\"'user.persona.apellidoPaterno'\" [width]=\"90\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Ap. Materno'\" [binding]=\"'user.persona.apellidoMaterno'\" [width]=\"90\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Aplicar'\" [binding]=\"'apply'\" [width]=\"70\" [isReadOnly]=\"false\"></azteca-grid-column>\n                          <azteca-grid-column [header]=\"'Cancelar'\" [binding]=\"'cancel'\" [width]=\"70\" [isReadOnly]=\"false\"></azteca-grid-column>\n                      </azteca-editable-list>\n\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, UsuarioService])
    ], WorkflowAccessUserEditor);
    return WorkflowAccessUserEditor;
}());
export { WorkflowAccessUserEditor };
