var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, ViewChildren, QueryList } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//Wijmo
import { Control, CollectionView } from 'wijmo/wijmo';
//ngx bootstrap
import { ModalDirective, TabDirective } from 'ngx-bootstrap';
//Kernel
import { Context } from '../../../core/services/context';
//
import { WorkflowActivity } from '../../models/workflow-activity';
import { DocumentTypeService } from '../../../core/services/document-type.service';
var WorkflowActivityEditor = /** @class */ (function () {
    function WorkflowActivityEditor(context, documentTypeService, formBuilder) {
        this.context = context;
        this.documentTypeService = documentTypeService;
        this.formBuilder = formBuilder;
        this.activityCopy = new WorkflowActivity();
        this.documentActivities = [];
        this.actionsCollection = new CollectionView();
        this.activity = new WorkflowActivity();
        //Outputs
        this.activityUpdated = new EventEmitter();
        this.form = formBuilder.group({
            'tag': ['', Validators.required],
            'actionText': [''],
            'statusText': [''],
            'duracion': [0],
            'accessControl': ['']
        });
    }
    WorkflowActivityEditor.prototype.ngAfterViewInit = function () {
        //setTimeout(_ => this.loadFormularios());
    };
    //////////////////////////////////// METODOS /////////////////////////////////////////////
    WorkflowActivityEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.load(); });
    };
    WorkflowActivityEditor.prototype.load = function () {
        this.activityCopy = this.copy(this.activity);
        this.actionsCollection.sourceCollection = this.activityCopy.actions;
        this.tabs.toArray()[0].active = true;
    };
    WorkflowActivityEditor.prototype.copy = function (activity) {
        return JSON.parse(JSON.stringify(activity));
    };
    //////////////////////////////////// HANDLERS /////////////////////////////////////////////
    WorkflowActivityEditor.prototype.onUpdate = function () {
        this.activityUpdated.emit(this.activityCopy);
        this.dialog.hide();
    };
    WorkflowActivityEditor.prototype.onTabSelect = function (args) {
        if (args.heading) {
            Control.invalidateAll();
        }
    };
    WorkflowActivityEditor.prototype.handleError = function (error) {
        console.log(error);
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], WorkflowActivityEditor.prototype, "idTipoDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], WorkflowActivityEditor.prototype, "activity", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], WorkflowActivityEditor.prototype, "activityUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], WorkflowActivityEditor.prototype, "dialog", void 0);
    __decorate([
        ViewChildren(TabDirective),
        __metadata("design:type", QueryList)
    ], WorkflowActivityEditor.prototype, "tabs", void 0);
    WorkflowActivityEditor = __decorate([
        Component({
            selector: 'custom-workflow-activity-editor',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n\n                      <div class=\"modal-header\">\n                          <!--Modal Header-->\n                          <h4>Editar informaci\u00F3n de la actividad</h4>\n                          <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div> <!--Modal Header-->\n                      <div class=\"modal-body\">\n                          <tabset>\n                              <tab heading=\"General\" (select)=\"onTabSelect($event)\">\n\n                                  <azteca-form-field [label]=\"'Etiqueta (ID):'\">\n                                      <az-textbox formControlName=\"tag\" [(ngModel)]=\"activityCopy.tag\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Nombre de la acci\u00F3n:'\">\n                                      <az-textbox formControlName=\"actionText\" [(ngModel)]=\"activityCopy.actionText\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Nombre del estatus:'\">\n                                      <az-textbox formControlName=\"statusText\" [(ngModel)]=\"activityCopy.statusText\"></az-textbox>\n                                  </azteca-form-field>\n\n                                  <azteca-form-field [label]=\"'Duraci\u00F3n (horas):'\">\n                                      <az-input-number formControlName=\"duracion\" [(ngModel)]=\"activityCopy.duracion\" [format]=\"'n2'\"></az-input-number>\n                                  </azteca-form-field>\n\n                                  <az-checkbox [label]=\"'Controlar acceso por usuario y/o grupo'\" formControlName=\"accessControl\" [(ngModel)]=\"activityCopy.accessControl\"></az-checkbox>\n\n\n                              </tab>\n                              <tab heading=\"Actividades\" (select)=\"onTabSelect($event)\">\n\n                                  <wj-flex-grid style=\"height:400px\" [itemsSource]=\"actionsCollection\">\n                                      <wj-flex-grid-column [header]=\"'Sel'\" [binding]=\"'selected'\" [width]=\"40\" dataType=\"Boolean\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'ID'\" [binding]=\"'tag'\" [width]=\"150\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'descripcion'\" [width]=\"'*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n\n                              </tab>\n                          </tabset>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!form.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div> <!--Modal directive-->\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [Context, DocumentTypeService, FormBuilder])
    ], WorkflowActivityEditor);
    return WorkflowActivityEditor;
}());
export { WorkflowActivityEditor };
