var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder } from '@angular/forms';
//ngx bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Kernel
import { Context } from '../../../core/services/context';
import { TrackableCollection } from '../../../editors/components/trackable-collection';
//
import { WorkflowCondition } from '../../models/workflow-condition';
var WorkflowConditionEditor = /** @class */ (function () {
    function WorkflowConditionEditor(context, formBuilder) {
        this.context = context;
        this.formBuilder = formBuilder;
        this.conditionCopy = new WorkflowCondition();
        this.optionsCollection = new TrackableCollection();
        this.condition = new WorkflowCondition();
        //Outputs
        this.conditionUpdated = new EventEmitter();
    }
    WorkflowConditionEditor.prototype.ngAfterViewInit = function () {
    };
    //////////////////////////////////// METODOS /////////////////////////////////////////////
    WorkflowConditionEditor.prototype.show = function () {
        this.conditionCopy = this.copy(this.condition);
        this.optionsCollection.sourceCollection = this.conditionCopy.options;
        this.dialog.config.backdrop = false;
        this.dialog.show();
    };
    WorkflowConditionEditor.prototype.copy = function (condicion) {
        return JSON.parse(JSON.stringify(condicion));
    };
    //////////////////////////////////// HANDLERS /////////////////////////////////////////////
    WorkflowConditionEditor.prototype.onUpdate = function () {
        this.conditionUpdated.emit(this.conditionCopy);
        this.dialog.hide();
    };
    WorkflowConditionEditor.prototype.handleError = function (error) {
        console.log(error);
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], WorkflowConditionEditor.prototype, "idTipoDocumento", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], WorkflowConditionEditor.prototype, "condition", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], WorkflowConditionEditor.prototype, "conditionUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], WorkflowConditionEditor.prototype, "dialog", void 0);
    WorkflowConditionEditor = __decorate([
        Component({
            selector: 'custom-workflow-conditions-editor',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <!--Modal Header-->\n                      <h4>Editar opciones de la bifurcaci\u00F3n</h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"dialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div> <!--Modal Header-->\n\n                  <div class=\"modal-body\">\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n\n                              <wj-flex-grid style=\"height:550px\" [itemsSource]=\"optionsCollection\">\n                                  <wj-flex-grid-column [header]=\"'Tag'\" [binding]=\"'tag'\" [width]=\"200\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'text'\" [width]=\"'*'\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n\n                          </div>\n                      </div>\n\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder])
    ], WorkflowConditionEditor);
    return WorkflowConditionEditor;
}());
export { WorkflowConditionEditor };
