var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Wijmo
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Bootstrap
import { AlertModule, ModalModule, TabsModule } from 'ngx-bootstrap';
//Modulos
import { SecurityModule } from '../security/security.module';
import { SearchModule } from '../search/search.module';
import { UtilsModule } from '../utils/utils.module';
import { ControlsModule } from '../controls/controls.module';
import { EditorsModule } from '../editors/editors.module';
import { DrawingModule } from '../drawing/drawing.module';
import { CustomRoutingModule } from './custom.routing.module';
//Componentes
import { CustomCatalogManager } from './components/custom-catalog.manager';
import { EnsambladosManager } from './components/ensamblados.manager';
import { EnsambladosEditor } from './components/ensamblados.editor';
import { DocumentTypeManager } from './components/document-type.manager';
import { DocumentTypeEditor } from './components/document-type.editor';
import { WorkflowEditor } from './components/workflow.editor';
import { WorkflowActivityEditor } from './components/parts/workflow-activity.editor';
import { WorkflowConditionEditor } from './components/parts/workflow-condition.editor';
import { WorkflowAccessUserEditor } from './components/parts/workflow-access-user.editor';
import { WorkflowAccessGroupEditor } from './components/parts/workflow-access-group.editor';
//Parts
import { ActividadEditor } from './components/parts/actividad.editor';
//Servicios
import { CustomCatalogService } from './services/custom-catalog.service';
var COMPONENTS = [CustomCatalogManager, EnsambladosManager, EnsambladosEditor, DocumentTypeManager, DocumentTypeEditor, ActividadEditor, WorkflowEditor,
    WorkflowActivityEditor, WorkflowConditionEditor, WorkflowAccessUserEditor, WorkflowAccessGroupEditor];
var SERVICES = [CustomCatalogService];
var CustomModule = /** @class */ (function () {
    function CustomModule() {
    }
    CustomModule = __decorate([
        NgModule({
            imports: [
                CommonModule, FormsModule, ReactiveFormsModule,
                WjInputModule, WjGridModule, WjGridFilterModule,
                AlertModule, ModalModule, TabsModule,
                SecurityModule, SearchModule, UtilsModule, ControlsModule, CustomRoutingModule, EditorsModule, DrawingModule
            ],
            declarations: COMPONENTS,
            providers: SERVICES,
            exports: COMPONENTS
        })
    ], CustomModule);
    return CustomModule;
}());
export { CustomModule };
