var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
//Componentes
import { CustomCatalogManager } from './components/custom-catalog.manager';
import { EnsambladosManager } from './components/ensamblados.manager';
import { EnsambladosEditor } from './components/ensamblados.editor';
import { DocumentTypeManager } from './components/document-type.manager';
import { DocumentTypeEditor } from './components/document-type.editor';
import { WorkflowEditor } from './components/workflow.editor';
//
import { AuthGuard } from '../core/services/auth-guard.service';
import { EditorDeactivateGuard } from '../editors/index';
var routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'catalogos/:proceso', component: CustomCatalogManager },
            { path: 'ensamblados/:proceso', component: EnsambladosManager },
            { path: 'ensamblados/:proceso/:id', component: EnsambladosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'documents-type/:proceso', component: DocumentTypeManager },
            { path: 'documents-type/:proceso/:id', component: DocumentTypeEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'documents-type/:proceso/:id/workflow', component: WorkflowEditor, canDeactivate: [EditorDeactivateGuard] },
        ]
    },
];
var CustomRoutingModule = /** @class */ (function () {
    function CustomRoutingModule() {
    }
    CustomRoutingModule = __decorate([
        NgModule({
            imports: [
                RouterModule.forChild(routes)
            ],
            exports: [
                RouterModule
            ]
        })
    ], CustomRoutingModule);
    return CustomRoutingModule;
}());
export { CustomRoutingModule };
