import { EventEmitter, QueryList, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import { Shape } from '../models/shape';
import { LinkDirective } from '../directives/link.directive';
import { RhombusDirective } from '../directives/rhombus.directive';
import { RectangleDirective } from '../directives/rectangle.directive';
import { TextBlockDirective } from '../directives/text-block.directive';
import { PaperEventArgs } from '../models/paper-event-args';
import { ConnectionEventArgs } from '../models/connection-event-args';
import { DiagramService } from '../services/diagram.service';
export declare class PaperComponent {
    private diagramService;
    private _zone;
    private paper;
    width: number;
    height: number;
    gridSize: number;
    cellClick: EventEmitter<PaperEventArgs>;
    cellDblClick: EventEmitter<PaperEventArgs>;
    linkConnect: EventEmitter<ConnectionEventArgs>;
    linkDisconnect: EventEmitter<ConnectionEventArgs>;
    linkDeleted: EventEmitter<LinkDirective>;
    blankClick: EventEmitter<PaperEventArgs>;
    shapes: QueryList<Shape>;
    links: QueryList<LinkDirective>;
    rectangles: QueryList<RectangleDirective>;
    rhombus: QueryList<RhombusDirective>;
    textBlocks: QueryList<TextBlockDirective>;
    constructor(diagramService: DiagramService, _zone: NgZone);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    clear(): void;
    fitToContent(): void;
    createPaper(): void;
    private checkConnection;
    private checkDisconnection;
    private removeLink;
    createLinks(): void;
    private addEventListeners;
    createEventObservable<T>(eventName: string): Observable<T>;
    getConnectedLinks(element: Shape, opt: {
        inbound?: boolean;
        outbound?: boolean;
    }): LinkDirective[];
}
