var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, Input, forwardRef } from '@angular/core';
//
import { Shape } from '../models/shape';
import { CircleService } from '../services/circle.service';
var CircleDirective = /** @class */ (function (_super) {
    __extends(CircleDirective, _super);
    function CircleDirective(circleService) {
        var _this = _super.call(this) || this;
        _this.circleService = circleService;
        //
        _this._addedToService = false;
        //Inputs
        _this.width = 100;
        _this.height = 100;
        return _this;
    }
    CircleDirective_1 = CircleDirective;
    CircleDirective.prototype.ngOnChanges = function (changes) {
        if (!this._addedToService) {
            this.circleService.add(this);
            this._addedToService = true;
            this.addEventListers();
            return;
        }
        if (changes['x'] || changes['y']) {
            this.circleService.updatePosition(this);
        }
        if (changes['width'] || changes['height']) {
            this.circleService.updateSize(this);
        }
        if (changes['text']) {
            this.circleService.updateText(this);
        }
    };
    CircleDirective.prototype.ngOnDestroy = function () {
        this.circleService.delete(this);
    };
    CircleDirective.prototype.addEventListers = function () {
        var _this = this;
        this.circleService.createEventObservable('change:position', this)
            .subscribe(function (args) {
            _this.x = args.changed.position.x;
            _this.y = args.changed.position.y;
            _this.positionChange.emit(args.changed.position);
        });
    };
    var CircleDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CircleDirective.prototype, "width", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CircleDirective.prototype, "height", void 0);
    CircleDirective = CircleDirective_1 = __decorate([
        Directive({
            selector: 'joint-circle',
            providers: [
                {
                    provide: Shape, useExisting: forwardRef(function () { return CircleDirective_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [CircleService])
    ], CircleDirective);
    return CircleDirective;
}(Shape));
export { CircleDirective };
