import { EventEmitter, SimpleChange } from '@angular/core';
import { ILink } from '../models/link';
import { Shape } from '../models/shape';
import { IPoint } from '../models/point';
import { LinkEventArgs } from '../models/link-event-args';
import { Link } from '../models/joint-types';
import { LinkService } from '../services/link.service';
export declare class LinkDirective implements ILink {
    private linkService;
    private _addedToService;
    private _sourceShapeID;
    private _targetShapeID;
    drawn: boolean;
    shape: Link;
    id: any;
    number: any;
    sourceX: number;
    sourceY: number;
    sourceID: number;
    targetX: number;
    targetY: number;
    targetID: number;
    vertices: IPoint[];
    label: string;
    data: any;
    connected: EventEmitter<LinkEventArgs>;
    disconnected: EventEmitter<LinkEventArgs>;
    verticesChange: EventEmitter<void>;
    constructor(linkService: LinkService);
    ngOnChanges(changes: SimpleChange): void;
    draw(sourceShape: Shape, targetShape: Shape): void;
    ngOnDestroy(): void;
    private checkConnection;
    private addEventListers;
}
