var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
//
import { DiagramService } from './diagram.service';
var CircleService = /** @class */ (function () {
    function CircleService(diagramService, _zone) {
        this.diagramService = diagramService;
        this._zone = _zone;
        this.circles = new Map();
    }
    CircleService.prototype.add = function (circleDirective) {
        var circle = this.diagramService.createCircle({
            position: { x: circleDirective.x, y: circleDirective.y },
            size: { width: circleDirective.width, height: circleDirective.height },
            attrs: {
                circle: { fill: circleDirective.color, stroke: circleDirective.stroke, rx: 5, ry: 5, 'stroke-linecap': 'round' },
                text: { text: circleDirective.text, fill: '#1e1b1d' }
            }
        });
        circleDirective.shape = circle;
        this.circles.set(circleDirective, circle);
    };
    CircleService.prototype.delete = function (circleDirective) {
        var circle = this.circles.get(circleDirective);
        if (circle) {
            this.diagramService.deleteCell(circle);
            this.circles.delete(circleDirective);
        }
    };
    CircleService.prototype.updatePosition = function (circleDirective) {
        var circle = this.circles.get(circleDirective);
        circle.position(circleDirective.x, circleDirective.y);
    };
    CircleService.prototype.updateSize = function (circleDirective) {
        var circle = this.circles.get(circleDirective);
        circle.resize(circleDirective.width, circleDirective.height);
    };
    CircleService.prototype.updateText = function (circleDirective) {
        var circle = this.circles.get(circleDirective);
        circle.attr({ text: { text: circleDirective.text } });
    };
    CircleService.prototype.createEventObservable = function (eventName, circleDirective) {
        var _this = this;
        return Observable.create(function (observer) {
            var circle = _this.circles.get(circleDirective);
            circle.on(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
        });
    };
    CircleService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [DiagramService, NgZone])
    ], CircleService);
    return CircleService;
}());
export { CircleService };
