var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
var joint = require('jointjs');
var DiagramService = /** @class */ (function () {
    function DiagramService() {
    }
    /////////////////////////////// DEFINICIÓN DE FORMAS //////////////////////////////////////////////////////
    /////////////////////////////// METODOS PUBLICOS /////////////////////////////////////////////////////////
    DiagramService.prototype.createDiagram = function (options) {
        this.graph = new joint.dia.Graph();
        options.model = this.graph;
        this._paper = new joint.dia.Paper(options);
        return this._paper;
    };
    DiagramService.prototype.clear = function () {
        this.graph.clear();
    };
    DiagramService.prototype.deleteCell = function (cell) {
        this.graph.removeCells([cell]);
    };
    //LINK
    DiagramService.prototype.createLink = function (options) {
        var link = new joint.dia.Link(options);
        this.graph.addCell(link);
        return link;
    };
    //RECTANGULO
    DiagramService.prototype.createRectangle = function (options) {
        var rect = new joint.shapes.basic.Rect(options);
        this.graph.addCell(rect);
        return rect;
    };
    //TEXT BLOCK
    DiagramService.prototype.createTextBlock = function (options) {
        var textBlock = new joint.shapes.basic.TextBlock(options);
        this.graph.addCell(textBlock);
        return textBlock;
    };
    //RHOMBUS
    DiagramService.prototype.createRhombus = function (options) {
        var rhombus = new joint.shapes.basic.Rhombus(options);
        this.graph.addCell(rhombus);
        return rhombus;
    };
    //CIRCLE
    DiagramService.prototype.createCircle = function (options) {
        var circle = new joint.shapes.basic.Circle(options);
        this.graph.addCell(circle);
        return circle;
    };
    DiagramService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [])
    ], DiagramService);
    return DiagramService;
}());
export { DiagramService };
