import { NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import { DiagramService } from './diagram.service';
import { LinkDirective } from '../directives/link.directive';
import { Shape } from '../models/shape';
export declare class LinkService {
    private diagramService;
    private _zone;
    private links;
    constructor(diagramService: DiagramService, _zone: NgZone);
    add(linkDirective: LinkDirective, sourceShape: Shape, targetShape: Shape): void;
    delete(linkDirective: LinkDirective): void;
    updateVertices(linkDirective: LinkDirective): void;
    updateLabel(linkDirective: LinkDirective): void;
    updatePosition(linkDirective: LinkDirective): void;
    createEventObservable<T>(eventName: string, link: LinkDirective): Observable<T>;
}
