var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
//
import { DiagramService } from './diagram.service';
var LinkService = /** @class */ (function () {
    function LinkService(diagramService, _zone) {
        this.diagramService = diagramService;
        this._zone = _zone;
        this.links = new Map();
    }
    LinkService.prototype.add = function (linkDirective, sourceShape, targetShape) {
        var link = this.diagramService.createLink({
            source: {
                id: sourceShape ? sourceShape.shape.id : null,
                x: sourceShape ? null : linkDirective.sourceX,
                y: sourceShape ? null : linkDirective.sourceY
            },
            target: {
                id: targetShape ? targetShape.shape.id : null,
                x: targetShape ? null : linkDirective.targetX,
                y: targetShape ? null : linkDirective.targetY
            },
            vertices: linkDirective.vertices,
            attrs: {
                '.connection': { stroke: '#e0cfc2' },
                '.marker-target': { fill: '#4b4a67', stroke: '#4b4a67', d: 'M 10 0 L 0 5 L 10 10 z' }
            },
            labels: [
                { position: 0.5, attrs: { text: { text: linkDirective.label } } }
            ]
        });
        linkDirective.shape = link;
        this.links.set(linkDirective, link);
    };
    LinkService.prototype.delete = function (linkDirective) {
        var link = this.links.get(linkDirective);
        if (link) {
            this.diagramService.deleteCell(link);
            this.links.delete(linkDirective);
        }
    };
    LinkService.prototype.updateVertices = function (linkDirective) {
        var link = this.links.get(linkDirective);
        link.attr('vertices', linkDirective.vertices);
    };
    LinkService.prototype.updateLabel = function (linkDirective) {
        var link = this.links.get(linkDirective);
        link.label(0, { position: 0.5, attrs: { text: { text: linkDirective.label } } });
    };
    LinkService.prototype.updatePosition = function (linkDirective) {
    };
    LinkService.prototype.createEventObservable = function (eventName, link) {
        var _this = this;
        return Observable.create(function (observer) {
            var jointLink = _this.links.get(link);
            jointLink.on(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
        });
    };
    LinkService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [DiagramService, NgZone])
    ], LinkService);
    return LinkService;
}());
export { LinkService };
