var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
//
import { DiagramService } from './diagram.service';
var RectangleService = /** @class */ (function () {
    function RectangleService(diagramService, _zone) {
        this.diagramService = diagramService;
        this._zone = _zone;
        this.rectangles = new Map();
    }
    RectangleService.prototype.add = function (rectangleDirective) {
        var rectangle = this.diagramService.createRectangle({
            position: { x: rectangleDirective.x, y: rectangleDirective.y },
            size: { width: rectangleDirective.width, height: rectangleDirective.height },
            attrs: {
                rect: { fill: rectangleDirective.color, stroke: rectangleDirective.stroke, rx: 5, ry: 5, 'stroke-linecap': 'round' },
                text: { text: rectangleDirective.text, fill: '#1e1b1d' }
            }
        });
        rectangleDirective.shape = rectangle;
        this.rectangles.set(rectangleDirective, rectangle);
    };
    RectangleService.prototype.delete = function (rectangleDirective) {
        var rect = this.rectangles.get(rectangleDirective);
        if (rect) {
            this.diagramService.deleteCell(rect);
            this.rectangles.delete(rectangleDirective);
        }
    };
    RectangleService.prototype.updatePosition = function (rectangleDirective) {
        var rect = this.rectangles.get(rectangleDirective);
        rect.position(rectangleDirective.x, rectangleDirective.y);
    };
    RectangleService.prototype.updateSize = function (rectangleDirective) {
        var rect = this.rectangles.get(rectangleDirective);
        rect.resize(rectangleDirective.width, rectangleDirective.height);
    };
    RectangleService.prototype.updateText = function (rectangleDirective) {
        var rect = this.rectangles.get(rectangleDirective);
        rect.attr({ text: { text: rectangleDirective.text } });
    };
    RectangleService.prototype.createEventObservable = function (eventName, rectangleDirective) {
        var _this = this;
        return Observable.create(function (observer) {
            var rect = _this.rectangles.get(rectangleDirective);
            rect.on(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
        });
    };
    RectangleService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [DiagramService, NgZone])
    ], RectangleService);
    return RectangleService;
}());
export { RectangleService };
