var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
//
import { DiagramService } from './diagram.service';
var RhombusService = /** @class */ (function () {
    function RhombusService(diagramService, _zone) {
        this.diagramService = diagramService;
        this._zone = _zone;
        this.rombos = new Map();
    }
    RhombusService.prototype.add = function (rhombusDirective) {
        var rombo = this.diagramService.createRhombus({
            position: { x: rhombusDirective.x, y: rhombusDirective.y },
            size: { width: rhombusDirective.width, height: rhombusDirective.height },
            content: rhombusDirective.text,
            attrs: {
                path: { fill: rhombusDirective.color, stroke: rhombusDirective.stroke, rx: 5, ry: 5, 'stroke-linecap': 'round' },
                text: { text: rhombusDirective.text, fill: '#1e1b1d' }
            }
        });
        rhombusDirective.shape = rombo;
        this.rombos.set(rhombusDirective, rombo);
    };
    RhombusService.prototype.delete = function (rhombusDirective) {
        var rombo = this.rombos.get(rhombusDirective);
        if (rombo) {
            this.diagramService.deleteCell(rombo);
            this.rombos.delete(rhombusDirective);
        }
    };
    RhombusService.prototype.updatePosition = function (rhombusDirective) {
        var rombo = this.rombos.get(rhombusDirective);
        rombo.position(rhombusDirective.x, rhombusDirective.y);
    };
    RhombusService.prototype.updateSize = function (rhombusDirective) {
        var rombo = this.rombos.get(rhombusDirective);
        rombo.resize(rhombusDirective.width, rhombusDirective.height);
    };
    RhombusService.prototype.createEventObservable = function (eventName, rhombusDirective) {
        var _this = this;
        return Observable.create(function (observer) {
            var rhombus = _this.rombos.get(rhombusDirective);
            rhombus.on(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
        });
    };
    RhombusService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [DiagramService, NgZone])
    ], RhombusService);
    return RhombusService;
}());
export { RhombusService };
