var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
//
import { DiagramService } from './diagram.service';
var TextBlockService = /** @class */ (function () {
    function TextBlockService(diagramService, _zone) {
        this.diagramService = diagramService;
        this._zone = _zone;
        this.blocks = new Map();
    }
    TextBlockService.prototype.add = function (textBlockDirective) {
        var block = this.diagramService.createTextBlock({
            position: { x: textBlockDirective.x, y: textBlockDirective.y },
            size: { width: textBlockDirective.width, height: textBlockDirective.height },
            content: textBlockDirective.text,
            attrs: {
                rect: { fill: textBlockDirective.color, stroke: textBlockDirective.stroke, rx: 5, ry: 5, 'stroke-linecap': 'round' },
            }
        });
        textBlockDirective.shape = block;
        this.blocks.set(textBlockDirective, block);
    };
    TextBlockService.prototype.delete = function (textBlockDirective) {
        var block = this.blocks.get(textBlockDirective);
        if (block) {
            this.diagramService.deleteCell(block);
            this.blocks.delete(textBlockDirective);
        }
    };
    TextBlockService.prototype.updatePosition = function (textBlockDirective) {
        var block = this.blocks.get(textBlockDirective);
        block.position(textBlockDirective.x, textBlockDirective.y);
    };
    TextBlockService.prototype.updateSize = function (textBlockDirective) {
        var block = this.blocks.get(textBlockDirective);
        block.resize(textBlockDirective.width, textBlockDirective.height);
    };
    TextBlockService.prototype.updateText = function (textBlockDirective) {
        var block = this.blocks.get(textBlockDirective);
        block.updateContent(block, textBlockDirective.text);
    };
    TextBlockService.prototype.createEventObservable = function (eventName, textBlock) {
        var _this = this;
        return Observable.create(function (observer) {
            var block = _this.blocks.get(textBlock);
            block.on(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
        });
    };
    TextBlockService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [DiagramService, NgZone])
    ], TextBlockService);
    return TextBlockService;
}());
export { TextBlockService };
