var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
//ngx bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//
import { TrackableItem } from '../../core/models/trackable-item';
import { AlertsBarComponent } from '../../controls/components/alerts-bar.component';
var BasicEditorComponent = /** @class */ (function () {
    function BasicEditorComponent() {
        this.canceled = false;
        //Inputs
        this.title = '';
        this.okCaption = 'Aceptar';
        this.cancelCaption = 'Cancelar';
        this.valid = false;
        this.dirty = false;
        //Outputs
        this.creatingItem = new EventEmitter();
        this.loadingItem = new EventEmitter();
        this.updatingItem = new EventEmitter();
        this.cancelingEdit = new EventEmitter();
    }
    /////////////////// METODOS ///////////////////////
    BasicEditorComponent.prototype.show = function () {
        var _this = this;
        this.canceled = false;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.selectAction(); });
    };
    BasicEditorComponent.prototype.showAlert = function (message, type) {
        this.alertsBar.showAlert(message, type);
    };
    BasicEditorComponent.prototype.selectAction = function () {
        if (this.item._clientID == 0) {
            this.creatingItem.emit();
        }
        else {
            this.loadingItem.emit(this.item);
        }
    };
    /////////////////// HANDLERS //////////////////////
    BasicEditorComponent.prototype.onCancelEdit = function () {
        this.canceled = true;
        this.cancelingEdit.emit();
        this.dialog.hide();
    };
    BasicEditorComponent.prototype.onUpdatingInfo = function () {
        this.updatingItem.emit(this.item);
        this.dialog.hide();
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], BasicEditorComponent.prototype, "title", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], BasicEditorComponent.prototype, "okCaption", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], BasicEditorComponent.prototype, "cancelCaption", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], BasicEditorComponent.prototype, "valid", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], BasicEditorComponent.prototype, "dirty", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TrackableItem)
    ], BasicEditorComponent.prototype, "item", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BasicEditorComponent.prototype, "creatingItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BasicEditorComponent.prototype, "loadingItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BasicEditorComponent.prototype, "updatingItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BasicEditorComponent.prototype, "cancelingEdit", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], BasicEditorComponent.prototype, "dialog", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], BasicEditorComponent.prototype, "alertsBar", void 0);
    BasicEditorComponent = __decorate([
        Component({
            selector: 'azteca-basic-editor',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title pull-left\">{{title}}</h5>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"onCancelEdit()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>            \n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <ng-content></ng-content>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdatingInfo()\" [disabled]=\"!valid\">{{okCaption}}</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancelEdit()\">{{cancelCaption}}</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [])
    ], BasicEditorComponent);
    return BasicEditorComponent;
}());
export { BasicEditorComponent };
