import { EventEmitter, QueryList } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Menu } from 'wijmo/wijmo.input';
import { EditorEventArgs } from '../models/editor-event-args';
import { Context } from '../../core/services/context';
import { CatalogService } from '../../core/services/catalog.service';
import { CatalogInfo } from '../../core/models/catalog';
import { Deferred } from '../../core/deferred';
import { CatalogOptions } from '../../custom/models/catalog-options';
import { MenuItem } from '../../controls/models/menu-item';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
import { AlertsBarComponent } from '../../controls/components/alerts-bar.component';
export declare class CatalogEditorComponent {
    private router;
    private route;
    private context;
    private catalogService;
    identity: number;
    readonlyMode: boolean;
    widthClass: string[];
    canceled: boolean;
    defaultOptions: CatalogOptions;
    defDiscardChanges: Deferred<boolean>;
    info: CatalogInfo;
    title: string;
    valid: boolean;
    enabled: boolean;
    dirty: boolean;
    configureCatalog: EventEmitter<CatalogOptions>;
    creatingItem: EventEmitter<void>;
    viewingItem: EventEmitter<number>;
    loadingItem: EventEmitter<number>;
    cloningItem: EventEmitter<number>;
    savingItem: EventEmitter<EditorEventArgs>;
    menuItemClick: EventEmitter<MenuItem>;
    cancelingEdit: EventEmitter<void>;
    menuItems: QueryList<MenuItemDirective>;
    alerts: AlertsBarComponent;
    discardDialog: ModalDirective;
    constructor(router: Router, route: ActivatedRoute, context: Context, catalogService: CatalogService<CatalogInfo>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadConfiguration(): void;
    triggerOperation(): void;
    showAlert(message: string, type: string): void;
    confirmDiscardChanges(): Promise<boolean>;
    discardChanges(): void;
    cancelDiscard(): void;
    private saveHandler;
    private saveCloseHanlder;
    protected onSaveItem(closeEditor: boolean): void;
    reset(): void;
    closeEditor(): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    private handleError;
}
