import { EventEmitter, QueryList, SimpleChange } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { Menu } from 'wijmo/wijmo.input';
import { Context } from '../../core/services/context';
import { CatalogService } from '../../core/services/catalog.service';
import { CatalogInfo, CatalogItem } from '../../core/models/catalog';
import { CatalogOptions } from '../../custom/models/catalog-options';
import { SearchRequest } from '../../search/models/search-request';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
import { MenuItem } from '../../controls/models/menu-item';
import { AlertsBarComponent } from '../../controls/components/alerts-bar.component';
import { GridColumn } from '../../controls/directives/grid-column';
export declare class CatalogManagerComponent {
    protected context: Context;
    private catalogService;
    menuItems: MenuItem[];
    currentItem: CatalogItem;
    widthClass: string;
    defaultOptions: CatalogOptions;
    options: CatalogOptions;
    columns: QueryList<GridColumn>;
    deleteDialog: ModalDirective;
    customMenuItems: QueryList<MenuItemDirective>;
    alerts: AlertsBarComponent;
    pageSize: number;
    pageIndex: number;
    totalRows: number;
    standAlone: boolean;
    catalogList: CatalogItem[];
    serverSide: boolean;
    enabled: boolean;
    allowNew: boolean;
    allowView: boolean;
    allowEdit: boolean;
    allowDelete: boolean;
    allowClone: boolean;
    allowChangeState: boolean;
    allowAudit: boolean;
    configureCatalog: EventEmitter<CatalogOptions>;
    searchRequested: EventEmitter<SearchRequest>;
    currentItemChanged: EventEmitter<CatalogItem>;
    addingItem: EventEmitter<void>;
    viewingItem: EventEmitter<CatalogItem>;
    editingItem: EventEmitter<CatalogItem>;
    deletingItem: EventEmitter<CatalogItem>;
    cloningItem: EventEmitter<CatalogItem>;
    changingItemState: EventEmitter<CatalogItem>;
    menuItemClick: EventEmitter<MenuItem>;
    constructor(context: Context, catalogService: CatalogService<CatalogInfo>);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChange): void;
    ngAfterViewInit(): void;
    loadConfiguration(): void;
    triggerSearch(): void;
    showAlert(message: string, type: string): void;
    searchRequestedHandler(request: SearchRequest): void;
    private isMenuItemEnabled;
    private setMenuItemState;
    getMenuItem(name: string): MenuItem;
    createMenu(): void;
    updateCustomMenuItems(): void;
    onValidateMenu(item: CatalogItem): void;
    currentItemChangedHandler(item: CatalogItem): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    onIsDroppedDown(menu: Menu, args: any): void;
    deleteItem(): void;
    hideDeleteDialog(): void;
    onItemSelected(item: CatalogItem): void;
    optionClick(option: MenuItem): void;
    newItemHandler(): void;
    private handleError;
}
