import { EventEmitter, QueryList } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Menu } from 'wijmo/wijmo.input';
import { EditorEventArgs } from '../models/editor-event-args';
import { WorkflowEventArgs } from '../models/workflow-event-args';
import { Context } from '../../core/services/context';
import { DocumentService } from '../../core/services/document.service';
import { Deferred } from '../../core/deferred';
import { DocumentInfo, DocumentItem } from '../../core/models/document';
import { DocumentDetail } from '../../core/models/document-detail';
import { DocumentTypeInfo } from '../../core/models/document-type';
import { WorkflowOption } from '../../core/models/workflow-option';
import { MenuItem } from '../../controls/models/menu-item';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
import { AlertsBarComponent } from '../../controls/components/alerts-bar.component';
export declare class DocumentEditorComponent {
    private router;
    private route;
    private context;
    private documentService;
    identity: string;
    readonlyMode: boolean;
    widthClass: string[];
    canceled: boolean;
    defDiscardChanges: Deferred<boolean>;
    documentType: DocumentTypeInfo;
    stepOptions: WorkflowOption[];
    isHeaderCollapsed: boolean;
    document: DocumentInfo<DocumentDetail>;
    title: string;
    valid: boolean;
    enabled: boolean;
    dirty: boolean;
    configureDocument: EventEmitter<DocumentTypeInfo>;
    creatingDocument: EventEmitter<void>;
    viewingDocument: EventEmitter<string>;
    loadingDocument: EventEmitter<string>;
    cloningDocument: EventEmitter<string>;
    savingDocument: EventEmitter<EditorEventArgs>;
    applyingNextStep: EventEmitter<WorkflowEventArgs>;
    applyingPreviousStep: EventEmitter<DocumentItem>;
    menuItemClick: EventEmitter<MenuItem>;
    cancelingEdit: EventEmitter<void>;
    validatingMenu: EventEmitter<DocumentItem>;
    menuItems: QueryList<MenuItemDirective>;
    alerts: AlertsBarComponent;
    discardDialog: ModalDirective;
    optionsDialog: ModalDirective;
    confirmNextStepDialog: ModalDirective;
    confirmPrevioustStepDialog: ModalDirective;
    constructor(router: Router, route: ActivatedRoute, context: Context, documentService: DocumentService<DocumentDetail, DocumentInfo<DocumentDetail>>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadConfiguration(): void;
    triggerOperation(): void;
    nextStep(): void;
    previousStep(): void;
    onConfirmNextStep(): void;
    onConfirmPreviousStep(): void;
    onWorkflowOptionSelected(option: WorkflowOption): void;
    showAlert(message: string, type: string): void;
    confirmDiscardChanges(): Promise<boolean>;
    discardChanges(): void;
    cancelDiscard(): void;
    private getDocumentItem;
    private saveHandler;
    private saveCloseHanlder;
    protected onSaveItem(closeEditor: boolean): void;
    reset(): void;
    closeEditor(): void;
    onMenuItemClicked(menu: Menu, args: any): void;
    private handleError;
}
