import { EventEmitter, QueryList, SimpleChange } from '@angular/core';
import { Menu } from 'wijmo/wijmo.input';
import { FlexGrid, CellRangeEventArgs } from 'wijmo/wijmo.grid';
import { BaseControl } from '../../controls/models/base-control';
import { TrackableItem } from '../../core/models/trackable-item';
import { MenuItem } from '../../controls/models/menu-item';
import { ToolbarButton } from '../../controls/models/toolbar-button';
import { GridColumn } from '../../controls/directives/grid-column';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
export declare class EditableListComponent extends BaseControl {
    currentItem: TrackableItem;
    private collectionView;
    private _listItems;
    gridDetail: FlexGrid;
    columns: QueryList<GridColumn>;
    menuItems: QueryList<MenuItemDirective>;
    listItems: TrackableItem[];
    allowNew: boolean;
    allowEdit: boolean;
    allowDelete: boolean;
    contextMenuOpen: EventEmitter<TrackableItem>;
    currentItemChanged: EventEmitter<TrackableItem>;
    addingItem: EventEmitter<void>;
    editingItem: EventEmitter<TrackableItem>;
    deletingItem: EventEmitter<TrackableItem>;
    listItemsUpdated: EventEmitter<TrackableItem[]>;
    menuItemClick: EventEmitter<MenuItem>;
    cellUpdated: EventEmitter<CellRangeEventArgs>;
    constructor();
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChange): void;
    private validateColumns;
    private validateMenu;
    findMenuItem(name: string): MenuItemDirective;
    deleteItem(item: TrackableItem): void;
    updateItem(item: TrackableItem): void;
    updateItems(items: TrackableItem[]): void;
    refresh(): void;
    contextMenuClick(menu: Menu): void;
    onToolbarClick(button: ToolbarButton): void;
    onMenuItemClick(option: MenuItem): void;
    initialized(sender: FlexGrid, args: any): void;
    onCellUpdated(args: CellRangeEventArgs): void;
}
