import { EventEmitter, QueryList, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { TreeComponent, ITreeOptions, IActionMapping, TreeNode } from 'angular-tree-component';
import { ModalDirective } from 'ngx-bootstrap';
import { Menu } from 'wijmo/wijmo.input';
import { Context } from '../../core/services/context';
import { CatalogService } from '../../core/services/catalog.service';
import { Deferred } from '../../core/deferred';
import { CatalogInfo } from '../../core/models/catalog';
import { HierarchyInfo, HierarchyNode, HierarchyChanges } from '../../core/models/hierarchy';
import { CatalogOptions } from '../../custom/models/catalog-options';
import { MenuItem } from '../../controls/models/menu-item';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
import { Alert } from '../../controls/models/alert';
import { ToolbarButton } from '../../controls/models/toolbar-button';
export declare class HierarchyManagerComponent {
    private context;
    private catalogService;
    private router;
    private route;
    private location;
    private changeDetector;
    alerts: Alert[];
    defaultOptions: CatalogOptions;
    menuItems: MenuItem[];
    lastCreated: HierarchyInfo<HierarchyNode>;
    deletedNodes: HierarchyInfo<HierarchyNode>[];
    clipboardNode: TreeNode;
    canceled: boolean;
    defDiscardChanges: Deferred<boolean>;
    customMenuItems: QueryList<MenuItemDirective>;
    tree: TreeComponent;
    editDialog: ModalDirective;
    deleteDialog: ModalDirective;
    discardDialog: ModalDirective;
    nodes: HierarchyInfo<HierarchyNode>[];
    title: string;
    editorTitle: string;
    enabled: boolean;
    currentNode: TreeNode;
    validForm: boolean;
    allowDropHandler: Function;
    displayField: string;
    configureCatalog: EventEmitter<CatalogOptions>;
    menuItemClick: EventEmitter<MenuItem>;
    currentNodeChanged: EventEmitter<TreeNode>;
    creatingNode: EventEmitter<TreeNode>;
    editingNode: EventEmitter<TreeNode>;
    savingNode: EventEmitter<any>;
    deletingNode: EventEmitter<TreeNode>;
    copyingNode: EventEmitter<TreeNode>;
    pastingNode: EventEmitter<TreeNode>;
    savingHierarchy: EventEmitter<HierarchyChanges<HierarchyNode>>;
    nodesChanged: EventEmitter<HierarchyInfo<HierarchyNode>[]>;
    validatingMenu: EventEmitter<TreeNode>;
    actionMapping: IActionMapping;
    treeOptions: ITreeOptions;
    constructor(context: Context, catalogService: CatalogService<CatalogInfo>, router: Router, route: ActivatedRoute, location: Location, changeDetector: ChangeDetectorRef);
    ngAfterViewInit(): void;
    loadConfiguration(): void;
    createMenu(): void;
    mainToolbarHandler(button: ToolbarButton): void;
    private getLastClientID;
    private selectAction;
    onMenuItemClick(menu: Menu, args: any): void;
    showEditor(): void;
    hideEditor(): void;
    showAlert(message: string, type: string): void;
    closeAlert(i: number): void;
    findInfoByClientID(clientID: number, nodes: HierarchyInfo<HierarchyNode>[]): HierarchyInfo<HierarchyNode>;
    addNode(info: HierarchyInfo<HierarchyNode>, parentNode: TreeNode): void;
    updateNode(info: HierarchyInfo<HierarchyNode>): void;
    deleteNode(node: TreeNode): void;
    pasteNode(node: TreeNode, target: TreeNode): void;
    reset(): void;
    private resetNodeData;
    private confirmDelete;
    private onTreeUpdated;
    private activateLastCreated;
    private onCurrentNodeChanged;
    private onMoveNode;
    private onCommitEdit;
    private onCancelEdit;
    confirmDiscardChanges(): Promise<boolean>;
    cancelDiscard(): void;
    discardChanges(): void;
    onOpeningMenu(menu: Menu): void;
    private handleError;
}
