var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { CollectionView, NotifyCollectionChangedAction } from 'wijmo/wijmo';
import { ChangeState } from '../../core/models/change-tracking';
var TrackableCollection = /** @class */ (function (_super) {
    __extends(TrackableCollection, _super);
    function TrackableCollection(sourceCollection) {
        var _this = _super.call(this, sourceCollection) || this;
        _this.filter = function (item) {
            return (!item.state || item.state != ChangeState.DELETED);
        };
        _this.collectionChanged.addHandler(function (sender, args) {
            if (args.action == NotifyCollectionChangedAction.Change && args.item != null) {
                args.item.state = ChangeState.MODIFIED;
            }
        });
        _this.currentChanged.addHandler(function (args) {
        });
        return _this;
    }
    TrackableCollection.prototype.addNew = function () {
        var newItem = _super.prototype.addNew.call(this);
        newItem.id = 0;
        newItem.state = ChangeState.ADDED;
        return newItem;
    };
    TrackableCollection.prototype.remove = function (item) {
        this.editItem(item);
        item.state = ChangeState.DELETED;
        this.commitEdit();
    };
    TrackableCollection.prototype.removeAt = function (index) {
        var item = this.items[index];
        item.state = ChangeState.DELETED;
    };
    return TrackableCollection;
}(CollectionView));
export { TrackableCollection };
