var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
//Bootstrap
import { AlertModule, ModalModule, TabsModule, CollapseModule } from 'ngx-bootstrap';
//Tree
import { TreeModule } from 'angular-tree-component';
//Modulos Azteca
import { CoreModule } from '../core/core.module';
import { UtilsModule } from '../utils/utils.module';
import { SearchModule } from '../search/search.module';
import { ControlsModule } from '../controls/controls.module';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Components
import { CatalogManagerComponent } from './components/catalog-manager.component';
import { CatalogEditorComponent } from './components/catalog-editor.component';
import { HierarchyManagerComponent } from './components/hierarchy-manager.component';
import { DocumentManagerComponent } from './components/document-manager.component';
import { DocumentEditorComponent } from './components/document-editor.component';
import { EditableListComponent } from './components/editable-list.component';
import { BasicEditorComponent } from './components/basic-editor.component';
//Parts
import { DocumentHistoryComponent } from './components/parts/document-history.component';
import { DocumentGroupsComponent } from './components/parts/document-groups.component';
//Servicios
import { EditorDeactivateGuard } from './services/editor-deactivate-guard.service';
var COMPONENTS = [CatalogManagerComponent, CatalogEditorComponent, HierarchyManagerComponent, DocumentManagerComponent,
    DocumentEditorComponent, EditableListComponent, BasicEditorComponent, DocumentHistoryComponent, DocumentGroupsComponent];
var SERVICES = [EditorDeactivateGuard];
var EditorsModule = /** @class */ (function () {
    function EditorsModule() {
    }
    EditorsModule = __decorate([
        NgModule({
            imports: [
                CommonModule, FormsModule, ReactiveFormsModule,
                AlertModule.forRoot(), TabsModule.forRoot(), ModalModule.forRoot(), CollapseModule.forRoot(),
                WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule, TreeModule,
                CoreModule, UtilsModule, SearchModule, ControlsModule
            ],
            providers: [EditorDeactivateGuard],
            declarations: COMPONENTS,
            exports: COMPONENTS
        })
    ], EditorsModule);
    return EditorsModule;
}());
export { EditorsModule };
