import { EventEmitter } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Context, TrackableItem } from '../../core';
import { IEditor } from './editor';
import { BasicEditorComponent } from '../components/basic-editor.component';
export declare class BasicEditor implements IEditor {
    protected context: Context;
    form: FormGroup;
    private _valid;
    private _dirty;
    readonly valid: boolean;
    readonly dirty: boolean;
    readonly canceled: boolean;
    clientIndexStart: number;
    savingItem: EventEmitter<TrackableItem>;
    savingItems: EventEmitter<TrackableItem[]>;
    editor: BasicEditorComponent;
    constructor(context: Context);
    ngAfterViewInit(): void;
    show(): void;
    showAlert(message: string, type: string): void;
    confirmDiscard(): Promise<boolean>;
    private changeState;
    protected createClientID(): number;
    protected copyItem(originalItem: TrackableItem): TrackableItem;
    handleError(error: any): void;
}
