var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { BasicEditorComponent } from '../components/basic-editor.component';
var BasicEditor = /** @class */ (function () {
    function BasicEditor(context) {
        this.context = context;
        this._valid = false;
        this._dirty = false;
        //Inputs
        this.clientIndexStart = 0;
        //Outputs
        this.savingItem = new EventEmitter();
        this.savingItems = new EventEmitter();
    }
    Object.defineProperty(BasicEditor.prototype, "valid", {
        get: function () {
            return this._valid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BasicEditor.prototype, "dirty", {
        get: function () {
            return this._dirty;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BasicEditor.prototype, "canceled", {
        get: function () {
            return this.editor.canceled;
        },
        enumerable: true,
        configurable: true
    });
    /////////////////// HANDLERS //////////////////////
    BasicEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.form)
            return;
        this.form.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
    };
    /////////////// METODOS ////////////////
    BasicEditor.prototype.show = function () {
        this.editor.show();
    };
    BasicEditor.prototype.showAlert = function (message, type) {
        this.editor.showAlert(message, type);
    };
    BasicEditor.prototype.confirmDiscard = function () {
        return Promise.resolve(true);
    };
    BasicEditor.prototype.changeState = function () {
        this._valid = this.form.valid;
        this._dirty = this.form.dirty;
    };
    BasicEditor.prototype.createClientID = function () {
        this.clientIndexStart += 1;
        return this.clientIndexStart;
    };
    BasicEditor.prototype.copyItem = function (originalItem) {
        return JSON.parse(JSON.stringify(originalItem));
    };
    BasicEditor.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.editor.showAlert(message, 'danger');
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], BasicEditor.prototype, "clientIndexStart", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BasicEditor.prototype, "savingItem", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], BasicEditor.prototype, "savingItems", void 0);
    __decorate([
        ViewChild(BasicEditorComponent),
        __metadata("design:type", BasicEditorComponent)
    ], BasicEditor.prototype, "editor", void 0);
    return BasicEditor;
}());
export { BasicEditor };
