import { ChangeDetectorRef } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, ProcessComponent, PolicyInfo } from '../../core';
import { CatalogEditorComponent } from '../components/catalog-editor.component';
import { IEditor } from './editor';
export declare abstract class CatalogEditor extends ProcessComponent implements IEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    errorMessage: string;
    catalogForm: FormGroup;
    readonlyMode: boolean;
    private _valid;
    private _dirty;
    readonly valid: boolean;
    readonly dirty: boolean;
    readonly canceled: boolean;
    autogeneratedCode: boolean;
    editor: CatalogEditorComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    ngAfterViewInit(): void;
    private changeState;
    onCancelingEdit(): void;
    confirmDiscard(): Promise<boolean>;
    showAlert(message: string, type: string): void;
    reset(): void;
    handleError(error: any): void;
    setReadonlyMode(): void;
    applyPolicy(policy: PolicyInfo): void;
}
