import { Router, ActivatedRoute } from '@angular/router';
import { Context, ProcessComponent, PolicyInfo } from '../../core';
import { CatalogManagerComponent } from '../components/catalog-manager.component';
export declare abstract class CatalogManager extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    errorMessage: string;
    readonly ALLOW_NEW_POLICY: string;
    readonly ALLOW_EDIT_POLICY: string;
    readonly ALLOW_CLONE_POLICY: string;
    readonly ALLOW_STATE_CHANGE_POLICY: string;
    readonly ALLOW_AUDIT_POLICY: string;
    readonly ALLOW_DELETE_POLICY: string;
    pageIndex: number;
    totalRows: number;
    enabled: boolean;
    allowNew: boolean;
    allowView: boolean;
    allowEdit: boolean;
    allowDelete: boolean;
    allowClone: boolean;
    allowChangeState: boolean;
    allowAudit: boolean;
    manager: CatalogManagerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute);
    refreshList(): void;
    showAlert(message: string, type: string): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
}
