var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ViewChild, Input } from '@angular/core';
//
import { ProcessComponent } from '../../core';
import { CatalogManagerComponent } from '../components/catalog-manager.component';
var CatalogManager = /** @class */ (function (_super) {
    __extends(CatalogManager, _super);
    function CatalogManager(context, router, route) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.ALLOW_NEW_POLICY = 'allowNew';
        _this.ALLOW_EDIT_POLICY = 'allowEdit';
        _this.ALLOW_CLONE_POLICY = 'allowClone';
        _this.ALLOW_STATE_CHANGE_POLICY = 'allowStateChange';
        _this.ALLOW_AUDIT_POLICY = 'allowStateAudit';
        _this.ALLOW_DELETE_POLICY = 'allowDelete';
        //
        _this.pageIndex = 0;
        _this.totalRows = 0;
        _this.enabled = true;
        _this.allowNew = true;
        _this.allowView = true;
        _this.allowEdit = true;
        _this.allowDelete = true;
        _this.allowClone = true;
        _this.allowChangeState = true;
        _this.allowAudit = true;
        return _this;
    }
    CatalogManager.prototype.refreshList = function () {
        this.manager.triggerSearch();
    };
    CatalogManager.prototype.showAlert = function (message, type) {
        var _this = this;
        setTimeout(function (_) { return _this.manager.showAlert(message, type); });
    };
    CatalogManager.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        this.errorMessage = this.context.getExceptionMessage(error);
        this.manager.showAlert(this.errorMessage, 'danger');
    };
    //Implementación de políticas
    CatalogManager.prototype.applyPolicy = function (policy) {
        if (this.allowPolicies && !this.isPolicyApplied(policy.nombre)) {
            var policyName = policy.nombre.trim();
            switch (policyName) {
                case this.ENABLED_POLICY:
                    this.manager.enabled = policy.valor == 'true' ? true : false;
                    break;
                case this.ALLOW_NEW_POLICY:
                    this.allowNew = (policy.valor == 'true' ? true : false);
                    break;
                case this.ALLOW_EDIT_POLICY:
                    this.allowEdit = (policy.valor == 'true' ? true : false);
                    break;
                case this.ALLOW_CLONE_POLICY:
                    this.allowClone = (policy.valor == 'true' ? true : false);
                    break;
                case this.ALLOW_STATE_CHANGE_POLICY:
                    this.allowChangeState = (policy.valor == 'true' ? true : false);
                    break;
                case this.ALLOW_AUDIT_POLICY:
                    this.allowAudit = (policy.valor == 'true' ? true : false);
                    break;
                case this.ALLOW_DELETE_POLICY:
                    this.allowDelete = (policy.valor == 'true' ? true : false);
                    break;
            }
            this.appliedPolicies.push(policy);
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CatalogManager.prototype, "pageIndex", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CatalogManager.prototype, "totalRows", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowNew", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowView", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowEdit", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowDelete", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowClone", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowChangeState", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogManager.prototype, "allowAudit", void 0);
    __decorate([
        ViewChild(CatalogManagerComponent),
        __metadata("design:type", CatalogManagerComponent)
    ], CatalogManager.prototype, "manager", void 0);
    return CatalogManager;
}(ProcessComponent));
export { CatalogManager };
