import { FormGroup } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, ProcessComponent, PolicyInfo, DocumentTypeService, WorkflowHistory } from '../../core';
import { DocumentEditorComponent } from '../components/document-editor.component';
import { IEditor } from './editor';
export declare class DocumentEditor extends ProcessComponent implements IEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    protected documentTypeService: DocumentTypeService;
    errorMessage: string;
    documentForm: FormGroup;
    readonlyMode: boolean;
    history: WorkflowHistory[];
    private _valid;
    private _dirty;
    readonly valid: boolean;
    readonly dirty: boolean;
    readonly canceled: boolean;
    editor: DocumentEditorComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, documentTypeService: DocumentTypeService);
    ngAfterViewInit(): void;
    private changeState;
    onCancelingEdit(): void;
    confirmDiscard(): Promise<boolean>;
    showAlert(message: string, type: string): void;
    reset(): void;
    handleError(error: any): void;
    setReadonlyMode(): void;
    loadHistory(idDocument: string): void;
    applyPolicy(policy: PolicyInfo): void;
}
