var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ViewChild } from '@angular/core';
//
import { ProcessComponent, PolicyInfo } from '../../core';
import { DocumentEditorComponent } from '../components/document-editor.component';
var DocumentEditor = /** @class */ (function (_super) {
    __extends(DocumentEditor, _super);
    function DocumentEditor(context, router, route, documentTypeService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.documentTypeService = documentTypeService;
        _this.readonlyMode = false;
        _this.history = [];
        //
        _this._valid = false;
        _this._dirty = false;
        return _this;
    }
    Object.defineProperty(DocumentEditor.prototype, "valid", {
        get: function () {
            return this._valid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentEditor.prototype, "dirty", {
        get: function () {
            return this._dirty;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentEditor.prototype, "canceled", {
        get: function () {
            return this.editor.canceled;
        },
        enumerable: true,
        configurable: true
    });
    DocumentEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.documentForm)
            return;
        this.editor.cancelingEdit.subscribe(function (_) { return _this.onCancelingEdit(); });
        this.documentForm.statusChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.changeState(); });
        });
        setTimeout(function (_) { return _this.changeState(); });
    };
    DocumentEditor.prototype.changeState = function () {
        this._valid = this.documentForm.valid;
        this._dirty = this.documentForm.dirty;
        this.editor.dirty = this.documentForm.dirty;
    };
    DocumentEditor.prototype.onCancelingEdit = function () {
        this.router.navigate(['../'], { relativeTo: this.route });
    };
    DocumentEditor.prototype.confirmDiscard = function () {
        return this.editor.confirmDiscardChanges();
    };
    DocumentEditor.prototype.showAlert = function (message, type) {
        this.editor.showAlert(message, type);
    };
    DocumentEditor.prototype.reset = function () {
        this._dirty = false;
        this.editor.dirty = false;
        this.editor.reset();
        this.documentForm.markAsPristine();
    };
    DocumentEditor.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        this.errorMessage = this.context.getExceptionMessage(error);
        this.editor.showAlert(this.errorMessage, 'danger');
    };
    DocumentEditor.prototype.setReadonlyMode = function () {
        //Enviar política de sólo lectura a todos los componentes del editor
        var policy = new PolicyInfo();
        policy.nombre = this.ENABLED_POLICY;
        policy.valor = "false";
        this.applyPolicy(policy);
        //
        this.readonlyMode = true;
        this.editor.enabled = false;
    };
    DocumentEditor.prototype.loadHistory = function (idDocument) {
        var _this = this;
        this.context.app.showSpinner();
        this.documentTypeService.loadWorkflowHistory(idDocument)
            .then(function (history) {
            _this.history = history;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Implementación de políticas
    DocumentEditor.prototype.applyPolicy = function (policy) {
        if (this.allowPolicies && !this.isPolicyApplied(policy.nombre)) {
            if (policy.nombre.toLowerCase() == this.ENABLED_POLICY) {
                this.children.forEach(function (item, index) {
                    item.applyPolicy(policy);
                });
                this.appliedPolicies.push(policy);
            }
        }
    };
    __decorate([
        ViewChild(DocumentEditorComponent),
        __metadata("design:type", DocumentEditorComponent)
    ], DocumentEditor.prototype, "editor", void 0);
    return DocumentEditor;
}(ProcessComponent));
export { DocumentEditor };
