import { Router, ActivatedRoute } from '@angular/router';
import { Context, ProcessComponent, PolicyInfo } from '../../core';
import { FilterGroup } from '../../search';
import { DocumentManagerComponent } from '../components/document-manager.component';
export declare class DocumentManager extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    errorMessage: string;
    readonly ALLOW_NEW_POLICY: string;
    readonly ALLOW_EDIT_POLICY: string;
    readonly ALLOW_CLONE_POLICY: string;
    readonly ALLOW_NEXT_POLICY: string;
    readonly ALLOW_PREVIOUS_POLICY: string;
    readonly ALLOW_AUDIT_POLICY: string;
    readonly ALLOW_DELETE_POLICY: string;
    readonly ALLOW_EXPORT_POLICY: string;
    totalRows: number;
    filterGroups: FilterGroup[];
    enabled: boolean;
    allowNew: boolean;
    allowView: boolean;
    allowEdit: boolean;
    allowDelete: boolean;
    allowClone: boolean;
    allowAudit: boolean;
    allowNext: boolean;
    allowPrevious: boolean;
    allowExport: boolean;
    manager: DocumentManagerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute);
    refreshList(): void;
    showAlert(message: string, type: string): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
}
