import { ChangeDetectorRef } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyInfo, HierarchyNode, ProcessComponent, PolicyInfo } from '../../core';
import { MenuItem } from '../../controls/models/menu-item';
import { IEditor } from './editor';
import { HierarchyManagerComponent } from '../components/hierarchy-manager.component';
export declare class HierarchyManager extends ProcessComponent implements IEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    errorMessage: string;
    nodeForm: FormGroup;
    dirty: boolean;
    readonly canceled: boolean;
    readonly menuItems: MenuItem[];
    enabled: boolean;
    allowNew: boolean;
    allowEdit: boolean;
    allowDelete: boolean;
    allowCopy: boolean;
    autogeneratedCode: boolean;
    manager: HierarchyManagerComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    ngAfterViewInit(): void;
    confirmDiscard(): Promise<boolean>;
    showAlert(message: string, type: string): void;
    showEditor(): void;
    hideEditor(): void;
    addNode(info: HierarchyInfo<HierarchyNode>, parentNode: TreeNode): void;
    updateNode(info: HierarchyInfo<HierarchyNode>): void;
    deleteNode(node: TreeNode): void;
    reset(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
