var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, ViewChild } from '@angular/core';
//
import { ProcessComponent } from '../../core';
import { HierarchyManagerComponent } from '../components/hierarchy-manager.component';
var HierarchyManager = /** @class */ (function (_super) {
    __extends(HierarchyManager, _super);
    //
    function HierarchyManager(context, router, route, changeDetector) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.dirty = false;
        //Inputs
        _this.enabled = true;
        _this.allowNew = true;
        _this.allowEdit = true;
        _this.allowDelete = true;
        _this.allowCopy = true;
        _this.autogeneratedCode = false;
        return _this;
    }
    Object.defineProperty(HierarchyManager.prototype, "canceled", {
        get: function () {
            return this.manager.canceled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HierarchyManager.prototype, "menuItems", {
        get: function () {
            return this.manager.menuItems;
        },
        enumerable: true,
        configurable: true
    });
    HierarchyManager.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (!this.nodeForm)
            return;
        this.nodeForm.statusChanges.subscribe(function () {
            _this.changeDetector.detectChanges();
        });
    };
    HierarchyManager.prototype.confirmDiscard = function () {
        return this.manager.confirmDiscardChanges();
    };
    HierarchyManager.prototype.showAlert = function (message, type) {
        this.manager.showAlert(message, type);
    };
    HierarchyManager.prototype.showEditor = function () {
        this.manager.showEditor();
    };
    HierarchyManager.prototype.hideEditor = function () {
        this.manager.hideEditor();
    };
    HierarchyManager.prototype.addNode = function (info, parentNode) {
        this.manager.addNode(info, parentNode);
        this.dirty = true;
    };
    HierarchyManager.prototype.updateNode = function (info) {
        this.manager.updateNode(info);
        this.dirty = true;
    };
    HierarchyManager.prototype.deleteNode = function (node) {
        this.manager.deleteNode(node);
        this.dirty = true;
    };
    HierarchyManager.prototype.reset = function () {
        this.dirty = false;
        this.manager.reset();
    };
    //Implementación de políticas
    HierarchyManager.prototype.applyPolicy = function (policy) {
        if (this.allowPolicies && !this.isPolicyApplied(policy.nombre)) {
            if (policy.nombre.toLowerCase() == this.ENABLED_POLICY) {
                this.children.forEach(function (item, index) {
                    item.applyPolicy(policy);
                });
                this.appliedPolicies.push(policy);
            }
        }
    };
    HierarchyManager.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
        this.errorMessage = this.context.getExceptionMessage(error);
        this.showAlert(this.errorMessage, 'danger');
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchyManager.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchyManager.prototype, "allowNew", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchyManager.prototype, "allowEdit", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchyManager.prototype, "allowDelete", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchyManager.prototype, "allowCopy", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchyManager.prototype, "autogeneratedCode", void 0);
    __decorate([
        ViewChild(HierarchyManagerComponent),
        __metadata("design:type", HierarchyManagerComponent)
    ], HierarchyManager.prototype, "manager", void 0);
    return HierarchyManager;
}(ProcessComponent));
export { HierarchyManager };
