var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
import { DataMap } from 'wijmo/wijmo.grid';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogEditor } from '../../editors';
//Features
import { AsentamientoHumanoInfo } from '../models/asentamiento-humano';
import { AsentamientoHumanoService } from '../services/asentamiento-humano.service';
import { TipoAsentamientoService } from '../services/tipo-asentamiento.service';
var AsentamientosHumanosEditor = /** @class */ (function (_super) {
    __extends(AsentamientosHumanosEditor, _super);
    //
    function AsentamientosHumanosEditor(router, route, formBuilder, changeDetector, context, location, asentamientoHumanoService, tipoAsentamienotService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.asentamientoHumanoService = asentamientoHumanoService;
        _this.tipoAsentamienotService = tipoAsentamienotService;
        _this.asentamientohumano = new AsentamientoHumanoInfo();
        _this.tiposAsentamiento = [];
        _this.catalogForm = formBuilder.group({
            'codigo': [''],
            'nombre': ['', Validators.required],
            'poblacion': [0],
            'tipoAsentamiento': [0],
            'cp': ['']
        });
        return _this;
    }
    AsentamientosHumanosEditor_1 = AsentamientosHumanosEditor;
    AsentamientosHumanosEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idMunicipio = +params['idMunicipio'];
        });
        this.autogeneratedCode = options.codigoAutogenerado;
        setTimeout(function (_) { return _this.loadTipoAsentamiento(); });
    };
    AsentamientosHumanosEditor.prototype.onCreatingItem = function () {
        this.asentamientohumano.idMunicipio = this.idMunicipio;
    };
    AsentamientosHumanosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.asentamientoHumanoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.asentamientohumano = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AsentamientosHumanosEditor.prototype.loadTipoAsentamiento = function () {
        var _this = this;
        this.tipoAsentamienotService.loadList()
            .then(function (tiposAsentamiento) {
            _this.tiposAsentamiento = tiposAsentamiento;
            _this.tiposAsentamiento.push({ id: 0, codigo: '0', nombre: '[NO SELECCIONADA]', activo: true });
            _this.tiposAsentamientoMap = new DataMap(_this.tiposAsentamiento, 'id', 'nombre');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AsentamientosHumanosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.asentamientoHumanoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.asentamientohumano = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AsentamientosHumanosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.asentamientoHumanoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.asentamientohumano = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AsentamientosHumanosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.asentamientoHumanoService.update(this.asentamientohumano)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.asentamientohumano = info;
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AsentamientosHumanosEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    AsentamientosHumanosEditor.prototype.callMethod = function (args) {
        console.log("Cambios de valor");
    };
    var AsentamientosHumanosEditor_1;
    AsentamientosHumanosEditor = AsentamientosHumanosEditor_1 = __decorate([
        Component({
            selector: 'general-asentamiento-humanos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Asentamientos Humanos'\"\n                                 [info]=\"asentamientohumano\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-xs-10 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"asentamientohumano.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"asentamientohumano.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n        \n              <div class=\"row\">\n                  <div class=\"col-xs-10\">\n                      <tabset>\n                          <tab heading=\"General\">                       \n\n                              <div class=\"row\">\n                                  <div class=\"col-xs-10 col-md-8\"> \n                                      <azteca-form-field [label]=\"'Tipo de asentamiento:'\">\n                                          <az-combobox formControlName=\"tipoAsentamiento\"\n                                                       [(ngModel)]=\"asentamientohumano.idTipoAsentamiento\"\n                                                       [items]=\"tiposAsentamiento\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-xs-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'C\u00F3digo Postal:'\">\n                                          <az-textbox formControlName=\"cp\" [(ngModel)]=\"asentamientohumano.codigoPostal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return AsentamientosHumanosEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: AsentamientoHumanoService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, AsentamientoHumanoService, TipoAsentamientoService])
    ], AsentamientosHumanosEditor);
    return AsentamientosHumanosEditor;
}(CatalogEditor));
export { AsentamientosHumanosEditor };
