var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Output, ViewChild, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from '../../core';
import { AlertsBarComponent } from '../../controls';
import { CalendarioService } from '../services/calendario.service';
var CalendarioCreateComponent = /** @class */ (function () {
    function CalendarioCreateComponent(formBuilder, context, router, route, calendarioService) {
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.calendarioService = calendarioService;
        this.title = 'Crear calendario';
        this.sabadoLaborable = false;
        this.domingoLaborable = false;
        this.calendarCreated = new EventEmitter();
        this.editorForm = formBuilder.group({
            'fechaIni': [''],
            'fechaFin': [''],
            'sabadoLaborable': [false],
            'domingoLaborable': [false],
        });
    }
    CalendarioCreateComponent.prototype.showCreate = function (idCalendario) {
        this.idCalendario = idCalendario;
        this.dlgCalendarCreate.config.backdrop = false;
        this.dlgCalendarCreate.show();
    };
    CalendarioCreateComponent.prototype.accept = function () {
        var _this = this;
        this.calendarioService.createFechas(this.idCalendario, this.fechaIni, this.fechaFin, this.sabadoLaborable, this.domingoLaborable)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El calendario se ha generado con éxito.', 'success');
            _this.calendarCreated.emit(true);
            _this.dlgCalendarCreate.hide();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioCreateComponent.prototype.discardChanges = function () {
        this.dlgCalendarCreate.hide();
    };
    CalendarioCreateComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    CalendarioCreateComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], CalendarioCreateComponent.prototype, "calendarCreated", void 0);
    __decorate([
        ViewChild('dlgCalendarCreate'),
        __metadata("design:type", ModalDirective)
    ], CalendarioCreateComponent.prototype, "dlgCalendarCreate", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], CalendarioCreateComponent.prototype, "alerts", void 0);
    CalendarioCreateComponent = __decorate([
        Component({
            selector: 'calendario-create',
            template: "\n      <div bsModal #dlgCalendarCreate=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-3\">\n                                  <azteca-form-field [label]=\"'Fecha Inicio:'\">\n                                      <az-input-date formControlName=\"fechaIni\" [(ngModel)]=\"fechaIni\"></az-input-date>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-3\">\n                                  <azteca-form-field [label]=\"'Fecha Fin:'\">\n                                      <az-input-date formControlName=\"fechaFin\" [(ngModel)]=\"fechaFin\"></az-input-date>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-3\">\n                                  <az-checkbox [label]=\"'El Sabado es laborable'\" formControlName=\"sabadoLaborable\" [(ngModel)]=\"sabadoLaborable\"></az-checkbox>\n                                  <az-checkbox [label]=\"'El domingo es laborable'\" formControlName=\"domingoLaborable\" [(ngModel)]=\"domingoLaborable\"></az-checkbox>\n                              </div>\n                          </div>\n\n                          <div class=\"modal-footer\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"accept()\" [disabled]=\"false\">Aceptar</button>\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"discardChanges()\">Descartar</button>\n\n                          </div>\n\n                      </form>\n\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n\n    \n\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [FormBuilder, Context, Router, ActivatedRoute, CalendarioService])
    ], CalendarioCreateComponent);
    return CalendarioCreateComponent;
}());
export { CalendarioCreateComponent };
