var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, ViewChild, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, Validators } from '@angular/forms';
import { BaseComponent, Context } from '../../core';
import { ModalDirective } from 'ngx-bootstrap';
import { FechaDiaItem } from '../models/calendario';
import { CalendarioService } from '../services/calendario.service';
var DiaFestivoEditorComponent = /** @class */ (function (_super) {
    __extends(DiaFestivoEditorComponent, _super);
    function DiaFestivoEditorComponent(context, builder, router, route, calendarioService, location) {
        var _this = _super.call(this) || this;
        _this.builder = builder;
        _this.router = router;
        _this.route = route;
        _this.calendarioService = calendarioService;
        _this.location = location;
        _this.title = '';
        _this.diaFestivoCopy = new FechaDiaItem();
        _this.diaFestivoSelected = new EventEmitter();
        _this.editorForm = builder.group({
            'fecha': [new Date],
            'notas': [0, Validators.required],
            'habil': [true]
        });
        return _this;
    }
    DiaFestivoEditorComponent.prototype.showAdd = function () {
        this.diaFestivoCopy = new FechaDiaItem; // <DiaFestivoItem>this.copyItem(this.detail);
        this.diaFestivoCopy.habil = true;
        this.dlgDiaFestivoEditorDialog.config.backdrop = false;
        this.dlgDiaFestivoEditorDialog.show();
    };
    DiaFestivoEditorComponent.prototype.showEdit = function (diaFestivo) {
        var copy = new FechaDiaItem();
        copy._clientID = this.diaFestivo._clientID;
        copy.id = diaFestivo.id;
        copy.fecha = diaFestivo.fecha;
        copy.notas = diaFestivo.notas;
        this.diaFestivoCopy = copy;
        this.dlgDiaFestivoEditorDialog.config.backdrop = false;
        this.dlgDiaFestivoEditorDialog.show();
    };
    DiaFestivoEditorComponent.prototype.accept = function () {
        this.diaFestivoSelected.emit(this.diaFestivoCopy);
        this.dlgDiaFestivoEditorDialog.hide();
    };
    DiaFestivoEditorComponent.prototype.discardChanges = function () {
        this.dlgDiaFestivoEditorDialog.hide();
    };
    DiaFestivoEditorComponent.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        Input(),
        __metadata("design:type", FechaDiaItem)
    ], DiaFestivoEditorComponent.prototype, "diaFestivo", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DiaFestivoEditorComponent.prototype, "diaFestivoSelected", void 0);
    __decorate([
        ViewChild('dlgDiaFestivoEditorDialog'),
        __metadata("design:type", ModalDirective)
    ], DiaFestivoEditorComponent.prototype, "dlgDiaFestivoEditorDialog", void 0);
    DiaFestivoEditorComponent = __decorate([
        Component({
            selector: 'general-dia-festivo-editor',
            template: "\n      <div bsModal #dlgDiaFestivoEditorDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n\n                          <az-panel [header]=\"'Dia Festivo'\" type=\"success\">\n                        \n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Fecha:'\">\n                                          <az-input-date formControlName=\"fecha\" [(ngModel)]=\"diaFestivoCopy.fecha\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Descripcion:'\">\n                                          <az-textbox formControlName=\"notas\" [(ngModel)]=\"diaFestivoCopy.notas\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-12\">\n                                          <az-checkbox formControlName=\"habil\" [(ngModel)]=\"diaFestivoCopy.habil\" label=\"El dia festivo permanece h\u00E1bil'\"></az-checkbox>\n                                      </div>\n                                  </div>\n\n\n                              </div>\n\n                          </az-panel>\n\n                          <div class=\"modal-footer\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"accept()\" [disabled]=\"false\">Aceptar</button>\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"discardChanges()\">Descartar</button>\n\n                          </div>\n\n                      </form>\n\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n\n\n\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder, Router, ActivatedRoute, CalendarioService,
            Location])
    ], DiaFestivoEditorComponent);
    return DiaFestivoEditorComponent;
}(BaseComponent));
export { DiaFestivoEditorComponent };
