import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo } from '../../core';
import { CalendarioInfo, FechaDiaItem } from '../models/calendario';
import { CalendarioService } from '../services/calendario.service';
import { DiaFestivoEditorComponent } from '../components/calendarios-dia-festivo-editor.component';
import { ToolbarButton, AlertsBarComponent } from '../../controls/index';
export declare class CalendarioDiasFestivosComponent extends BaseComponent {
    private context;
    private calendarioService;
    private router;
    private route;
    private location;
    diasFestivos: FechaDiaItem[];
    idCalendario: number;
    calendario: CalendarioInfo;
    currentItem: CatalogItem;
    readonly title: string;
    diaFestivoEditorDialog: DiaFestivoEditorComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, calendarioService: CalendarioService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCalendario(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onAddingItem(): void;
    onEditingItem(item: FechaDiaItem): void;
    onDeletingItem(item: FechaDiaItem): void;
    onItemsUpdated(item: FechaDiaItem): void;
    onDiaFestivoSelected(item: FechaDiaItem): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
