var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
//
import * as moment from 'moment';
import { BaseComponent, Context } from '../../core';
import { CalendarioInfo, FechaDiaItem } from '../models/calendario';
import { CalendarioService } from '../services/calendario.service';
import { DiaFestivoEditorComponent } from '../components/calendarios-dia-festivo-editor.component';
import { AlertsBarComponent } from '../../controls/index';
//
//////import { UsuariosListComponent } from '../components/dialogs/usuarios-list.component';
var CalendarioDiasFestivosComponent = /** @class */ (function (_super) {
    __extends(CalendarioDiasFestivosComponent, _super);
    //
    function CalendarioDiasFestivosComponent(context, calendarioService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.calendarioService = calendarioService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.calendario = new CalendarioInfo();
        return _this;
    }
    Object.defineProperty(CalendarioDiasFestivosComponent.prototype, "title", {
        get: function () {
            return 'Dias Festivos del Calendario - ' + this.calendario.nombre + " [" + moment(this.calendario.fechaIni).toDate().toLocaleDateString() + " - " + moment(this.calendario.fechaFin).toDate().toLocaleDateString() + "]";
        },
        enumerable: true,
        configurable: true
    });
    CalendarioDiasFestivosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idCalendario = +param['id'];
        });
    };
    CalendarioDiasFestivosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.refreshList(); });
        setTimeout(function (_) { return _this.loadCalendario(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    CalendarioDiasFestivosComponent.prototype.loadCalendario = function () {
        var _this = this;
        this.calendarioService.getDetailByID(this.idCalendario)
            .then(function (grupo) { return _this.calendario = grupo; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioDiasFestivosComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.calendarioService.getDiasFestivos(this.idCalendario)
            .then(function (diasFestivos) {
            _this.diasFestivos = diasFestivos;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    CalendarioDiasFestivosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    CalendarioDiasFestivosComponent.prototype.onToolbarButtonClick = function (button) {
        //    if (button.name == 'ADD') {
        //        this.usuariosDialog.show();
        //    }
        //    if (button.name == 'REFRESH') {
        //        this.refreshList();
        //    }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    CalendarioDiasFestivosComponent.prototype.onAddingItem = function () {
        this.diaFestivoEditorDialog.diaFestivo = new FechaDiaItem();
        this.diaFestivoEditorDialog.showAdd();
    };
    CalendarioDiasFestivosComponent.prototype.onEditingItem = function (item) {
        this.diaFestivoEditorDialog.diaFestivo = new FechaDiaItem();
        this.diaFestivoEditorDialog.showAdd();
    };
    CalendarioDiasFestivosComponent.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.context.app.showSpinner();
        this.calendarioService.removeDiaFestivo(this.idCalendario, item.fecha)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.diasFestivos = _this.diasFestivos.filter(function (itemDia) { return itemDia.fecha != item.fecha; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioDiasFestivosComponent.prototype.onItemsUpdated = function (item) {
    };
    CalendarioDiasFestivosComponent.prototype.onDiaFestivoSelected = function (item) {
        var _this = this;
        if (item.fecha.getTime() >= moment(this.calendario.fechaIni).toDate().getTime() && item.fecha.getTime() <= moment(this.calendario.fechaFin).toDate().getTime()) {
            var newDiasFestivos = this.diasFestivos.slice();
            if (item._clientID == 0) {
                item._clientID = this.diasFestivos.length + 1;
                newDiasFestivos.push(item);
            }
            else {
                var index = newDiasFestivos.findIndex(function (item) { return item._clientID == item._clientID; });
                newDiasFestivos[index] = item;
            }
            this.diasFestivos = newDiasFestivos;
            //this.diasFestivos = newDiasFestivos;
            this.context.app.showSpinner();
            this.calendarioService.addDiasFestivos(this.idCalendario, this.diasFestivos)
                .then(function (_) {
                _this.refreshList();
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.alerts.showAlert('Fecha no pertenece al calendario', 'danger');
        }
    };
    CalendarioDiasFestivosComponent.prototype.applyPolicy = function (policy) {
    };
    CalendarioDiasFestivosComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        ViewChild(DiaFestivoEditorComponent),
        __metadata("design:type", DiaFestivoEditorComponent)
    ], CalendarioDiasFestivosComponent.prototype, "diaFestivoEditorDialog", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], CalendarioDiasFestivosComponent.prototype, "alerts", void 0);
    CalendarioDiasFestivosComponent = __decorate([
        Component({
            selector: 'general-calendario-dias-festivos',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <!--<az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar dia festivo'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>-->\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de dias festivos-->\n                  <azteca-editable-list #diasFestivosList\n                                        (addingItem)=\"onAddingItem()\"\n                                        (editingItem)=\"onEditingItem($event)\"\n                                        (deletingItem)=\"onDeletingItem($event)\"\n                                        (listItemsUpdated)=\"onItemsUpdated($event)\"\n                                        [listItems]=\"diasFestivos\">\n\n                      <!-- OPCIONES DEL MENU-->\n                      <!--<azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar art\u00EDculo'\"></azteca-menu-item>-->\n                      <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar art\u00EDculo'\"></azteca-menu-item>\n\n                      <!-- COLUMNAS DEL GRID-->\n                      <azteca-grid-column [header]=\"'Dia'\" [binding]=\"'fecha'\" [width]=\"'20*'\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Descripcion'\" [binding]=\"'notas'\" [width]=\"'60*'\"></azteca-grid-column>\n\n                  </azteca-editable-list>\n            \n              </az-panel>\n          </div>\n      </div>\n\n      <general-dia-festivo-editor #diaFestivoEditorDialog\n                                  (diaFestivoSelected)=\"onDiaFestivoSelected($event)\">\n\n      </general-dia-festivo-editor>\n    "
        }),
        __metadata("design:paramtypes", [Context, CalendarioService, Router, ActivatedRoute,
            Location])
    ], CalendarioDiasFestivosComponent);
    return CalendarioDiasFestivosComponent;
}(BaseComponent));
export { CalendarioDiasFestivosComponent };
