import { QueryList } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, PolicyInfo } from '../../core';
import { CalendarioInfo, FechaDiaItem } from '../models/calendario';
import { CalendarioService } from '../services/calendario.service';
import { DiaFestivoEditorComponent } from '../components/calendarios-dia-festivo-editor.component';
import { ToolbarButton, AlertsBarComponent, MenuItemDirective } from '../../controls/index';
import * as input from 'wijmo/wijmo.input';
import { WjCalendar } from 'wijmo/wijmo.angular2.input';
export declare class CalendarioDiasHabilesComponent extends BaseComponent {
    private context;
    private calendarioService;
    private router;
    private route;
    private location;
    idCalendario: number;
    calendario: CalendarioInfo;
    fechas: FechaDiaItem[];
    diasHabiles: FechaDiaItem[];
    accion: string;
    fechaCurrent: FechaDiaItem;
    readonly title: string;
    diaFestivoEditorDialog: DiaFestivoEditorComponent;
    alerts: AlertsBarComponent;
    calendar: WjCalendar;
    menuItems: QueryList<MenuItemDirective>;
    constructor(context: Context, calendarioService: CalendarioService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCalendario(): void;
    loadDiasHabiles(): void;
    formatItem(e: input.FormatItemEventArgs): void;
    private _getDiaHabil;
    private _getFecha;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    onDayClicked(): void;
    cambiar(): void;
    addDiaHabil(fecha: Date): void;
    removeDiaHabil(date: Date): void;
    cambiarFechaHabil(): void;
    cambiarFechaEstadistica(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
}
