var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild, ContentChildren, QueryList } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
//
import { BaseComponent, Context } from '../../core';
import { CalendarioInfo, FechaDiaItem } from '../models/calendario';
import { CalendarioService } from '../services/calendario.service';
import { DiaFestivoEditorComponent } from '../components/calendarios-dia-festivo-editor.component';
import { AlertsBarComponent, MenuItemDirective } from '../../controls/index';
import * as moment from 'moment';
//wijmo
import * as wijmo from 'wijmo/wijmo';
import { WjCalendar } from 'wijmo/wijmo.angular2.input';
//import '@grapecity/wijmo.styles/wijmo.css';
//import * 'wijmo/wijmo.styles/wijmo.css';
//import '@grapecity/wijmo.styles/wijmo.css';
//import './styles.css';
//
//////import { UsuariosListComponent } from '../components/dialogs/usuarios-list.component';
var CalendarioDiasHabilesComponent = /** @class */ (function (_super) {
    __extends(CalendarioDiasHabilesComponent, _super);
    //
    function CalendarioDiasHabilesComponent(context, calendarioService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.calendarioService = calendarioService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.calendario = new CalendarioInfo();
        _this.fechas = [];
        _this.diasHabiles = [];
        //diasFestivos: FechaDiaItem[] = [];
        _this.accion = "accionar";
        _this.fechaCurrent = new FechaDiaItem();
        return _this;
    }
    Object.defineProperty(CalendarioDiasHabilesComponent.prototype, "title", {
        get: function () {
            return 'Dias habiles del Calendario - ' + this.calendario.nombre + " [" + moment(this.calendario.fechaIni).toDate().toLocaleDateString() + " - " + moment(this.calendario.fechaFin).toDate().toLocaleDateString() + "]";
        },
        enumerable: true,
        configurable: true
    });
    CalendarioDiasHabilesComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idCalendario = +param['id'];
        });
        /////
        //if (document.getElementById('calendario').addEventListener) {
        //    document.getElementById('calendario').addEventListener('contextmenu', function (event) {
        //        event.preventDefault();
        //        let element = document.getElementById('menu');
        //        element.classList.toggle('hide');
        //        element.style.position = 'absolute';
        //        element.style.zIndex = '1';
        //        element.style.top = event.layerY + 'px';
        //        element.style.left = event.layerX + 'px';
        //    }, false);
        //}
        //document.addEventListener('pointerdown', function (event) {
        //    document.getElementById('menu').classList.add('hide');
        //});
    };
    CalendarioDiasHabilesComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadCalendario(); });
        setTimeout(function (_) { return _this.loadDiasHabiles(); });
        setTimeout(function (_) { return _this.calendar.refresh(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    CalendarioDiasHabilesComponent.prototype.loadCalendario = function () {
        var _this = this;
        this.calendarioService.getDetailByID(this.idCalendario)
            .then(function (grupo) {
            _this.calendario = grupo;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioDiasHabilesComponent.prototype.loadDiasHabiles = function () {
        var _this = this;
        this.context.app.showSpinner();
        //let fechasBak = new FechaDiaItem[]();
        this.calendarioService.getFechas(this.idCalendario)
            .then(function (fechas) {
            _this.fechas = fechas;
            _this.context.app.hideSpinner();
            _this.fechas.forEach(function (item) {
                item.fecha = moment(item.fecha).toDate();
                item.state = 'UNMODIFIED';
                //if (item.habil == true)
                //    fechasBak.push(item.copy);
            });
            //se asignan los dias habiles
            //this.diasHabiles = fechasBak;
            var diasHabilesBak = _this.fechas.filter(function (fecha) { return fecha.habil == true; });
            _this.diasHabiles = diasHabilesBak;
            setTimeout(function (_) { return _this.calendar.refresh(); });
            setTimeout(function (_) { return _this.onDayClicked(); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioDiasHabilesComponent.prototype.formatItem = function (e) {
        // apply styles to weekends and holidays
        var weekday = e.data.getDay(), holiday = this._getDiaHabil(e.data);
        //
        //wijmo.toggleClass(e.item, 'date-weekend', weekday == 0 || weekday == 6);
        //wijmo.toggleClass(e.item, 'date-holiday', holiday != null);
        wijmo.toggleClass(e.item, 'date-weekend', holiday != null && holiday.state != "DELETED");
        if (holiday)
            e.item.title = holiday.notas;
    };
    // gets the holiday for a given date
    CalendarioDiasHabilesComponent.prototype._getDiaHabil = function (date) {
        //let day = date.getDate();
        //let month = date.getMonth() + 1;
        //let holiday = this.diasHabiles.find(search => search.fecha==date);
        var holiday = this.diasHabiles.find(function (search) {
            return search.fecha.getDate() == date.getDate() &&
                search.fecha.getMonth() == date.getMonth() &&
                search.fecha.getFullYear() == date.getFullYear();
        });
        //
        //if (!holiday) {
        //    let weekDay = date.getDay(),
        //        weekNum = Math.floor((day - 1) / 7) + 1;
        //    //holiday = this.diasHabiles[month + '/' + weekNum + '/' + weekDay];
        //    holiday = this.diasHabiles.find(search => search.fecha == date );
        //}
        //
        return holiday;
    };
    CalendarioDiasHabilesComponent.prototype._getFecha = function (date) {
        var fecha = this.fechas.find(function (search) {
            return search.fecha.getDate() == date.getDate() &&
                search.fecha.getMonth() == date.getMonth() &&
                search.fecha.getFullYear() == date.getFullYear();
        });
        return fecha;
    };
    CalendarioDiasHabilesComponent.prototype.applyPolicy = function (policy) {
    };
    CalendarioDiasHabilesComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    //////////////////////////////////*****************************//////////////////////////////////////
    CalendarioDiasHabilesComponent.prototype.onDayClicked = function () {
        var fechaCurrent = this.calendar.value;
        if (fechaCurrent.getTime() >= moment(this.calendario.fechaIni).toDate().getTime() && fechaCurrent.getTime() <= moment(this.calendario.fechaFin).toDate().getTime()) {
            var habil = this._getDiaHabil(this.calendar.value);
            if (habil && habil.state != "DELETED")
                this.accion = 'Establecer como inhábil';
            else
                this.accion = 'Establecer como hábil';
            var fecha = this._getFecha(this.calendar.value);
            if (fecha)
                this.fechaCurrent = fecha;
        }
        else
            this.accion = 'Fecha no pertenece al calendario';
    };
    CalendarioDiasHabilesComponent.prototype.cambiar = function () {
        var _this = this;
        if (this.accion != "Fecha no pertenece al calendario") {
            this.context.app.showSpinner();
            var habilitar_1 = false;
            var diaHabil = this._getDiaHabil(this.calendar.value);
            if (!diaHabil || diaHabil.state == 'DELETED')
                habilitar_1 = true;
            this.calendarioService.setDiaHabil(this.idCalendario, this.calendar.value, habilitar_1)
                .then(function (_) {
                if (habilitar_1)
                    _this.addDiaHabil(_this.calendar.value);
                else
                    _this.removeDiaHabil(_this.calendar.value);
                _this.context.app.hideSpinner();
                setTimeout(function (_) {
                    _this.calendar.refresh();
                    _this.onDayClicked();
                });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    CalendarioDiasHabilesComponent.prototype.addDiaHabil = function (fecha) {
        var diaHabil = this._getDiaHabil(fecha);
        if (diaHabil)
            diaHabil.state = 'MODIFIED';
        else {
            var diasHabilesBak = this.diasHabiles;
            var dia = new FechaDiaItem();
            dia.fecha = fecha;
            diasHabilesBak.push(dia);
            this.diasHabiles = diasHabilesBak;
        }
        this.onDayClicked();
    };
    CalendarioDiasHabilesComponent.prototype.removeDiaHabil = function (date) {
        var diasHabilesBak = this.diasHabiles;
        var dia = diasHabilesBak.find(function (search) { return search.fecha.getDate() == date.getDate() &&
            search.fecha.getMonth() == date.getMonth() &&
            search.fecha.getFullYear() == date.getFullYear(); });
        if (dia) {
            dia.state = 'DELETED';
            this.diasHabiles = diasHabilesBak;
        }
        this.onDayClicked();
    };
    CalendarioDiasHabilesComponent.prototype.cambiarFechaHabil = function () {
        var _this = this;
        this.calendarioService.setFechaHabil(this.idCalendario, this.fechaCurrent.fecha, this.fechaCurrent.fechaHabil)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Se ha establecido la fecha hábil con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioDiasHabilesComponent.prototype.cambiarFechaEstadistica = function () {
        var _this = this;
        this.calendarioService.setFechaEstadistica(this.idCalendario, this.fechaCurrent.fecha, this.fechaCurrent.fechaEstadistica)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Se ha establecido la fecha estadistica con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendarioDiasHabilesComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    __decorate([
        ViewChild(DiaFestivoEditorComponent),
        __metadata("design:type", DiaFestivoEditorComponent)
    ], CalendarioDiasHabilesComponent.prototype, "diaFestivoEditorDialog", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], CalendarioDiasHabilesComponent.prototype, "alerts", void 0);
    __decorate([
        ViewChild(WjCalendar),
        __metadata("design:type", WjCalendar)
    ], CalendarioDiasHabilesComponent.prototype, "calendar", void 0);
    __decorate([
        ContentChildren(MenuItemDirective),
        __metadata("design:type", QueryList)
    ], CalendarioDiasHabilesComponent.prototype, "menuItems", void 0);
    CalendarioDiasHabilesComponent = __decorate([
        Component({
            selector: 'general-calendario-dias-habiles',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n\n\n                  <div class=\"row\">\n                      <div class=\"col-4\">\n                          <!--Toolbar Principal-->\n                          <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                              <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                          </az-toolbar>\n                      </div>\n\n                      <div class=\"col-3\">\n                          Fecha seleccionada: <b>{{ theCalendar.value.toLocaleDateString()}}</b>.\n                      </div>\n                      <div class=\"col-3\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"cambiar()\" title=\"'Accion'\">\n                              {{ accion }}\n                          </button>\n                      </div>\n\n                  </div>\n                       \n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <wj-calendar #theCalendar\n                                       (formatItem)=\"formatItem($event)\"\n                                       (valueChanged)=\"onDayClicked($event)\">\n                          </wj-calendar>\n                      </div>\n                  </div>\n           \n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <az-panel [header]=\"'Avanzado'\">\n                              <div class=\"row\">\n                                  <div class=\"col-2\">\n                                      Fecha H\u00E1bil:\n                                  </div>\n                                  <div class=\"col-3\">\n                                      <az-input-date [(ngModel)]=\"fechaCurrent.fechaHabil\"></az-input-date>\n                                  </div>\n                                  <div class=\"col-3\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"cambiarFechaHabil()\" title=\"'establecer fecha h\u00E1bil'\">Establecer</button>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-2\">\n                                      Fecha estadistica:\n                                  </div>\n                                  <div class=\"col-3\">\n                                      <az-input-date [(ngModel)]=\"fechaCurrent.fechaEstadistica\"></az-input-date>\n                                  </div>\n                                  <div class=\"col-3\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"cambiarFechaEstadistica()\" title=\"'establecer fecha estadistica'\">Establecer</button>\n                                  </div>\n                              </div>\n                          </az-panel>\n                      </div>\n                  </div>\n\n                      <!--<az-input-date (formatItem)=\"formatItem($event)\">\n\n          </az-input-date>\n\n          <azteca-schedule id=\"calendario\"\n                           (dayClicked)=\"onDayClicked($event)\"\n                           [viewMonthVisible]=\"true\"\n                           [viewWeekVisible]=\"false\"\n                           [viewDayVisible]=\"false\"\n                           (pointerdown)=\"mouseDown($event)\">\n          </azteca-schedule>-->\n                      <!-- OPCIONES DEL MENU-->\n                      <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar art\u00EDculo'\"></azteca-menu-item>\n                      <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar art\u00EDculo'\"></azteca-menu-item>\n\n                  </az-panel>\n          </div>\n      </div>\n\n      <wj-menu id=\"menu\" #ctxMenu (itemClicked)=\"contextMenuClick(ctxMenu)\" style=\"display:none\">\n          <wj-menu-item *ngFor=\"let item of menuItems\">\n              <div *ngIf=\"item.enabled\">\n                  <span [class]=\"item.icon\"></span>\n                  <b>{{item.text}}</b>\n                  <br>\n                  <small><i>{{item.smallText}}</i></small>\n              </div>\n          </wj-menu-item>\n      </wj-menu>\n    "
        }),
        __metadata("design:paramtypes", [Context, CalendarioService, Router, ActivatedRoute,
            Location])
    ], CalendarioDiasHabilesComponent);
    return CalendarioDiasHabilesComponent;
}(BaseComponent));
export { CalendarioDiasHabilesComponent };
