import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { MenuItem } from '../../controls';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { CalendarioService } from '../services/calendario.service';
import { CalendarioInfo } from '../models/calendario';
import { CalendarioCreateComponent } from '../components/calendarios-create.component';
export declare class CalendariosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private calendarioService;
    calendario: CalendarioInfo;
    dlgCalendarCreate: CalendarioCreateComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, calendarioService: CalendarioService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(item: MenuItem): void;
}
