import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { MenuItem } from '../../controls';
import { CalendarioService } from '../services/calendario.service';
import { CalendarioItem } from '../models/calendario';
import { CalendarioCreateComponent } from '../components/calendarios-create.component';
export declare class CalendariosManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private calendarioService;
    calendarios: CalendarioItem[];
    dlgCalendarCreate: CalendarioCreateComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, calendarioService: CalendarioService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
    onCalendarioCreated(exitoso: boolean): void;
}
