var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, forwardRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogManager } from '../../editors';
//Features
import { CalendarioService } from '../services/calendario.service';
import { CalendarioCreateComponent } from '../components/calendarios-create.component';
var CalendariosManager = /** @class */ (function (_super) {
    __extends(CalendariosManager, _super);
    //    
    function CalendariosManager(context, router, route, calendarioService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.calendarioService = calendarioService;
        _this.calendarios = [];
        return _this;
    }
    CalendariosManager_1 = CalendariosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CalendariosManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    CalendariosManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.calendarioService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.calendarios = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendariosManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    CalendariosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    CalendariosManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    CalendariosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.calendarioService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendariosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    CalendariosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.calendarioService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CalendariosManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'CREATE') {
            this.dlgCalendarCreate.showCreate(this.manager.currentItem.id);
        }
        else if (option.name == 'FREE') {
            this.router.navigate(['kernel/general/calendarios/', this.process.id, this.manager.currentItem.id, "dias-festivos"]);
        }
        else if (option.name == 'HABILES') {
            this.router.navigate(['kernel/general/calendarios/', this.process.id, this.manager.currentItem.id, "dias-habiles"]);
        }
    };
    CalendariosManager.prototype.onCalendarioCreated = function (exitoso) {
        this.showAlert('El calendario se genero con exito.', 'success');
    };
    var CalendariosManager_1;
    __decorate([
        ViewChild('dlgCalendarCreate'),
        __metadata("design:type", CalendarioCreateComponent)
    ], CalendariosManager.prototype, "dlgCalendarCreate", void 0);
    CalendariosManager = CalendariosManager_1 = __decorate([
        Component({
            selector: 'general-calendarios-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">General - Calendarios</div>\n          <div class=\"card-block\">\n\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [allowAudit]=\"allowAudit\"\n                                      [catalogList]=\"calendarios\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'CREATE'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Generar'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'FREE'\" [icon]=\"'glyphicon glyphicon-certificate'\" [text]=\"'Dias festivos'\" [smallText]=\"'editar dias festivos'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'HABILES'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Dias habiles'\" [smallText]=\"'editar dias habiles'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'20*'\"></azteca-grid-column>\n\n              </azteca-catalog-manager>\n\n          </div>\n      </div>\n\n      <calendario-create #dlgCalendarCreate\n                       (calendarCreated)=\"onCalendarioCreated($event)\"\n                       >\n\n      </calendario-create>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return CalendariosManager_1; })
                },
                {
                    provide: CatalogService, useExisting: CalendarioService
                }
            ]
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute, CalendarioService])
    ], CalendariosManager);
    return CalendariosManager;
}(CatalogManager));
export { CalendariosManager };
