var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Angular
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//Wijmo
import { CollectionView, NotifyCollectionChangedAction } from 'wijmo/wijmo';
import { DataMap } from 'wijmo/wijmo.grid';
//
import { BaseComponent } from '../../core';
import { BaseControl } from '../../controls';
import { ChangeState } from '../../editors';
var ClasificacionesEditorComponent = /** @class */ (function (_super) {
    __extends(ClasificacionesEditorComponent, _super);
    function ClasificacionesEditorComponent() {
        var _this = _super.call(this) || this;
        _this.valoresCollection = new CollectionView();
        //Inputs
        _this.valores = [];
        _this.clasificadores = [];
        //Outpus
        _this.valoresChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    ClasificacionesEditorComponent_1 = ClasificacionesEditorComponent;
    ClasificacionesEditorComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        //Si los valores cambian, asignar a collection view
        if (changes['valores']) {
            this.updateValores();
        }
        //Si cambian los clasificadores, recrear data map
        if (changes['clasificadores']) {
            this.clasificadoresMap = new DataMap(this.clasificadores, 'idClasificacion', 'nombre');
            this.clasificadoresMap.getDisplayValues = function (dataItem) {
                var idGrupo = _this.valoresCollection.currentItem.idGrupoClasificaciones;
                var filterdList = _this.clasificadores.filter(function (c) { return c.idGrupoClasificaciones == idGrupo; })
                    .map(function (c) { return c.nombre; });
                return filterdList;
            };
        }
    };
    ClasificacionesEditorComponent.prototype.updateValores = function () {
        var _this = this;
        this.valoresCollection = new CollectionView(this.valores, {
            getError: function (item, property) {
                switch (property) {
                    case 'idClasificacion':
                        return item.requerido && item[property] <= 0 ? 'La clasificación es requerida' : null;
                } //switch
                return null;
            } //getError
        });
        //Suscribir a cambios en la colección
        this.valoresCollection.collectionChanged.addHandler(function (sender, args) {
            if (args.action == NotifyCollectionChangedAction.Change && args.item != null) {
                args.item.state = ChangeState.MODIFIED;
                _this.valoresChange.emit(_this.valores);
                _this.propagateChange(_this.valores);
            }
        });
    };
    //Implementación de control value accesor
    ClasificacionesEditorComponent.prototype.writeValue = function (value) {
        this.valores = value ? value : [];
        this.updateValores();
    };
    ClasificacionesEditorComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ClasificacionesEditorComponent.prototype.registerOnTouched = function () { };
    var ClasificacionesEditorComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ClasificacionesEditorComponent.prototype, "valores", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ClasificacionesEditorComponent.prototype, "clasificadores", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], ClasificacionesEditorComponent.prototype, "valoresChange", void 0);
    ClasificacionesEditorComponent = ClasificacionesEditorComponent_1 = __decorate([
        Component({
            selector: 'az-clasificaciones-editor',
            template: "\n\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <wj-flex-grid style=\"height:550px\" [itemsSource]=\"valoresCollection\">\n\n                  <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                  <wj-flex-grid-column [header]=\"'Clasificaci\u00F3n'\" [binding]=\"'grupo'\" [width]=\"'30*'\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Valor'\" [binding]=\"'idClasificacion'\" [width]=\"'20*'\" [dataMap]=\"clasificadoresMap\"></wj-flex-grid-column>\n              </wj-flex-grid>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ClasificacionesEditorComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return ClasificacionesEditorComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [])
    ], ClasificacionesEditorComponent);
    return ClasificacionesEditorComponent;
}(BaseControl));
export { ClasificacionesEditorComponent };
