import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { FlexGrid } from 'wijmo/wijmo.grid';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { ToolbarButton, AzAutocompleteComponent } from '../../controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from '../../editors';
import { GrupoClasificacionService } from '../services/grupo-clasificacion.service';
import { GrupoClasificacionInfo, EntidadClasificacionItem } from '../models/grupo-clasificacion';
export declare class ClasificacionesGruposEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private grupoClasificacionService;
    grupoclasificacion: GrupoClasificacionInfo;
    entidades: EntidadClasificacionItem[];
    clasificacionesCollection: TrackableCollection;
    entidad: string;
    entidadAutoComplete: AzAutocompleteComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, grupoClasificacionService: GrupoClasificacionService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    validaEntidad(): {
        error: string;
    };
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onChangedBinario(val: boolean): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelect(args: any): void;
    loadEntidades(): void;
    gridClasificacionesInitialized(sender: FlexGrid, args: any): void;
    onClasificacionToolbar(button: ToolbarButton): void;
    onClasificacionDelete(item: any): void;
}
