var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
import { Control } from 'wijmo/wijmo';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { AzAutocompleteComponent } from '../../controls';
import { CatalogEditor, TrackableCollection } from '../../editors';
//Features
import { GrupoClasificacionService } from '../services/grupo-clasificacion.service';
import { GrupoClasificacionInfo, ClasificacionItem } from '../models/grupo-clasificacion';
var ClasificacionesGruposEditor = /** @class */ (function (_super) {
    __extends(ClasificacionesGruposEditor, _super);
    function ClasificacionesGruposEditor(router, route, formBuilder, changeDetector, context, location, grupoClasificacionService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.grupoClasificacionService = grupoClasificacionService;
        _this.grupoclasificacion = new GrupoClasificacionInfo();
        _this.entidades = [];
        _this.clasificacionesCollection = new TrackableCollection();
        _this.entidad = '';
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'entidad': ['', function (control) { return _this.validaEntidad(); }],
            'requerido': [''],
            'binario': ['']
        });
        return _this;
    }
    ClasificacionesGruposEditor_1 = ClasificacionesGruposEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ClasificacionesGruposEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.loadEntidades();
        this.autogeneratedCode = options.codigoAutogenerado;
        this.route.params.forEach(function (param) {
            _this.entidad = param['entidad'];
            if (!_this.entidad) {
                _this.entidad = "";
            }
            _this.grupoclasificacion.Entidad = _this.entidad;
            _this.entidadAutoComplete.text = _this.entidad;
        });
    };
    ClasificacionesGruposEditor.prototype.onCreatingItem = function () {
    };
    ClasificacionesGruposEditor.prototype.validaEntidad = function () {
        if (this.entidad != '')
            return null;
        else
            return { error: "Valor no ingresado" };
    };
    ClasificacionesGruposEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoClasificacionService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupoclasificacion = info;
            _this.clasificacionesCollection.sourceCollection = _this.grupoclasificacion.clasificaciones;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasificacionesGruposEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.grupoClasificacionService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupoclasificacion = info;
            _this.clasificacionesCollection.sourceCollection = _this.grupoclasificacion.clasificaciones;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasificacionesGruposEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoClasificacionService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupoclasificacion = info;
            _this.clasificacionesCollection.sourceCollection = _this.grupoclasificacion.clasificaciones;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasificacionesGruposEditor.prototype.onChangedBinario = function (val) {
        if (val) {
            this.grupoclasificacion.clasificaciones = [];
            var clasificacion = new ClasificacionItem();
            clasificacion.nombre = 'Si';
            clasificacion.valor = 1;
            clasificacion.referencia = '1';
            this.grupoclasificacion.clasificaciones.push(clasificacion);
            var clasificacion2 = new ClasificacionItem();
            clasificacion2.nombre = 'No';
            clasificacion2.valor = 0;
            clasificacion2.referencia = '0';
            this.grupoclasificacion.clasificaciones.push(clasificacion2);
        }
        else {
            this.grupoclasificacion.clasificaciones = [];
        }
        this.clasificacionesCollection.sourceCollection = this.grupoclasificacion.clasificaciones;
    };
    ClasificacionesGruposEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoClasificacionService.update(this.grupoclasificacion)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupoclasificacion = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
            var clasificacionesTemp = _this.grupoclasificacion.clasificaciones.slice();
            _this.grupoclasificacion.clasificaciones = clasificacionesTemp;
            _this.clasificacionesCollection.sourceCollection = clasificacionesTemp;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasificacionesGruposEditor.prototype.onTabSelect = function (args) {
        if (args.heading) {
            Control.invalidateAll();
        }
    };
    ClasificacionesGruposEditor.prototype.loadEntidades = function () {
        var _this = this;
        this.grupoClasificacionService.loadEntidades()
            .then(function (entidades) { return _this.entidades = entidades; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasificacionesGruposEditor.prototype.gridClasificacionesInitialized = function (sender, args) {
    };
    ClasificacionesGruposEditor.prototype.onClasificacionToolbar = function (button) {
        if (!this.grupoclasificacion.binario) {
            var newClasificacion = new ClasificacionItem();
            newClasificacion.nombre = "[Nueva Clasificacion]";
            newClasificacion.idClasificacion = 0;
            newClasificacion.referencia = "";
            var clasificacionesTemp = this.grupoclasificacion.clasificaciones.slice();
            clasificacionesTemp.push(newClasificacion);
            this.grupoclasificacion.clasificaciones = clasificacionesTemp;
            this.clasificacionesCollection.sourceCollection = clasificacionesTemp;
        }
    };
    ClasificacionesGruposEditor.prototype.onClasificacionDelete = function (item) {
        if (!this.grupoclasificacion.binario) {
            this.clasificacionesCollection.remove(this.clasificacionesCollection.currentItem);
        }
    };
    var ClasificacionesGruposEditor_1;
    __decorate([
        ViewChild(AzAutocompleteComponent),
        __metadata("design:type", AzAutocompleteComponent)
    ], ClasificacionesGruposEditor.prototype, "entidadAutoComplete", void 0);
    ClasificacionesGruposEditor = ClasificacionesGruposEditor_1 = __decorate([
        Component({
            selector: 'general-clasificacionesgrupos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Grupo de Clasificaciones'\"\n                                 [info]=\"grupoclasificacion\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"grupoclasificacion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"grupoclasificacion.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelect($event)\">\n                        \t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Entidad:'\">\n                                          <az-autocomplete #entidadAutoComplete\n                                                           formControlName=\"entidad\"\n                                                           [(ngModel)]=\"grupoclasificacion.entidad\"\n                                                           [items]=\"entidades\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [enabled]=\"entidad == ''\"\n                                                           >\n                                          </az-autocomplete>\n\n                                      </azteca-form-field>\n\n                                      <az-checkbox formControlName=\"requerido\" [label]=\"'Requerido'\" [(ngModel)]=\"grupoclasificacion.requerido\"></az-checkbox>\n\n                                      <az-checkbox formControlName=\"binario\" [label]=\"'Binario'\" [(ngModel)]=\"grupoclasificacion.binario\" (checkedChanged)=\"onChangedBinario($event)\" [enabled]=\"(!grupoclasificacion.binario && grupoclasificacion.identity == 0)\" ></az-checkbox>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Clasificaciones\" (select)=\"onTabSelect($event)\">\n                              <az-toolbar (buttonClick)=\"onClasificacionToolbar($event)\">\n                                  <az-toolbar-button [name]=\"'add'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar nueva clasificacion'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #grdClasificaciones style=\"height:550px\"\n                                                    [itemsSource]=\"clasificacionesCollection\"\n                                                    (initialialized)=\"gridClasificacionesInitialized(grdClasificaciones, $event)\">\n                                          <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn wj-btn-default\" (click)=\"onClasificacionDelete(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-trash\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"'Clasificacion'\" [binding]=\"'nombre'\" [width]=\"'30*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Valor'\" [binding]=\"'valor'\" [width]=\"'10*'\" [dataType]=\"number\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Referencia'\" [binding]=\"'referencia'\" [width]=\"'20*'\"></wj-flex-grid-column>                                    \n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ClasificacionesGruposEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: GrupoClasificacionService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, GrupoClasificacionService])
    ], ClasificacionesGruposEditor);
    return ClasificacionesGruposEditor;
}(CatalogEditor));
export { ClasificacionesGruposEditor };
