var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogEditor } from '../../editors';
//Features
import { CodigoPostalService } from '../services/codigo-postal.service';
import { CodigoPostalInfo } from '../models/codigo-postal';
var CodigosPostalesEditor = /** @class */ (function (_super) {
    __extends(CodigosPostalesEditor, _super);
    function CodigosPostalesEditor(router, route, formBuilder, changeDetector, context, location, codigoPostalService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.codigoPostalService = codigoPostalService;
        _this.codigopostal = new CodigoPostalInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'codigoPostal': ['', Validators.required],
            'referencia': [''],
            'area': ['']
        });
        return _this;
    }
    CodigosPostalesEditor_1 = CodigosPostalesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CodigosPostalesEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idEstado = +params['idEstado'];
        });
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    CodigosPostalesEditor.prototype.onCreatingItem = function () {
        this.codigopostal.idEstado = this.idEstado;
    };
    CodigosPostalesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.codigoPostalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.codigopostal = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CodigosPostalesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.codigoPostalService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.codigopostal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CodigosPostalesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.codigoPostalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.codigopostal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CodigosPostalesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.codigoPostalService.update(this.codigopostal)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.codigopostal = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CodigosPostalesEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    var CodigosPostalesEditor_1;
    CodigosPostalesEditor = CodigosPostalesEditor_1 = __decorate([
        Component({
            selector: 'general-codigos-postales-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Codigo Postal'\"\n                                 [info]=\"codigopostal\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"codigopostal.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'CodigoPostal:'\">\n                          <az-textbox formControlName=\"codigoPostal\" [(ngModel)]=\"codigopostal.codigoPostal\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Referencia:'\">\n                          <az-textbox formControlName=\"referencia\" [(ngModel)]=\"codigopostal.referencia\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-map-polygon formControlName=\"area\" [(ngModel)]=\"codigopostal.area\">\n\n                      </azteca-map-polygon>\n\n                  </div>\n              </div>\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return CodigosPostalesEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: CodigoPostalService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, CodigoPostalService])
    ], CodigosPostalesEditor);
    return CodigosPostalesEditor;
}(CatalogEditor));
export { CodigosPostalesEditor };
