import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { CodigoPostalService } from '../services/codigo-postal.service';
import { CodigoPostalItem } from '../models/codigo-postal';
export declare class CodigosPostalesManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private codigoPostalService;
    codigospostales: CodigoPostalItem[];
    idEstado: number;
    refreshListParent: EventEmitter<void>;
    constructor(router: Router, route: ActivatedRoute, context: Context, codigoPostalService: CodigoPostalService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
