import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { EstadoService } from '../services/estado.service';
import { EstadoInfo } from '../models/estado';
import { MunicipioItem } from '../models/municipio';
import { MunicipioService } from '../services/municipio.service';
import { CodigoPostalItem } from '../models/codigo-postal';
import { CodigoPostalService } from '../services/codigo-postal.service';
export declare class EstadosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private estadoService;
    private municipioService;
    private codigoPostalService;
    estado: EstadoInfo;
    municipios: MunicipioItem[];
    codigosPostales: CodigoPostalItem[];
    idPais: number;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, estadoService: EstadoService, municipioService: MunicipioService, codigoPostalService: CodigoPostalService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onCancelingEdit(): void;
    selectMunicipiosTab(): void;
    selectCodigosPostalesTab(): void;
    loadMunicipios(): void;
    loadCodigosPostales(): void;
}
