import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { EstadoService } from '../services/estado.service';
import { EstadoItem } from '../models/estado';
export declare class EstadosManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private estadoService;
    estados: EstadoItem[];
    idPais: number;
    refreshListParent: EventEmitter<void>;
    constructor(router: Router, route: ActivatedRoute, context: Context, estadoService: EstadoService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
