import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { FormatoTipoService } from '../services/formato-tipo.service';
import { FormatoService } from '../services/formato.service';
import { FormatoTipoInfo } from '../models/formato-tipo';
import { FormatoItem } from '../models/formato';
export declare class FormatosTiposEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private formatoTipoService;
    private formatoService;
    formatotipo: FormatoTipoInfo;
    formatos: FormatoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, formatoTipoService: FormatoTipoService, formatoService: FormatoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectedTab(args: any): void;
    loadFormatos(): void;
}
