var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, Input, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogEditor } from '../../editors';
import { SearchRequest } from '../../search';
//Features
import { FormatoTipoService } from '../services/formato-tipo.service';
import { FormatoService } from '../services/formato.service';
import { FormatoTipoInfo } from '../models/formato-tipo';
//wijmo
import { Control } from "wijmo/wijmo";
var FormatosTiposEditor = /** @class */ (function (_super) {
    __extends(FormatosTiposEditor, _super);
    //
    function FormatosTiposEditor(router, route, formBuilder, changeDetector, context, location, formatoTipoService, formatoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.formatoTipoService = formatoTipoService;
        _this.formatoService = formatoService;
        _this.formatotipo = new FormatoTipoInfo();
        _this.formatos = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'sample_field': ['']
        });
        return _this;
    }
    FormatosTiposEditor_1 = FormatosTiposEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    FormatosTiposEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    FormatosTiposEditor.prototype.onCreatingItem = function () {
    };
    FormatosTiposEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.formatoTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.formatotipo = info;
            _this.setReadonlyMode();
            _this.loadFormatos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormatosTiposEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.formatoTipoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.formatotipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormatosTiposEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.formatoTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.formatotipo = info;
            _this.loadFormatos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormatosTiposEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.formatoTipoService.update(this.formatotipo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.formatotipo = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FormatosTiposEditor.prototype.onSelectedTab = function (args) {
        if (args.heading) {
            Control.invalidateAll();
        }
    };
    FormatosTiposEditor.prototype.loadFormatos = function () {
        var _this = this;
        var request = new SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicionServidorSMTP = { field: "idFormatoTipo", operator: "=", valueType: "int", value: this.formatotipo.identity.toString() };
        request.conditions.push(condicionServidorSMTP);
        //
        this.context.app.showSpinner();
        this.formatoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.formatos = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var FormatosTiposEditor_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], FormatosTiposEditor.prototype, "formatos", void 0);
    FormatosTiposEditor = FormatosTiposEditor_1 = __decorate([
        Component({
            selector: 'general-formatostipos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'FormatoTipo'\"\n                                 [info]=\"formatotipo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"formatotipo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"formatotipo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Formatos\" [disabled]=\"formatotipo.identity == 0\" (select)=\"onSelectedTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <general-formatos-manager [name]=\"'formatos'\"\n                                                                [formatos]=\"formatos\"\n                                                                [idFormatoTipo]=\"formatotipo.identity\">\n                                      </general-formatos-manager>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return FormatosTiposEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: FormatoTipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, FormatoTipoService, FormatoService])
    ], FormatosTiposEditor);
    return FormatosTiposEditor;
}(CatalogEditor));
export { FormatosTiposEditor };
