import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { IdiomaService } from '../services/idioma.service';
import { IdiomaInfo } from '../models/idioma';
export declare class IdiomasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private idiomaService;
    idioma: IdiomaInfo;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, idiomaService: IdiomaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
}
