import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { MunicipioService } from '../services/municipio.service';
import { MunicipioInfo } from '../models/municipio';
import { PoblacionItem } from '../models/poblacion';
import { PoblacionService } from '../services/poblacion.service';
import { AsentamientoHumanoService } from '../services/asentamiento-humano.service';
import { AsentamientoHumanoItem } from '../models/asentamiento-humano';
export declare class MunicipiosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private municipioService;
    private poblacionService;
    private asentamientoHumanoService;
    municipio: MunicipioInfo;
    poblaciones: PoblacionItem[];
    asentamientosHumanos: AsentamientoHumanoItem[];
    idEstado: number;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, municipioService: MunicipioService, poblacionService: PoblacionService, asentamientoHumanoService: AsentamientoHumanoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onCancelingEdit(): void;
    selectPoblacionesTab(): void;
    selectAsentamientosTab(): void;
    loadPoblaciones(): void;
    loadAsentamientosHumanos(): void;
}
