var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, Input, Output, EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogManager } from '../../editors';
//Features
import { MunicipioService } from '../services/municipio.service';
var MunicipiosManager = /** @class */ (function (_super) {
    __extends(MunicipiosManager, _super);
    //    
    function MunicipiosManager(router, route, context, municipioService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.municipioService = municipioService;
        _this.municipios = [];
        _this.refreshListParent = new EventEmitter();
        return _this;
    }
    MunicipiosManager_1 = MunicipiosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    MunicipiosManager.prototype.onConfigureCatalog = function (options) {
        //this.manager.serverSide = options.busquedasServidor;
        //this.manager.pageSize = options.tamanioPagina;        
        //this.refreshList();
    };
    MunicipiosManager.prototype.doSearch = function (request) {
        //this.context.app.showSpinner();
        //this.municipioService.search(this.context.app.defaultSite.identity, request)
        //    .then(response => {
        //        this.context.app.hideSpinner();
        //        //
        //        this.municipios = response.rows;
        //        this.totalRows = response.totalRows;
        //        this.pageIndex = request.pageIndex;                                
        //    })
        //    .catch(error => this.handleError(error));
    };
    MunicipiosManager.prototype.onAddingItem = function () {
        this.router.navigate(['kernel/general/municipios', this.process.id, this.idEstado, 0]);
    };
    MunicipiosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    MunicipiosManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['kernel/general/municipios', this.process.id, this.idEstado, item.id]);
    };
    MunicipiosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.municipioService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.refreshListParent.emit();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    MunicipiosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    MunicipiosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.municipioService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.refreshListParent.emit();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var MunicipiosManager_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], MunicipiosManager.prototype, "municipios", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MunicipiosManager.prototype, "idEstado", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], MunicipiosManager.prototype, "refreshListParent", void 0);
    MunicipiosManager = MunicipiosManager_1 = __decorate([
        Component({
            selector: 'general-municipios-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"municipios\"\n                              [totalRows]=\"totalRows\"\n                              [pageSize]=\"20\"\n                              [standAlone]=\"false\"\n                              [serverSide]=\"false\">\n\n\n          <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" dataType=\"Number\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return MunicipiosManager_1; })
                },
                {
                    provide: CatalogService, useExisting: MunicipioService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, Context, MunicipioService])
    ], MunicipiosManager);
    return MunicipiosManager;
}(CatalogManager));
export { MunicipiosManager };
