import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { AzAutocompleteComponent } from '../../controls';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { GrupoClasificacionService } from '../services/grupo-clasificacion.service';
import { ParametroService } from '../services/parametro.service';
import { ParametroInfo, EntidadParametroItem } from '../models/parametro';
export declare class ParametrosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private parametroService;
    private grupoClasificacionService;
    parametro: ParametroInfo;
    entidades: EntidadParametroItem[];
    entidad: string;
    entidadAutoComplete: AzAutocompleteComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, parametroService: ParametroService, grupoClasificacionService: GrupoClasificacionService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    validaEntidad(): string;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadEntidades(): void;
}
