import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { ParametroService } from '../services/parametro.service';
import { ParametroItem } from '../models/parametro';
export declare class ParametrosManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private parametroService;
    parametros: ParametroItem[];
    entidad: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, parametroService: ParametroService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
