import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { PersonaService } from '../services/persona.service';
import { PersonaItem } from '../models/persona';
export declare class PersonasManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private personaService;
    personas: PersonaItem[];
    standAlone: boolean;
    refreshListParent: EventEmitter<void>;
    deletedPersona: EventEmitter<number>;
    constructor(router: Router, route: ActivatedRoute, context: Context, personaService: PersonaService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
