import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { PoblacionService } from '../services/poblacion.service';
import { PoblacionItem } from '../models/poblacion';
export declare class PoblacionesManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private poblacionService;
    poblaciones: PoblacionItem[];
    idMunicipio: number;
    refreshListParent: EventEmitter<void>;
    constructor(router: Router, route: ActivatedRoute, context: Context, poblacionService: PoblacionService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
}
