var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { Context, BaseComponent } from '../../core';
import { CatalogSelector } from '../../search';
import { AsentamientoHumanoService } from '../services/asentamiento-humano.service';
var AsentamientoHumanoSelectorComponent = /** @class */ (function (_super) {
    __extends(AsentamientoHumanoSelectorComponent, _super);
    function AsentamientoHumanoSelectorComponent(context, asentamientoHumanoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.asentamientoHumanoService = asentamientoHumanoService;
        _this.selectedItem = null;
        return _this;
    }
    AsentamientoHumanoSelectorComponent_1 = AsentamientoHumanoSelectorComponent;
    AsentamientoHumanoSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.asentamientoHumanoService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.nombre;
                _this.propagateChange(itemID);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.propagateChange(0);
        }
    };
    AsentamientoHumanoSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.asentamientoHumanoService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.asentamientos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var AsentamientoHumanoSelectorComponent_1;
    AsentamientoHumanoSelectorComponent = AsentamientoHumanoSelectorComponent_1 = __decorate([
        Component({
            selector: 'asentamiento-humano-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"asentamientos\"\n                               [dialogTitle]=\"'Asentamientos'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [dataType]=\"Number\" [width]=\"'1*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'CP'\" [binding]=\"'codigoPostal'\" [width]=\"'3*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-selector>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return AsentamientoHumanoSelectorComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return AsentamientoHumanoSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Context, AsentamientoHumanoService])
    ], AsentamientoHumanoSelectorComponent);
    return AsentamientoHumanoSelectorComponent;
}(CatalogSelector));
export { AsentamientoHumanoSelectorComponent };
