var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Observable } from 'rxjs';
import { mergeMap } from 'rxjs/operators';
//
import { Context, BaseComponent } from '../../core';
import { CatalogAutocomplete } from '../../search';
import { CodigoPostalService } from '../services/codigo-postal.service';
var CodigoPostalAutocompleteComponent = /** @class */ (function (_super) {
    __extends(CodigoPostalAutocompleteComponent, _super);
    function CodigoPostalAutocompleteComponent(context, codigoPostalService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.codigoPostalService = codigoPostalService;
        _this.idEstado = 0;
        _this.valueMember = 'codigo';
        _this.catalogSource = Observable.create(function (observer) {
            observer.next(_this.value);
        })
            .pipe(mergeMap(function (keyword) { return _this.findKeyword(keyword); }));
        return _this;
    }
    CodigoPostalAutocompleteComponent_1 = CodigoPostalAutocompleteComponent;
    CodigoPostalAutocompleteComponent.prototype.findKeyword = function (keyword) {
        return this.codigoPostalService.searchCodigo(keyword, this.idEstado);
    };
    var CodigoPostalAutocompleteComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CodigoPostalAutocompleteComponent.prototype, "idEstado", void 0);
    CodigoPostalAutocompleteComponent = CodigoPostalAutocompleteComponent_1 = __decorate([
        Component({
            selector: 'codigo-postal-autocomplete',
            template: "\n      <azteca-catalog-autocomplete [(value)]=\"value\"\n                                   [valueMember]=\"valueMember\"\n                                   [enabled]=\"enabled\"\n                                   [visible]=\"visible\"\n                                   [dataSource]=\"catalogSource\"\n                                   (valueChange)=\"onValueChange($event)\">\n\n      </azteca-catalog-autocomplete>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return CodigoPostalAutocompleteComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return CodigoPostalAutocompleteComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Context, CodigoPostalService])
    ], CodigoPostalAutocompleteComponent);
    return CodigoPostalAutocompleteComponent;
}(CatalogAutocomplete));
export { CodigoPostalAutocompleteComponent };
