import { EventEmitter, SimpleChange } from '@angular/core';
import { ControlValueAccessor, FormBuilder } from '@angular/forms';
import { BaseControl } from '../../controls/models/base-control';
import { CatalogItem } from '../../core';
import { DomicilioInfo } from '../models/domicilio';
import { PoblacionInfo } from '../models/poblacion';
export declare class DomicilioEditorComponent extends BaseControl implements ControlValueAccessor {
    private formBuilder;
    private form;
    private idEstado;
    readonly valid: boolean;
    domicilio: DomicilioInfo;
    valueChanged: EventEmitter<DomicilioInfo>;
    validChange: EventEmitter<boolean>;
    calleRequired: boolean;
    calleVisible: boolean;
    calleEnabled: boolean;
    numExtRequired: boolean;
    numExtVisible: boolean;
    numExtEnabled: boolean;
    numIntRequired: boolean;
    numIntVisible: boolean;
    numIntEnabled: boolean;
    cruceUnoRequired: boolean;
    cruceUnoVisible: boolean;
    cruceUnoEnabled: boolean;
    cruceDosRequired: boolean;
    cruceDosVisible: boolean;
    cruceDosEnabled: boolean;
    asentamientoRequired: boolean;
    asentamientoVisible: boolean;
    asentamientoEnabled: boolean;
    coloniaRequired: boolean;
    coloniaVisible: boolean;
    coloniaEnabled: boolean;
    cpRequired: boolean;
    cpVisible: boolean;
    cpEnabled: boolean;
    poblacionRequired: boolean;
    poblacionVisible: boolean;
    poblacionEnabled: boolean;
    private info;
    constructor(formBuilder: FormBuilder);
    ngOnChanges(changes: SimpleChange): void;
    ngAfterViewInit(): void;
    updateDomicilio(): void;
    notifyChange(): void;
    updateCalleValidators(): void;
    updateAsentamientoValidators(): void;
    updatePoblacionValidators(): void;
    onCalleChanged(args: any): void;
    onNumExtChanged(args: any): void;
    onNumIntChanged(args: any): void;
    onCruce1Changed(args: any): void;
    onCruce2Changed(args: any): void;
    onColoniaChanged(value: any): void;
    onAsentamientoChanged(item: CatalogItem): void;
    onCodigoPostalChanged(value: string): void;
    onPoblacionChanged(item: PoblacionInfo): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
