var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { Validators, NG_VALUE_ACCESSOR, FormBuilder } from '@angular/forms';
//
import { BaseControl } from '../../controls/models/base-control';
import { BaseComponent } from '../../core';
import { DomicilioInfo } from '../models/domicilio';
var DomicilioEditorComponent = /** @class */ (function (_super) {
    __extends(DomicilioEditorComponent, _super);
    //
    function DomicilioEditorComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.idEstado = 0; //Variable local para filtrar los codigos postales
        //Inputs
        _this.domicilio = new DomicilioInfo();
        //Outputs
        _this.valueChanged = new EventEmitter();
        _this.validChange = new EventEmitter();
        //Calle
        _this.calleRequired = false;
        _this.calleVisible = true;
        _this.calleEnabled = true;
        //Num Ext
        _this.numExtRequired = false;
        _this.numExtVisible = true;
        _this.numExtEnabled = true;
        //Num Int
        _this.numIntRequired = false;
        _this.numIntVisible = true;
        _this.numIntEnabled = true;
        //Cruce Uno
        _this.cruceUnoRequired = false;
        _this.cruceUnoVisible = true;
        _this.cruceUnoEnabled = true;
        //Cruce 2
        _this.cruceDosRequired = false;
        _this.cruceDosVisible = true;
        _this.cruceDosEnabled = true;
        //Asentamiento Humano
        _this.asentamientoRequired = false;
        _this.asentamientoVisible = false;
        _this.asentamientoEnabled = true;
        //Colonia
        _this.coloniaRequired = false;
        _this.coloniaVisible = true;
        _this.coloniaEnabled = true;
        //Codigo Postal
        _this.cpRequired = false;
        _this.cpVisible = true;
        _this.cpEnabled = true;
        //Poblacion
        _this.poblacionRequired = false;
        _this.poblacionVisible = true;
        _this.poblacionEnabled = true;
        //Campos privados para enlazar a UI
        _this.info = new DomicilioInfo();
        _this.propagateChange = function (_) { };
        _this.form = formBuilder.group({
            'calle': [''],
            'numExt': [''],
            'numInt': [''],
            'cruce1': [''],
            'cruce2': [''],
            'asentamiento': [''],
            'colonia': [''],
            'cp': [''],
            'poblacion': [0]
        });
        return _this;
    }
    DomicilioEditorComponent_1 = DomicilioEditorComponent;
    Object.defineProperty(DomicilioEditorComponent.prototype, "valid", {
        //Indica si la información de la forma es válida
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    DomicilioEditorComponent.prototype.ngOnChanges = function (changes) {
        if (changes['domicilio']) {
            this.updateDomicilio();
        }
        if (changes['calleRequired']) {
            this.updateCalleValidators();
        }
        if (changes['asentamientoRequired']) {
            this.updateAsentamientoValidators();
        }
        if (changes['poblacionRequired']) {
            this.updatePoblacionValidators();
        }
    };
    DomicilioEditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.form.valid);
        });
    };
    //////////////////////////////// METODOS ////////////////////////////////////////
    DomicilioEditorComponent.prototype.updateDomicilio = function () {
        this.info.calle = this.domicilio.calle;
        this.info.numeroExterior = this.domicilio.numeroExterior;
        this.info.numeroInterior = this.domicilio.numeroInterior;
        this.info.cruce1 = this.domicilio.cruce1;
        this.info.cruce2 = this.domicilio.cruce2;
        this.info.idAsentamientoHumano = this.domicilio.idAsentamientoHumano;
        this.info.colonia = this.domicilio.colonia;
        this.info.codigoPostal = this.domicilio.codigoPostal;
        this.info.idPoblacion = this.domicilio.idPoblacion;
        this.info.poblacion = this.domicilio.poblacion;
    };
    DomicilioEditorComponent.prototype.notifyChange = function () {
        var newDomicilio = new DomicilioInfo();
        newDomicilio.calle = this.info.calle;
        newDomicilio.numeroExterior = this.info.numeroExterior;
        newDomicilio.numeroInterior = this.info.numeroInterior;
        newDomicilio.cruce1 = this.info.cruce1;
        newDomicilio.cruce2 = this.info.cruce2;
        newDomicilio.idAsentamientoHumano = this.info.idAsentamientoHumano;
        newDomicilio.colonia = this.info.colonia;
        newDomicilio.codigoPostal = this.info.codigoPostal;
        newDomicilio.idPoblacion = this.info.idPoblacion;
        newDomicilio.poblacion = this.info.poblacion;
        //
        this.valueChanged.emit(newDomicilio);
        this.propagateChange(newDomicilio);
    };
    DomicilioEditorComponent.prototype.updateCalleValidators = function () {
        if (this.calleRequired) {
            this.form.controls['calle'].setValidators(Validators.required);
        }
        else {
            this.form.controls['calle'].setValidators(null);
        }
    };
    DomicilioEditorComponent.prototype.updateAsentamientoValidators = function () {
        if (this.asentamientoRequired) {
            this.form.controls['asentamiento'].setValidators(Validators.required);
        }
        else {
            this.form.controls['asentamiento'].setValidators(null);
        }
    };
    DomicilioEditorComponent.prototype.updatePoblacionValidators = function () {
        if (this.poblacionRequired) {
            this.form.controls['poblacion'].setValidators(Validators.required);
        }
        else {
            this.form.controls['poblacion'].setValidators(null);
        }
    };
    //////////////////////////////// HANDLERS ////////////////////////////////////////
    //Calle
    DomicilioEditorComponent.prototype.onCalleChanged = function (args) {
        this.info.calle = args.target.value;
        this.notifyChange();
    };
    //Num Ext
    DomicilioEditorComponent.prototype.onNumExtChanged = function (args) {
        this.info.numeroExterior = args.target.value;
        this.notifyChange();
    };
    //num int
    DomicilioEditorComponent.prototype.onNumIntChanged = function (args) {
        this.info.numeroInterior = args.target.value;
        this.notifyChange();
    };
    //Cruce 1    
    DomicilioEditorComponent.prototype.onCruce1Changed = function (args) {
        this.info.cruce1 = args.target.value;
        this.notifyChange();
    };
    //Cruce 2   
    DomicilioEditorComponent.prototype.onCruce2Changed = function (args) {
        this.info.cruce2 = args.target.value;
        this.notifyChange();
    };
    // Colonia    
    DomicilioEditorComponent.prototype.onColoniaChanged = function (value) {
        this.info.colonia = value;
        this.notifyChange();
    };
    // Asentamiento Humano
    DomicilioEditorComponent.prototype.onAsentamientoChanged = function (item) {
        if (item != null) {
            this.info.idAsentamientoHumano = item.id;
        }
        else {
            this.info.idAsentamientoHumano = 0;
        }
        this.notifyChange();
    };
    // CP
    DomicilioEditorComponent.prototype.onCodigoPostalChanged = function (value) {
        this.info.codigoPostal = value;
        this.notifyChange();
    };
    // Poblacion
    DomicilioEditorComponent.prototype.onPoblacionChanged = function (item) {
        if (item != null) {
            this.info.idPoblacion = item.identity;
            this.info.poblacion = item;
            this.idEstado = item.municipio.idEstado;
        }
        else {
            this.info.idPoblacion = 0;
            this.info.poblacion = null;
            this.idEstado = 0;
        }
        this.notifyChange();
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    DomicilioEditorComponent.prototype.writeValue = function (value) {
        this.domicilio = value;
        this.updateDomicilio();
    };
    DomicilioEditorComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    DomicilioEditorComponent.prototype.registerOnTouched = function () {
    };
    var DomicilioEditorComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", DomicilioInfo)
    ], DomicilioEditorComponent.prototype, "domicilio", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DomicilioEditorComponent.prototype, "valueChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DomicilioEditorComponent.prototype, "validChange", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "calleRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "calleVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "calleEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "numExtRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "numExtVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "numExtEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "numIntRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "numIntVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "numIntEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cruceUnoRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cruceUnoVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cruceUnoEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cruceDosRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cruceDosVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cruceDosEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "asentamientoRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "asentamientoVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "asentamientoEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "coloniaRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "coloniaVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "coloniaEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cpRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cpVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "cpEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "poblacionRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "poblacionVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DomicilioEditorComponent.prototype, "poblacionEnabled", void 0);
    DomicilioEditorComponent = DomicilioEditorComponent_1 = __decorate([
        Component({
            selector: 'general-domicilio-editor',
            template: "\n      <form [formGroup]=\"form\">\n\n          <!--Poblaci\u00F3n y Codigo Postal-->\n          <div class=\"row\">\n              <div class=\"col-12 col-md-8\" *ngIf=\"poblacionVisible\">\n                  <azteca-form-field [label]=\"'Poblacion:'\">\n                      <poblacion-selector [(ngModel)]=\"info.idPoblacion\"\n                                          formControlName=\"poblacion\"\n                                          [enabled]=\"enabled && poblacionEnabled\"\n                                          (selectedItemChanged)=\"onPoblacionChanged($event)\"></poblacion-selector>\n                  </azteca-form-field>\n              </div>\n              <div class=\"col-12 col-md-4\" *ngIf=\"cpVisible\">\n                  <azteca-form-field [label]=\"'Codigo Postal:'\">\n                      <codigo-postal-autocomplete formControlName=\"cp\" \n                                                  [(ngModel)]=\"info.codigoPostal\" \n                                                  [enabled]=\"enabled && cpEnabled\"\n                                                  [idEstado]=\"idEstado\"\n                                                  (valueChange)=\"onCodigoPostalChanged($event)\"></codigo-postal-autocomplete>                \n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Calle-->\n          <div class=\"row\">\n              <div class=\"col-12\" *ngIf=\"calleVisible\">\n                  <azteca-form-field [label]=\"'Calle:'\">\n                      <az-textbox formControlName=\"calle\" [(ngModel)]=\"info.calle\" [enabled]=\"enabled && calleEnabled\" (change)=\"onCalleChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--N\u00FAmero exterior y n\u00FAmero interior-->\n          <div class=\"row\">\n              <div class=\"col-12 col-md-6\" *ngIf=\"numExtVisible\">\n                  <azteca-form-field [label]=\"'Num.Exterior:'\">\n                      <az-textbox formControlName=\"numExt\" [(ngModel)]=\"info.numeroExterior\" [enabled]=\"enabled && numExtEnabled\" (change)=\"onNumExtChanged($event)\"></az-textbox>                               \n                  </azteca-form-field>\n              </div>\n              <div class=\"col-12 col-md-6\" *ngIf=\"numIntVisible\">\n                  <azteca-form-field [label]=\"'Num. Interior:'\">\n                      <az-textbox formControlName=\"numInt\" [(ngModel)]=\"info.numeroInterior\" [enabled]=\"enabled && numIntEnabled\" (change)=\"onNumIntChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Cruces-->\n          <div class=\"row\">\n              <div class=\"col-12\" *ngIf=\"cruceUnoVisible\">\n                  <azteca-form-field [label]=\"'Cruce 1:'\">\n                      <az-textbox formControlName=\"cruce1\" [(ngModel)]=\"info.cruce1\" [enabled]=\"enabled && cruceUnoEnabled\" (change)=\"onCruce1Changed($event)\"></az-textbox>                \n                  </azteca-form-field>\n              </div>\n          </div>\n          <div class=\"row\">\n              <div class=\"col-12\" *ngIf=\"cruceDosVisible\">\n                  <azteca-form-field [label]=\"'Cruce 2:'\">\n                      <az-textbox formControlName=\"cruce2\" [(ngModel)]=\"info.cruce2\" [enabled]=\"enabled && cruceDosEnabled\" (change)=\"onCruce2Changed($event)\"></az-textbox>                \n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Asentamiento Humano/Colonia y C\u00F3digo Postal-->\n          <div class=\"row\">\n              <div class=\"col-12\" *ngIf=\"asentamientoVisible\">\n                  <azteca-form-field [label]=\"'Colonia:'\">\n                      <asentamiento-humano-selector [(ngModel)]=\"info.idAsentamientoHumano\"\n                                                    formControlName=\"asentamiento\"\n                                                    [enabled]=\"enabled && asentamientoEnabled\"\n                                                    (selectedItemChanged)=\"onAsentamientoChanged($event)\"></asentamiento-humano-selector>\n                  </azteca-form-field>\n              </div>\n              <div class=\"col-12\" *ngIf=\"coloniaVisible\">\n                  <azteca-form-field [label]=\"'Colonia:'\">\n                      <asentamiento-humano-autocomplete   [(ngModel)]=\"info.colonia\"\n                                                          formControlName=\"colonia\"\n                                                          [enabled]=\"enabled && coloniaEnabled\"\n                                                          [codigoPostal]=\"info.codigoPostal\"\n                                                          (valueChange)=\"onColoniaChanged($event)\"></asentamiento-humano-autocomplete>\n                  </azteca-form-field>\n              </div>\n          </div>\n    \n\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return DomicilioEditorComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return DomicilioEditorComponent_1; }), multi: true
                }
            ],
            styles: [
                '.ng-valid-component { border-left: 1px solid #ccc!important;}'
            ]
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], DomicilioEditorComponent);
    return DomicilioEditorComponent;
}(BaseControl));
export { DomicilioEditorComponent };
