import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from '../../core';
import { SearchRequest, CatalogSelector } from '../../search/index';
import { MunicipioInfo, MunicipioItem } from '../models/municipio';
import { MunicipioService } from '../services/municipio.service';
export declare class MunicipioSelectorComponent extends CatalogSelector {
    protected context: Context;
    private municipioService;
    idEstado: number;
    municipios: MunicipioItem[];
    selectedItem: MunicipioInfo;
    selectedItemChanged: EventEmitter<MunicipioInfo>;
    constructor(context: Context, municipioService: MunicipioService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
}
