var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Angular
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//Wijmo
import { CollectionView, NotifyCollectionChangedAction } from 'wijmo/wijmo';
//
import { BaseComponent } from '../../core';
import { BaseControl } from '../../controls';
import { ChangeState } from '../../editors';
var ParametrosEditorComponent = /** @class */ (function (_super) {
    __extends(ParametrosEditorComponent, _super);
    function ParametrosEditorComponent() {
        var _this = _super.call(this) || this;
        _this.parametrosCollection = new CollectionView();
        _this.parametrosValores = [];
        _this.parametrosChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    ParametrosEditorComponent_1 = ParametrosEditorComponent;
    ParametrosEditorComponent.prototype.ngOnChanges = function (changes) {
        if (changes['parametrosValores']) {
            this.updateParametros();
        }
    };
    ParametrosEditorComponent.prototype.validarRegExp = function (expresion, valor) {
        var myRe = new RegExp(expresion);
        return myRe.test(valor);
    };
    ParametrosEditorComponent.prototype.updateParametros = function () {
        var _this = this;
        this.parametrosCollection = new CollectionView(this.parametrosValores, {
            getError: function (item, property) {
                switch (property) {
                    case 'valor':
                        return item.requerido && item[property] == "" ? 'El parámetro es requerido'
                            : item.validar && !_this.validarRegExp(item.expresion, item.valor) ? 'No cumple con la expresión regular ' + item.expresion
                                : null;
                } //switch
                return null;
            } //getError
        });
        //Suscribir a cambios en la colección
        this.parametrosCollection.collectionChanged.addHandler(function (sender, args) {
            if (args.action == NotifyCollectionChangedAction.Change && args.item != null) {
                args.item.state = ChangeState.MODIFIED;
                _this.parametrosChange.emit(_this.parametrosValores);
                _this.propagateChange(_this.parametrosValores);
            }
        });
    };
    //Implementación de control value accesor
    ParametrosEditorComponent.prototype.writeValue = function (value) {
        this.parametrosValores = value ? value : [];
        this.updateParametros();
    };
    ParametrosEditorComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ParametrosEditorComponent.prototype.registerOnTouched = function () { };
    var ParametrosEditorComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ParametrosEditorComponent.prototype, "parametrosValores", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], ParametrosEditorComponent.prototype, "parametrosChange", void 0);
    ParametrosEditorComponent = ParametrosEditorComponent_1 = __decorate([
        Component({
            selector: 'az-parametros-editor',
            template: "\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <wj-flex-grid style=\"height:550px\" [itemsSource]=\"parametrosCollection\">\n\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"'Par\u00E1metro'\" [binding]=\"'nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Valor'\" [binding]=\"'valor'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n              </div>\n          </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ParametrosEditorComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return ParametrosEditorComponent_1; }), multi: true
                }
            ]
        }),
        __metadata("design:paramtypes", [])
    ], ParametrosEditorComponent);
    return ParametrosEditorComponent;
}(BaseControl));
export { ParametrosEditorComponent };
