import { EventEmitter, SimpleChange } from '@angular/core';
import { ControlValueAccessor, FormBuilder } from '@angular/forms';
import { BaseControl } from '../../controls/models/base-control';
import { PersonaInfo } from '../models/persona';
export declare class PersonaEditorComponent extends BaseControl implements ControlValueAccessor {
    private formBuilder;
    private form;
    readonly valid: boolean;
    persona: PersonaInfo;
    nombreRequired: boolean;
    nombreVisible: boolean;
    nombreEnabled: boolean;
    apellidoPaternoRequired: boolean;
    apellidoPaternoVisible: boolean;
    apellidoPaternoEnabled: boolean;
    apellidoMaternoRequired: boolean;
    apellidoMaternoVisible: boolean;
    apellidoMaternoEnabled: boolean;
    telefonoCasaRequired: boolean;
    telefonoCasaVisible: boolean;
    telefonoCasaEnabled: boolean;
    telefonoOficinaRequired: boolean;
    telefonoOficinaVisible: boolean;
    telefonoOficinaEnabled: boolean;
    celularRequired: boolean;
    celularVisible: boolean;
    celularEnabled: boolean;
    correoRequired: boolean;
    correoVisible: boolean;
    correoEnabled: boolean;
    personaChange: EventEmitter<PersonaInfo>;
    validChange: EventEmitter<boolean>;
    private nombre;
    private apellidoPaterno;
    private apellidoMaterno;
    private telefonoCasa;
    private telefonoOficina;
    private celular;
    private correo;
    constructor(formBuilder: FormBuilder);
    ngOnChanges(changes: SimpleChange): void;
    ngAfterViewInit(): void;
    updatePersona(): void;
    notifiyChange(): void;
    updateNombreValidators(): void;
    updateApellidoPatValidators(): void;
    updateApellidoMatValidators(): void;
    updateTelCasaValidators(): void;
    updateTelOficinaValidators(): void;
    updateCelularValidators(): void;
    updateCorreoValidators(): void;
    onNombreChanged(args: any): void;
    onApellidoPatChanged(args: any): void;
    onApellidoMatChanged(args: any): void;
    onTelCasaChanged(args: any): void;
    onTelOficinaChanged(args: any): void;
    onCelularChanged(args: any): void;
    onCorreoChanged(args: any): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
