var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { Validators, NG_VALUE_ACCESSOR, FormBuilder } from '@angular/forms';
//
import { BaseComponent } from '../../core';
import { BaseControl } from '../../controls/models/base-control';
import { PersonaInfo } from '../models/persona';
var PersonaEditorComponent = /** @class */ (function (_super) {
    __extends(PersonaEditorComponent, _super);
    //
    function PersonaEditorComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        //Inputs
        _this.persona = new PersonaInfo();
        //Nombre
        _this.nombreRequired = false;
        _this.nombreVisible = true;
        _this.nombreEnabled = true;
        //Apellido Paterno
        _this.apellidoPaternoRequired = false;
        _this.apellidoPaternoVisible = true;
        _this.apellidoPaternoEnabled = true;
        //Apellido Materno
        _this.apellidoMaternoRequired = false;
        _this.apellidoMaternoVisible = true;
        _this.apellidoMaternoEnabled = true;
        //Tel Casa
        _this.telefonoCasaRequired = false;
        _this.telefonoCasaVisible = true;
        _this.telefonoCasaEnabled = true;
        //Tel Oficina
        _this.telefonoOficinaRequired = false;
        _this.telefonoOficinaVisible = true;
        _this.telefonoOficinaEnabled = true;
        //Celular
        _this.celularRequired = false;
        _this.celularVisible = true;
        _this.celularEnabled = true;
        //Correo
        _this.correoRequired = false;
        _this.correoVisible = true;
        _this.correoEnabled = true;
        //Outputs
        _this.personaChange = new EventEmitter();
        _this.validChange = new EventEmitter();
        //Campos privados para enlazar a UI
        _this.nombre = '';
        _this.apellidoPaterno = '';
        _this.apellidoMaterno = '';
        _this.telefonoCasa = '';
        _this.telefonoOficina = '';
        _this.celular = '';
        _this.correo = '';
        _this.propagateChange = function (_) { };
        _this.form = formBuilder.group({
            'nombre': [''],
            'apellidoPaterno': [''],
            'apellidoMaterno': [''],
            'telefonoCasa': [''],
            'telefonoOficina': [''],
            'celular': [''],
            'correo': ['']
        });
        return _this;
    }
    PersonaEditorComponent_1 = PersonaEditorComponent;
    Object.defineProperty(PersonaEditorComponent.prototype, "valid", {
        //Indica si la información de la forma es válida
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    PersonaEditorComponent.prototype.ngOnChanges = function (changes) {
        if (changes['persona']) {
            this.updatePersona();
        }
        if (changes['nombreRequired']) {
            this.updateNombreValidators();
        }
        if (changes['apellidoPaternoRequired']) {
            this.updateApellidoPatValidators();
        }
        if (changes['apellidoMaternoRequired']) {
            this.updateApellidoMatValidators();
        }
    };
    PersonaEditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.form.valid);
        });
    };
    //////////////////////////////// METODOS ////////////////////////////////////////
    PersonaEditorComponent.prototype.updatePersona = function () {
        this.nombre = this.persona.nombre;
        this.apellidoPaterno = this.persona.apellidoPaterno;
        this.apellidoMaterno = this.persona.apellidoMaterno;
        this.telefonoCasa = this.persona.telefonoCasa;
        this.telefonoOficina = this.persona.telefonoOficina;
        this.celular = this.persona.celular;
        this.correo = this.persona.correo;
    };
    PersonaEditorComponent.prototype.notifiyChange = function () {
        var newPersona = new PersonaInfo();
        newPersona.nombre = this.nombre;
        newPersona.apellidoPaterno = this.apellidoPaterno;
        newPersona.apellidoMaterno = this.apellidoMaterno;
        newPersona.telefonoCasa = this.telefonoCasa;
        newPersona.telefonoOficina = this.telefonoOficina;
        newPersona.celular = this.celular;
        newPersona.correo = this.correo;
        //
        this.personaChange.emit(newPersona);
        this.propagateChange(newPersona);
    };
    PersonaEditorComponent.prototype.updateNombreValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['nombre'].setValidators(Validators.required);
        }
        else {
            this.form.controls['nombre'].setValidators(null);
        }
    };
    PersonaEditorComponent.prototype.updateApellidoPatValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['apellidoPaterno'].setValidators(Validators.required);
        }
        else {
            this.form.controls['apellidoPaterno'].setValidators(null);
        }
    };
    PersonaEditorComponent.prototype.updateApellidoMatValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['apellidoMaterno'].setValidators(Validators.required);
        }
        else {
            this.form.controls['apellidoMaterno'].setValidators(null);
        }
    };
    PersonaEditorComponent.prototype.updateTelCasaValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['telefonoCasa'].setValidators(Validators.required);
        }
        else {
            this.form.controls['telefonoCasa'].setValidators(null);
        }
    };
    PersonaEditorComponent.prototype.updateTelOficinaValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['telefonoOficina'].setValidators(Validators.required);
        }
        else {
            this.form.controls['telefonoOficina'].setValidators(null);
        }
    };
    PersonaEditorComponent.prototype.updateCelularValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['celular'].setValidators(Validators.required);
        }
        else {
            this.form.controls['celular'].setValidators(null);
        }
    };
    PersonaEditorComponent.prototype.updateCorreoValidators = function () {
        if (this.nombreRequired) {
            this.form.controls['correo'].setValidators(Validators.required);
        }
        else {
            this.form.controls['correo'].setValidators(null);
        }
    };
    //////////////////////////////// HANDLERS ////////////////////////////////////////
    PersonaEditorComponent.prototype.onNombreChanged = function (args) {
        this.nombre = args.target.value;
        this.notifiyChange();
    };
    PersonaEditorComponent.prototype.onApellidoPatChanged = function (args) {
        this.apellidoPaterno = args.target.value;
        this.notifiyChange();
    };
    PersonaEditorComponent.prototype.onApellidoMatChanged = function (args) {
        this.apellidoMaterno = args.target.value;
        this.notifiyChange();
    };
    PersonaEditorComponent.prototype.onTelCasaChanged = function (args) {
        this.telefonoCasa = args.target.value;
        this.notifiyChange();
    };
    PersonaEditorComponent.prototype.onTelOficinaChanged = function (args) {
        this.telefonoOficina = args.target.value;
        this.notifiyChange();
    };
    PersonaEditorComponent.prototype.onCelularChanged = function (args) {
        this.celular = args.target.value;
        this.notifiyChange();
    };
    PersonaEditorComponent.prototype.onCorreoChanged = function (args) {
        this.correo = args.target.value;
        this.notifiyChange();
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    PersonaEditorComponent.prototype.writeValue = function (value) {
        this.persona = value;
        this.updatePersona();
    };
    PersonaEditorComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    PersonaEditorComponent.prototype.registerOnTouched = function () {
    };
    var PersonaEditorComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", PersonaInfo)
    ], PersonaEditorComponent.prototype, "persona", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "nombreRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "nombreVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "nombreEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "apellidoPaternoRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "apellidoPaternoVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "apellidoPaternoEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "apellidoMaternoRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "apellidoMaternoVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "apellidoMaternoEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "telefonoCasaRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "telefonoCasaVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "telefonoCasaEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "telefonoOficinaRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "telefonoOficinaVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "telefonoOficinaEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "celularRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "celularVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "celularEnabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "correoRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "correoVisible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PersonaEditorComponent.prototype, "correoEnabled", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], PersonaEditorComponent.prototype, "personaChange", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], PersonaEditorComponent.prototype, "validChange", void 0);
    PersonaEditorComponent = PersonaEditorComponent_1 = __decorate([
        Component({
            selector: 'general-persona-editor',
            template: "\n      <form [formGroup]=\"form\">\n\n          <!--Nombre-->\n          <div class=\"row\">\n              <div class=\"col-12\" *ngIf=\"nombreVisible\">\n                  <azteca-form-field [label]=\"'Nombre:'\">\n                      <az-textbox formControlName=\"nombre\" [(ngModel)]=\"nombre\" [enabled]=\"enabled && nombreEnabled\" (change)=\"onNombreChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Apellido paterno y materno-->\n          <div class=\"row\">\n              <div class=\"col-12 col-md-6\" *ngIf=\"apellidoPaternoVisible\">\n                  <azteca-form-field [label]=\"'Apellido paterno:'\">\n                      <az-textbox formControlName=\"apellidoPaterno\" [(ngModel)]=\"apellidoPaterno\" [enabled]=\"enabled && apellidoPaternoEnabled\" (change)=\"onApellidoPatChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n              <div class=\"col-12 col-md-6\" *ngIf=\"apellidoMaternoVisible\">\n                  <azteca-form-field [label]=\"'Apellido materno:'\">\n                      <az-textbox formControlName=\"apellidoMaterno\" [(ngModel)]=\"apellidoMaterno\" [enabled]=\"enabled && apellidoMaternoEnabled\" (change)=\"onApellidoMatChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Tel Casa y Oficina-->\n          <div class=\"row\">\n              <div class=\"col-12 col-md-6\" *ngIf=\"telefonoCasaVisible\">\n                  <azteca-form-field [label]=\"'Tel\u00E9fono de casa:'\">\n                      <az-textbox formControlName=\"telefonoCasa\" [(ngModel)]=\"telefonoCasa\" [enabled]=\"enabled && telefonoCasaEnabled\" (change)=\"onTelCasaChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n              <div class=\"col-12 col-md-6\" *ngIf=\"telefonoOficinaVisible\">\n                  <azteca-form-field [label]=\"'Tel\u00E9fono de oficina:'\">\n                      <az-textbox formControlName=\"telefonoOficina\" [(ngModel)]=\"telefonoOficina\" [enabled]=\"enabled && telefonoOficinaEnabled\" (change)=\"onTelOficinaChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <!--Celular y correo-->\n          <div class=\"row\">\n              <div class=\"col-12 col-md-6\" *ngIf=\"celularVisible\">\n                  <azteca-form-field [label]=\"'Celular:'\">\n                      <az-textbox formControlName=\"celular\" [(ngModel)]=\"celular\" [enabled]=\"enabled && celularEnabled\" (change)=\"onCelularChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n              <div class=\"col-12 col-md-6\" *ngIf=\"correoVisible\">\n                  <azteca-form-field [label]=\"'Correo electr\u00F3nico:'\">\n                      <az-textbox formControlName=\"correo\" [(ngModel)]=\"correo\" [enabled]=\"enabled && correoEnabled\" (change)=\"onCorreoChanged($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return PersonaEditorComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return PersonaEditorComponent_1; }), multi: true
                }
            ],
            styles: [
                '.ng-valid-component { border-left: 1px solid #ccc!important;}'
            ]
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], PersonaEditorComponent);
    return PersonaEditorComponent;
}(BaseControl));
export { PersonaEditorComponent };
