import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from '../../core';
import { SearchRequest, CatalogSelector } from '../../search/index';
import { PersonaInfo, PersonaItem } from '../models/persona';
import { PersonaService } from '../services/persona.service';
export declare class PersonaSelectorComponent extends CatalogSelector {
    protected context: Context;
    private personaService;
    idPais: number;
    personas: PersonaItem[];
    selectedItem: PersonaInfo;
    selectedItemChanged: EventEmitter<PersonaInfo>;
    constructor(context: Context, personaService: PersonaService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
}
