var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos
import { GeneralRoutingModule } from './general.routing.module';
import { UtilsModule } from '../utils/utils.module';
import { SearchModule } from '../search/search.module';
import { ControlsModule } from '../controls/controls.module';
import { EditorsModule } from '../editors/editors.module';
import { GeolocationModule } from '../geolocation/geolocation.module';
//Bootstrap
import { AlertModule, TabsModule, ModalModule } from 'ngx-bootstrap';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Controls
import { EstadoSelectorComponent } from './controls/estado-selector.component';
import { MunicipioSelectorComponent } from './controls/municipio-selector.component';
import { AsentamientoHumanoAutocompleteComponent } from './controls/asentamiento-humano-autocomplete.component';
;
import { PoblacionSelectorComponent } from './controls/poblacion-selector.component';
import { AsentamientoHumanoSelectorComponent } from './controls/asentamiento-humano-selector.component';
import { CodigoPostalAutocompleteComponent } from './controls/codigo-postal-autocomplete.component';
import { PersonaEditorComponent } from './controls/persona-editor.component';
import { CalendarioSelectorComponent } from './controls/calendario-selector.component';
import { ParametrosEditorComponent } from './controls/parametros-editor.component';
import { PersonaSelectorComponent } from './controls/persona-selector.component';
//Components
import { DomicilioEditorComponent } from './controls/domicilio-editor.component';
import { PaisesManager } from './components/paises.manager';
import { PaisesEditor } from './components/paises.editor';
import { EstadosManager } from './components/estados.manager';
import { EstadosEditor } from './components/estados.editor';
import { MunicipiosManager } from './components/municipios.manager';
import { MunicipiosEditor } from './components/municipios.editor';
import { PoblacionesManager } from './components/poblaciones.manager';
import { PoblacionesEditor } from './components/poblaciones.editor';
import { CodigosPostalesManager } from './components/codigos-postales.manager';
import { CodigosPostalesEditor } from './components/codigos-postales.editor';
import { TiposAsentamientoEditor } from './components/tipo-asentamiento.editor';
import { TiposAsentamientoManager } from './components/tipo-asentamiento.manager';
import { AsentamientosHumanosEditor } from './components/asentamiento-humano.editor';
import { AsentamientosHumanosManager } from './components/asentamiento-humano.manager';
import { FormatosTiposEditor } from './components/formatos-tipos.editor';
import { FormatosTiposManager } from './components/formatos-tipos.manager';
import { FormatosEditor } from './components/formatos.editor';
import { FormatosManager } from './components/formatos.manager';
import { ClasificacionesGruposEditor } from './components/clasificaciones-grupos.editor';
import { ClasificacionesGruposManager } from './components/clasificaciones-grupos.manager';
import { ClasificacionesEditorComponent } from './components/clasificaciones-editor.component';
import { ImpresorasEditor } from './components/impresoras.editor';
import { ImpresorasManager } from './components/impresoras.manager';
import { PersonasEditor } from './components/personas.editor';
import { PersonasManager } from './components/personas.manager';
import { IdiomasEditor } from './components/idiomas.editor';
import { IdiomasManager } from './components/idiomas.manager';
import { ReportComponent } from './components/report.component';
import { CalendariosManager } from './components/calendarios.manager';
import { CalendariosEditor } from './components/calendarios.editor';
import { CalendarioCreateComponent } from './components/calendarios-create.component';
import { CalendarioDiasFestivosComponent } from './components/calendarios-dias-festivos.component';
import { DiaFestivoEditorComponent } from './components/calendarios-dia-festivo-editor.component';
import { CalendarioDiasHabilesComponent } from './components/calendarios-dias-habiles.component';
import { ParametrosEditor } from './components/parametros.editor';
import { ParametrosManager } from './components/parametros.manager';
//Services
import { PaisService } from './services/pais.service';
import { EstadoService } from './services/estado.service';
import { MunicipioService } from './services/municipio.service';
import { PoblacionService } from './services/poblacion.service';
import { CodigoPostalService } from './services/codigo-postal.service';
import { AsentamientoHumanoService } from './services/asentamiento-humano.service';
import { TipoAsentamientoService } from './services/tipo-asentamiento.service';
import { FormatoTipoService } from './services/formato-tipo.service';
import { FormatoService } from './services/formato.service';
import { GrupoClasificacionService } from './services/grupo-clasificacion.service';
import { ImpresoraService } from './services/impresora.service';
import { PersonaService } from './services/persona.service';
import { IdiomaService } from './services/idioma.service';
import { CalendarioService } from './services/calendario.service';
import { ParametroService } from './services/parametro.service';
var COMPONENTS = [EstadoSelectorComponent, MunicipioSelectorComponent, PoblacionSelectorComponent, PersonaEditorComponent, AsentamientosHumanosEditor, AsentamientosHumanosManager, AsentamientoHumanoSelectorComponent, CodigoPostalAutocompleteComponent, DomicilioEditorComponent,
    TiposAsentamientoEditor, TiposAsentamientoManager, PaisesManager, PaisesEditor, EstadosManager, EstadosEditor, MunicipiosManager, MunicipiosEditor, PoblacionesManager, PoblacionesEditor, CodigosPostalesManager, CodigosPostalesEditor,
    FormatosTiposManager, FormatosTiposEditor, FormatosManager, FormatosEditor, ClasificacionesGruposManager, ClasificacionesGruposEditor,
    ClasificacionesEditorComponent, ImpresorasEditor, ImpresorasManager, PersonasManager, PersonasEditor, AsentamientoHumanoAutocompleteComponent, IdiomasManager, IdiomasEditor,
    ReportComponent, CalendariosManager, CalendariosEditor, CalendarioDiasFestivosComponent, CalendarioCreateComponent, DiaFestivoEditorComponent, CalendarioDiasHabilesComponent,
    CalendarioSelectorComponent, ParametrosManager, ParametrosEditor, ParametrosEditorComponent, PersonaSelectorComponent];
var SERVICES = [AsentamientoHumanoService, TipoAsentamientoService, PaisService, EstadoService, MunicipioService, PoblacionService, CodigoPostalService,
    FormatoTipoService, FormatoService, GrupoClasificacionService, ImpresoraService, PersonaService, IdiomaService, CalendarioService, ParametroService];
var GeneralModule = /** @class */ (function () {
    function GeneralModule() {
    }
    GeneralModule = __decorate([
        NgModule({
            imports: [
                FormsModule, ReactiveFormsModule, CommonModule,
                WjInputModule, WjGridModule, WjGridModule, WjGridFilterModule, EditorsModule,
                AlertModule, ModalModule,
                UtilsModule, SearchModule, ControlsModule, GeneralRoutingModule, GeolocationModule,
                TabsModule.forRoot()
            ],
            declarations: COMPONENTS,
            providers: SERVICES,
            exports: COMPONENTS
        })
    ], GeneralModule);
    return GeneralModule;
}());
export { GeneralModule };
