var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
//Components
import { PaisesManager } from './components/paises.manager';
import { PaisesEditor } from './components/paises.editor';
import { EstadosManager } from './components/estados.manager';
import { EstadosEditor } from './components/estados.editor';
import { MunicipiosManager } from './components/municipios.manager';
import { MunicipiosEditor } from './components/municipios.editor';
import { PoblacionesManager } from './components/poblaciones.manager';
import { PoblacionesEditor } from './components/poblaciones.editor';
import { TiposAsentamientoManager } from './components/tipo-asentamiento.manager';
import { TiposAsentamientoEditor } from './components/tipo-asentamiento.editor';
import { AsentamientosHumanosManager } from './components/asentamiento-humano.manager';
import { AsentamientosHumanosEditor } from './components/asentamiento-humano.editor';
import { CodigosPostalesManager } from './components/codigos-postales.manager';
import { CodigosPostalesEditor } from './components/codigos-postales.editor';
import { FormatosTiposManager } from './components/formatos-tipos.manager';
import { FormatosTiposEditor } from './components/formatos-tipos.editor';
import { FormatosEditor } from './components/formatos.editor';
import { PersonasEditor } from './components/personas.editor';
import { PersonasManager } from './components/personas.manager';
import { ClasificacionesGruposManager } from './components/clasificaciones-grupos.manager';
import { ClasificacionesGruposEditor } from './components/clasificaciones-grupos.editor';
import { ImpresorasManager } from './components/impresoras.manager';
import { ImpresorasEditor } from './components/impresoras.editor';
import { IdiomasEditor } from './components/idiomas.editor';
import { IdiomasManager } from './components/idiomas.manager';
import { ReportComponent } from './components/report.component';
import { CalendariosManager } from './components/calendarios.manager';
import { CalendariosEditor } from './components/calendarios.editor';
import { CalendarioDiasFestivosComponent } from './components/calendarios-dias-festivos.component';
import { CalendarioDiasHabilesComponent } from './components/calendarios-dias-habiles.component';
import { ParametrosManager } from './components/parametros.manager';
import { ParametrosEditor } from './components/parametros.editor';
//Guards
import { EditorDeactivateGuard } from '../editors/index';
var routes = [
    {
        path: 'kernel/general',
        children: [
            { path: 'tipoasentamiento/:proceso', component: TiposAsentamientoManager },
            { path: 'tipoasentamiento/:proceso/:id', component: TiposAsentamientoEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'asentamientohumano/:proceso', component: AsentamientosHumanosManager },
            { path: 'asentamientohumano/:proceso/:idMunicipio/:id', component: AsentamientosHumanosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'paises/:proceso', component: PaisesManager },
            { path: 'paises/:proceso/:id', component: PaisesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'estados/:proceso', component: EstadosManager },
            { path: 'estados/:proceso/:idPais/:id', component: EstadosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'municipios/:proceso', component: MunicipiosManager },
            { path: 'municipios/:proceso/:idEstado/:id', component: MunicipiosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'poblaciones/:proceso', component: PoblacionesManager },
            { path: 'poblaciones/:proceso/:idMunicipio/:id', component: PoblacionesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'codigospostales/:proceso', component: CodigosPostalesManager },
            { path: 'codigospostales/:proceso/:idEstado/:id', component: CodigosPostalesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'formatos-tipos/:proceso', component: FormatosTiposManager },
            { path: 'formatos-tipos/:proceso/:id', component: FormatosTiposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'formatos/:proceso/:idFormatoTipo/:id', component: FormatosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'grupos-clasificaciones/:proceso', component: ClasificacionesGruposManager },
            { path: 'grupos-clasificaciones/:proceso/:id', component: ClasificacionesGruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'impresoras/:proceso', component: ImpresorasManager },
            { path: 'impresoras/:proceso/:id', component: ImpresorasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'personas/:proceso', component: PersonasManager },
            { path: 'personas/:proceso/:id', component: PersonasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'idiomas/:proceso', component: IdiomasManager },
            { path: 'idiomas/:proceso/:id', component: IdiomasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'report/:proceso', component: ReportComponent, canDeactivate: [EditorDeactivateGuard] },
            { path: 'calendarios/:proceso', component: CalendariosManager },
            { path: 'calendarios/:proceso/:id', component: CalendariosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'calendarios/:proceso/:id/dias-festivos', component: CalendarioDiasFestivosComponent },
            { path: 'calendarios/:proceso/:id/dias-habiles', component: CalendarioDiasHabilesComponent },
            { path: 'parametros/:proceso', component: ParametrosManager },
            { path: 'parametros/:proceso/:id', component: ParametrosEditor, canDeactivate: [EditorDeactivateGuard] },
        ]
    },
];
var GeneralRoutingModule = /** @class */ (function () {
    function GeneralRoutingModule() {
    }
    GeneralRoutingModule = __decorate([
        NgModule({
            imports: [
                RouterModule.forChild(routes)
            ],
            exports: [
                RouterModule
            ]
        })
    ], GeneralRoutingModule);
    return GeneralRoutingModule;
}());
export { GeneralRoutingModule };
