import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from '../../core';
import { CalendarioInfo, FechaDiaItem } from '../models/calendario';
export declare class CalendarioService extends CatalogService<CalendarioInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<CalendarioInfo>;
    createFechas(idCalendario: number, fechaIni: Date, fechaFin: Date, sabadoLaborable: boolean, domingoLaborable: boolean): Promise<boolean>;
    getFechas(idCalendario: number): Promise<FechaDiaItem[]>;
    getDiasFestivos(idCalendario: number): Promise<FechaDiaItem[]>;
    addDiasFestivos(idCalendario: number, diasFestivos: FechaDiaItem[]): Promise<any>;
    removeDiaFestivo(idCalendario: number, fecha: Date): Promise<any>;
    getDiasHabiles(idCalendario: number): Promise<FechaDiaItem[]>;
    setDiaHabil(idCalendario: number, fecha: Date, habilitar: boolean): Promise<any>;
    setFechaHabil(idCalendario: number, fecha: Date, fechaHabil: Date): Promise<any>;
    setFechaEstadistica(idCalendario: number, fecha: Date, fechaEstadistica: Date): Promise<any>;
}
