var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { CalendarioInfo } from '../models/calendario';
import * as moment from 'moment';
var CalendarioService = /** @class */ (function (_super) {
    __extends(CalendarioService, _super);
    function CalendarioService(http, context) {
        return _super.call(this, http, context, 'api/kernel/general/calendarios') || this;
    }
    CalendarioService.prototype.create = function () {
        return Promise.resolve(new CalendarioInfo());
    };
    CalendarioService.prototype.createFechas = function (idCalendario, fechaIni, fechaFin, sabadoLaborable, domingoLaborable) {
        var fi = moment(fechaIni).format();
        var ff = moment(fechaFin).format();
        var params = new HttpParams()
            .set("idCalendario", idCalendario.toString())
            .set("fechaIni", fi)
            .set("fechaFin", ff)
            .set("sabadoLaborable", sabadoLaborable.toString())
            .set("domingoLaborable", domingoLaborable.toString());
        return this.apiService.post("create-calendar", params, null)
            .toPromise();
    };
    CalendarioService.prototype.getFechas = function (idCalendario) {
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString());
        //
        return this.apiService.get('get-fechas', params)
            .toPromise();
    };
    ///////////////////////////// Dias Festivos ////////////////////////////////////////////////
    CalendarioService.prototype.getDiasFestivos = function (idCalendario) {
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString());
        //
        return this.apiService.get('get-dias-festivos', params)
            .toPromise();
    };
    CalendarioService.prototype.addDiasFestivos = function (idCalendario, diasFestivos) {
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString());
        //
        return this.apiService.post('add-dias-festivos', params, diasFestivos)
            .toPromise();
    };
    CalendarioService.prototype.removeDiaFestivo = function (idCalendario, fecha) {
        var f = moment(fecha).format();
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString())
            .set('fecha', f);
        //
        return this.apiService.delete('remove-dia-festivo', params)
            .toPromise();
    };
    ///////////////////////////// Dias Festivos ////////////////////////////////////////////////
    CalendarioService.prototype.getDiasHabiles = function (idCalendario) {
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString());
        //
        return this.apiService.get('get-dias-habiles', params)
            .toPromise();
    };
    CalendarioService.prototype.setDiaHabil = function (idCalendario, fecha, habilitar) {
        var f = moment(fecha).format();
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString())
            .set('fecha', f)
            .set('habilitar', habilitar.toString());
        //
        return this.apiService.delete('set-dia-habil', params)
            .toPromise();
    };
    CalendarioService.prototype.setFechaHabil = function (idCalendario, fecha, fechaHabil) {
        var f = moment(fecha).format();
        var fh = moment(fechaHabil).format();
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString())
            .set('fecha', f)
            .set('fechaHabil', fh);
        //
        return this.apiService.delete('set-fecha-habil', params)
            .toPromise();
    };
    CalendarioService.prototype.setFechaEstadistica = function (idCalendario, fecha, fechaEstadistica) {
        var f = moment(fecha).format();
        var fe = moment(fechaEstadistica).format();
        var params = new HttpParams()
            .set('idCalendario', idCalendario.toString())
            .set('fecha', f)
            .set('fechaEstadistica', fe);
        //
        return this.apiService.delete('set-fecha-estadistica', params)
            .toPromise();
    };
    CalendarioService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], CalendarioService);
    return CalendarioService;
}(CatalogService));
export { CalendarioService };
