var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Output, EventEmitter } from '@angular/core';
import { Http } from '@angular/http';
import { Observable } from 'rxjs';
import { mergeMap } from 'rxjs/operators';
import 'rxjs/add/observable/of';
import { GeocodeService } from '../providers/geocode.service';
var GeocodeAutocompleteComponent = /** @class */ (function () {
    function GeocodeAutocompleteComponent(http) {
        var _this = this;
        this.http = http;
        /////////// INPUTS
        /////////// OUTPUS
        this.selectedItemChange = new EventEmitter();
        this.geocodeService = new GeocodeService(http, 'AIzaSyC4ZhXxsIbT1P5Wjj0ZmN5R5JBr4Lp-Kz8');
        this.dataSource = Observable
            .create(function (observer) {
            // Runs on every search
            observer.next(_this.asyncSelected);
        })
            .pipe(mergeMap(function (token) { return _this.geocodeService.findAddress(token); }));
    }
    /////////// METHODS
    /////////// HANDLERS
    GeocodeAutocompleteComponent.prototype.changeTypeaheadLoading = function (e) {
        this.typeaheadLoading = e;
    };
    GeocodeAutocompleteComponent.prototype.changeTypeaheadNoResults = function (e) {
        this.typeaheadNoResults = e;
    };
    GeocodeAutocompleteComponent.prototype.typeaheadOnSelect = function (e) {
        this.selectedItemChange.emit(e.item);
    };
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], GeocodeAutocompleteComponent.prototype, "selectedItemChange", void 0);
    GeocodeAutocompleteComponent = __decorate([
        Component({
            selector: 'azteca-geocode-autocomplete',
            template: "\n      <input [(ngModel)]=\"asyncSelected\"\n             [typeahead]=\"dataSource\"\n             (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n             (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n             (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n             typeaheadOptionsLimit=\"10\"       \n             typeaheadOptionField=\"formatted_address\"\n             placeholder=\"Buscar direcci\u00F3n...\"\n             class=\"form-control\">\n    "
        }),
        __metadata("design:paramtypes", [Http])
    ], GeocodeAutocompleteComponent);
    return GeocodeAutocompleteComponent;
}());
export { GeocodeAutocompleteComponent };
