import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Context } from '../../core/services/context';
import { BaseControl } from '../../controls';
import { Position } from '../models/position';
import { MapComponent } from '../components/map.component';
import { MapIcon } from '../models/map-icon';
export declare class LocationsComponent extends BaseControl implements ControlValueAccessor {
    private context;
    locations: Position[];
    center: Position;
    height: number;
    locationField: string;
    titleField: string;
    legendField: string;
    iconField: string;
    zoom: number;
    mapIcons: MapIcon[];
    allowEdit: boolean;
    allowDelete: boolean;
    locationsChange: EventEmitter<Position[]>;
    editingLocation: EventEmitter<Position>;
    deletingLocation: EventEmitter<Position>;
    map: MapComponent;
    constructor(context: Context);
    ngOnInit(): void;
    getIconUrl(location: any): string;
    onEditItem(location: Position): void;
    onDeleteItem(location: Position): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
