var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef, ViewChild } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { Context } from '../../core/services/context';
import { BaseComponent } from '../../core/models/base-component';
import { BaseControl } from '../../controls';
//
import { Position } from '../models/position';
import { MapComponent } from '../components/map.component';
var LocationsComponent = /** @class */ (function (_super) {
    __extends(LocationsComponent, _super);
    function LocationsComponent(context) {
        var _this = _super.call(this) || this;
        _this.context = context;
        //Inputs
        _this.locations = [];
        _this.height = 500;
        _this.locationField = '';
        _this.titleField = '';
        _this.legendField = '';
        _this.iconField = '';
        _this.zoom = 15;
        _this.mapIcons = [];
        _this.allowEdit = false;
        _this.allowDelete = false;
        //Outputs
        _this.locationsChange = new EventEmitter();
        _this.editingLocation = new EventEmitter();
        _this.deletingLocation = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    LocationsComponent_1 = LocationsComponent;
    LocationsComponent.prototype.ngOnInit = function () {
        if (this.locations && this.locations.length > 0 && !this.center) {
            if (this.locationField != '') {
                var firstPoint = this.locations[0];
                this.center = firstPoint[this.locationField];
            }
            else {
                this.center = this.locations[0];
            }
        }
    };
    LocationsComponent.prototype.getIconUrl = function (location) {
        if (this.iconField != '') {
            //Obtener índice de ícono y buscarlo en lista de iconos
            var iconIndex_1 = location[this.iconField];
            var mapIcon = this.mapIcons.find(function (i) { return i.iconIndex == iconIndex_1; });
            return mapIcon ? 'assets/map_icon/' + mapIcon.fileName : '';
        }
        else {
            return '';
        }
    };
    LocationsComponent.prototype.onEditItem = function (location) {
        this.editingLocation.emit(location);
    };
    LocationsComponent.prototype.onDeleteItem = function (location) {
        this.deletingLocation.emit(location);
    };
    //Implementación de control value accesor
    LocationsComponent.prototype.writeValue = function (value) {
        this.locations = value ? value : null;
    };
    LocationsComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    LocationsComponent.prototype.registerOnTouched = function () { };
    var LocationsComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], LocationsComponent.prototype, "locations", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Position)
    ], LocationsComponent.prototype, "center", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], LocationsComponent.prototype, "height", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], LocationsComponent.prototype, "locationField", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], LocationsComponent.prototype, "titleField", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], LocationsComponent.prototype, "legendField", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], LocationsComponent.prototype, "iconField", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], LocationsComponent.prototype, "zoom", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], LocationsComponent.prototype, "mapIcons", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], LocationsComponent.prototype, "allowEdit", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], LocationsComponent.prototype, "allowDelete", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], LocationsComponent.prototype, "locationsChange", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], LocationsComponent.prototype, "editingLocation", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], LocationsComponent.prototype, "deletingLocation", void 0);
    __decorate([
        ViewChild(MapComponent),
        __metadata("design:type", MapComponent)
    ], LocationsComponent.prototype, "map", void 0);
    LocationsComponent = LocationsComponent_1 = __decorate([
        Component({
            selector: 'azteca-locations',
            template: "\n      <div *ngIf=\"visible\">\n          <google-map [latitude]=\"center ? center.lat : 0\" \n                      [longitude]=\"center ? center.lng : 0\"\n                      [zoom]=\"zoom\" \n                      [height]=\"height\">\n\n              <google-map-marker *ngFor=\"let posicion of locations\"\n                                 [latitude]=\"locationField == '' ? posicion.lat : posicion[locationField].lat\"\n                                 [longitude]=\"locationField == '' ? posicion.lng: posicion[locationField].lng\"\n                                 [iconUrl]=\"getIconUrl(posicion)\"\n                                 [draggable]=\"false\">\n\n                  <google-map-info-window *ngIf=\"titleFIeld != '' || legendField != ''\">\n                      <b *ngIf=\"titleFIeld != ''\">{{posicion[titleField]}}</b>\n                      <br />\n                      <small *ngIf=\"legendField != ''\"><i>{{posicion[legendField]}}</i></small>\n                      <br />\n                      <div *ngIf=\"allowEdit || allowDelete\" class=\"btn-group\">\n                          <button *ngIf=\"allowEdit\" type=\"button\" class=\"btn btn-secondary\" title=\"Editar\" (click)=\"onEditItem(posicion)\">\n                              <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>\n                          </button>\n                          <button *ngIf=\"allowDelete\" type=\"button\" class=\"btn btn-secondary\" title=\"Eliminar\" (click)=\"onDeleteItem(posicion)\">\n                              <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>\n                          </button>\n                      </div>\n                  </google-map-info-window>\n              </google-map-marker>\n          </google-map>\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return LocationsComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return LocationsComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Context])
    ], LocationsComponent);
    return LocationsComponent;
}(BaseControl));
export { LocationsComponent };
