import { EventEmitter, SimpleChange } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as Google from '../models/google-maps-types';
import { BaseControl, ToolbarButton } from '../../controls';
import { Position } from '../models/position';
import { PolygonDirective } from '../directives/polygon.directive';
export declare class MapPolygonComponent extends BaseControl implements ControlValueAccessor {
    private defaultPosition;
    readonly drawingMode: string;
    private defaultPolyOptions;
    path: Position[];
    position: Position;
    height: number;
    zoom: number;
    strokeColor: string;
    strokeOpacity: number;
    strokeWeight: number;
    fillColor: string;
    fillOpacity: number;
    clickable: boolean;
    draggable: boolean;
    polygonOptions: Google.PolygonOptions;
    click: EventEmitter<Google.PolyMouseEvent>;
    dblClick: EventEmitter<Google.PolyMouseEvent>;
    dragStart: EventEmitter<void>;
    dragEnd: EventEmitter<Position[]>;
    pathChange: EventEmitter<Position[]>;
    polygon: PolygonDirective;
    ngOnChanges(changes: SimpleChange): void;
    onClick(args: Google.PolyMouseEvent): void;
    onDblClick(args: Google.PolyMouseEvent): void;
    onDragStart(): void;
    onDragEnd(path: Position[]): void;
    onChanged(path: Position[]): void;
    onPolygonComplete(polygon: Google.Polygon): void;
    toolbarClick(button: ToolbarButton): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
