var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import * as Google from '../models/google-maps-types';
import { BaseControl } from '../../controls';
import { BaseComponent } from '../../core/models/base-component';
//
import { Position } from '../models/position';
import { PolygonDirective } from '../directives/polygon.directive';
var MapPolygonComponent = /** @class */ (function (_super) {
    __extends(MapPolygonComponent, _super);
    function MapPolygonComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultPosition = new Position(20.677034, -103.346984);
        _this.defaultPolyOptions = {
            strokeWeight: 0,
            fillOpacity: 0.45,
            fillColor: '#1E90FF',
            editable: true
        };
        //
        _this.path = [];
        _this.position = _this.defaultPosition;
        _this.height = 500;
        _this.zoom = 10;
        _this.strokeColor = '#1E90FF';
        _this.strokeOpacity = 0.45;
        _this.strokeWeight = 0;
        _this.fillColor = '#1E90FF';
        _this.fillOpacity = 0.45;
        _this.clickable = true;
        _this.draggable = false;
        _this.polygonOptions = _this.defaultPolyOptions;
        //
        _this.click = new EventEmitter();
        _this.dblClick = new EventEmitter();
        _this.dragStart = new EventEmitter();
        _this.dragEnd = new EventEmitter();
        _this.pathChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    MapPolygonComponent_1 = MapPolygonComponent;
    Object.defineProperty(MapPolygonComponent.prototype, "drawingMode", {
        get: function () {
            return this.path.length > 3 ? null : 'polygon';
        },
        enumerable: true,
        configurable: true
    });
    MapPolygonComponent.prototype.ngOnChanges = function (changes) {
        if (changes['path'] && this.path.length > 3) {
            if (this.position == this.defaultPosition) {
                this.position = this.path[0];
            }
        }
    };
    /////////////////// HANDLERS DE EVENTOS /////////////////////////////////
    MapPolygonComponent.prototype.onClick = function (args) {
        this.click.emit(args);
    };
    MapPolygonComponent.prototype.onDblClick = function (args) {
        this.dblClick.emit(args);
    };
    MapPolygonComponent.prototype.onDragStart = function () {
        this.dragStart.emit();
    };
    MapPolygonComponent.prototype.onDragEnd = function (path) {
        this.dragEnd.emit(path);
        this.pathChange.emit(path);
        this.propagateChange(path);
    };
    MapPolygonComponent.prototype.onChanged = function (path) {
        this.pathChange.emit(path);
        this.propagateChange(path);
    };
    MapPolygonComponent.prototype.onPolygonComplete = function (polygon) {
        this.polygon.mapDrawnPolygon(polygon);
        this.pathChange.emit(this.polygon.path);
        this.propagateChange(this.polygon.path);
        this.path = this.polygon.path;
    };
    MapPolygonComponent.prototype.toolbarClick = function (button) {
        if (button.name == 'DELETE') {
            this.polygon.clear();
            this.path = [];
            this.pathChange.emit([]);
            this.propagateChange([]);
        }
    };
    //Implementación de control value accesor
    MapPolygonComponent.prototype.writeValue = function (value) {
        if (value && value.length >= 3) {
            this.path = value ? value : null;
            if (this.position == this.defaultPosition) {
                this.position = this.path[0];
            }
        }
        else {
            this.path = [];
        }
    };
    MapPolygonComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    MapPolygonComponent.prototype.registerOnTouched = function () { };
    var MapPolygonComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], MapPolygonComponent.prototype, "path", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "position", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapPolygonComponent.prototype, "height", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapPolygonComponent.prototype, "zoom", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], MapPolygonComponent.prototype, "strokeColor", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapPolygonComponent.prototype, "strokeOpacity", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapPolygonComponent.prototype, "strokeWeight", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], MapPolygonComponent.prototype, "fillColor", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MapPolygonComponent.prototype, "fillOpacity", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], MapPolygonComponent.prototype, "clickable", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], MapPolygonComponent.prototype, "draggable", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "polygonOptions", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "click", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "dblClick", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "dragStart", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "dragEnd", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], MapPolygonComponent.prototype, "pathChange", void 0);
    __decorate([
        ViewChild(PolygonDirective),
        __metadata("design:type", PolygonDirective)
    ], MapPolygonComponent.prototype, "polygon", void 0);
    MapPolygonComponent = MapPolygonComponent_1 = __decorate([
        Component({
            selector: 'azteca-map-polygon',
            template: "\n      <div *ngIf=\"visible\">\n          <az-toolbar *ngIf=\"enabled && path.length > 3\" (buttonClick)=\"toolbarClick($event)\">\n              <az-toolbar-button [name]=\"'DELETE'\" [text]=\"'Eliminar pol\u00EDgono'\" [icon]=\"'glyphicon glyphicon-trash'\"></az-toolbar-button>\n          </az-toolbar>\n\n          <google-map [latitude]=\"position.lat\" [longitude]=\"position.lng\" [height]=\"height\" [zoom]=\"zoom\">\n\n              <google-map-drawing [drawingMode]=\"drawingMode\"\n                                  [drawingControl]=\"enabled && path.length == 0\"\n                                  [polygonOptions]=\"polygonOptions\"\n                                  (polygonComplete)=\"onPolygonComplete($event)\">\n\n              </google-map-drawing>\n\n              <google-map-polygon [path]=\"path\"\n                                  [strokeColor]=\"strokeColor\"\n                                  [strokeOpacity]=\"strokeOpacity\"\n                                  [strokeWeight]=\"strokeWeight\"\n                                  [fillColor]=\"fillColor\"\n                                  [fillOpacity]=\"fillOpacity\"\n                                  [editable]=\"enabled\"\n                                  [visible]=\"visible\"\n                                  [clickable]=\"clickable\"\n                                  [draggable]=\"draggable\"\n                                  (click)=\"onClick($event)\"\n                                  (dblClick)=\"onDblClick($event)\"\n                                  (dragStart)=\"onDragStart()\"\n                                  (dragEnd)=\"onDragEnd($event)\"\n                                  (changed)=\"onChanged($event)\">\n\n              </google-map-polygon>\n\n          </google-map>\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return MapPolygonComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return MapPolygonComponent_1; }),
                    multi: true
                }]
        })
    ], MapPolygonComponent);
    return MapPolygonComponent;
}(BaseControl));
export { MapPolygonComponent };
