import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BaseControl } from '../../controls';
import { Context } from '../../core/services/context';
import { Position } from '../models/position';
import { MarkerDirective } from '../directives/marker.directive';
import { MapComponent } from '../components/map.component';
import { GeocodeResult } from '../models/geocode-result';
import * as Google from '../models/google-maps-types';
export declare class PositionComponent extends BaseControl implements ControlValueAccessor {
    private context;
    defaultPosition: Position;
    currentPosition: Position;
    position: Position;
    height: number;
    zoom: number;
    gestureHandling: string;
    styles: Google.MapTypeStyle[];
    zoomControl: boolean;
    fullscreenControlOptions: Google.FullscreenControlOptions;
    mapTypeId: 'roadmap' | 'hybrid' | 'satellite' | 'terrain' | string;
    clickableIcons: boolean;
    mapTypeControl: boolean;
    mapTypeControlOptions: Google.MapTypeControlOptions;
    streetViewControl: boolean;
    streetViewControlOptions: Google.StreetViewControlOptions;
    edited: boolean;
    positionChange: EventEmitter<Position>;
    marker: MarkerDirective;
    map: MapComponent;
    lat: any;
    area: any;
    constructor(context: Context);
    onDragEnd(args: any): void;
    ngOnInit(): void;
    refresh(): void;
    onAddressSelected(item: GeocodeResult): void;
    setNewMarket(): boolean;
    setCurrentPosition(): boolean;
    private getCurrentPosition;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
