var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
//
import { BaseControl } from '../../controls';
import { Context } from '../../core/services/context';
import { BaseComponent } from '../../core/models/base-component';
//
import { Position } from '../models/position';
import { MarkerDirective } from '../directives/marker.directive';
import { MapComponent } from '../components/map.component';
import * as Google from '../models/google-maps-types';
var PositionComponent = /** @class */ (function (_super) {
    __extends(PositionComponent, _super);
    function PositionComponent(context) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.defaultPosition = new Position(20.677034, -103.346984);
        _this.currentPosition = _this.defaultPosition;
        //Inputs
        _this.position = new Position(0, 0);
        _this.height = 500;
        _this.zoom = 15;
        _this.gestureHandling = 'greedy';
        _this.styles = [];
        _this.zoomControl = true;
        _this.mapTypeId = 'roadmap';
        _this.clickableIcons = true;
        _this.mapTypeControl = true;
        _this.streetViewControl = true;
        _this.edited = false;
        //Outputs
        _this.positionChange = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    PositionComponent_1 = PositionComponent;
    PositionComponent.prototype.onDragEnd = function (args) {
        var newPos = args.coords;
        this.propagateChange(newPos);
        this.positionChange.emit(newPos);
        this.lat.nativeElement.value = " Lat: " + args.coords.lat.toFixed(4) + "  Lng:" + args.coords.lng.toFixed(4);
    };
    PositionComponent.prototype.ngOnInit = function () {
        this.getCurrentPosition();
    };
    PositionComponent.prototype.refresh = function () {
        this.map.triggerResize(true);
    };
    //Handlers
    PositionComponent.prototype.onAddressSelected = function (item) {
        this.position = item.geometry.location;
        this.positionChange.emit(this.position);
        this.propagateChange(this.position);
        this.lat.nativeElement.value = " Lat:  " + item.geometry.location.lat.toFixed(4) + "   Lng: " + item.geometry.location.lng.toFixed(4);
    };
    PositionComponent.prototype.setNewMarket = function () {
        this.edited = true;
        this.area.nativeElement.value = " Area : 20,2 ";
        return false;
    };
    PositionComponent.prototype.setCurrentPosition = function () {
        this.getCurrentPosition();
        return false;
    };
    //obtener la geolocalizacion
    PositionComponent.prototype.getCurrentPosition = function () {
        var _this = this;
        if ("geolocation" in navigator) {
            navigator.geolocation.getCurrentPosition(function (position) {
                _this.position = new Position(position.coords.latitude, position.coords.longitude);
                _this.positionChange.emit(_this.position);
                _this.propagateChange(_this.position);
                _this.lat.nativeElement.value = "Lat:" + position.coords.latitude.toFixed(4) + " Lng:" + position.coords.longitude.toFixed(4) + " Pre:" + position.coords.accuracy + "mtr";
            });
        }
    };
    //Implementación de control value accesor
    PositionComponent.prototype.writeValue = function (value) {
        if (value && value.lat != 0)
            this.position = value ? value : null;
        else
            this.position = this.currentPosition;
    };
    PositionComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    PositionComponent.prototype.registerOnTouched = function () { };
    var PositionComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "position", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], PositionComponent.prototype, "height", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], PositionComponent.prototype, "zoom", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PositionComponent.prototype, "gestureHandling", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], PositionComponent.prototype, "styles", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PositionComponent.prototype, "zoomControl", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "fullscreenControlOptions", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PositionComponent.prototype, "mapTypeId", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PositionComponent.prototype, "clickableIcons", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PositionComponent.prototype, "mapTypeControl", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "mapTypeControlOptions", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], PositionComponent.prototype, "streetViewControl", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "streetViewControlOptions", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "edited", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "positionChange", void 0);
    __decorate([
        ViewChild(MarkerDirective),
        __metadata("design:type", MarkerDirective)
    ], PositionComponent.prototype, "marker", void 0);
    __decorate([
        ViewChild(MapComponent),
        __metadata("design:type", MapComponent)
    ], PositionComponent.prototype, "map", void 0);
    __decorate([
        ViewChild('lat'),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "lat", void 0);
    __decorate([
        ViewChild('area'),
        __metadata("design:type", Object)
    ], PositionComponent.prototype, "area", void 0);
    PositionComponent = PositionComponent_1 = __decorate([
        Component({
            selector: 'azteca-position',
            template: "\n\n      <div *ngIf=\"visible\">\n          <azteca-geocode-autocomplete (selectedItemChange)=\"onAddressSelected($event)\" #seach></azteca-geocode-autocomplete>\n          <div id=\"panel-localizacion\">\n              <button (click)=\"setCurrentPosition($event)\" class=\"btn_gpd\"></button>\n          </div>\n\n\n          <div id=\"floating-panel\"><input #lat readonly class=\"input_maps\" /></div>\n          <google-map [latitude]=\"position ? position.lat : defaultPosition.lat\" [longitude]=\"position ? position.lng : defaultPosition.lng\" [height]=\"height\" [zoom]=\"zoom\" [mapTypeControl]=\"mapTypeControl\" [mapTypeControlOptions]=\"mapTypeControlOptions\"\n                      [mapTypeId]=\"mapTypeId\" [gestureHandling]=\"gestureHandling\" [streetViewControlOptions]=\"streetViewControlOptions\"\n                      [fullscreenControlOptions]=\"fullscreenControlOptions\" [clickableIcons]=\"clickableIcons\" [styles]=\"styles\">\n              <google-map-marker [latitude]=\"position ? position.lat : defaultPosition.lat\"\n                                 [longitude]=\"position ? position.lng : defaultPosition.lng\"\n                                 [draggable]=\"enabled\"\n                                 (dragEnd)=\"onDragEnd($event)\">\n              </google-map-marker>\n          </google-map>\n      </div>\n      <div *ngIf=\"!visible\">\n          <span class=\"glyphicon glyphicon-lock\" aria-hidden=\"true\"></span>\n      </div>\n    ",
            providers: [{
                    provide: BaseComponent,
                    useExisting: forwardRef(function () { return PositionComponent_1; })
                },
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return PositionComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [Context])
    ], PositionComponent);
    return PositionComponent;
}(BaseControl));
export { PositionComponent };
