import { EventEmitter, SimpleChange } from '@angular/core';
import { DrawingService } from '../providers/drawing.service';
import * as Google from '../models/google-maps-types';
export declare class DrawingDirective {
    private drawingService;
    private _observableSubscriptions;
    private defaultLineOptions;
    private defaultPolyOptions;
    drawingMode: Google.OverlayType;
    drawingControl: boolean;
    polylineOptions: Google.PolylineOptions;
    rectangleOptions: Google.RectangleOptions;
    circleOptions: Google.PolygonOptions;
    polygonOptions: Google.PolygonOptions;
    polygonComplete: EventEmitter<Google.Polygon>;
    polylineComplete: EventEmitter<Google.Polyline>;
    rectangleComplete: EventEmitter<Google.Rectangle>;
    circleComplete: EventEmitter<Google.Circle>;
    overlayComplete: EventEmitter<Google.OverlayCompleteEvent>;
    constructor(drawingService: DrawingService);
    ngOnChanges(changes: {
        [key: string]: SimpleChange;
    }): void;
    private addListeners;
    ngOnDestroy(): void;
}
