import { EventEmitter, SimpleChange, QueryList } from '@angular/core';
import { MarkerService } from '../providers/marker.service';
import { InfoWindowDirective } from './info-window.directive';
export declare class MarkerDirective {
    private markerService;
    private markerAddedToService;
    private _observableSubscriptions;
    latitude: number;
    longitude: number;
    label: string;
    draggable: boolean;
    iconUrl: string;
    visible: boolean;
    title: string;
    opacity: number;
    data: any;
    /**
     * This event emitter gets emitted when the user clicks on the marker.
     */
    markerClick: EventEmitter<void>;
    /**
     * This event is fired when the user stops dragging the marker.
     */
    dragEnd: EventEmitter<MouseEvent>;
    /**
     * This event is fired when the user mouses over the marker.
     */
    mouseOver: EventEmitter<MouseEvent>;
    /**
     * This event is fired when the user mouses outside the marker.
     */
    mouseOut: EventEmitter<MouseEvent>;
    /**
     * @internal
     */
    /**
       * Whether to automatically open the child info window when the marker is clicked.
       */
    openInfoWindow: boolean;
    infoWindow: QueryList<InfoWindowDirective>;
    constructor(markerService: MarkerService);
    ngOnChanges(changes: {
        [key: string]: SimpleChange;
    }): void;
    ngAfterContentInit(): void;
    private handleInfoWindowUpdate;
    private addEventListeners;
    ngOnDestroy(): void;
}
