var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, Input, Output, EventEmitter } from '@angular/core';
import { MarkersetService } from '../providers/markerset.service';
var MarkersetDirective = /** @class */ (function () {
    function MarkersetDirective(markersetService) {
        this.markersetService = markersetService;
        this._observableSubscriptions = [];
        //
        this.markerClick = new EventEmitter();
    }
    MarkersetDirective.prototype.ngOnChanges = function (changes) {
        if (!this.markersetAddedToService && this.markers != null && this.markers != undefined) {
            this.markersetService.addMarkerset(this);
            this.markersetAddedToService = true;
            return;
        }
    };
    MarkersetDirective.prototype.ngOnDestroy = function () {
        this.markersetService.deleteMarkerset(this);
        this._observableSubscriptions.forEach(function (s) {
            s.unsubscribe();
        });
    };
    MarkersetDirective.prototype.addListeners = function () {
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], MarkersetDirective.prototype, "markers", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], MarkersetDirective.prototype, "data", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], MarkersetDirective.prototype, "markerClick", void 0);
    MarkersetDirective = __decorate([
        Directive({
            selector: 'google-map-markerset',
        }),
        __metadata("design:paramtypes", [MarkersetService])
    ], MarkersetDirective);
    return MarkersetDirective;
}());
export { MarkersetDirective };
