import { EventEmitter, SimpleChange } from '@angular/core';
import { PolygonService } from '../providers/polygon.service';
import * as Google from '../models/google-maps-types';
import { Position } from '../models/position';
export declare class PolygonDirective {
    private polygonService;
    private polygonAddedToService;
    private _observableSubscriptions;
    path: Position[];
    strokeColor: string;
    strokeOpacity: number;
    strokeWeight: number;
    fillColor: string;
    fillOpacity: number;
    editable: boolean;
    visible: boolean;
    clickable: boolean;
    draggable: boolean;
    data: any;
    click: EventEmitter<Google.PolyMouseEvent>;
    dblClick: EventEmitter<Google.PolyMouseEvent>;
    dragStart: EventEmitter<void>;
    dragEnd: EventEmitter<Position[]>;
    changed: EventEmitter<Position[]>;
    constructor(polygonService: PolygonService);
    ngOnChanges(changes: {
        [key: string]: SimpleChange;
    }): void;
    mapDrawnPolygon(polygon: Google.Polygon): void;
    clear(): void;
    private addEventListeners;
    ngOnDestroy(): void;
}
