import { NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import { MapService } from './map.service';
import { DrawingDirective } from '../directives/drawing.directive';
import * as Google from '../models/google-maps-types';
export declare class DrawingService {
    private mapService;
    private _zone;
    drawingManager: Promise<Google.DrawingManager>;
    constructor(mapService: MapService, _zone: NgZone);
    createManager(drawingDirective: DrawingDirective): void;
    deleteManager(drawingDirective: DrawingDirective): Promise<void>;
    updateDrawingMode(drawingDirective: DrawingDirective): void;
    updateDrawingControl(drawingDirective: DrawingDirective): void;
    updatePolylineOptions(drawingDirective: DrawingDirective): void;
    updateRectangleOptions(drawingDirective: DrawingDirective): void;
    updateCircleOptions(drawingDirective: DrawingDirective): void;
    updatePolygonOptions(drawingDirective: DrawingDirective): void;
    createEventObservable<T>(eventName: string, marker: DrawingDirective): Observable<T>;
}
