var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import { MapService } from './map.service';
var DrawingService = /** @class */ (function () {
    function DrawingService(mapService, _zone) {
        this.mapService = mapService;
        this._zone = _zone;
    }
    DrawingService.prototype.createManager = function (drawingDirective) {
        if (!this.drawingManager) {
            this.drawingManager = this.mapService.createDrawingManager({
                drawingMode: drawingDirective.drawingMode,
                drawingControlOptions: {
                    drawingModes: [drawingDirective.drawingMode]
                },
                polylineOptions: drawingDirective.polylineOptions,
                rectangleOptions: drawingDirective.rectangleOptions,
                circleOptions: drawingDirective.circleOptions,
                polygonOptions: drawingDirective.polygonOptions,
                drawingControl: drawingDirective.drawingControl
            });
        }
    };
    DrawingService.prototype.deleteManager = function (drawingDirective) {
        var _this = this;
        if (!this.drawingManager) {
            return Promise.resolve();
        }
        //
        return this.drawingManager.then(function (dm) {
            return _this._zone.run(function () {
                dm.setMap(null);
                _this.drawingManager = null;
            });
        });
    };
    DrawingService.prototype.updateDrawingMode = function (drawingDirective) {
        this.drawingManager.then(function (dm) { return dm.setDrawingMode(drawingDirective.drawingMode); });
    };
    DrawingService.prototype.updateDrawingControl = function (drawingDirective) {
        this.drawingManager.then(function (dm) { return dm.setOptions({ drawingControl: drawingDirective.drawingControl }); });
    };
    DrawingService.prototype.updatePolylineOptions = function (drawingDirective) {
        this.drawingManager.then(function (dm) { return dm.setOptions({ polylineOptions: drawingDirective.polylineOptions }); });
    };
    DrawingService.prototype.updateRectangleOptions = function (drawingDirective) {
        this.drawingManager.then(function (dm) { return dm.setOptions({ rectangleOptions: drawingDirective.rectangleOptions }); });
    };
    DrawingService.prototype.updateCircleOptions = function (drawingDirective) {
        this.drawingManager.then(function (dm) { return dm.setOptions({ circleOptions: drawingDirective.circleOptions }); });
    };
    DrawingService.prototype.updatePolygonOptions = function (drawingDirective) {
        this.drawingManager.then(function (dm) { return dm.setOptions({ polygonOptions: drawingDirective.polygonOptions }); });
    };
    DrawingService.prototype.createEventObservable = function (eventName, marker) {
        var _this = this;
        return Observable.create(function (observer) {
            _this.drawingManager.then(function (dm) {
                dm.addListener(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
            });
        });
    };
    DrawingService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [MapService, NgZone])
    ], DrawingService);
    return DrawingService;
}());
export { DrawingService };
