import { URLSearchParams, RequestOptions } from '@angular/http';
import { map } from 'rxjs/operators';
import 'rxjs/add/operator/toPromise';
var GeocodeService = /** @class */ (function () {
    function GeocodeService(http, key) {
        this.http = http;
        this.key = key;
        this.url = 'https://maps.googleapis.com/maps/api/geocode/json';
    }
    GeocodeService.prototype.findAddress = function (address) {
        var params = new URLSearchParams();
        params.set('address', address);
        params.set('key', this.key);
        params.set('region', 'mx');
        var options = new RequestOptions({ search: params });
        return this.http.get(this.url, options)
            .pipe(map(function (response) {
            var json = response.json();
            return json.results;
        }));
    };
    return GeocodeService;
}());
export { GeocodeService };
