import { Observable } from 'rxjs';
import { NgZone } from '@angular/core';
import { InfoWindowDirective } from '../directives/info-window.directive';
import { MapService } from './map.service';
import { InfoWindowOptions } from '../models/google-maps-types';
import { MarkerService } from './marker.service';
export declare class InfoWindowService {
    private mapService;
    private _zone;
    private markerService;
    private _infoWindows;
    constructor(mapService: MapService, _zone: NgZone, markerService: MarkerService);
    deleteInfoWindow(infoWindow: InfoWindowDirective): Promise<void>;
    setPosition(infoWindow: InfoWindowDirective): Promise<void>;
    setZIndex(infoWindow: InfoWindowDirective): Promise<void>;
    open(infoWindow: InfoWindowDirective): Promise<void>;
    close(infoWindow: InfoWindowDirective): Promise<void>;
    setOptions(infoWindow: InfoWindowDirective, options: InfoWindowOptions): Promise<void>;
    addInfoWindow(infoWindow: InfoWindowDirective): void;
    /**
     * Creates a Google Maps event listener for the given InfoWindow as an Observable
     */
    createEventObservable<T>(eventName: string, infoWindow: InfoWindowDirective): Observable<T>;
}
