import { NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import * as Google from '../models/google-maps-types';
export declare class MapService {
    private _zone;
    private _map;
    private _mapResolver;
    private _mapsLoaderPromise;
    mapOptions: Google.MapOptions;
    constructor(_zone: NgZone);
    createMap(el: Element, options: Google.MapOptions): Promise<void>;
    setMapOptions(options: Google.MapOptions): void;
    createMarker(options: Google.MarkerOptions): Promise<Google.Marker>;
    createInfoWindow(options?: Google.InfoWindowOptions): Promise<Google.InfoWindow>;
    createPolygon(options: Google.PolygonOptions): Promise<Google.Polygon>;
    createDrawingManager(options: Google.DrawingManagerOptions): Promise<Google.DrawingManager>;
    subscribeToMapEvent<E>(eventName: string): Observable<E>;
    setCenter(latLng: Google.LatLngLiteral): Promise<void>;
    getZoom(): Promise<number>;
    getBounds(): Promise<Google.LatLngBounds>;
    setZoom(zoom: number): Promise<void>;
    getCenter(): Promise<Google.LatLng>;
    panTo(latLng: Google.LatLng | Google.LatLngLiteral): Promise<void>;
    fitBounds(latLng: Google.LatLngBounds | Google.LatLngBoundsLiteral): Promise<void>;
    panToBounds(latLng: Google.LatLngBounds | Google.LatLngBoundsLiteral): Promise<void>;
    getNativeMap(): Promise<Google.GoogleMap>;
    triggerMapEvent(eventName: string): Promise<void>;
}
