var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import { Injectable } from '@angular/core';
var GoogleMapsLoader = require('google-maps');
var MapService = /** @class */ (function () {
    function MapService(_zone) {
        var _this = this;
        this._zone = _zone;
        this._map = new Promise(function (resolve) { _this._mapResolver = resolve; });
    }
    MapService.prototype.createMap = function (el, options) {
        var _this = this;
        if (this._mapsLoaderPromise) {
            return this._mapsLoaderPromise;
        }
        this._mapsLoaderPromise = new Promise(function (resolve, reject) {
            GoogleMapsLoader.KEY = 'AIzaSyC4ZhXxsIbT1P5Wjj0ZmN5R5JBr4Lp-Kz8';
            GoogleMapsLoader.LIBRARIES = ['drawing'];
            GoogleMapsLoader.load(function (google) {
                var map = new google.maps.Map(el, options);
                _this._mapResolver(map);
                resolve();
            });
        });
        return this._mapsLoaderPromise;
    };
    MapService.prototype.setMapOptions = function (options) {
        this._map.then(function (m) { m.setOptions(options); });
    };
    MapService.prototype.createMarker = function (options) {
        return this._map.then(function (map) {
            options.map = map;
            return new google.maps.Marker(options);
        });
    };
    MapService.prototype.createInfoWindow = function (options) {
        return this._map.then(function () { return new google.maps.InfoWindow(options); });
    };
    /*
    createMarkerCluster(options: ) {

    }
    */
    MapService.prototype.createPolygon = function (options) {
        return this.getNativeMap().then(function (map) {
            var polygon = new google.maps.Polygon(options);
            polygon.setMap(map);
            return polygon;
        });
    };
    MapService.prototype.createDrawingManager = function (options) {
        return this.getNativeMap().then(function (map) {
            var drawingManager = new google.maps.drawing.DrawingManager(options);
            drawingManager.setMap(map);
            return drawingManager;
        });
    };
    MapService.prototype.subscribeToMapEvent = function (eventName) {
        var _this = this;
        return Observable.create(function (observer) {
            _this._map.then(function (m) {
                m.addListener(eventName, function (arg) { _this._zone.run(function () { return observer.next(arg); }); });
            });
        });
    };
    MapService.prototype.setCenter = function (latLng) {
        return this._map.then(function (map) { return map.setCenter(latLng); });
    };
    MapService.prototype.getZoom = function () { return this._map.then(function (map) { return map.getZoom(); }); };
    MapService.prototype.getBounds = function () {
        return this._map.then(function (map) { return map.getBounds(); });
    };
    MapService.prototype.setZoom = function (zoom) {
        return this._map.then(function (map) { return map.setZoom(zoom); });
    };
    MapService.prototype.getCenter = function () {
        return this._map.then(function (map) { return map.getCenter(); });
    };
    MapService.prototype.panTo = function (latLng) {
        return this._map.then(function (map) { return map.panTo(latLng); });
    };
    MapService.prototype.fitBounds = function (latLng) {
        return this._map.then(function (map) { return map.fitBounds(latLng); });
    };
    MapService.prototype.panToBounds = function (latLng) {
        return this._map.then(function (map) { return map.panToBounds(latLng); });
    };
    MapService.prototype.getNativeMap = function () {
        return this._map;
    };
    MapService.prototype.triggerMapEvent = function (eventName) {
        return this._map.then(function (m) { return google.maps.event.trigger(m, eventName); });
    };
    MapService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [NgZone])
    ], MapService);
    return MapService;
}());
export { MapService };
