import { NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import { MarkerDirective } from '../directives/marker.directive';
import { MapService } from './map.service';
import { Marker } from '../models/google-maps-types';
export declare class MarkerService {
    private mapService;
    private _zone;
    private markers;
    constructor(mapService: MapService, _zone: NgZone);
    addMarker(markerDirective: MarkerDirective): void;
    deleteMarker(marker: MarkerDirective): Promise<void>;
    updatePosition(marker: MarkerDirective): Promise<void>;
    updateVisible(marker: MarkerDirective): Promise<void>;
    updateTitle(marker: MarkerDirective): Promise<void>;
    updateLabel(marker: MarkerDirective): Promise<void>;
    updateDraggable(marker: MarkerDirective): Promise<void>;
    updateIcon(marker: MarkerDirective): Promise<void>;
    updateOpacity(marker: MarkerDirective): Promise<void>;
    getNativeMarker(marker: MarkerDirective): Promise<Marker>;
    createEventObservable<T>(eventName: string, marker: MarkerDirective): Observable<T>;
}
