var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import { MapService } from './map.service';
var MarkerService = /** @class */ (function () {
    function MarkerService(mapService, _zone) {
        this.mapService = mapService;
        this._zone = _zone;
        this.markers = new Map();
    }
    MarkerService.prototype.addMarker = function (markerDirective) {
        var markerPromise = this.mapService.createMarker({
            position: { lat: markerDirective.latitude, lng: markerDirective.longitude },
            label: markerDirective.label,
            draggable: markerDirective.draggable,
            icon: markerDirective.iconUrl,
            opacity: markerDirective.opacity,
            visible: markerDirective.visible,
            title: markerDirective.title
        });
        this.markers.set(markerDirective, markerPromise);
    };
    MarkerService.prototype.deleteMarker = function (marker) {
        var _this = this;
        var m = this.markers.get(marker);
        if (m == null) {
            return Promise.resolve();
        }
        return m.then(function (m) {
            return _this._zone.run(function () {
                m.setMap(null);
                _this.markers.delete(marker);
            });
        });
    };
    MarkerService.prototype.updatePosition = function (marker) {
        return this.markers.get(marker).then(function (m) { return m.setPosition({ lat: marker.latitude, lng: marker.longitude }); });
    };
    MarkerService.prototype.updateVisible = function (marker) {
        return this.markers.get(marker).then(function (m) { return m.setVisible(marker.visible); });
    };
    MarkerService.prototype.updateTitle = function (marker) {
        return this.markers.get(marker).then(function (m) { return m.setTitle(marker.title); });
    };
    MarkerService.prototype.updateLabel = function (marker) {
        return this.markers.get(marker).then(function (m) { m.setLabel(marker.label); });
    };
    MarkerService.prototype.updateDraggable = function (marker) {
        return this.markers.get(marker).then(function (m) { return m.setDraggable(marker.draggable); });
    };
    MarkerService.prototype.updateIcon = function (marker) {
        return this.markers.get(marker).then(function (m) { return m.setIcon(marker.iconUrl); });
    };
    MarkerService.prototype.updateOpacity = function (marker) {
        return this.markers.get(marker).then(function (m) { return m.setOpacity(marker.opacity); });
    };
    MarkerService.prototype.getNativeMarker = function (marker) {
        return this.markers.get(marker);
    };
    MarkerService.prototype.createEventObservable = function (eventName, marker) {
        var _this = this;
        return Observable.create(function (observer) {
            _this.markers.get(marker).then(function (m) {
                m.addListener(eventName, function (e) { return _this._zone.run(function () { return observer.next(e); }); });
            });
        });
    };
    MarkerService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [MapService, NgZone])
    ], MarkerService);
    return MarkerService;
}());
export { MarkerService };
