import { NgZone } from '@angular/core';
import { PolygonDirective } from '../directives/polygon.directive';
import { MapService } from './map.service';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/toPromise';
import * as Google from '../models/google-maps-types';
export declare class PolygonService {
    private mapService;
    private _zone;
    private polygons;
    constructor(mapService: MapService, _zone: NgZone);
    addPolygon(polygonDirective: PolygonDirective, polygon?: Google.Polygon): void;
    updatePolygon(polygon: PolygonDirective): Promise<void>;
    updateClickable(polygon: PolygonDirective): Promise<void>;
    updateVisible(polygon: PolygonDirective): Promise<void>;
    updateEditable(polygon: PolygonDirective): Promise<void>;
    updateFillColor(polygon: PolygonDirective): Promise<void>;
    updateFillOpacity(polygon: PolygonDirective): Promise<void>;
    updateStrokeColor(polygon: PolygonDirective): Promise<void>;
    updateStrokeOpacity(polygon: PolygonDirective): Promise<void>;
    updateStrokeWeight(polygon: PolygonDirective): Promise<void>;
    updateDraggable(polygon: PolygonDirective): Promise<void>;
    setPolygonOptions(polygon: PolygonDirective, options: {
        [propName: string]: any;
    }): Promise<void>;
    getPath(polygon: PolygonDirective): Promise<Google.LatLng[]>;
    deletePolygon(polygon: PolygonDirective): Promise<void>;
    createEventObservable<T>(eventName: string, polygon: PolygonDirective): Observable<T>;
    createPathEventObservable(polygon: PolygonDirective): Observable<Array<Google.LatLng>>;
}
