var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogEditor } from '../../editors';
//Features
import { OperadorService } from '../services/operador.service';
import { OperadorInfo } from '../models/operador';
var OperadoresEditor = /** @class */ (function (_super) {
    __extends(OperadoresEditor, _super);
    //
    function OperadoresEditor(router, route, formBuilder, changeDetector, context, location, operadorService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.operadorService = operadorService;
        _this.operador = new OperadorInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'correo': [''],
            'celular': [''],
            'direccionIP': ['']
        });
        return _this;
    }
    OperadoresEditor_1 = OperadoresEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    OperadoresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    OperadoresEditor.prototype.onCreatingItem = function () {
    };
    OperadoresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.operadorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.operador = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OperadoresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.operadorService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.operador = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OperadoresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.operadorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.operador = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    OperadoresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.operadorService.update(this.operador)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.operador = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var OperadoresEditor_1;
    OperadoresEditor = OperadoresEditor_1 = __decorate([
        Component({
            selector: 'notification-operadores-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Operador'\"\n                                 [info]=\"operador\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"operador.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"operador.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n                        \t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <azteca-form-field [label]=\"'Correo:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"operador.correo\"></az-textbox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Celular:'\">\n                                          <az-textbox formControlName=\"celular\" [(ngModel)]=\"operador.celular\"></az-textbox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Direcci\u00F3n IP:'\">\n                                          <az-textbox formControlName=\"direccionIP\" [(ngModel)]=\"operador.direccionIP\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                         </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return OperadoresEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: OperadorService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, OperadorService])
    ], OperadoresEditor);
    return OperadoresEditor;
}(CatalogEditor));
export { OperadoresEditor };
