var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogEditor } from '../../editors/index';
//Features
import { RemitenteMailService } from '../services/remitente-mail.service';
import { RemitenteMailInfo } from '../models/remitente-mail';
var RemitentesMailEditor = /** @class */ (function (_super) {
    __extends(RemitentesMailEditor, _super);
    //
    function RemitentesMailEditor(router, route, formBuilder, changeDetector, context, location, remitenteMailService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.remitenteMailService = remitenteMailService;
        _this.remitentemail = new RemitenteMailInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'email': ['', Validators.required],
            'user': ['', Validators.required],
            'pwd': ['', Validators.required],
            'sample_field': ['']
        });
        return _this;
    }
    RemitentesMailEditor_1 = RemitentesMailEditor;
    RemitentesMailEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idServidorSMTP = +params['idServidorSMTP'];
        });
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    RemitentesMailEditor.prototype.onCreatingItem = function () {
        //Asignar y cargar datos de la empresa que dependerá la sucursal
        this.remitentemail.idServidorSMTP = this.idServidorSMTP;
    };
    RemitentesMailEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.remitenteMailService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.remitentemail = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RemitentesMailEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.remitenteMailService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.remitentemail = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RemitentesMailEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.remitenteMailService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.remitentemail = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RemitentesMailEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.remitentemail.idServidorSMTP = this.idServidorSMTP;
        this.remitenteMailService.update(this.remitentemail)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.remitentemail = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RemitentesMailEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    var RemitentesMailEditor_1;
    RemitentesMailEditor = RemitentesMailEditor_1 = __decorate([
        Component({
            selector: 'notification-remitentes-mail-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Remitente de correo'\"\n                                 [info]=\"remitentemail\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-xs-10 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"remitentemail.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"remitentemail.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-xs-10 col-md-10\">\n                      <azteca-form-field [label]=\"'Direcci\u00F3n de correo:'\">\n                          <az-textbox formControlName=\"email\" [(ngModel)]=\"remitentemail.mailAddress\"></az-textbox>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Usuario:'\">\n                          <az-textbox formControlName=\"user\" [(ngModel)]=\"remitentemail.userName\"></az-textbox>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Contrase\u00F1a:'\">\n                          <az-textbox formControlName=\"pwd\" [(ngModel)]=\"remitentemail.password\"></az-textbox>\n                      </azteca-form-field>\n\n                      <az-checkbox [label]=\"'Omitir autentificaci\u00F3n SMPT:'\" formControlName=\"sample_field\" [(ngModel)]=\"remitentemail.overrideSMTPAuth\"></az-checkbox>\n\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return RemitentesMailEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: RemitenteMailService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, RemitenteMailService])
    ], RemitentesMailEditor);
    return RemitentesMailEditor;
}(CatalogEditor));
export { RemitentesMailEditor };
