var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, Input } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { CatalogManager } from '../../editors';
//Features
import { RemitenteMailService } from '../services/remitente-mail.service';
var RemitentesMailManager = /** @class */ (function (_super) {
    __extends(RemitentesMailManager, _super);
    //    
    function RemitentesMailManager(router, route, context, remitenteMailService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.remitenteMailService = remitenteMailService;
        _this.remitentes = [];
        return _this;
    }
    RemitentesMailManager_1 = RemitentesMailManager;
    RemitentesMailManager.prototype.onConfigureCatalog = function (options) {
    };
    RemitentesMailManager.prototype.doSearch = function (request) {
    };
    RemitentesMailManager.prototype.onAddingItem = function () {
        this.router.navigate(['kernel/notification/remitentes-mail', this.process.id, this.idServidorSMTP, 0]);
    };
    RemitentesMailManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['kernel/notification/remitentes-mail', this.process.id, this.idServidorSMTP, item.id]);
    };
    RemitentesMailManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    RemitentesMailManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.remitenteMailService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RemitentesMailManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    RemitentesMailManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.remitenteMailService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var RemitentesMailManager_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], RemitentesMailManager.prototype, "remitentes", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], RemitentesMailManager.prototype, "idServidorSMTP", void 0);
    RemitentesMailManager = RemitentesMailManager_1 = __decorate([
        Component({
            selector: 'notification-remitentes-mail-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"remitentes\"\n                              [totalRows]=\"totalRows\"\n                              [pageSize]=\"10\"\n                              [standAlone]=\"false\"\n                              [serverSide]=\"false\">\n\n    \n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Email'\" [binding]=\"'mailAddress'\" [width]=\"'60*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return RemitentesMailManager_1; })
                },
                {
                    provide: CatalogService, useExisting: RemitenteMailService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, Context, RemitenteMailService])
    ], RemitentesMailManager);
    return RemitentesMailManager;
}(CatalogManager));
export { RemitentesMailManager };
