import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom/index';
import { CatalogEditor, EditorEventArgs } from '../../editors/index';
import { Clasificacion } from '../../general/models/clasificacion';
import { ServidorSMTPService } from '../services/servidor-smtp.service';
import { ServidorSMTPInfo } from '../models/servidor-smtp';
import { RemitenteMailItem } from '../models/remitente-mail';
import { RemitenteMailService } from '../services/remitente-mail.service';
import { RemitentesMailManager } from './remitentes-mail.manager';
export declare class ServidoresSMTPEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private servidorSMTPService;
    private remitenteMailService;
    servidorsmtp: ServidorSMTPInfo;
    metodosAutentificacion: {
        id: string;
        nombre: string;
    }[];
    clasificadores: Clasificacion[];
    remitentes: RemitenteMailItem[];
    siteManager: RemitentesMailManager;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, servidorSMTPService: ServidorSMTPService, remitenteMailService: RemitenteMailService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    selectTab(args: any): void;
    loadRemitentes(): void;
    loadClasificadores(): void;
}
