var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, ViewChild, Input, forwardRef, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
import { Control } from 'wijmo/wijmo';
//Azteca Kernel
import { Context, BaseComponent, CatalogService } from '../../core';
import { AztecaValidators } from '../../controls/index';
import { CatalogEditor } from '../../editors/index';
import { SearchRequest } from '../../search/index';
//Features
import { ServidorSMTPService } from '../services/servidor-smtp.service';
import { ServidorSMTPInfo } from '../models/servidor-smtp';
import { RemitenteMailService } from '../services/remitente-mail.service';
import { RemitentesMailManager } from './remitentes-mail.manager';
var ServidoresSMTPEditor = /** @class */ (function (_super) {
    __extends(ServidoresSMTPEditor, _super);
    //
    function ServidoresSMTPEditor(router, route, formBuilder, changeDetector, context, location, servidorSMTPService, remitenteMailService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.servidorSMTPService = servidorSMTPService;
        _this.remitenteMailService = remitenteMailService;
        _this.servidorsmtp = new ServidorSMTPInfo();
        _this.metodosAutentificacion = [];
        _this.clasificadores = [];
        _this.remitentes = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required],
            'hostName': ['', Validators.required],
            'port': [''],
            'userName': [''],
            'password': [''],
            'authMethod': [''],
            'clasificaciones': [[], AztecaValidators.validClasifications]
        });
        _this.metodosAutentificacion =
            [
                { "id": "N", "nombre": "Ninguna" },
                { "id": "P", "nombre": "Contraseña Normal" },
                { "id": "A", "nombre": "Avanzado" }
            ];
        return _this;
    }
    ServidoresSMTPEditor_1 = ServidoresSMTPEditor;
    ServidoresSMTPEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    ServidoresSMTPEditor.prototype.onCreatingItem = function () {
        var _this = this;
        this.servidorSMTPService.create()
            .then(function (servidor) {
            _this.servidorsmtp = servidor;
            _this.loadClasificadores();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServidoresSMTPEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.servidorSMTPService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servidorsmtp = info;
            _this.setReadonlyMode();
            _this.loadRemitentes();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServidoresSMTPEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.servidorSMTPService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servidorsmtp = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServidoresSMTPEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.servidorSMTPService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servidorsmtp = info;
            _this.loadRemitentes();
            _this.loadClasificadores();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServidoresSMTPEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.servidorSMTPService.update(this.servidorsmtp)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servidorsmtp = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServidoresSMTPEditor.prototype.selectTab = function (args) {
        if (args.heading) {
            Control.invalidateAll();
        }
    };
    ServidoresSMTPEditor.prototype.loadRemitentes = function () {
        var _this = this;
        var request = new SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicionServidorSMTP = { field: "idServidorSMTP", operator: "=", valueType: "int", value: this.servidorsmtp.identity.toString() };
        request.conditions.push(condicionServidorSMTP);
        //
        this.context.app.showSpinner();
        this.remitenteMailService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.remitentes = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServidoresSMTPEditor.prototype.loadClasificadores = function () {
        var _this = this;
        this.servidorSMTPService.loadClassifiers(this.servidorsmtp.identity)
            .then(function (clasificadores) { return _this.clasificadores = clasificadores; })
            .catch(function (error) { return _this.handleError(error); });
    };
    var ServidoresSMTPEditor_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ServidoresSMTPEditor.prototype, "remitentes", void 0);
    __decorate([
        ViewChild(RemitentesMailManager),
        __metadata("design:type", RemitentesMailManager)
    ], ServidoresSMTPEditor.prototype, "siteManager", void 0);
    ServidoresSMTPEditor = ServidoresSMTPEditor_1 = __decorate([
        Component({
            selector: 'notification-servidores-smtp-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Servidor SMTP'\"\n                                 [info]=\"servidorsmtp\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n         \n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'REMITENTES'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Remitentes'\" [smallText]=\"'editar remitentes de correo'\"></azteca-menu-item>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"servidorsmtp.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"servidorsmtp.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Nombre del host:'\">\n                                          <az-textbox formControlName=\"hostName\" [(ngModel)]=\"servidorsmtp.hostName\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Puerto:'\">\n                                          <az-textbox formControlName=\"port\" [(ngModel)]=\"servidorsmtp.port\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Nombre del Usuario:'\">\n                                          <az-textbox formControlName=\"userName\" [(ngModel)]=\"servidorsmtp.userName\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Contrase\u00F1a:'\">\n                                          <az-textbox formControlName=\"password\" [(ngModel)]=\"servidorsmtp.password\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Metodo de autentificaci\u00F3n:'\">\n                                          <az-combobox formControlName=\"authMethod\" [(ngModel)]=\"servidorsmtp.authMethod\" [items]=\"metodosAutentificacion\" [displayMember]=\"'nombre'\" [valueMember]=\"'id'\"></az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Remitentes\" [disabled]=\"servidorsmtp.identity == 0\" (select)=\"selectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <notification-remitentes-mail-manager \n                                                                       [name]=\"'remitentes'\"\n                                                                       [remitentes]=\"remitentes\"\n                                                                       [idServidorSMTP]=\"servidorsmtp.identity\">\n                                      </notification-remitentes-mail-manager>\n                                  </div>\n                              </div>\n                          </tab>\n                          <tab heading=\"Clasificaciones\" (select)=\"selectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <az-clasificaciones-editor formControlName=\"clasificaciones\" [(ngModel)]=\"servidorsmtp.clasificaciones\" [clasificadores]=\"clasificadores\">\n\n                                      </az-clasificaciones-editor>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return ServidoresSMTPEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: ServidorSMTPService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, FormBuilder, ChangeDetectorRef,
            Context, Location, ServidorSMTPService, RemitenteMailService])
    ], ServidoresSMTPEditor);
    return ServidoresSMTPEditor;
}(CatalogEditor));
export { ServidoresSMTPEditor };
