var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos
import { NotificationRoutingModule } from './notification.routing.module';
import { UtilsModule } from '../utils/utils.module';
import { SearchModule } from '../search/search.module';
import { ControlsModule } from '../controls/controls.module';
import { EditorsModule } from '../editors/editors.module';
import { GeneralModule } from '../general/general.module';
//Bootstrap
import { AlertModule, TabsModule, ModalModule } from 'ngx-bootstrap';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Controls
import { RemitenteMailSelectorComponent } from './controls/remitente-mail-selector.component';
import { OperadorSelectorComponent } from './controls/operador-selector.component';
//Components
import { ServidoresSMTPEditor } from './catalogs/servidores-smtp.editor';
import { ServidoresSMTPManager } from './catalogs/servidores-smtp.manager';
import { RemitentesMailEditor } from './catalogs/remitentes-mail.editor';
import { RemitentesMailManager } from './catalogs/remitentes-mail.manager';
import { OperadoresEditor } from './catalogs/operadores.editor';
import { OperadoresManager } from './catalogs/operadores.manager';
//Services
import { ServidorSMTPService } from './services/servidor-smtp.service';
import { RemitenteMailService } from './services/remitente-mail.service';
import { OperadorService } from './services/operador.service';
import { MessageSourceService } from './services/message-source.service';
import { MessageService } from './services/message.service';
var COMPONENTS = [ServidoresSMTPEditor, ServidoresSMTPManager, RemitentesMailEditor, RemitentesMailManager, RemitenteMailSelectorComponent,
    OperadoresManager, OperadoresEditor, OperadorSelectorComponent];
var SERVICES = [ServidorSMTPService, RemitenteMailService, OperadorService, MessageService, MessageSourceService];
var NotificationModule = /** @class */ (function () {
    function NotificationModule() {
    }
    NotificationModule = __decorate([
        NgModule({
            imports: [
                FormsModule, ReactiveFormsModule, CommonModule,
                WjInputModule, WjGridModule, WjGridModule, WjGridFilterModule, EditorsModule,
                AlertModule, ModalModule,
                UtilsModule, SearchModule, ControlsModule, NotificationRoutingModule, GeneralModule,
                TabsModule.forRoot()
            ],
            declarations: COMPONENTS,
            providers: SERVICES,
            exports: COMPONENTS
        })
    ], NotificationModule);
    return NotificationModule;
}());
export { NotificationModule };
