var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams } from '@angular/common/http';
import { Context } from '../../core/services/context';
var PrinterService = /** @class */ (function () {
    function PrinterService(context, http) {
        this.context = context;
        this.http = http;
        this.printerServerUrl = 'http://localhost:8091/print-server';
    }
    PrinterService.prototype.printPdfFile = function (fileUri, printerName) {
        var headers = new HttpHeaders();
        //Headers
        headers.append('Accept', 'q=0.8;application/text;q=0.9');
        //Parametros
        var params = new HttpParams()
            .set('contentType', 'url')
            .set('fileExtension', 'pdf');
        //
        if (printerName) {
            params = params.set('printerName', printerName);
        }
        //
        return this.http.post(this.printerServerUrl, fileUri, { headers: headers, params: params })
            .toPromise();
    };
    PrinterService.prototype.printPdf = function (pdfContent, printerName) {
        var headers = new HttpHeaders();
        //Headers
        headers.append('Accept', 'q=0.8;application/text;q=0.9');
        //Parametros
        var params = new HttpParams()
            .set('contentType', 'base64')
            .set('fileExtension', 'pdf');
        //
        if (printerName) {
            params = params.set('printerName', printerName);
        }
        //
        return this.http.post(this.printerServerUrl, pdfContent, { headers: headers, params: params })
            .toPromise();
    };
    PrinterService.prototype.printText = function (text, printerName) {
        var headers = new HttpHeaders();
        //Headers
        headers.append('Accept', 'q=0.8;application/text;q=0.9');
        //Parametros
        var params = new HttpParams()
            .set('contentType', 'text')
            .set('fileExtension', 'txt');
        //
        if (printerName) {
            params = params.set('printerName', printerName);
        }
        //
        return this.http.post(this.printerServerUrl, text, { headers: headers, params: params })
            .toPromise();
    };
    PrinterService.prototype.printTextFile = function (fileUri, printerName) {
        var headers = new HttpHeaders();
        //Headers
        headers.append('Accept', 'q=0.8;application/text;q=0.9');
        //Parametros
        var params = new HttpParams()
            .set('contentType', 'url')
            .set('fileExtension', 'txt');
        //
        if (printerName) {
            params = params.set('printerName', printerName);
        }
        //
        return this.http.post(this.printerServerUrl, fileUri, { headers: headers, params: params })
            .toPromise();
    };
    PrinterService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Context, HttpClient])
    ], PrinterService);
    return PrinterService;
}());
export { PrinterService };
