import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, EnsambladoService, EnsambladoItem } from '../../core';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { CatalogOptions } from '../../custom';
import { JobSourceService } from '../services/job-source.service';
import { JobSourceInfo } from '../models/job-source';
export declare class JobOrigenesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private jobSourceService;
    private ensambladoService;
    jobSource: JobSourceInfo;
    ensamblados: EnsambladoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, jobSourceService: JobSourceService, ensambladoService: EnsambladoService);
    loadEnsamblados(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
}
