import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { ScheduleService } from '../services/schedule.service';
import { ScheduleInfo } from '../models/schedule';
export declare class SchedulesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private scheduleService;
    schedule: ScheduleInfo;
    frecuencias: {
        'name': string;
        'value': string;
    }[];
    ocurrencias: {
        "id": boolean;
        "nombre": string;
    }[];
    ocurrenciaMes: string;
    ocurrenciasMes: {
        "id": string;
        "nombre": string;
    }[];
    periodoMes: string;
    periodosMes: {
        "id": string;
        "nombre": string;
    }[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, scheduleService: ScheduleService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
}
