import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { ScheduleService } from '../services/schedule.service';
import { ScheduleItem } from '../models/schedule';
import { MenuItem } from '../../controls/models/menu-item';
export declare class SchedulesManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private scheduleService;
    schedules: ScheduleItem[];
    currentItem: CatalogItem;
    constructor(context: Context, router: Router, route: ActivatedRoute, scheduleService: ScheduleService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onCurrenItemChanged(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
}
