var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos
import { QueueRoutingModule } from './queue.routing.module';
import { UtilsModule } from '../utils/utils.module';
import { SearchModule } from '../search/search.module';
import { ControlsModule } from '../controls/controls.module';
import { GeneralModule } from '../general/general.module';
import { EditorsModule } from '../editors/editors.module';
//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//////////////////////////// COMPONENTS ///////////////////////////
import { JobOrigenesManager } from './components/job-origenes.manager';
import { JobOrigenesEditor } from './components/job-origenes.editor';
import { JobQueueComponent } from './components/job-queue.component';
import { SchedulesManager } from './components/schedules.manager';
import { SchedulesEditor } from './components/schedules.editor';
//////////////////////////// SERVICES ///////////////////////////
import { JobSourceService } from './services/job-source.service';
import { ScheduleService } from './services/schedule.service';
import { JobService } from './services/job.service';
import { AsyncTaskService } from './services/async-task.service';
var COMPONENTES = [JobOrigenesManager, JobOrigenesEditor, JobQueueComponent, SchedulesManager, SchedulesEditor];
var SERVICIOS = [JobSourceService, ScheduleService, JobService, AsyncTaskService, ScheduleService];
var QueueModule = /** @class */ (function () {
    function QueueModule() {
    }
    QueueModule = __decorate([
        NgModule({
            imports: [
                FormsModule, ReactiveFormsModule, CommonModule,
                TabsModule.forRoot(), ModalModule.forRoot(),
                QueueRoutingModule, UtilsModule, SearchModule, EditorsModule, ControlsModule, GeneralModule,
                WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule
            ],
            declarations: COMPONENTES,
            providers: SERVICIOS,
            exports: COMPONENTES
        })
    ], QueueModule);
    return QueueModule;
}());
export { QueueModule };
