var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
//////////////////////////// GUARDS ///////////////////////////
import { EditorDeactivateGuard } from '../editors/index';
import { AuthGuard } from '../core/services/auth-guard.service';
//////////////////////////// COMPONENTS ///////////////////////////
import { JobOrigenesManager } from './components/job-origenes.manager';
import { JobOrigenesEditor } from './components/job-origenes.editor';
import { JobQueueComponent } from './components/job-queue.component';
import { SchedulesManager } from './components/schedules.manager';
import { SchedulesEditor } from './components/schedules.editor';
var routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'job-sources/:proceso', component: JobOrigenesManager },
            { path: 'job-sources/:proceso/:id', component: JobOrigenesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'job-sources/:proceso/:id/jobs', component: JobQueueComponent },
            { path: 'schedules/:proceso', component: SchedulesManager },
            { path: 'schedules/:proceso/:id', component: SchedulesEditor }
        ]
    },
];
var QueueRoutingModule = /** @class */ (function () {
    function QueueRoutingModule() {
    }
    QueueRoutingModule = __decorate([
        NgModule({
            imports: [
                RouterModule.forChild(routes)
            ],
            exports: [
                RouterModule
            ]
        })
    ], QueueRoutingModule);
    return QueueRoutingModule;
}());
export { QueueRoutingModule };
