var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
//
import { Context } from '../../core/services/context';
import { BaseService } from '../../core/services/base-service';
import { Observable } from 'rxjs';
var AsyncTaskService = /** @class */ (function (_super) {
    __extends(AsyncTaskService, _super);
    function AsyncTaskService(http, context) {
        var _this = _super.call(this, http, context, 'api/kernel/queue/async') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    AsyncTaskService.prototype.isEjecutando = function (idAsyncTask) {
        var params = new HttpParams()
            .set('idAsyncTask', idAsyncTask.toString());
        return this.apiService.get('is-ejecutando', params).toPromise();
    };
    AsyncTaskService.prototype.getDetail = function (idAsyncTask) {
        var params = new HttpParams()
            .set('idAsyncTask', idAsyncTask.toString());
        return this.apiService.get('get-detail', params).toPromise();
    };
    AsyncTaskService.prototype.subscribeTask = function (idAsyncTask) {
        var self = this;
        return Observable.create(function (observer) {
            var interval = setInterval(function () {
                self.isEjecutando(idAsyncTask).then(function (result) {
                    if (!result) {
                        clearInterval(interval);
                        self.getDetail(idAsyncTask).then(function (info) {
                            observer.next(info);
                            observer.complete();
                        }).catch(function (error) { return observer.error(error); });
                    }
                }).catch(function (error) {
                    observer.error(error);
                    clearInterval(interval);
                });
            }, 5000);
        });
    };
    AsyncTaskService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], AsyncTaskService);
    return AsyncTaskService;
}(BaseService));
export { AsyncTaskService };
