var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import * as moment from 'moment';
//Azteca Kernel
import { Context, CatalogService } from '../../core';
//Locales
import { JobSourceInfo } from '../models/job-source';
var JobSourceService = /** @class */ (function (_super) {
    __extends(JobSourceService, _super);
    function JobSourceService(http, context) {
        return _super.call(this, http, context, 'api/kernel/queue/job-sources') || this;
    }
    JobSourceService.prototype.create = function () {
        return Promise.resolve(new JobSourceInfo());
    };
    JobSourceService.prototype.loadJobListByTag = function (sourceTag, fechaInicial, fechaFinal) {
        var params = new HttpParams()
            .set('sourceTag', sourceTag)
            .set('fechaInicial', moment(fechaInicial).format())
            .set('fechaFinal', moment(fechaFinal).format());
        //
        return this.apiService.get('job-list-tag', params)
            .toPromise();
    };
    JobSourceService.prototype.loadJobListByID = function (idJobOrigen, fechaInicial, fechaFinal) {
        var params = new HttpParams()
            .set('idJobOrigen', idJobOrigen.toString())
            .set('fechaInicial', moment(fechaInicial).format())
            .set('fechaFinal', moment(fechaFinal).format());
        //
        return this.apiService.get('job-list-id', params)
            .toPromise();
    };
    JobSourceService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], JobSourceService);
    return JobSourceService;
}(CatalogService));
export { JobSourceService };
