var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
//
var AutocompleteCellComponent = /** @class */ (function () {
    function AutocompleteCellComponent() {
        this.selectedValue = 0;
        this.maxItems = 20;
        this.minLength = 2;
        this.displayMember = 'nombre';
        this.valueMember = 'id';
        //
        this.selectedItemChanged = new EventEmitter();
    }
    //
    AutocompleteCellComponent.prototype.onSelectedIndexChanged = function (autocomplete, args) {
        if (autocomplete.selectedItem) {
            this.selectedValue = autocomplete.selectedValue;
        }
        else {
            this.selectedValue = 0;
        }
        this.selectedItemChanged.emit(autocomplete.selectedItem);
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AutocompleteCellComponent.prototype, "cell", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AutocompleteCellComponent.prototype, "maxItems", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AutocompleteCellComponent.prototype, "minLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AutocompleteCellComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AutocompleteCellComponent.prototype, "valueMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], AutocompleteCellComponent.prototype, "itemsSourceHandler", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AutocompleteCellComponent.prototype, "selectedItemChanged", void 0);
    AutocompleteCellComponent = __decorate([
        Component({
            selector: 'azteca-autocomplete-cell',
            template: "\n      <wj-auto-complete \n                          #autocomplete\n                          style=\"width:100%\"                  \n                          [placeholder]=\"'Introduzca b\u00FAsqueda...'\"\n                          [maxItems]=\"maxItems\"\n                          [minLength]=\"minLength\"\n                          [displayMemberPath]=\"displayMember\"\n                          [selectedValuePath]=\"valueMember\"\n                          [itemsSourceFunction]=\"itemsSourceHandler\"\n                          [showDropDownButton]=\"false\"                  \n                          (selectedIndexChanged)=\"onSelectedIndexChanged(autocomplete, $event)\">\n      </wj-auto-complete>\n    "
        })
    ], AutocompleteCellComponent);
    return AutocompleteCellComponent;
}());
export { AutocompleteCellComponent };
