var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
//
import { Context } from '../../core/services/context';
var CatalogAutocompleteComponent = /** @class */ (function () {
    //
    function CatalogAutocompleteComponent(context) {
        this.context = context;
        this.enabled = true;
        this.visible = true;
        this.value = '';
        this.valueMember = 'nombre';
        //    
        this.valueChange = new EventEmitter();
    }
    CatalogAutocompleteComponent.prototype.onTextChanged = function (args) {
        this.valueChange.emit(args.target.value);
    };
    CatalogAutocompleteComponent.prototype.typeaheadOnSelect = function (args) {
        var value = args.item[this.valueMember];
        this.valueChange.emit(value);
    };
    CatalogAutocompleteComponent.prototype.changeTypeaheadLoading = function (loading) {
    };
    CatalogAutocompleteComponent.prototype.changeTypeaheadNoResults = function (noResults) {
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogAutocompleteComponent.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogAutocompleteComponent.prototype, "visible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CatalogAutocompleteComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Observable)
    ], CatalogAutocompleteComponent.prototype, "dataSource", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CatalogAutocompleteComponent.prototype, "valueMember", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], CatalogAutocompleteComponent.prototype, "valueChange", void 0);
    CatalogAutocompleteComponent = __decorate([
        Component({
            selector: 'azteca-catalog-autocomplete',
            template: "\n      <input type=\"text\" class=\"form-control\" [(ngModel)]=\"value\" [disabled]=\"!enabled\" (keyup)=\"onTextChanged($event)\"\n             [typeahead]=\"dataSource\"\n             (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n             (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n             (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n             typeaheadOptionsLimit=\"20\"\n             [typeaheadOptionField]=\"valueMember\"\n             typeaheadMinLength=\"2\"\n             typeaheadWaitMs=\"500\" />\n    "
        }),
        __metadata("design:paramtypes", [Context])
    ], CatalogAutocompleteComponent);
    return CatalogAutocompleteComponent;
}());
export { CatalogAutocompleteComponent };
