import { EventEmitter, QueryList, SimpleChanges } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { CatalogItem } from '../../core/models/catalog';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
export declare class CatalogListDialogComponent {
    selectedItems: CatalogItem[];
    selectedItem: CatalogItem;
    list: CatalogItem[];
    catalogList: CatalogItem[];
    serverSide: boolean;
    pageIndex: number;
    pageSize: number;
    totalRows: number;
    multiSelect: boolean;
    excludedItems: CatalogItem[];
    title: string;
    searchRequested: EventEmitter<SearchRequest>;
    selectedItemChanged: EventEmitter<CatalogItem>;
    selectedItemsChanged: EventEmitter<CatalogItem[]>;
    listDialog: ModalDirective;
    columns: QueryList<GridColumn>;
    constructor();
    ngOnChanges(changes: SimpleChanges): void;
    private updateSelected;
    private onSearchRequested;
    private onCurrentItemChanged;
    private onItemSelected;
    onItemCheckedChanged(item: CatalogItem): void;
    private onConfirmClick;
    private onCancelClick;
    triggerSearch(): void;
    show(): void;
    isValid(): boolean;
    refreshControls(): void;
}
