import { EventEmitter, QueryList } from '@angular/core';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs } from 'wijmo/wijmo.grid';
import { FlexGridFilter } from 'wijmo/wijmo.grid.filter';
import { Menu } from 'wijmo/wijmo.input';
import { CatalogItem } from '../../core/models/catalog';
import { SearchRequest } from '../models/search-request';
import { GridColumn } from '../../controls/directives/grid-column';
import { MenuItem } from '../../controls/models/menu-item';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
export declare class CatalogListComponent {
    private _emptyFilter;
    private _catalogList;
    private _currentFilter;
    private _currentSortedColumn;
    private _currentSortOrder;
    private _pageSize;
    private _serverSide;
    currentItem: CatalogItem;
    catalogView: CollectionView;
    readonly pageCount: number;
    columns: QueryList<GridColumn>;
    filter: FlexGridFilter;
    grid: FlexGrid;
    smallGrid: FlexGrid;
    contextMenu: Menu;
    contextMenuItems: QueryList<MenuItemDirective>;
    enabled: boolean;
    catalogList: CatalogItem[];
    showSelectColumn: boolean;
    showStatusColumn: boolean;
    showRowButton: boolean;
    rowButtonIcon: string;
    pageIndex: number;
    pageSize: number;
    serverSide: boolean;
    totalRows: number;
    searchRequested: EventEmitter<SearchRequest>;
    contextMenuClick: EventEmitter<MenuItem>;
    currentItemChanged: EventEmitter<CatalogItem>;
    itemSelected: EventEmitter<CatalogItem>;
    contextMenuOpen: EventEmitter<CatalogItem>;
    rowButtonClick: EventEmitter<any>;
    itemCheckedChanged: EventEmitter<CatalogItem>;
    private setFilterType;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    initialized(sender: FlexGrid, args: any): void;
    setDefaultFilterOperator(): void;
    moveFirst(): void;
    movePrevious(): void;
    moveNext(): void;
    moveLast(): void;
    getStatusColor(activo: boolean): string;
    filterChanged(e: any, args: any): void;
    sortChanged(sender: FlexGrid, args: CellRangeEventArgs): void;
    createSearchRequest(pageIndex: number): SearchRequest;
    menuItemClicked(menu: Menu, args: any): void;
    onRowButtonClick(row: any): void;
    onCellUpdated(args: CellRangeEventArgs): void;
    refreshCurrenItem(): void;
}
