import { EventEmitter, QueryList, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { TypeaheadMatch } from 'ngx-bootstrap';
import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
import { Context } from '../../core/services/context';
import { CatalogInfo, CatalogItem } from '../../core/models/catalog';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
export declare class CatalogSelectorComponent {
    private context;
    private modalService;
    selectedRow: CatalogItem;
    modalRef: BsModalRef;
    enabled: boolean;
    visible: boolean;
    selectedItem: CatalogInfo;
    displayValue: string;
    catalogList: CatalogItem[];
    serverSide: boolean;
    pageIndex: number;
    pageSize: number;
    totalRows: number;
    dialogTitle: string;
    dataSource: Observable<any>;
    displayMember: string;
    showListButton: boolean;
    searchRequested: EventEmitter<SearchRequest>;
    selectedItemChanged: EventEmitter<CatalogItem>;
    keywordSearch: EventEmitter<string>;
    listDialog: TemplateRef<any>;
    columns: QueryList<GridColumn>;
    config: {
        backdrop: boolean;
        class: string;
    };
    constructor(context: Context, modalService: BsModalService);
    showListDialog(): void;
    hideListDialog(): void;
    searchRequestedHandler(request: SearchRequest): void;
    currentItemChangedHandler(item: CatalogItem): void;
    selectItem(item: CatalogItem): void;
    clear(): void;
    onTextChanged(args: any): void;
    typeaheadOnSelect(args: TypeaheadMatch): void;
    changeTypeaheadLoading(loading: boolean): void;
    changeTypeaheadNoResults(noResults: boolean): void;
    refreshControls(): void;
}
