var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, ViewChild, ContentChildren, EventEmitter, QueryList, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import * as wijmo from 'wijmo/wijmo';
import { BsModalService } from 'ngx-bootstrap/modal';
//
import { Context } from '../../core/services/context';
import { CatalogInfo } from '../../core/models/catalog';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
var CatalogSelectorComponent = /** @class */ (function () {
    function CatalogSelectorComponent(context, modalService) {
        this.context = context;
        this.modalService = modalService;
        this.selectedRow = null;
        //
        this.enabled = true;
        this.visible = true;
        this.selectedItem = null;
        this.displayValue = "";
        this.dialogTitle = "Lista del catálogo";
        this.displayMember = 'nombre';
        this.showListButton = true;
        //
        this.searchRequested = new EventEmitter();
        this.selectedItemChanged = new EventEmitter();
        this.keywordSearch = new EventEmitter();
        this.config = {
            backdrop: false,
            class: 'gray modal-lg'
        };
    }
    CatalogSelectorComponent.prototype.showListDialog = function () {
        this.modalRef = this.modalService.show(this.listDialog, this.config);
        this.refreshControls();
        var request = new SearchRequest();
        request.pageIndex = 0;
        request.pageSize = this.pageSize;
        request.paged = this.serverSide ? true : false;
        //
        this.searchRequested.emit(request);
    };
    CatalogSelectorComponent.prototype.hideListDialog = function () {
        this.modalRef.hide();
    };
    CatalogSelectorComponent.prototype.searchRequestedHandler = function (request) {
        //Redireccionar request a componente padre
        this.searchRequested.emit(request);
    };
    CatalogSelectorComponent.prototype.currentItemChangedHandler = function (item) {
        this.selectedRow = item;
    };
    CatalogSelectorComponent.prototype.selectItem = function (item) {
        this.selectedItemChanged.emit(item);
        this.hideListDialog();
    };
    CatalogSelectorComponent.prototype.clear = function () {
        this.selectedItemChanged.emit(null);
    };
    CatalogSelectorComponent.prototype.onTextChanged = function (args) {
        if (args.which !== 0) {
            this.keywordSearch.emit(args.target.value);
        }
    };
    CatalogSelectorComponent.prototype.typeaheadOnSelect = function (args) {
        this.selectedItemChanged.emit(args.item);
    };
    CatalogSelectorComponent.prototype.changeTypeaheadLoading = function (loading) {
    };
    CatalogSelectorComponent.prototype.changeTypeaheadNoResults = function (noResults) {
    };
    CatalogSelectorComponent.prototype.refreshControls = function () {
        wijmo.Control.invalidateAll();
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogSelectorComponent.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogSelectorComponent.prototype, "visible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", CatalogInfo)
    ], CatalogSelectorComponent.prototype, "selectedItem", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CatalogSelectorComponent.prototype, "displayValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], CatalogSelectorComponent.prototype, "catalogList", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogSelectorComponent.prototype, "serverSide", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CatalogSelectorComponent.prototype, "pageIndex", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CatalogSelectorComponent.prototype, "pageSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CatalogSelectorComponent.prototype, "totalRows", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CatalogSelectorComponent.prototype, "dialogTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Observable)
    ], CatalogSelectorComponent.prototype, "dataSource", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CatalogSelectorComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], CatalogSelectorComponent.prototype, "showListButton", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], CatalogSelectorComponent.prototype, "searchRequested", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], CatalogSelectorComponent.prototype, "selectedItemChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], CatalogSelectorComponent.prototype, "keywordSearch", void 0);
    __decorate([
        ViewChild('listDialog'),
        __metadata("design:type", TemplateRef)
    ], CatalogSelectorComponent.prototype, "listDialog", void 0);
    __decorate([
        ContentChildren(GridColumn),
        __metadata("design:type", QueryList)
    ], CatalogSelectorComponent.prototype, "columns", void 0);
    CatalogSelectorComponent = __decorate([
        Component({
            selector: 'azteca-catalog-selector',
            template: "\n      <div class=\"input-group\">\n          <input type=\"text\" class=\"form-control\" [(ngModel)]=\"displayValue\" [disabled]=\"!enabled\" (keypress)=\"onTextChanged($event)\"\n               [typeahead]=\"dataSource\"\n               (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n               (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n               (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n               typeaheadOptionsLimit=\"20\"\n               [typeaheadOptionField]=\"displayMember\"\n               typeaheadMinLength=\"2\"\n               typeaheadWaitMs=\"500\"\n               placeholder=\"Introduzca b\u00FAsqueda...\"/>\n\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"showListDialog()\" *ngIf=\"enabled && showListButton\">\n                  <span class=\"glyphicon glyphicon-list-alt\"></span>\n              </button>\n          </span>\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"clear()\" *ngIf=\"selectedItem != null && enabled\">\n                  <span class=\"glyphicon glyphicon-remove\"></span>\n              </button>\n          </span>\n      </div>\n\n      <ng-template #listDialog>\n\n          <div class=\"modal-header\">\n              <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"hideListDialog()\">\n                  <span aria-hidden=\"true\">&times;</span>\n              </button>\n              <h4 class=\"modal-title\">{{dialogTitle}}</h4>\n          </div>\n          <div class=\"modal-body\">\n              <azteca-catalog-list [catalogList]=\"catalogList\"\n                                   (searchRequested)=\"searchRequestedHandler($event)\"\n                                   (itemSelected)=\"selectItem($event)\"\n                                   (currentItemChanged)=\"currentItemChangedHandler($event)\"\n                                   [serverSide]=\"serverSide\"\n                                   [pageSize]=\"pageSize\"\n                                   [totalRows]=\"totalRows\"\n                                   [pageIndex]=\"pageIndex\">\n\n\n                  <azteca-grid-column *ngFor=\"let col of columns\"\n                                      [header]=\"col.header\"\n                                      [binding]=\"col.binding\"\n                                      [dataType]=\"col.dataType\"\n                                      [dataMap]=\"col.dataMap\"\n                                      [width]=\"col.width\">\n\n                  </azteca-grid-column>\n\n              </azteca-catalog-list>\n\n\n          </div><!--Modal Body-->\n          <div class=\"modal-footer\">\n              <!--Toolbar-->\n              <div class=\"btn-group\">\n                  <button type=\"submit\" class=\"btn btn-primary\" (click)=\"selectItem(selectedRow)\" [disabled]=\"selectedRow == null\">\n                      <span class=\"glyphicon glyphicon-ok\" aria-hidden=\"true\"></span> Aceptar\n                  </button>\n                  <button type=\"button\" class=\"btn btn-warning\" (click)=\"hideListDialog()\">\n                      <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cancelar\n                  </button>\n              </div> <!--Toolbar-->\n          </div> <!--Modal Footer-->\n      <ng-template #template>\n    "
        }),
        __metadata("design:paramtypes", [Context, BsModalService])
    ], CatalogSelectorComponent);
    return CatalogSelectorComponent;
}());
export { CatalogSelectorComponent };
