import { EventEmitter, QueryList, SimpleChanges } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { DocumentItem } from '../../core/models/document';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
export declare class DocumentListDialogComponent {
    selectedItems: DocumentItem[];
    selectedItem: DocumentItem;
    list: DocumentItem[];
    fechaInicial: Date;
    fechaFinal: Date;
    documentList: DocumentItem[];
    serverSide: boolean;
    pageIndex: number;
    pageSize: number;
    totalRows: number;
    multiSelect: boolean;
    excludedItems: DocumentItem[];
    title: string;
    startPeriod: number;
    endPeriod: number;
    searchRequested: EventEmitter<SearchRequest>;
    selectedItemChanged: EventEmitter<DocumentItem>;
    selectedItemsChanged: EventEmitter<DocumentItem[]>;
    listDialog: ModalDirective;
    columns: QueryList<GridColumn>;
    constructor();
    ngAfterViewInit(): void;
    loadConfiguration(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private updateSelected;
    private onSearchRequested;
    private onCurrentItemChanged;
    private currentItemChangedHandler;
    private onItemSelected;
    onItemCheckedChanged(item: DocumentItem): void;
    selectItem(item: DocumentItem): void;
    private onConfirmClick;
    private onCancelClick;
    triggerSearch(): void;
    show(): void;
    isValid(): boolean;
    refreshControls(): void;
}
