import { EventEmitter, QueryList, SimpleChange } from '@angular/core';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs } from 'wijmo/wijmo.grid';
import { FlexGridFilter } from 'wijmo/wijmo.grid.filter';
import { Menu } from 'wijmo/wijmo.input';
import { DocumentItem } from '../../core/models/document';
import { FilterGroup } from '../models/filter-group';
import { GridColumn } from '../../controls/directives/grid-column';
import { MenuItem } from '../../controls/models/menu-item';
import { MenuItemDirective } from '../../controls/directives/menu-item.directive';
export declare class DocumentListComponent {
    private _pageSize;
    currentDocument: DocumentItem;
    documentsView: CollectionView;
    readonly pageCount: number;
    columns: QueryList<GridColumn>;
    grid: FlexGrid;
    filter: FlexGridFilter;
    contextMenu: Menu;
    contextMenuItems: QueryList<MenuItemDirective>;
    enabled: boolean;
    documentList: DocumentItem[];
    showSelectColumn: boolean;
    showRowButton: boolean;
    showStatusColumn: boolean;
    rowButtonIcon: string;
    pageIndex: number;
    pageSize: number;
    filterGroup: FilterGroup;
    contextMenuClick: EventEmitter<MenuItem>;
    currentItemChanged: EventEmitter<DocumentItem>;
    itemSelected: EventEmitter<DocumentItem>;
    contextMenuOpen: EventEmitter<DocumentItem>;
    rowButtonClick: EventEmitter<any>;
    itemCheckedChanged: EventEmitter<DocumentItem>;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChange): void;
    initialized(sender: FlexGrid, args: any): void;
    private updateCollectionView;
    setDefaultFilterOperator(): void;
    moveFirst(): void;
    movePrevious(): void;
    moveNext(): void;
    moveLast(): void;
    getStatusColor(idStatus: number): string;
    filterChanged(e: any, args: any): void;
    sortChanged(sender: FlexGrid, args: CellRangeEventArgs): void;
    menuItemClicked(menu: Menu, args: any): void;
    onRowButtonClick(row: any): void;
    onCellUpdated(args: CellRangeEventArgs): void;
}
