import { EventEmitter, QueryList } from '@angular/core';
import { Observable } from 'rxjs';
import { ModalDirective, TypeaheadMatch } from 'ngx-bootstrap';
import { Context } from '../../core/services/context';
import { DocumentDetail } from '../../core/models/document-detail';
import { DocumentInfo, DocumentItem } from '../../core/models/document';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
export declare class DocumentSelectorComponent {
    private context;
    selectedRow: DocumentItem;
    fechaInicial: Date;
    fechaFinal: Date;
    enabled: boolean;
    visible: boolean;
    selectedItem: DocumentInfo<DocumentDetail>;
    displayValue: string;
    documentList: DocumentItem[];
    pageSize: number;
    maxRows: number;
    dataSource: Observable<any>;
    displayMember: string;
    showListButton: boolean;
    startPeriod: number;
    endPeriod: number;
    searchRequested: EventEmitter<SearchRequest>;
    selectedItemChanged: EventEmitter<DocumentItem>;
    keywordSearch: EventEmitter<string>;
    listDialog: ModalDirective;
    columns: QueryList<GridColumn>;
    constructor(context: Context);
    showListDialog(): void;
    triggerSearch(): void;
    currentItemChangedHandler(item: DocumentItem): void;
    selectItem(item: DocumentItem): void;
    clear(): void;
    hideListDialog(): void;
    onTextChanged(args: any): void;
    typeaheadOnSelect(args: TypeaheadMatch): void;
    changeTypeaheadLoading(loading: boolean): void;
    changeTypeaheadNoResults(noResults: boolean): void;
    refreshControls(): void;
}
