var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, ViewChild, ContentChildren, EventEmitter, QueryList } from '@angular/core';
import { Observable } from 'rxjs';
//
import { ModalDirective } from 'ngx-bootstrap';
import * as wijmo from 'wijmo/wijmo';
import * as moment from 'moment';
//
import { Context } from '../../core/services/context';
import { DocumentInfo } from '../../core/models/document';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
import { ConditionValueType } from '../models/condition-value-type';
var DocumentSelectorComponent = /** @class */ (function () {
    function DocumentSelectorComponent(context) {
        this.context = context;
        this.selectedRow = null;
        this.fechaInicial = new Date();
        this.fechaFinal = new Date();
        //
        this.enabled = true;
        this.visible = true;
        this.selectedItem = null;
        this.displayValue = '';
        this.documentList = [];
        this.maxRows = 5000;
        this.displayMember = 'nombre';
        this.showListButton = true;
        this.startPeriod = 2;
        this.endPeriod = 2;
        //
        this.searchRequested = new EventEmitter();
        this.selectedItemChanged = new EventEmitter();
        this.keywordSearch = new EventEmitter();
    }
    DocumentSelectorComponent.prototype.showListDialog = function () {
        this.fechaInicial = moment().subtract(this.startPeriod, 'day').toDate();
        this.fechaFinal = moment().add(this.endPeriod, 'day').toDate();
        //
        this.listDialog.config.backdrop = false;
        this.listDialog.show();
        //
        this.triggerSearch();
    };
    DocumentSelectorComponent.prototype.triggerSearch = function () {
        var request = new SearchRequest();
        request.pageIndex = 0;
        request.pageSize = this.pageSize;
        request.paged = false;
        request.maxRows = this.maxRows;
        //Agregar condiciones de fecha
        var condicionFechaIni = { field: 'fechaCreacion', operator: '>=', valueType: ConditionValueType.DATE_TIME, value: moment(this.fechaInicial).format() };
        var condicionFechaFin = { field: 'fechaCreacion', operator: '<=', valueType: ConditionValueType.DATE_TIME, value: moment(this.fechaFinal).format() };
        request.conditions.push(condicionFechaIni, condicionFechaFin);
        //
        this.searchRequested.emit(request);
    };
    DocumentSelectorComponent.prototype.currentItemChangedHandler = function (item) {
        this.selectedRow = item;
    };
    DocumentSelectorComponent.prototype.selectItem = function (item) {
        this.selectedItemChanged.emit(item);
        this.hideListDialog();
    };
    DocumentSelectorComponent.prototype.clear = function () {
        this.selectedItemChanged.emit(null);
    };
    DocumentSelectorComponent.prototype.hideListDialog = function () {
        this.listDialog.hide();
    };
    DocumentSelectorComponent.prototype.onTextChanged = function (args) {
        if (args.which !== 0) {
            this.keywordSearch.emit(args.target.value);
        }
    };
    DocumentSelectorComponent.prototype.typeaheadOnSelect = function (args) {
        this.selectedItemChanged.emit(args.item);
    };
    DocumentSelectorComponent.prototype.changeTypeaheadLoading = function (loading) {
    };
    DocumentSelectorComponent.prototype.changeTypeaheadNoResults = function (noResults) {
    };
    DocumentSelectorComponent.prototype.refreshControls = function () {
        wijmo.Control.invalidateAll();
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DocumentSelectorComponent.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DocumentSelectorComponent.prototype, "visible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", DocumentInfo)
    ], DocumentSelectorComponent.prototype, "selectedItem", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DocumentSelectorComponent.prototype, "displayValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], DocumentSelectorComponent.prototype, "documentList", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], DocumentSelectorComponent.prototype, "pageSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], DocumentSelectorComponent.prototype, "maxRows", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Observable)
    ], DocumentSelectorComponent.prototype, "dataSource", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DocumentSelectorComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DocumentSelectorComponent.prototype, "showListButton", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], DocumentSelectorComponent.prototype, "startPeriod", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], DocumentSelectorComponent.prototype, "endPeriod", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DocumentSelectorComponent.prototype, "searchRequested", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DocumentSelectorComponent.prototype, "selectedItemChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DocumentSelectorComponent.prototype, "keywordSearch", void 0);
    __decorate([
        ViewChild('listDialog'),
        __metadata("design:type", ModalDirective)
    ], DocumentSelectorComponent.prototype, "listDialog", void 0);
    __decorate([
        ContentChildren(GridColumn),
        __metadata("design:type", QueryList)
    ], DocumentSelectorComponent.prototype, "columns", void 0);
    DocumentSelectorComponent = __decorate([
        Component({
            selector: 'azteca-document-selector',
            template: "\n      <div class=\"input-group\">\n          <input type=\"text\" class=\"form-control\" [(ngModel)]=\"displayValue\" [disabled]=\"!enabled\" (keypress)=\"onTextChanged($event)\"\n                 [typeahead]=\"dataSource\"\n                 (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n                 (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n                 (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n                 typeaheadOptionsLimit=\"20\"\n                 [typeaheadOptionField]=\"displayMember\"\n                 typeaheadMinLength=\"2\"\n                 typeaheadWaitMs=\"500\"\n                 placeholder=\"Introduzca b\u00FAsqueda...\" />\n\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"showListDialog()\" *ngIf=\"enabled && showListButton\">\n                  <span class=\"glyphicon glyphicon-list-alt\"></span>\n              </button>\n          </span>\n\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"clear()\" *ngIf=\"selectedItem != null && enabled\">\n                  <span class=\"glyphicon glyphicon-remove\"></span>\n              </button>\n          </span>\n      </div>\n\n      <div bsModal #listDialog=\"bs-modal\" (onShown)=\"refreshControls()\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"hideListDialog()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                      <h4 class=\"modal-title\">{{dialogTitle}}</h4>\n                  </div>\n                  <div class=\"modal-body\">\n                      <!--FILTRO DE PERIODO-->\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <label class=\"form-control-label\">Fecha inicial:</label>\n                              <az-input-date [(ngModel)]=\"fechaInicial\"></az-input-date>\n                          </div>\n                          <div class=\"col-12 col-lg-6\">\n                              <label class=\"form-control-label\">Fecha final:</label>\n                              <az-input-date [(ngModel)]=\"fechaFinal\"></az-input-date>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <button class=\"btn btn-default\" (click)=\"triggerSearch()\">Actualizar listado</button>\n                          </div>\n                      </div>\n\n                      <!--LISTADO DE DOCUMENTOS-->\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n\n                              <azteca-document-list [documentList]=\"documentList\"\n                                                    (currentItemChanged)=\"currentItemChangedHandler($event)\"\n                                                    (itemSelected)=\"selectItem($event)\"\n                                                    [enabled]=\"enabled\"\n                                                    [pageSize]=\"pageSize\">\n\n                                  <!-- Mapear columnas definidas en componente padre-->\n                                  <azteca-grid-column *ngFor=\"let col of columns\"\n                                                      [header]=\"col.header\"\n                                                      [binding]=\"col.binding\"\n                                                      [dataType]=\"col.dataType ? col.dataType :'String'\"\n                                                      [dataMap]=\"col.dataMap\"\n                                                      [format]=\"col.format\"\n                                                      [width]=\"col.width\">\n\n                                      <!-- Add cell template if col.cellTemplate is specified. -->\n                                      <ng-template wjFlexGridCellTemplate *ngIf=\"col.cellTemplate\" [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <!-- Load the component whose type is specified in col.cellTemplate -->\n                                          <wj-component-loader [component]=\"col.cellTemplate\" [properties]=\"{cell: cell}\"></wj-component-loader>\n                                      </ng-template>\n\n                                  </azteca-grid-column>\n\n                              </azteca-document-list>\n\n                          </div>\n                      </div>\n\n                  </div><!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <!--Toolbar-->\n                      <div class=\"btn-group\">\n                          <button type=\"submit\" class=\"btn btn-primary\" (click)=\"selectItem(selectedRow)\" [disabled]=\"selectedRow == null\">\n                              <span class=\"glyphicon glyphicon-ok\" aria-hidden=\"true\"></span> Aceptar\n                          </button>\n                          <button type=\"button\" class=\"btn btn-warning\" (click)=\"hideListDialog()\">\n                              <span class=\"glyphicon glyphicon-remove\" aria-hidden=\"true\"></span> Cancelar\n                          </button>\n                      </div> <!--Toolbar-->\n                  </div> <!--Modal Footer-->\n              </div> <!--Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal Directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context])
    ], DocumentSelectorComponent);
    return DocumentSelectorComponent;
}());
export { DocumentSelectorComponent };
