import { EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { HierarchyInfo, HierarchyNode } from '../../core/models/hierarchy';
import { ITreeHost } from '../models/tree-host';
export declare class HierarchyDialogComponent implements ITreeHost {
    private parent;
    currentNode: HierarchyInfo<HierarchyNode>;
    selectedNode: HierarchyInfo<HierarchyNode>;
    nodes: HierarchyInfo<HierarchyNode>[];
    title: string;
    selectedNodeChanged: EventEmitter<HierarchyInfo<HierarchyNode>>;
    dialog: ModalDirective;
    constructor(parent: ITreeHost);
    loadChildren(parent: HierarchyInfo<HierarchyNode>): Promise<HierarchyInfo<HierarchyNode>[]>;
    show(): void;
    hide(): void;
    onCurrentNodeChanged(info: HierarchyInfo<HierarchyNode>): void;
    onNodeSelected(info: HierarchyInfo<HierarchyNode>): void;
    private selectCurrentNode;
}
