var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, EventEmitter, Input, Output, ViewChild, forwardRef, Optional, SkipSelf } from '@angular/core';
//
import { ModalDirective } from 'ngx-bootstrap';
import { ITreeHost } from '../models/tree-host';
var HierarchyDialogComponent = /** @class */ (function () {
    function HierarchyDialogComponent(parent) {
        this.parent = parent;
        this.currentNode = null;
        this.selectedNode = null;
        //Outputs
        this.selectedNodeChanged = new EventEmitter();
    }
    HierarchyDialogComponent_1 = HierarchyDialogComponent;
    HierarchyDialogComponent.prototype.loadChildren = function (parent) {
        return this.parent.loadChildren(parent);
    };
    HierarchyDialogComponent.prototype.show = function () {
        this.selectedNode = null;
        this.dialog.config.backdrop = false;
        this.dialog.show();
    };
    HierarchyDialogComponent.prototype.hide = function () {
        this.dialog.hide();
    };
    HierarchyDialogComponent.prototype.onCurrentNodeChanged = function (info) {
        this.currentNode = info;
    };
    HierarchyDialogComponent.prototype.onNodeSelected = function (info) {
        this.selectedNode = info;
        this.selectedNodeChanged.emit(info);
        this.hide();
    };
    HierarchyDialogComponent.prototype.selectCurrentNode = function () {
        if (this.currentNode) {
            this.selectedNode = this.currentNode;
            this.selectedNodeChanged.emit(this.selectedNode);
            this.hide();
        }
    };
    var HierarchyDialogComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HierarchyDialogComponent.prototype, "nodes", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HierarchyDialogComponent.prototype, "title", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchyDialogComponent.prototype, "selectedNodeChanged", void 0);
    __decorate([
        ViewChild('hierarchyDialog'),
        __metadata("design:type", ModalDirective)
    ], HierarchyDialogComponent.prototype, "dialog", void 0);
    HierarchyDialogComponent = HierarchyDialogComponent_1 = __decorate([
        Component({
            selector: 'azteca-hierarchy-dialog',
            template: "\n      <div bsModal #hierarchyDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\" *ngIf=\"title\">{{title}}</div>\n                  <div class=\"modal-body\">\n\n                      <azteca-hierarchy-tree [nodes]=\"nodes\"\n                                             (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                             (nodeSelected)=\"onNodeSelected($event)\">\n\n                      </azteca-hierarchy-tree>\n\n                  </div> <!-- Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"selectCurrentNode()\" [disabled]=\"!currentNode\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-default\" (click)=\"dialog.hide()\">Cancelar</button>\n                  </div> <!-- Modal Footer-->\n\n              </div> <!--Modal Content-->\n          </div> <!-- Modal-->\n      </div> <!-- Modal Directive-->\n    ",
            providers: [{ provide: ITreeHost, useExisting: forwardRef(function () { return HierarchyDialogComponent_1; }) }]
        }),
        __param(0, SkipSelf()), __param(0, Optional()),
        __metadata("design:paramtypes", [ITreeHost])
    ], HierarchyDialogComponent);
    return HierarchyDialogComponent;
}());
export { HierarchyDialogComponent };
