import { EventEmitter, QueryList } from '@angular/core';
import { Observable } from 'rxjs';
import { TypeaheadMatch } from 'ngx-bootstrap';
import { Context } from '../../core/services/context';
import { CatalogInfo, CatalogItem } from '../../core/models/catalog';
import { HierarchyInfo, HierarchyNode } from '../../core/models/hierarchy';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
import { ITreeHost } from '../models/tree-host';
import { CatalogListDialogComponent } from './catalog-list-dialog.component';
import { HierarchyDialogComponent } from './hierarchy-dialog.component';
export declare class HierarchySelectorComponent implements ITreeHost {
    private context;
    private parent;
    hierarchyList: CatalogItem[];
    nodes: HierarchyInfo<HierarchyNode>;
    enabled: boolean;
    visible: boolean;
    selectedItem: CatalogInfo;
    displayValue: string;
    serverSide: boolean;
    pageIndex: number;
    pageSize: number;
    totalRows: number;
    dialogTitle: string;
    dataSource: Observable<any>;
    valueMember: string;
    displayMember: string;
    showListButton: boolean;
    showTreeButton: boolean;
    searchRequested: EventEmitter<SearchRequest>;
    selectedItemChanged: EventEmitter<CatalogItem>;
    keywordSearch: EventEmitter<string>;
    loadingHierarchy: EventEmitter<void>;
    listDialog: CatalogListDialogComponent;
    hierarchyDialog: HierarchyDialogComponent;
    columns: QueryList<GridColumn>;
    constructor(context: Context, parent: ITreeHost);
    showListDialog(): void;
    showHierarchyDialog(): void;
    clear(): void;
    loadChildren(parent: HierarchyInfo<HierarchyNode>): Promise<HierarchyInfo<HierarchyNode>[]>;
    onSearchRequested(request: SearchRequest): void;
    onSelectedItemChanged(item: CatalogItem): void;
    onSelectedNodeChanged(info: HierarchyInfo<HierarchyNode>): void;
    onTextChanged(args: any): void;
    typeaheadOnSelect(args: TypeaheadMatch): void;
    changeTypeaheadLoading(loading: boolean): void;
    changeTypeaheadNoResults(noResults: boolean): void;
}
