var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, Input, Output, ViewChild, ContentChildren, EventEmitter, QueryList, forwardRef, Optional, SkipSelf } from '@angular/core';
import { Observable } from 'rxjs';
//
import { Context } from '../../core/services/context';
import { CatalogInfo } from '../../core/models/catalog';
import { HierarchyInfo } from '../../core/models/hierarchy';
import { GridColumn } from '../../controls/directives/grid-column';
import { SearchRequest } from '../models/search-request';
import { ITreeHost } from '../models/tree-host';
import { CatalogListDialogComponent } from './catalog-list-dialog.component';
import { HierarchyDialogComponent } from './hierarchy-dialog.component';
var HierarchySelectorComponent = /** @class */ (function () {
    function HierarchySelectorComponent(context, parent) {
        this.context = context;
        this.parent = parent;
        this.enabled = true;
        this.visible = true;
        this.selectedItem = null;
        this.displayValue = '';
        this.dialogTitle = 'Lista del catálogo';
        this.valueMember = 'id';
        this.displayMember = 'nombre';
        this.showListButton = true;
        this.showTreeButton = true;
        //
        this.searchRequested = new EventEmitter();
        this.selectedItemChanged = new EventEmitter();
        this.keywordSearch = new EventEmitter();
        this.loadingHierarchy = new EventEmitter();
    }
    HierarchySelectorComponent_1 = HierarchySelectorComponent;
    //Operaciones
    HierarchySelectorComponent.prototype.showListDialog = function () {
        this.listDialog.show();
        var request = new SearchRequest();
        request.pageIndex = 0;
        request.pageSize = this.pageSize;
        request.paged = this.serverSide ? true : false;
        //
        this.searchRequested.emit(request);
    };
    HierarchySelectorComponent.prototype.showHierarchyDialog = function () {
        this.loadingHierarchy.emit();
        this.hierarchyDialog.show();
    };
    HierarchySelectorComponent.prototype.clear = function () {
        this.displayValue = '';
        this.selectedItemChanged.emit(null);
    };
    HierarchySelectorComponent.prototype.loadChildren = function (parent) {
        return this.parent.loadChildren(parent);
    };
    HierarchySelectorComponent.prototype.onSearchRequested = function (request) {
        //Redireccionar request a componente padre
        this.searchRequested.emit(request);
    };
    //Handlers
    HierarchySelectorComponent.prototype.onSelectedItemChanged = function (item) {
        this.selectedItemChanged.emit(item);
    };
    HierarchySelectorComponent.prototype.onSelectedNodeChanged = function (info) {
        var item = { id: info.identity, codigo: info.code, activo: info.active, data: info };
        this.selectedItemChanged.emit(item);
    };
    HierarchySelectorComponent.prototype.onTextChanged = function (args) {
        if (args.which !== 0) {
            this.keywordSearch.emit(args.target.value);
        }
    };
    HierarchySelectorComponent.prototype.typeaheadOnSelect = function (args) {
        this.selectedItemChanged.emit(args.item);
    };
    HierarchySelectorComponent.prototype.changeTypeaheadLoading = function (loading) {
    };
    HierarchySelectorComponent.prototype.changeTypeaheadNoResults = function (noResults) {
    };
    var HierarchySelectorComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HierarchySelectorComponent.prototype, "hierarchyList", void 0);
    __decorate([
        Input(),
        __metadata("design:type", HierarchyInfo)
    ], HierarchySelectorComponent.prototype, "nodes", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelectorComponent.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelectorComponent.prototype, "visible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", CatalogInfo)
    ], HierarchySelectorComponent.prototype, "selectedItem", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HierarchySelectorComponent.prototype, "displayValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelectorComponent.prototype, "serverSide", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], HierarchySelectorComponent.prototype, "pageIndex", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], HierarchySelectorComponent.prototype, "pageSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], HierarchySelectorComponent.prototype, "totalRows", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HierarchySelectorComponent.prototype, "dialogTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Observable)
    ], HierarchySelectorComponent.prototype, "dataSource", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HierarchySelectorComponent.prototype, "valueMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], HierarchySelectorComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelectorComponent.prototype, "showListButton", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelectorComponent.prototype, "showTreeButton", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchySelectorComponent.prototype, "searchRequested", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchySelectorComponent.prototype, "selectedItemChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchySelectorComponent.prototype, "keywordSearch", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchySelectorComponent.prototype, "loadingHierarchy", void 0);
    __decorate([
        ViewChild('listDialog'),
        __metadata("design:type", CatalogListDialogComponent)
    ], HierarchySelectorComponent.prototype, "listDialog", void 0);
    __decorate([
        ViewChild('hierarchyDialog'),
        __metadata("design:type", HierarchyDialogComponent)
    ], HierarchySelectorComponent.prototype, "hierarchyDialog", void 0);
    __decorate([
        ContentChildren(GridColumn),
        __metadata("design:type", QueryList)
    ], HierarchySelectorComponent.prototype, "columns", void 0);
    HierarchySelectorComponent = HierarchySelectorComponent_1 = __decorate([
        Component({
            selector: 'azteca-hierarchy-selector',
            template: "\n      <div class=\"input-group\">\n          <input type=\"text\" class=\"form-control\" [(ngModel)]=\"displayValue\" [disabled]=\"!enabled\" (keypress)=\"onTextChanged($event)\"\n                 [typeahead]=\"dataSource\"\n                 (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n                 (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n                 (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n                 typeaheadOptionsLimit=\"10\"\n                 [typeaheadOptionField]=\"displayMember\"\n                 typeaheadMinLength=\"2\"\n                 typeaheadWaitMs=\"500\"\n                 placeholder=\"Introduzca b\u00FAsqueda...\" />\n\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"showHierarchyDialog()\" title=\"Abrir di\u00E1logo de jerarqu\u00EDa\" *ngIf=\"enabled && showTreeButton\">\n                  <i class=\"fa fa-sitemap\" aria-hidden=\"true\"></i>\n              </button>\n          </span>\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"showListDialog()\" title=\"Abrir di\u00E1logo de listado\" *ngIf=\"enabled && showListButton\">\n                  <span class=\"glyphicon glyphicon-list-alt\"></span>\n              </button>\n          </span>\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"clear()\" title=\"Borrar selecci\u00F3n\" *ngIf=\"selectedItem != null && enabled\">\n                  <span class=\"glyphicon glyphicon-remove\"></span>\n              </button>\n          </span>\n      </div>\n\n      <azteca-hierarchy-dialog #hierarchyDialog \n                               [nodes]=\"nodes\"\n                               (selectedNodeChanged)=\"onSelectedNodeChanged($event)\">\n\n      </azteca-hierarchy-dialog>\n\n      <catalog-list-dialog #listDialog\n                           (searchRequested)=\"onSearchRequested($event)\"                     \n                           (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                           [catalogList]=\"hierarchyList\"                     \n                           [multiSelect]=\"false\"\n                           [serverSide]=\"serverSide\"\n                           [pageSize]=\"pageSize\"\n                           [totalRows]=\"totalRows\"\n                           [pageIndex]=\"pageIndex\">\n\n\n          <!-- Mapear columnas definidas en componente padre-->\n          <azteca-grid-column *ngFor=\"let col of columns\"\n                              [header]=\"col.header\"\n                              [binding]=\"col.binding\"\n                              [dataType]=\"col.dataType ? col.dataType :'String'\"\n                              [dataMap]=\"col.dataMap\"\n                              [width]=\"col.width\">\n\n              <!-- Add cell template if col.cellTemplate is specified. -->\n              <ng-template wjFlexGridCellTemplate *ngIf=\"col.cellTemplate\" [cellType]=\"'Cell'\" let-cell=\"cell\">\n                  <!-- Load the component whose type is specified in col.cellTemplate -->\n                  <wj-component-loader [component]=\"col.cellTemplate\" [properties]=\"{cell: cell}\"></wj-component-loader>\n              </ng-template>\n\n          </azteca-grid-column>\n\n\n\n      </catalog-list-dialog>\n    ",
            providers: [{ provide: ITreeHost, useExisting: forwardRef(function () { return HierarchySelectorComponent_1; }) }]
        }),
        __param(1, Optional()), __param(1, SkipSelf()),
        __metadata("design:paramtypes", [Context, ITreeHost])
    ], HierarchySelectorComponent);
    return HierarchySelectorComponent;
}());
export { HierarchySelectorComponent };
