var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, EventEmitter, Input, Output, Optional } from '@angular/core';
import { ITreeHost } from '../models/tree-host';
var HierarchyTreeComponent = /** @class */ (function () {
    function HierarchyTreeComponent(parent) {
        var _this = this;
        this.parent = parent;
        //Configuración del árbol
        this.actionMapping = {
            mouse: {
                dblClick: function (tree, node, event) {
                    _this.nodeSelected.emit(node.data);
                }
            }
        };
        this.treeOptions = {
            displayField: 'nombre', allowDrag: false, actionMapping: this.actionMapping,
            getChildren: (function (node) {
                return _this.parent.loadChildren(node.data);
            })
        };
        //Outputs
        this.currentNodeChanged = new EventEmitter();
        this.nodeSelected = new EventEmitter();
    }
    //Tree events
    HierarchyTreeComponent.prototype.onTreeUpdated = function () {
    };
    HierarchyTreeComponent.prototype.onCurrentNodeChanged = function (args) {
        var node = args.node;
        this.currentNodeChanged.emit(node.data);
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], HierarchyTreeComponent.prototype, "nodes", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchyTreeComponent.prototype, "currentNodeChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchyTreeComponent.prototype, "nodeSelected", void 0);
    HierarchyTreeComponent = __decorate([
        Component({
            selector: 'azteca-hierarchy-tree',
            template: "\n      <div style=\"height:500px;overflow:auto\">\n          <tree-root [nodes]=\"nodes\"\n                     [options]=\"treeOptions\"\n                     (updateData)=\"onTreeUpdated($event)\"\n                     (activate)=\"onCurrentNodeChanged($event)\">\n\n              <ng-template #treeNodeTemplate let-node=\"node\" let-index=\"index\">\n                  <span [class]=\"node.data.icon\"></span>\n                  <span>{{ node.data.nombre }}</span>\n              </ng-template>\n              <ng-template #loadingTemplate>\n                  Cargando, por favor espere...\n              </ng-template>\n          </tree-root>\n      </div>\n    "
        }),
        __param(0, Optional()),
        __metadata("design:paramtypes", [ITreeHost])
    ], HierarchyTreeComponent);
    return HierarchyTreeComponent;
}());
export { HierarchyTreeComponent };
