var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
//
import { Context } from '../../core/services/context';
import { CatalogInfo } from '../../core/models/catalog';
//
var SelectorCellComponent = /** @class */ (function () {
    //
    function SelectorCellComponent(context) {
        this.context = context;
        this.selectedRow = null;
        this.enabled = true;
        this.visible = true;
        this.selectedItem = null;
        this.displayValue = '';
        this.valueMember = 'id';
        this.displayMember = 'nombre';
        //
        this.selectedItemChanged = new EventEmitter();
        this.keywordSearch = new EventEmitter();
    }
    SelectorCellComponent.prototype.currentItemChangedHandler = function (item) {
        this.selectedRow = item;
    };
    SelectorCellComponent.prototype.clear = function () {
        this.selectedItemChanged.emit(null);
    };
    SelectorCellComponent.prototype.onTextChanged = function (args) {
        this.keywordSearch.emit(args.target.value);
    };
    SelectorCellComponent.prototype.typeaheadOnSelect = function (args) {
        this.selectedItemChanged.emit(args.item);
    };
    SelectorCellComponent.prototype.changeTypeaheadLoading = function (loading) {
    };
    SelectorCellComponent.prototype.changeTypeaheadNoResults = function (noResults) {
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectorCellComponent.prototype, "cell", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SelectorCellComponent.prototype, "enabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SelectorCellComponent.prototype, "visible", void 0);
    __decorate([
        Input(),
        __metadata("design:type", CatalogInfo)
    ], SelectorCellComponent.prototype, "selectedItem", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectorCellComponent.prototype, "displayValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectorCellComponent.prototype, "valueMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectorCellComponent.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Observable)
    ], SelectorCellComponent.prototype, "dataSource", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], SelectorCellComponent.prototype, "selectedItemChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], SelectorCellComponent.prototype, "keywordSearch", void 0);
    SelectorCellComponent = __decorate([
        Component({
            selector: 'selector-cell',
            template: "\n      <div class=\"input-group\">\n          <input type=\"text\" class=\"form-control\" [(ngModel)]=\"displayValue\" [disabled]=\"!enabled\" (keyup)=\"onTextChanged($event)\"\n                 [typeahead]=\"dataSource\"\n                 (typeaheadLoading)=\"changeTypeaheadLoading($event)\"\n                 (typeaheadNoResults)=\"changeTypeaheadNoResults($event)\"\n                 (typeaheadOnSelect)=\"typeaheadOnSelect($event)\"\n                 typeaheadOptionsLimit=\"10\"\n                 [typeaheadOptionField]=\"displayMember\"\n                 typeaheadMinLength=\"2\"\n                 placeholder=\"Introduzca b\u00FAsqueda...\" />\n\n          <span class=\"input-group-btn\">\n              <button class=\"btn btn-default\" type=\"button\" (click)=\"clear()\" *ngIf=\"selectedItem != null && enabled\">\n                  <span class=\"glyphicon glyphicon-remove\"></span>\n              </button>\n          </span>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [Context])
    ], SelectorCellComponent);
    return SelectorCellComponent;
}());
export { SelectorCellComponent };
