var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { AutocompleteCellComponent } from '../components/autocomplete-cell.component';
var AutocompleteCell = /** @class */ (function () {
    function AutocompleteCell() {
        this._selectedID = 0;
        this.selectedItem = null;
        this.maxItems = 20;
        this.minLength = 2;
        this.displayMember = 'nombre';
        this.valueMember = 'id';
        //
        this.selectedItemChanged = new EventEmitter();
        this.valueChange = new EventEmitter();
    }
    Object.defineProperty(AutocompleteCell.prototype, "value", {
        get: function () {
            return this._selectedID;
        },
        set: function (val) {
            if (val != this._selectedID) {
                this._selectedID = val ? val : 0;
                this.valueChange.emit(this._selectedID);
            }
        },
        enumerable: true,
        configurable: true
    });
    //
    AutocompleteCell.prototype.onSelectedItemChanged = function (item) {
        if (item) {
            this.value = this.autocomplete.selectedValue;
            this.selectedItem = item;
        }
        else {
            this.value = 0;
            this.selectedItem = null;
        }
        this.selectedItemChanged.emit(item);
    };
    //Implementación de políticas
    AutocompleteCell.prototype.applyPolicy = function (policy) {
    };
    AutocompleteCell.prototype.handleError = function (error) {
        console.error(error);
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AutocompleteCell.prototype, "cell", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AutocompleteCell.prototype, "maxItems", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AutocompleteCell.prototype, "minLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AutocompleteCell.prototype, "displayMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AutocompleteCell.prototype, "valueMember", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], AutocompleteCell.prototype, "value", null);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AutocompleteCell.prototype, "selectedItemChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AutocompleteCell.prototype, "valueChange", void 0);
    __decorate([
        ViewChild(AutocompleteCellComponent),
        __metadata("design:type", AutocompleteCellComponent)
    ], AutocompleteCell.prototype, "autocomplete", void 0);
    return AutocompleteCell;
}());
export { AutocompleteCell };
