import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs';
import { BaseControl } from '../../controls/index';
import { Context, CatalogItem } from '../../core';
import { CatalogSelectorComponent } from '../../search/components/catalog-selector.component';
export declare abstract class CatalogSelector extends BaseControl implements ControlValueAccessor {
    protected context: Context;
    protected _selectedID: number;
    displayValue: string;
    pageIndex: number;
    pageSize: number;
    totalRows: number;
    keywordSearchSource: Observable<any>;
    selectedID: number;
    showListButton: boolean;
    valueMember: string;
    userSelectionChanged: EventEmitter<CatalogItem>;
    innerSelector: CatalogSelectorComponent;
    constructor(context: Context);
    abstract loadItem(itemID: number): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
    handleError(reason: any): void;
    itemChangedHandler(item: CatalogItem): void;
    markUnselected(): void;
    clear(): void;
}
