import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs';
import { BaseControl } from '../../controls/index';
import { Context, DocumentItem } from '../../core';
import { DocumentSelectorComponent } from '../../search/components/document-selector.component';
export declare abstract class DocumentSelector extends BaseControl implements ControlValueAccessor {
    protected context: Context;
    protected _selectedID: string;
    displayValue: string;
    pageIndex: number;
    pageSize: number;
    totalRows: number;
    keywordSearchSource: Observable<any>;
    selectedID: string;
    showListButton: boolean;
    valueMember: string;
    userSelectionChanged: EventEmitter<DocumentItem>;
    innerSelector: DocumentSelectorComponent;
    constructor(context: Context);
    abstract loadItem(itemID: string): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
    handleError(reason: any): void;
    itemChangedHandler(item: DocumentItem): void;
    markUnselected(): void;
    clear(): void;
}
