var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, EventEmitter, Output, ViewChild } from '@angular/core';
//
import { BaseControl } from '../../controls/index';
import { DocumentSelectorComponent } from '../../search/components/document-selector.component';
var DocumentSelector = /** @class */ (function (_super) {
    __extends(DocumentSelector, _super);
    function DocumentSelector(context) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this._selectedID = '';
        _this.displayValue = '';
        _this.pageIndex = 0;
        _this.pageSize = 20;
        _this.totalRows = 0;
        _this.showListButton = true;
        _this.valueMember = 'id';
        //Outputs
        _this.userSelectionChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    Object.defineProperty(DocumentSelector.prototype, "selectedID", {
        //Inputs
        get: function () {
            return this._selectedID;
        },
        set: function (value) {
            if (value != this._selectedID) {
                this._selectedID = value ? value : '';
                this.loadItem(this._selectedID);
            }
        },
        enumerable: true,
        configurable: true
    });
    DocumentSelector.prototype.writeValue = function (value) {
        this.selectedID = value ? value : '';
    };
    DocumentSelector.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    DocumentSelector.prototype.registerOnTouched = function () { };
    DocumentSelector.prototype.handleError = function (reason) {
        this.context.app.hideSpinner();
    };
    DocumentSelector.prototype.itemChangedHandler = function (item) {
        if (item != null) {
            this.selectedID = item.id;
            this.propagateChange(item.id);
        }
        else {
            this.selectedID = '';
            this.propagateChange(0);
        }
        this.userSelectionChanged.emit(item);
    };
    DocumentSelector.prototype.markUnselected = function () {
        this._selectedID = '';
        this.propagateChange(0);
    };
    DocumentSelector.prototype.clear = function () {
        this.innerSelector.clear();
    };
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], DocumentSelector.prototype, "selectedID", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DocumentSelector.prototype, "showListButton", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DocumentSelector.prototype, "valueMember", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DocumentSelector.prototype, "userSelectionChanged", void 0);
    __decorate([
        ViewChild(DocumentSelectorComponent),
        __metadata("design:type", DocumentSelectorComponent)
    ], DocumentSelector.prototype, "innerSelector", void 0);
    return DocumentSelector;
}(BaseControl));
export { DocumentSelector };
