var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, EventEmitter, Output, ViewChild } from '@angular/core';
//
import { BaseControl } from '../../controls/index';
import { HierarchySelectorComponent } from '../components/hierarchy-selector.component';
var HierarchySelector = /** @class */ (function (_super) {
    __extends(HierarchySelector, _super);
    function HierarchySelector(context) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this._selectedID = 0;
        _this.displayValue = '';
        _this.pageIndex = 0;
        _this.pageSize = 20;
        _this.totalRows = 0;
        _this.showListButton = true;
        _this.showTreeButton = true;
        //Outputs
        _this.itemChanged = new EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    Object.defineProperty(HierarchySelector.prototype, "selectedID", {
        //Inputs
        get: function () {
            return this._selectedID;
        },
        set: function (value) {
            if (value != this._selectedID) {
                this._selectedID = value ? value : 0;
                this.loadItem(this._selectedID);
            }
        },
        enumerable: true,
        configurable: true
    });
    HierarchySelector.prototype.writeValue = function (value) {
        this.selectedID = value ? value : 0;
    };
    HierarchySelector.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    HierarchySelector.prototype.registerOnTouched = function () { };
    HierarchySelector.prototype.handleError = function (reason) {
        this.context.app.hideSpinner();
    };
    HierarchySelector.prototype.itemChangedHandler = function (item) {
        if (item != null) {
            this.loadItem(item.id);
            this.propagateChange(item.id);
        }
        else {
            this.loadItem(0);
            this.propagateChange(0);
        }
        this.itemChanged.emit(item);
    };
    HierarchySelector.prototype.clear = function () {
        this.innerSelector.clear();
    };
    HierarchySelector.prototype.markUnselected = function () {
        this._selectedID = 0;
        this.propagateChange(0);
    };
    __decorate([
        Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], HierarchySelector.prototype, "selectedID", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelector.prototype, "showListButton", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], HierarchySelector.prototype, "showTreeButton", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], HierarchySelector.prototype, "itemChanged", void 0);
    __decorate([
        ViewChild(HierarchySelectorComponent),
        __metadata("design:type", HierarchySelectorComponent)
    ], HierarchySelector.prototype, "innerSelector", void 0);
    return HierarchySelector;
}(BaseControl));
export { HierarchySelector };
