var SearchRequest = /** @class */ (function () {
    function SearchRequest() {
        this.paged = true;
        this.conditions = [];
        this.order = [];
        this.pageIndex = 1;
        this.pageSize = 20;
        this.maxRows = 0;
    }
    SearchRequest.prototype.SetGridConditions = function (gridFilter) {
        var _this = this;
        this.conditions = [];
        gridFilter.filters.forEach(function (filter) {
            var condition = new SearchCondition();
            condition.field = filter.binding;
            condition.operator = _this.getOperator(filter.condition1.operator);
            condition.value = filter.condition1.value;
            condition.valueType = _this.getValueType(filter.condition1.value);
            _this.conditions.push(condition);
        });
    };
    SearchRequest.prototype.getOperator = function (gridOperator) {
        switch (gridOperator) {
            case 0:
                return "=";
            case 1:
                return "<>";
            case 2:
                return ">";
            case 3:
                return ">=";
            case 4:
                return "<";
            case 5:
                return "<=";
            case 6:
                return "STARTS";
            case 7:
                return "ENDS";
            case 8:
                return "CONTAINS";
            case 9:
                return "NOTCONTAINS";
        }
    };
    SearchRequest.prototype.getValueType = function (value) {
        if (typeof value === 'number') {
            return "decimal";
        }
        else if (typeof value === 'boolean') {
            return "boolean";
        }
        else if (typeof value === 'Date') {
            return "datetime";
        }
        else {
            return "string";
        }
    };
    return SearchRequest;
}());
export { SearchRequest };
var SearchCondition = /** @class */ (function () {
    function SearchCondition() {
    }
    return SearchCondition;
}());
export { SearchCondition };
var SortOrder = /** @class */ (function () {
    function SortOrder() {
    }
    return SortOrder;
}());
export { SortOrder };
