import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { BaseControl } from '../../controls/index';
import { Context, CatalogItem } from '../../core';
import { SelectorCellComponent } from '../../search/components/selector-cell.component';
export declare abstract class SelectorCell extends BaseControl {
    protected context: Context;
    protected _selectedID: number;
    displayValue: string;
    keyword: string;
    keywordSearchSource: Observable<any>;
    selectedItem: CatalogItem;
    cell: any;
    value: number;
    valueChanged: EventEmitter<number>;
    selectedItemChanged: EventEmitter<CatalogItem>;
    cellSelector: SelectorCellComponent;
    constructor(context: Context);
    handleError(reason: any): void;
    itemChangedHandler(item: CatalogItem): void;
    setDisplayValue(item: CatalogItem): void;
    markUnselected(): void;
    clear(): void;
}
