var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Input, EventEmitter, Output, ViewChild } from '@angular/core';
//
import { BaseControl } from '../../controls/index';
import { SelectorCellComponent } from '../../search/components/selector-cell.component';
var SelectorCell = /** @class */ (function (_super) {
    __extends(SelectorCell, _super);
    function SelectorCell(context) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this._selectedID = 0;
        _this.displayValue = "";
        _this.keyword = '';
        _this.selectedItem = null;
        //Outputs
        _this.valueChanged = new EventEmitter();
        _this.selectedItemChanged = new EventEmitter();
        return _this;
    }
    Object.defineProperty(SelectorCell.prototype, "value", {
        get: function () {
            return this._selectedID;
        },
        set: function (value) {
            if (value != this._selectedID) {
                this._selectedID = value ? value : 0;
                this.valueChanged.emit();
            }
        },
        enumerable: true,
        configurable: true
    });
    SelectorCell.prototype.handleError = function (reason) {
        console.error(reason);
        this.context.app.hideSpinner();
    };
    SelectorCell.prototype.itemChangedHandler = function (item) {
        if (item != null) {
            this.value = item.id;
            this.selectedItem = item;
        }
        else {
            this.value = 0;
            this.selectedItem = null;
        }
        this.selectedItemChanged.emit(item);
        this.setDisplayValue(item);
    };
    SelectorCell.prototype.setDisplayValue = function (item) {
        if (item != null) {
            this.displayValue = item.nombre;
        }
        else {
            this.displayValue = '';
        }
    };
    SelectorCell.prototype.markUnselected = function () {
        this.value = 0;
    };
    SelectorCell.prototype.clear = function () {
        this.cellSelector.clear();
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectorCell.prototype, "cell", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], SelectorCell.prototype, "value", null);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], SelectorCell.prototype, "valueChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], SelectorCell.prototype, "selectedItemChanged", void 0);
    __decorate([
        ViewChild(SelectorCellComponent),
        __metadata("design:type", SelectorCellComponent)
    ], SelectorCell.prototype, "cellSelector", void 0);
    return SelectorCell;
}(BaseControl));
export { SelectorCell };
