import { Observable } from 'rxjs';
import { Context, CatalogItem, ModuloInfo, ModuloItem, ModuloService } from '../../../core';
import { SearchRequest, HierarchySelector, ITreeHost } from '../../../search/index';
export declare class ModuloSelectorComponent extends HierarchySelector implements ITreeHost {
    protected context: Context;
    private moduloService;
    modulos: ModuloItem[];
    nodes: ModuloInfo[];
    selectedItem: ModuloInfo;
    constructor(context: Context, moduloService: ModuloService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
    onLoadingHierarchy(): void;
    loadChildren(parent: ModuloInfo): Promise<ModuloInfo[]>;
}
