var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, Output, EventEmitter } from '@angular/core';
//
//Kernel
import { Context, ModuloService } from '../../../core';
import { ITreeHost, HierarchyTree } from '../../../search/index';
//
var ModulosTreeComponent = /** @class */ (function (_super) {
    __extends(ModulosTreeComponent, _super);
    function ModulosTreeComponent(context, moduloService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.moduloService = moduloService;
        //
        _this.currentNodeChanged = new EventEmitter();
        return _this;
    }
    ModulosTreeComponent_1 = ModulosTreeComponent;
    ModulosTreeComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadRoots(); });
    };
    ModulosTreeComponent.prototype.loadRoots = function () {
        var _this = this;
        this.moduloService.loadChildren(this.context.app.defaultCompany.identity, 0)
            .then(function (modulos) { return _this.modulos = modulos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ModulosTreeComponent.prototype.loadChildren = function (parent) {
        return this.moduloService.loadChildren(this.context.app.defaultCompany.identity, parent.identity);
    };
    ModulosTreeComponent.prototype.onModuloSelected = function (modulo) {
        this.currentNodeChanged.emit(modulo);
    };
    var ModulosTreeComponent_1;
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], ModulosTreeComponent.prototype, "currentNodeChanged", void 0);
    ModulosTreeComponent = ModulosTreeComponent_1 = __decorate([
        Component({
            selector: 'security-modulos-tree',
            template: "\n      <azteca-hierarchy-tree [nodes]=\"modulos\" (currentNodeChanged)=\"onModuloSelected($event)\">\n\n      </azteca-hierarchy-tree>\n    ",
            providers: [{ provide: ITreeHost, useExisting: forwardRef(function () { return ModulosTreeComponent_1; }) }]
        }),
        __metadata("design:paramtypes", [Context, ModuloService])
    ], ModulosTreeComponent);
    return ModulosTreeComponent;
}(HierarchyTree));
export { ModulosTreeComponent };
