var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
//
import { Context, GrupoService } from '../../../core';
import { CatalogListDialog } from '../../../search/index';
//
var GruposListComponent = /** @class */ (function (_super) {
    __extends(GruposListComponent, _super);
    function GruposListComponent(context, grupoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.grupoService = grupoService;
        return _this;
    }
    GruposListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.grupoService.search(this.context.app.defaultSite.identity, request)
            .then(function (result) {
            _this.grupos = result.rows;
            _this.totalRows = result.totalRows;
            _this.pageIndex = request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposListComponent.prototype.onSelectedItemsChanged = function (selectedGroups) {
        this.selectedItemsChanged.emit(selectedGroups);
    };
    GruposListComponent.prototype.onSelectedItemChanged = function (group) {
        this.selectedItemChanged.emit(group);
    };
    GruposListComponent = __decorate([
        Component({
            selector: 'security-grupos-list',
            template: "\n      <catalog-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                           (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                           (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                           [catalogList]=\"grupos\"\n                           [excludedItems]=\"excludedItems\"\n                           [multiSelect]=\"multiSelect\"\n                           [serverSide]=\"serverSide\"\n                           [pageSize]=\"pageSize\"\n                           [totalRows]=\"totalRows\"\n                           [pageIndex]=\"pageIndex\">\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n    \n\n      </catalog-list-dialog>\n    "
        }),
        __metadata("design:paramtypes", [Context, GrupoService])
    ], GruposListComponent);
    return GruposListComponent;
}(CatalogListDialog));
export { GruposListComponent };
