var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Output, EventEmitter, forwardRef } from '@angular/core';
//
import { Context, ModuloService } from '../../../core';
import { ITreeHost, HierarchyDialog } from '../../../search/index';
//
var ModulosDialogComponent = /** @class */ (function (_super) {
    __extends(ModulosDialogComponent, _super);
    function ModulosDialogComponent(context, moduloService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.moduloService = moduloService;
        //Inputs
        //Outputs
        _this.selectedNodeChanged = new EventEmitter();
        return _this;
    }
    ModulosDialogComponent_1 = ModulosDialogComponent;
    ModulosDialogComponent.prototype.loadRoots = function () {
        var _this = this;
        this.modulos = [];
        this.moduloService.loadChildren(this.context.app.defaultCompany.identity, 0)
            .then(function (modulos) { return _this.modulos = modulos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ModulosDialogComponent.prototype.loadChildren = function (parent) {
        return this.moduloService.loadChildren(this.context.app.defaultCompany.identity, parent.identity);
    };
    ModulosDialogComponent.prototype.onSelectedNodeChanged = function (node) {
        this.selectedNodeChanged.emit(node);
    };
    var ModulosDialogComponent_1;
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], ModulosDialogComponent.prototype, "selectedNodeChanged", void 0);
    ModulosDialogComponent = ModulosDialogComponent_1 = __decorate([
        Component({
            selector: 'security-modulos-dialog',
            template: "\n      <azteca-hierarchy-dialog #hierarchyDialog [nodes]=\"modulos\"\n                               (selectedNodeChanged)=\"onSelectedNodeChanged($event)\">\n\n      </azteca-hierarchy-dialog>\n    ",
            providers: [{ provide: ITreeHost, useExisting: forwardRef(function () { return ModulosDialogComponent_1; }) }]
        }),
        __metadata("design:paramtypes", [Context, ModuloService])
    ], ModulosDialogComponent);
    return ModulosDialogComponent;
}(HierarchyDialog));
export { ModulosDialogComponent };
