var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from '@angular/core';
//
import { Context, SucursalService } from '../../../core';
import { CatalogListDialog } from '../../../search';
//
var SucursalesListComponent = /** @class */ (function (_super) {
    __extends(SucursalesListComponent, _super);
    function SucursalesListComponent(context, sucursalService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.sucursalService = sucursalService;
        //Inputs
        _this.idEmpresa = 0;
        return _this;
    }
    SucursalesListComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        //Si se especificó empresa, agregar filtro
        if (this.idEmpresa > 0) {
            var condEmpresa = { field: 'idEmpresa', operator: '=', valueType: 'int', value: this.idEmpresa.toString() };
            request.conditions.push(condEmpresa);
        }
        this.sucursalService.search(this.context.app.defaultSite.identity, request)
            .then(function (result) {
            _this.sucursales = result.rows;
            _this.totalRows = result.totalRows;
            _this.pageIndex = request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesListComponent.prototype.onSelectedItemsChanged = function (selectedUsers) {
        this.selectedItemsChanged.emit(selectedUsers);
    };
    SucursalesListComponent.prototype.onSelectedItemChanged = function (user) {
        this.selectedItemChanged.emit(user);
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], SucursalesListComponent.prototype, "idEmpresa", void 0);
    SucursalesListComponent = __decorate([
        Component({
            selector: 'security-sucursales-list',
            template: "\n      <catalog-list-dialog (searchRequested)=\"onSearchRequested($event)\"\n                           (selectedItemsChanged)=\"onSelectedItemsChanged($event)\"\n                           (selectedItemChanged)=\"onSelectedItemChanged($event)\"\n                           [catalogList]=\"sucursales\"\n                           [excludedItems]=\"excludedItems\"\n                           [multiSelect]=\"multiSelect\"\n                           [serverSide]=\"serverSide\"\n                           [pageSize]=\"pageSize\"\n                           [totalRows]=\"totalRows\"\n                           [pageIndex]=\"pageIndex\">\n\n\n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Domicilio'\" [binding]=\"'domicilio'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Colonia'\" [binding]=\"'colonia'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Poblaci\u00F3n'\" [binding]=\"'poblacion'\" [width]=\"'2*'\"></azteca-grid-column>\n\n      </catalog-list-dialog>\n    "
        }),
        __metadata("design:paramtypes", [Context, SucursalService])
    ], SucursalesListComponent);
    return SucursalesListComponent;
}(CatalogListDialog));
export { SucursalesListComponent };
