import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, EmpresaInfo, SucursalItem, EmpresaService, SucursalService } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogEditor, EditorEventArgs } from '../../editors';
import { SucursalesManager } from './sucursales.manager';
export declare class EmpresasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private empresaService;
    private sucursalService;
    private location;
    empresa: EmpresaInfo;
    sucursales: SucursalItem[];
    siteManager: SucursalesManager;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, empresaService: EmpresaService, sucursalService: SucursalService, location: Location);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    selectSucursalesTab(args: any): void;
    onSucursalesListUpdated(): void;
    loadSucursales(): void;
    onDomicilioValidChange(): void;
}
