import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { FlexGrid } from 'wijmo/wijmo.grid';
import { Context, BaseComponent, PolicyInfo, PolicyAccess, GrupoInfo, GrupoService, ProcesoAcceso, ModuloInfo } from '../../core';
import { MenuItem, ToolbarButton, AlertsBarComponent } from '../../controls';
import { PoliticasUsuarioEditor } from './parts/politicas-usuario.editor';
import { PoliticasGlobalesEditor } from './parts/politicas-globales.editor';
export declare class GrupoAccesosComponent extends BaseComponent {
    private context;
    private route;
    private location;
    private grupoService;
    grupo: GrupoInfo;
    accesos: ProcesoAcceso[];
    accesosCollection: CollectionView;
    currentModule: ModuloInfo;
    politicasMenu: MenuItem[];
    currentProceso: ProcesoAcceso;
    allowSelection: boolean;
    politicasUsuarioEditor: PoliticasUsuarioEditor;
    politicasGlobalesEditor: PoliticasGlobalesEditor;
    alerts: AlertsBarComponent;
    constructor(context: Context, route: ActivatedRoute, location: Location, grupoService: GrupoService);
    ngOnInit(): void;
    loadGrupo(idGrupo: number): void;
    loadAccesos(idGrupo: number): void;
    saveAccesos(): void;
    createPoliticasMenu(): void;
    handleError(error: any): void;
    onGrupoSelected(grupo: GrupoInfo): void;
    onMainToolbarClick(button: ToolbarButton): void;
    onModuloSelected(modulo: ModuloInfo): void;
    procesosGridInitialized(grid: FlexGrid): void;
    selectPoliticasAction(option: MenuItem): void;
    onProcesosToolbarClick(option: MenuItem): void;
    politicasMenuClick(menu: Menu): void;
    onPoliticasUsuarioUpdated(politicas: PolicyAccess[]): void;
    onPoliticasGlobalesUpdated(politicas: PolicyAccess[]): void;
    applyPolicy(policy: PolicyInfo): void;
}
