var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef, ChangeDetectorRef, } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, Validators } from '@angular/forms';
import { Location } from '@angular/common';
//Azteca Kernel
import { Context, BaseComponent, CatalogService, GrupoInfo, GrupoService } from '../../core';
import { CatalogEditor } from '../../editors';
//Locales
var GruposEditor = /** @class */ (function (_super) {
    __extends(GruposEditor, _super);
    function GruposEditor(context, router, route, location, formBuilder, changeDetector, grupoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.grupoService = grupoService;
        _this.grupo = new GrupoInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', Validators.required],
            'nombre': ['', Validators.required]
        });
        return _this;
    }
    GruposEditor_1 = GruposEditor;
    GruposEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    GruposEditor.prototype.onCreatingItem = function () {
    };
    GruposEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupo = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.grupoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.grupo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.grupoService.update(this.grupo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.grupo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.grupo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    GruposEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
        else if (item.name == 'ACCESS') {
            this.router.navigate(['kernel/security/grupo-accesos', this.process.id, { idGrupo: this.grupo.identity }]);
        }
    };
    var GruposEditor_1;
    GruposEditor = GruposEditor_1 = __decorate([
        Component({
            selector: 'security-grupos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Grupo de Usuarios'\"\n                                 [info]=\"grupo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'ACCESS'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Accesos'\" [smallText]=\"'definir accesos'\"></azteca-menu-item>        \n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">                    \n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"grupo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"grupo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>        \n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return GruposEditor_1; })
                },
                {
                    provide: CatalogService, useExisting: GrupoService
                }
            ]
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute, Location, FormBuilder, ChangeDetectorRef,
            GrupoService])
    ], GruposEditor);
    return GruposEditor;
}(CatalogEditor));
export { GruposEditor };
