import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem, GrupoInfo, GrupoService } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { MenuItem } from '../../controls';
export declare class GruposManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private grupoService;
    grupos: GrupoInfo[];
    constructor(router: Router, route: ActivatedRoute, context: Context, grupoService: GrupoService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
}
