import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges, ModuloInfo, ModuloService, CategoriaModulos } from '../../core';
import { CatalogOptions } from '../../custom/models/catalog-options';
import { HierarchyManager } from '../../editors/index';
import { MenuItem } from '../../controls/index';
export declare class ModulosManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private moduloService;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    modulos: ModuloInfo[];
    moduloEdicion: ModuloInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    categorias: CategoriaModulos[];
    constructor(context: Context, changeDetector: ChangeDetectorRef, moduloService: ModuloService, formBuilder: FormBuilder, router: Router, route: ActivatedRoute);
    onConfigureCatalog(options: CatalogOptions): void;
    loadHierarchy(): void;
    onNodesChanged(modulos: ModuloInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<ModuloInfo>): void;
    loadCategorias(): void;
    onMenuItemClick(menuItem: MenuItem): void;
}
