var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//Wijmo
import { Control, CollectionView, NotifyCollectionChangedAction } from 'wijmo/wijmo';
//
import { PolicyScope } from '../../../core';
import { ChangeState } from '../../../editors';
//
var PoliticasUsuarioEditor = /** @class */ (function () {
    function PoliticasUsuarioEditor() {
        //Inputs
        this.politicas = [];
        //Outputs
        this.politicasUpdated = new EventEmitter();
    }
    /////////////////////// METODOS //////////////////////////////
    PoliticasUsuarioEditor.prototype.createCollection = function () {
        this.politicasCollection = new CollectionView(this.copy(this.politicas));
        //Filtrar sólo políticas de ámbito usuario
        this.politicasCollection.filter = function (item) {
            return item.ambito == PolicyScope.USER;
        };
        //Marcar los registros modificados
        this.politicasCollection.collectionChanged.addHandler(function (sender, args) {
            if (args.action == NotifyCollectionChangedAction.Change && args.item != null) {
                args.item.state = ChangeState.MODIFIED;
            }
        });
        this.politicasCollection.refresh();
    };
    PoliticasUsuarioEditor.prototype.copy = function (original) {
        return JSON.parse(JSON.stringify(original));
    };
    PoliticasUsuarioEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        Control.invalidateAll();
        setTimeout(function (_) { return _this.createCollection(); });
    };
    /////////////////////// HANDLER //////////////////////////////
    PoliticasUsuarioEditor.prototype.onUpdate = function () {
        this.politicasUpdated.emit(this.politicasCollection.sourceCollection);
        this.dialog.hide();
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], PoliticasUsuarioEditor.prototype, "politicas", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], PoliticasUsuarioEditor.prototype, "politicasUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], PoliticasUsuarioEditor.prototype, "dialog", void 0);
    PoliticasUsuarioEditor = __decorate([
        Component({
            selector: 'security-politicas-usuario-editor',
            template: "\n      <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <wj-flex-grid style=\"height:500px\" [itemsSource]=\"politicasCollection\">\n                          <wj-flex-grid-column [header]=\"'Pol\u00EDtica'\" [binding]=\"'descripcion'\" [width]=\"'*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Asignar'\" [allowResizing]=\"false\" [binding]=\"'selected'\" dataType=\"Boolean\" [width]=\"100\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [])
    ], PoliticasUsuarioEditor);
    return PoliticasUsuarioEditor;
}());
export { PoliticasUsuarioEditor };
