var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//
import { Context, PolicyInfo, PolicyType, PolicyScope, SubProceso } from '../../../core';
import { AztecaValidators } from '../../../controls';
import { ChangeState } from '../../../editors';
//
var PoliticasEditor = /** @class */ (function () {
    function PoliticasEditor(context, formBuilder) {
        this.context = context;
        this.formBuilder = formBuilder;
        this.tiposComponente = [];
        this.ROOT_COMPONENT = 1;
        this.CHILD_COMPONENT = 2;
        this.ambitos = [];
        this.tipos = [];
        this.subProcesosList = [];
        //Inputs
        this.politica = new PolicyInfo();
        this.subProcesos = [];
        //Outputs
        this.policyUpdated = new EventEmitter();
        this.form = this.formBuilder.group({
            'tipoComponente': [1, AztecaValidators.selected],
            'url': [''],
            'nombre': ['', Validators.required],
            'componente': [''],
            'valor': ['', Validators.required],
            'descripcion': ['', Validators.required],
            'tipo': ['U'],
            'ambito': ['G']
        });
        //Tipos de componente
        this.tiposComponente.push({ id: this.ROOT_COMPONENT, nombre: 'Raíz' });
        this.tiposComponente.push({ id: this.CHILD_COMPONENT, nombre: 'Hijo' });
        //Ambitos
        this.ambitos.push({ id: PolicyScope.GLOBAL, nombre: 'Aplicar a todos los usuarios' });
        this.ambitos.push({ id: PolicyScope.USER, nombre: 'Aplicar sólo a usuarios específicos' });
        //Tipos de política
        this.tipos.push({ id: PolicyType.UI, nombre: 'Interface' });
        this.tipos.push({ id: PolicyType.LOGIC, nombre: 'Lógica' });
    }
    //////////// METODOS //////////////////////////
    PoliticasEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.selectAction(); });
    };
    PoliticasEditor.prototype.selectAction = function () {
        //Crear una copia de los sub procesos y agregar opción para proceso principal
        this.subProcesosList = this.subProcesos.slice();
        var procLocal = new SubProceso();
        procLocal.nombre = '<Proceso principal>';
        procLocal.url = '';
        this.subProcesosList.unshift(procLocal);
        //Determinar si se creará o editará la política
        if (this.politica._clientID == 0) {
            this.form.reset({ url: '', tipoComponente: this.ROOT_COMPONENT, tipo: PolicyType.UI, ambito: PolicyScope.GLOBAL });
        }
        else {
            this.tipoComponente = this.politica.componente == '<ROOT>' ? this.ROOT_COMPONENT : this.CHILD_COMPONENT;
        }
    };
    //////////// HANDLERS //////////////////////////
    PoliticasEditor.prototype.onUpdate = function () {
        if (this.politica.state == ChangeState.UNCHANGED) {
            this.politica.state = ChangeState.MODIFIED;
        }
        //Si el tipo de componente es raíz, asignar valor estático a campo del nombre
        if (this.tipoComponente == this.ROOT_COMPONENT) {
            this.politica.componente = '<ROOT>';
        }
        this.dialog.hide();
        this.policyUpdated.emit(this.politica);
    };
    PoliticasEditor.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        Input(),
        __metadata("design:type", PolicyInfo)
    ], PoliticasEditor.prototype, "politica", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], PoliticasEditor.prototype, "subProcesos", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], PoliticasEditor.prototype, "policyUpdated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], PoliticasEditor.prototype, "dialog", void 0);
    PoliticasEditor = __decorate([
        Component({
            selector: 'security-politicas-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n\n\n                          <azteca-form-field [label]=\"'Aplica para:'\">\n                              <az-combobox formControlName=\"url\" \n                                           [(ngModel)]=\"politica.url\" \n                                           [items]=\"subProcesosList\" \n                                           [valueMember]=\"'url'\"\n                                           [displayMember]=\"'nombre'\"></az-combobox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Tipo de componente:'\">\n                              <az-combobox \n                                           formControlName=\"tipoComponente\"\n                                           [(ngModel)]=\"tipoComponente\"\n                                           [items]=\"tiposComponente\"\n                                           [valueMember]=\"'id'\"\n                                           [displayMember]=\"'nombre'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Componente:'\" *ngIf=\"tipoComponente == CHILD_COMPONENT\">\n                              <az-textbox formControlName=\"componente\" [(ngModel)]=\"politica.componente\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Nombre:'\">\n                              <az-textbox formControlName=\"nombre\" [(ngModel)]=\"politica.nombre\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Valor:'\">\n                              <az-textbox formControlName=\"valor\" [(ngModel)]=\"politica.valor\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Alcance predeterminado:'\">\n                              <az-combobox formControlName=\"ambito\"\n                                           [(ngModel)]=\"politica.ambito\"\n                                           [items]=\"ambitos\"\n                                           [valueMember]=\"'id'\"\n                                           [displayMember]=\"'nombre'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Tipo de pol\u00EDtica:'\">\n                              <az-combobox formControlName=\"tipo\"\n                                           [(ngModel)]=\"politica.tipo\"\n                                           [items]=\"tipos\"\n                                           [valueMember]=\"'id'\"\n                                           [displayMember]=\"'nombre'\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                              <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"politica.descripcion\"></az-textarea>\n                          </azteca-form-field>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate($event)\" [disabled]=\"!form.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div>\n      </form> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder])
    ], PoliticasEditor);
    return PoliticasEditor;
}());
export { PoliticasEditor };
