var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';
//ng2 bootstrap
import { ModalDirective } from 'ngx-bootstrap';
//
import { Context, SubProceso } from '../../../core';
//
var SubProcesosEditor = /** @class */ (function () {
    function SubProcesosEditor(context, formBuilder) {
        this.context = context;
        this.formBuilder = formBuilder;
        this.tiposComponente = [];
        this.ROOT_COMPONENT = 1;
        this.CHILD_COMPONENT = 2;
        this.ambitos = [];
        this.tipos = [];
        //Inputs
        this.subProceso = new SubProceso();
        //Outputs
        this.updated = new EventEmitter();
        this.form = this.formBuilder.group({
            'nombre': ['', Validators.required],
            'url': ['', Validators.required]
        });
    }
    //////////// METODOS //////////////////////////
    SubProcesosEditor.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.selectAction(); });
    };
    SubProcesosEditor.prototype.selectAction = function () {
        this.form.reset({ nombre: '', url: '' });
    };
    //////////// HANDLERS //////////////////////////
    SubProcesosEditor.prototype.onUpdate = function () {
        this.dialog.hide();
        this.updated.emit(this.subProceso);
    };
    SubProcesosEditor.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        Input(),
        __metadata("design:type", SubProceso)
    ], SubProcesosEditor.prototype, "subProceso", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], SubProcesosEditor.prototype, "updated", void 0);
    __decorate([
        ViewChild(ModalDirective),
        __metadata("design:type", ModalDirective)
    ], SubProcesosEditor.prototype, "dialog", void 0);
    SubProcesosEditor = __decorate([
        Component({
            selector: 'security-sub-procesos-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n\n                          <azteca-form-field [label]=\"'Nombre:'\">\n                              <az-textbox formControlName=\"nombre\" [(ngModel)]=\"subProceso.nombre\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Url:'\">\n                              <az-textbox formControlName=\"url\" [(ngModel)]=\"subProceso.url\"></az-textbox>\n                          </azteca-form-field>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate($event)\" [disabled]=\"!form.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div>\n      </form> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, FormBuilder])
    ], SubProcesosEditor);
    return SubProcesosEditor;
}());
export { SubProcesosEditor };
