import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Menu } from 'wijmo/wijmo.input';
import { FlexGrid, DataMap } from 'wijmo/wijmo.grid';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, ProcesoService, ProcesoInfo, TipoProceso, PolicyInfo, SubProceso } from '../../core';
import { CatalogOptions } from '../../custom';
import { ToolbarButton, MenuItem } from '../../controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from '../../editors';
import { PoliticasEditor } from './parts/politicas.editor';
import { SubProcesosEditor } from './parts/sub-procesos.editor';
export declare class ProcesosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private procesoService;
    proceso: ProcesoInfo;
    tipos: TipoProceso[];
    currentPolitica: PolicyInfo;
    politicasCollection: TrackableCollection;
    politicasMenu: MenuItem[];
    ambitosMap: DataMap;
    subProcesosCollection: TrackableCollection;
    currentSubProceso: SubProceso;
    private _lastPolID;
    private _lastSubProcID;
    editorPoliticas: PoliticasEditor;
    editorSubProcesos: SubProcesosEditor;
    deletePolicyDialog: ModalDirective;
    deleteSubProcesoDialog: ModalDirective;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, procesoService: ProcesoService);
    createPoliticasMenu(): void;
    loadTiposProceso(): void;
    clonePolicy(original: PolicyInfo): PolicyInfo;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onProcesoMenuClick(item: MenuItem): void;
    onSubProcesosToolbar(button: ToolbarButton): void;
    onSubProcesoAdded(subProceso: SubProceso): void;
    onDeleteSubProceso(subProceso: SubProceso): void;
    onConfirmDeleteSubProceso(): void;
    politicasGridInitialized(sender: FlexGrid, args: any): void;
    onPoliticasToolbar(button: ToolbarButton): void;
    politicasMenuClick(menu: Menu): void;
    selectPoliticasAction(item: MenuItem): void;
    onPoliticaUpdated(politica: PolicyInfo): void;
    onDeletePolicy(): void;
    tabSelected(args: any): void;
}
