var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
//
import { BaseComponent, Context, SucursalService } from '../../core';
import { AlertsBarComponent } from '../../controls/index';
//
import { UsuariosListComponent } from '../components/dialogs/usuarios-list.component';
var SucursalMiembrosComponent = /** @class */ (function (_super) {
    __extends(SucursalMiembrosComponent, _super);
    //
    function SucursalMiembrosComponent(context, sucursalService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.sucursalService = sucursalService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.title = '';
        return _this;
    }
    SucursalMiembrosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idSucursal = +param['id'];
        });
    };
    SucursalMiembrosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.refreshList(); });
        setTimeout(function (_) { return _this.loadSucursal(); });
    };
    ///////////////// METODOS ///////////////////////////////
    SucursalMiembrosComponent.prototype.loadSucursal = function () {
        var _this = this;
        this.sucursalService.getDetailByID(this.idSucursal)
            .then(function (info) {
            _this.sucursal = info;
            _this.title = 'Miembros de la sucursal - ' + _this.sucursal.nombre;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalMiembrosComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.getMembers(this.idSucursal)
            .then(function (usuarios) {
            _this.usuarios = usuarios;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////// HANDLERS ///////////////////////////////
    SucursalMiembrosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    SucursalMiembrosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.usuariosDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    SucursalMiembrosComponent.prototype.onSelectedUsersChanged = function (newUsers) {
        var _this = this;
        this.sucursalService.addMembers(this.idSucursal, newUsers)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los usuarios han sido agregados con éxito.', 'success');
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalMiembrosComponent.prototype.onRemoveUser = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.removeMember(this.idSucursal, this.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.usuarios = _this.usuarios.filter(function (item) { return item.id != _this.currentItem.id; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalMiembrosComponent.prototype.applyPolicy = function (policy) {
    };
    SucursalMiembrosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        ViewChild(UsuariosListComponent),
        __metadata("design:type", UsuariosListComponent)
    ], SucursalMiembrosComponent.prototype, "usuariosDialog", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], SucursalMiembrosComponent.prototype, "alerts", void 0);
    SucursalMiembrosComponent = __decorate([
        Component({
            selector: 'security-sucursal-miembros',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Usuarios'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de usuarios-->\n                  <azteca-catalog-list [catalogList]=\"usuarios\"\n                                       [showRowButton]=\"true\"\n                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                       (rowButtonClick)=\"onRemoveUser()\"\n                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                       [enabled]=\"enabled\"\n                                       [pageSize]=\"15\"\n                                       [serverSide]=\"false\">\n\n                      <azteca-grid-column [header]=\"'ID'\" [binding]=\"'id'\" [width]=\"50\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'20*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombrePersona'\" [width]=\"'40*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'10*'\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n\n\n              </az-panel>\n          </div>\n      </div>\n\n      <security-usuarios-list (selectedItemsChanged)=\"onSelectedUsersChanged($event)\"\n                              [excludedItems]=\"usuarios\"\n                              [multiSelect]=\"true\">\n\n      </security-usuarios-list>\n    "
        }),
        __metadata("design:paramtypes", [Context, SucursalService, Router, ActivatedRoute,
            Location])
    ], SucursalMiembrosComponent);
    return SucursalMiembrosComponent;
}(BaseComponent));
export { SucursalMiembrosComponent };
