import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, SucursalInfo, SucursalService, EmpresaService } from '../../core';
import { CatalogOptions } from '../../custom';
import { MenuItem } from '../../controls';
import { CatalogEditor, EditorEventArgs } from '../../editors';
export declare class SucursalesEditor extends CatalogEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    private sucursalService;
    private empresaService;
    sucursal: SucursalInfo;
    idEmpresa: number;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, sucursalService: SucursalService, empresaService: EmpresaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onCancelingEdit(): void;
    onMenuItemClick(option: MenuItem): void;
    onDomicilioValidChange(): void;
}
