import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem, SucursalItem, SucursalService } from '../../core';
import { CatalogOptions } from '../../custom';
import { CatalogManager } from '../../editors';
import { SearchRequest } from '../../search';
import { MenuItem } from '../../controls';
export declare class SucursalesManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private sucursalService;
    idEmpresa: number;
    sucursales: SucursalItem[];
    listUpdated: EventEmitter<void>;
    constructor(router: Router, route: ActivatedRoute, context: Context, sucursalService: SucursalService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
}
