var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//Azteca Kernel
import { Context, BaseComponent, CatalogService, SucursalService } from '../../core';
import { CatalogManager } from '../../editors';
//
var SucursalesManager = /** @class */ (function (_super) {
    __extends(SucursalesManager, _super);
    function SucursalesManager(router, route, context, sucursalService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.sucursalService = sucursalService;
        //
        _this.listUpdated = new EventEmitter();
        return _this;
    }
    SucursalesManager_1 = SucursalesManager;
    SucursalesManager.prototype.onConfigureCatalog = function (options) {
    };
    SucursalesManager.prototype.doSearch = function (request) {
    };
    SucursalesManager.prototype.onAddingItem = function () {
        this.router.navigate(['kernel/security/sucursales', this.process.id, this.idEmpresa, 0]);
    };
    SucursalesManager.prototype.onViewingItem = function (item) {
        this.router.navigate(['kernel/security/sucursales', this.process.id, this.idEmpresa, item.id, { readonly: true }]);
    };
    SucursalesManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['kernel/security/sucursales', this.process.id, this.idEmpresa, item.id]);
    };
    SucursalesManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.sucursalService.delete(item.id)
            .then(function (success) {
            _this.listUpdated.emit();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesManager.prototype.onCloningItem = function (item) {
        this.router.navigate(['kernel/security/sucursales', this.idEmpresa, 0, { cloneId: item.id }]);
    };
    SucursalesManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.sucursalService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.listUpdated.emit();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['kernel/security/sucursales', this.process.id, this.idEmpresa, this.manager.currentItem.id, 'members']);
        }
    };
    var SucursalesManager_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], SucursalesManager.prototype, "idEmpresa", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], SucursalesManager.prototype, "sucursales", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], SucursalesManager.prototype, "listUpdated", void 0);
    SucursalesManager = SucursalesManager_1 = __decorate([
        Component({
            selector: 'azteca-sucursales-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (configureCatalog)=\"onConfigureCatalog($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n                              (menuItemClick)=\"onMenuItemClick($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [allowAudit]=\"allowAudit\"\n                              [catalogList]=\"sucursales\"\n                              [pageSize]=\"15\"\n                              [standAlone]=\"false\"\n                              [serverSide]=\"false\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n          <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n\n\n          <!------------------- Columnas del listado ----------------------------->\n    \n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\" ></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Domicilio'\" [binding]=\"'domicilio'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Colonia'\" [binding]=\"'colonia'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Poblaci\u00F3n'\" [binding]=\"'poblacion'\" [width]=\"'2*'\"></azteca-grid-column>\n   \n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return SucursalesManager_1; })
                },
                {
                    provide: CatalogService, useExisting: SucursalService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, Context, SucursalService])
    ], SucursalesManager);
    return SucursalesManager;
}(CatalogManager));
export { SucursalesManager };
