import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { FlexGrid } from 'wijmo/wijmo.grid';
import { Context, BaseComponent, PolicyInfo, PolicyAccess, UsuarioInfo, UsuarioService, ProcesoAcceso, ModuloInfo, EmpresaService, EmpresaItem, SucursalService, SucursalItem } from '../../core';
import { MenuItem, ToolbarButton, AlertsBarComponent } from '../../controls';
import { PoliticasUsuarioEditor } from './parts/politicas-usuario.editor';
import { PoliticasGlobalesEditor } from './parts/politicas-globales.editor';
export declare class UsuarioAccesosComponent extends BaseComponent {
    private context;
    private route;
    private location;
    private usuarioService;
    private empresaService;
    private sucursalService;
    usuario: UsuarioInfo;
    accesos: ProcesoAcceso[];
    accesosCollection: CollectionView;
    empresas: EmpresaItem[];
    idEmpresa: number;
    sucursales: SucursalItem[];
    idSucursal: number;
    currentModule: ModuloInfo;
    politicasMenu: MenuItem[];
    currentProceso: ProcesoAcceso;
    allowSelection: boolean;
    politicasUsuarioEditor: PoliticasUsuarioEditor;
    politicasGlobalesEditor: PoliticasGlobalesEditor;
    alerts: AlertsBarComponent;
    constructor(context: Context, route: ActivatedRoute, location: Location, usuarioService: UsuarioService, empresaService: EmpresaService, sucursalService: SucursalService);
    ngOnInit(): void;
    loadUsuario(idUsuario: number): void;
    loadEmpresasUsuario(idUsuario: number): void;
    loadSucursalesUsuario(idEmpresa: number, idUsuario: number): void;
    loadAccesos(idUsuario: number, idSucursal: number): void;
    saveAccesos(): void;
    createPoliticasMenu(): void;
    onUsuarioSelected(usuario: UsuarioInfo): void;
    onSelectedEmpresaChanged(idEmpresa: number): void;
    onSelectedSucursalChanged(idSucursal: number): void;
    onMainToolbarClick(button: ToolbarButton): void;
    onModuloSelected(modulo: ModuloInfo): void;
    procesosGridInitialized(grid: FlexGrid): void;
    selectPoliticasAction(option: MenuItem): void;
    onProcesosToolbarClick(option: MenuItem): void;
    politicasMenuClick(menu: Menu): void;
    onPoliticasUsuarioUpdated(politicas: PolicyAccess[]): void;
    onPoliticasGlobalesUpdated(politicas: PolicyAccess[]): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    cboResets(): void;
}
