import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, PolicyInfo, UsuarioInfo, EmpresaItem, SucursalItem, UsuarioService, EmpresaService, SucursalService } from '../../core';
import { ToolbarButton, AlertsBarComponent } from '../../controls/index';
import { SucursalesListComponent } from './dialogs/sucursales-list.component';
export declare class UsuarioSucursalesComponent extends BaseComponent {
    private context;
    private router;
    private route;
    private location;
    private usuarioService;
    private sucursalService;
    private empresaService;
    sucursales: SucursalItem[];
    currentSucursales: SucursalItem[];
    empresas: EmpresaItem[];
    idUsuario: number;
    usuario: UsuarioInfo;
    currentItem: SucursalItem;
    idEmpresa: number;
    readonly title: string;
    sucursalesDialog: SucursalesListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, usuarioService: UsuarioService, sucursalService: SucursalService, empresaService: EmpresaService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadUsuario(): void;
    loadEmpresas(): void;
    refreshList(): void;
    onCurrentItemChanged(item: SucursalItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedEmpresaChanged(idEmpresa: number): void;
    onSelectedBranchesChanged(newBranches: SucursalItem[]): void;
    onRemoveBranch(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
