var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
//
import { BaseComponent, Context, UsuarioInfo, UsuarioService, EmpresaService, SucursalService } from '../../core';
import { AlertsBarComponent } from '../../controls/index';
//
import { SucursalesListComponent } from './dialogs/sucursales-list.component';
var UsuarioSucursalesComponent = /** @class */ (function (_super) {
    __extends(UsuarioSucursalesComponent, _super);
    //
    function UsuarioSucursalesComponent(context, router, route, location, usuarioService, sucursalService, empresaService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.usuarioService = usuarioService;
        _this.sucursalService = sucursalService;
        _this.empresaService = empresaService;
        _this.sucursales = [];
        _this.currentSucursales = [];
        _this.empresas = [];
        _this.idUsuario = 0;
        _this.usuario = new UsuarioInfo();
        _this.idEmpresa = 0;
        return _this;
    }
    Object.defineProperty(UsuarioSucursalesComponent.prototype, "title", {
        get: function () {
            return 'Acceso a sucursales del usuario - ' + this.usuario.code;
        },
        enumerable: true,
        configurable: true
    });
    UsuarioSucursalesComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idUsuario = +param['id'];
        });
    };
    UsuarioSucursalesComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.refreshList(); });
        setTimeout(function (_) { return _this.loadUsuario(); });
        setTimeout(function (_) { return _this.loadEmpresas(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    UsuarioSucursalesComponent.prototype.loadUsuario = function () {
        var _this = this;
        this.usuarioService.getDetailByID(this.idUsuario)
            .then(function (user) { return _this.usuario = user; })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuarioSucursalesComponent.prototype.loadEmpresas = function () {
        var _this = this;
        this.empresaService.loadList()
            .then(function (empresas) { return _this.empresas = empresas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuarioSucursalesComponent.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.usuarioService.loadBranchAccess(this.idUsuario)
            .then(function (sucursales) {
            _this.sucursales = sucursales;
            _this.currentSucursales = _this.sucursales.filter(function (s) { return s.idEmpresa == _this.idEmpresa; });
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    UsuarioSucursalesComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    UsuarioSucursalesComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.sucursalesDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.refreshList();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    UsuarioSucursalesComponent.prototype.onSelectedEmpresaChanged = function (idEmpresa) {
        this.currentSucursales = this.sucursales.filter(function (s) { return s.idEmpresa == idEmpresa; });
    };
    UsuarioSucursalesComponent.prototype.onSelectedBranchesChanged = function (newBranches) {
        var _this = this;
        this.context.app.showSpinner();
        this.usuarioService.addBranches(this.idUsuario, newBranches)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los accesos han sido concedidos con éxito.', 'success');
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuarioSucursalesComponent.prototype.onRemoveBranch = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.usuarioService.removeBranch(this.idUsuario, this.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            var index = _this.sucursales.findIndex(function (s) { return s.id == _this.currentItem.id; });
            _this.sucursales.splice(index, 1);
            _this.currentSucursales = _this.sucursales.filter(function (s) { return s.idEmpresa == _this.idEmpresa; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuarioSucursalesComponent.prototype.applyPolicy = function (policy) {
    };
    UsuarioSucursalesComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        ViewChild(SucursalesListComponent),
        __metadata("design:type", SucursalesListComponent)
    ], UsuarioSucursalesComponent.prototype, "sucursalesDialog", void 0);
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], UsuarioSucursalesComponent.prototype, "alerts", void 0);
    UsuarioSucursalesComponent = __decorate([
        Component({
            selector: 'security-usuario-sucursales',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!-- Lista de empresas -->\n                  <div class=\"row\">\n                      <div class=\"col-12 col-lg-6\">\n                          <label class=\"form-control-label\">Empresa:</label>\n                          <az-combobox [items]=\"empresas\" \n                                       [valueMember]=\"'id'\" \n                                       [displayMember]=\"'nombre'\" \n                                       [(ngModel)]=\"idEmpresa\"\n                                       (selectedItemChanged)=\"onSelectedEmpresaChanged($event)\">\n                          </az-combobox>\n                      </div>\n                  </div>\n\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Asignar sucursales'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"idEmpresa > 0\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de sucursales-->\n                  <azteca-catalog-list [catalogList]=\"currentSucursales\"\n                                       [showRowButton]=\"true\"\n                                       [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                       (rowButtonClick)=\"onRemoveBranch()\"\n                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                       [enabled]=\"enabled\"\n                                       [pageSize]=\"15\"\n                                       [serverSide]=\"false\">\n\n                      <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Domicilio'\" [binding]=\"'domicilio'\" [width]=\"'3*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Colonia'\" [binding]=\"'colonia'\" [width]=\"'2*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Poblaci\u00F3n'\" [binding]=\"'poblacion'\" [width]=\"'2*'\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n\n\n              </az-panel>\n          </div>\n      </div>\n\n      <security-sucursales-list   (selectedItemsChanged)=\"onSelectedBranchesChanged($event)\"\n                                  [idEmpresa]=\"idEmpresa\"\n                                  [excludedItems]=\"sucursales\"\n                                  [multiSelect]=\"true\">\n\n      </security-sucursales-list>\n    "
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute, Location,
            UsuarioService, SucursalService, EmpresaService])
    ], UsuarioSucursalesComponent);
    return UsuarioSucursalesComponent;
}(BaseComponent));
export { UsuarioSucursalesComponent };
