import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, UsuarioService, UsuarioInfo, GrupoItem } from '../../core';
import { CatalogOptions } from '../../custom/index';
import { ToolbarButton, MenuItem } from '../../controls/index';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from '../../editors/index';
import { GruposListComponent } from './dialogs/grupos-list.component';
export declare class UsuariosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private usuarioService;
    usuario: UsuarioInfo;
    gruposCollection: TrackableCollection;
    systemUser: boolean;
    gruposList: GruposListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, usuarioService: UsuarioService);
    resetPassword(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(option: MenuItem): void;
    onPersonValidChange(): void;
    onGruposToolbar(button: ToolbarButton): void;
    onDeleteGroup(grupo: GrupoItem): void;
    onSelectedGroupsChanged(grupos: GrupoItem[]): void;
    onTabSelected(args: any): void;
}
