var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
//Frameworks
import { Component, forwardRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
//Azteca Kernel
import { Context, BaseComponent, CatalogService, UsuarioService } from '../../core';
import { CatalogManager } from '../../editors';
//Features
var UsuariosManager = /** @class */ (function (_super) {
    __extends(UsuariosManager, _super);
    //    
    function UsuariosManager(router, route, context, usuarioService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.usuarioService = usuarioService;
        _this.usuarios = [];
        return _this;
    }
    UsuariosManager_1 = UsuariosManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    UsuariosManager.prototype.resetPassword = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.usuarioService.resetPassword(this.manager.currentItem.id)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.showAlert('El password ha sido reestablecido con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    UsuariosManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    UsuariosManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.usuarioService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.usuarios = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuariosManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    UsuariosManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    UsuariosManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    UsuariosManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.usuarioService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuariosManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    UsuariosManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.usuarioService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UsuariosManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'SITES') {
            this.router.navigate([this.manager.currentItem.id, 'branches'], { relativeTo: this.route });
        }
        else if (option.name == 'ACCESS') {
        }
        else if (option.name == 'RESET') {
            this.resetPassword();
        }
    };
    var UsuariosManager_1;
    UsuariosManager = UsuariosManager_1 = __decorate([
        Component({
            selector: 'security-usuarios-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Usuarios</div>\n          <div class=\"card-body\">\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n                                      [enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [allowAudit]=\"allowAudit\"\n                                      [catalogList]=\"usuarios\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'SITES'\" [icon]=\"'fa fa-building'\" [text]=\"'Sucursales'\" [smallText]=\"'accesos a empresas y sucursales'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'ACCESS'\" [icon]=\"'glyphicon glyphicon-lock'\" [text]=\"'Accesos'\" [smallText]=\"'accesos a procesos y pol\u00EDticas'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'RESET'\" [icon]=\"'glyphicon glyphicon-erase'\" [text]=\"'Reestablecer contrase\u00F1a'\" [smallText]=\"'reestablecer la contrase\u00F1a'\"></azteca-menu-item>\n\n                  <!------------------- Columnas del listado --------------------->\n\n                  <azteca-grid-column [header]=\"'Usuario'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Dominio'\" [binding]=\"'dominio'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Correo'\" [binding]=\"'correo'\" [width]=\"'20*'\"></azteca-grid-column>\n\n\n              </azteca-catalog-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: BaseComponent, useExisting: forwardRef(function () { return UsuariosManager_1; })
                },
                {
                    provide: CatalogService, useExisting: UsuarioService
                }
            ]
        }),
        __metadata("design:paramtypes", [Router, ActivatedRoute, Context, UsuarioService])
    ], UsuariosManager);
    return UsuariosManager;
}(CatalogManager));
export { UsuariosManager };
