var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
//Modulos
import { SecurityRoutingModule } from './security.routing.module';
import { UtilsModule } from '../utils/utils.module';
import { SearchModule } from '../search/search.module';
import { ControlsModule } from '../controls/controls.module';
import { GeneralModule } from '../general/general.module';
import { EditorsModule } from '../editors/editors.module';
import { GeolocationModule } from '../geolocation/geolocation.module';
//Bootstrap
import { TabsModule, ModalModule } from 'ngx-bootstrap';
//Wijmo
import { WjCoreModule } from 'wijmo/wijmo.angular2.core';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
//Components
import { EmpresasManager } from './components/empresas.manager';
import { EmpresasEditor } from './components/empresas.editor';
import { SucursalesManager } from './components/sucursales.manager';
import { SucursalesEditor } from './components/sucursales.editor';
import { GruposManager } from './components/grupos.manager';
import { GruposEditor } from './components/grupos.editor';
import { RolesManager } from './components/roles.manager';
import { RolesEditor } from './components/roles.editor';
import { ProcesosManager } from './components/procesos.manager';
import { ProcesosEditor } from './components/procesos.editor';
import { ModulosManager } from './components/modulos.manager';
import { UsuariosManager } from './components/usuarios.manager';
import { UsuariosEditor } from './components/usuarios.editor';
import { GrupoMiembrosComponent } from './components/grupo-miembros.component';
import { SucursalMiembrosComponent } from './components/sucursal-miembros.component';
import { GrupoAccesosComponent } from './components/grupo-accesos.component';
import { UsuarioAccesosComponent } from './components/usuario-accesos.component';
import { UnauthorizedComponent } from './components/unauthorized.component';
import { UsuarioSucursalesComponent } from './components/usuario-sucursales.component';
//Controls
import { ModulosTreeComponent } from './components/controls/modulos-tree.component';
import { UsuariosListComponent } from './components/dialogs/usuarios-list.component';
import { GruposListComponent } from './components/dialogs/grupos-list.component';
import { SucursalesListComponent } from './components/dialogs/sucursales-list.component';
import { ModulosDialogComponent } from './components/dialogs/modulos-dialog.component';
import { ModuloSelectorComponent } from './components/controls/modulo-selector.component';
import { RolSelectorComponent } from './components/controls/rol-selector.component';
import { GrupoSelectorComponent } from './components/controls/grupo-selector.component';
import { UsuarioSelectorComponent } from './components/controls/usuario-selector.component';
import { SucursalSelectorComponent } from './components/controls/sucursal-selector.component';
//Parts
import { PoliticasEditor } from './components/parts/politicas.editor';
import { PoliticasUsuarioEditor } from './components/parts/politicas-usuario.editor';
import { PoliticasGlobalesEditor } from './components/parts/politicas-globales.editor';
import { SubProcesosEditor } from './components/parts/sub-procesos.editor';
var COMPONENTES = [EmpresasManager, EmpresasEditor, SucursalesManager, SucursalesEditor, GruposManager, GruposEditor,
    RolesEditor, RolesManager, GrupoMiembrosComponent, ModulosManager, UsuariosListComponent, ProcesosManager, ProcesosEditor,
    ModulosTreeComponent, ModulosDialogComponent, ModuloSelectorComponent, UsuariosManager, UsuariosEditor, RolSelectorComponent,
    PoliticasEditor, SucursalMiembrosComponent, GrupoAccesosComponent, UsuarioAccesosComponent, GrupoSelectorComponent, UsuarioSelectorComponent,
    PoliticasUsuarioEditor, PoliticasGlobalesEditor, UnauthorizedComponent, SubProcesosEditor, GruposListComponent, SucursalesListComponent,
    UsuarioSucursalesComponent, SucursalSelectorComponent];
var SERVICIOS = [];
var SecurityModule = /** @class */ (function () {
    function SecurityModule() {
    }
    SecurityModule = __decorate([
        NgModule({
            imports: [
                FormsModule, ReactiveFormsModule, CommonModule,
                TabsModule.forRoot(), ModalModule.forRoot(),
                SecurityRoutingModule, UtilsModule, SearchModule, EditorsModule, ControlsModule, GeneralModule, GeolocationModule,
                WjCoreModule, WjInputModule, WjGridModule, WjGridFilterModule
            ],
            declarations: COMPONENTES,
            providers: SERVICIOS,
            exports: COMPONENTES
        })
    ], SecurityModule);
    return SecurityModule;
}());
export { SecurityModule };
