var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
//Components
import { EmpresasManager } from './components/empresas.manager';
import { EmpresasEditor } from './components/empresas.editor';
import { SucursalesManager } from './components/sucursales.manager';
import { SucursalesEditor } from './components/sucursales.editor';
import { GruposManager } from './components/grupos.manager';
import { GruposEditor } from './components/grupos.editor';
import { RolesManager } from './components/roles.manager';
import { RolesEditor } from './components/roles.editor';
import { ModulosManager } from './components/modulos.manager';
import { ProcesosManager } from './components/procesos.manager';
import { ProcesosEditor } from './components/procesos.editor';
import { UsuariosManager } from './components/usuarios.manager';
import { UsuariosEditor } from './components/usuarios.editor';
import { GrupoAccesosComponent } from './components/grupo-accesos.component';
import { UsuarioAccesosComponent } from './components/usuario-accesos.component';
import { UnauthorizedComponent } from './components/unauthorized.component';
//Parts
import { GrupoMiembrosComponent } from './components/grupo-miembros.component';
import { SucursalMiembrosComponent } from './components/sucursal-miembros.component';
import { UsuarioSucursalesComponent } from './components/usuario-sucursales.component';
//Guards
import { EditorDeactivateGuard } from '../editors/index';
import { AuthGuard } from '../core/services/auth-guard.service';
var routes = [
    {
        path: '',
        canActivateChild: [AuthGuard],
        children: [
            { path: 'empresas/:proceso', component: EmpresasManager },
            { path: 'empresas/:proceso/:id', component: EmpresasEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'sucursales/:proceso', component: SucursalesManager },
            { path: 'sucursales/:proceso/:idEmpresa/:id', component: SucursalesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'sucursales/:proceso/:idEmpresa/:id/members', component: SucursalMiembrosComponent },
            { path: 'grupos/:proceso', component: GruposManager },
            { path: 'grupos/:proceso/:id', component: GruposEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'grupos/:proceso/:id/members', component: GrupoMiembrosComponent },
            { path: 'roles/:proceso', component: RolesManager },
            { path: 'roles/:proceso/:id', component: RolesEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'modulos/:proceso', component: ModulosManager, canDeactivate: [EditorDeactivateGuard] },
            { path: 'procesos/:proceso', component: ProcesosManager },
            { path: 'procesos/:proceso/:id', component: ProcesosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'usuarios/:proceso', component: UsuariosManager },
            { path: 'usuarios/:proceso/:id', component: UsuariosEditor, canDeactivate: [EditorDeactivateGuard] },
            { path: 'usuarios/:proceso/:id/branches', component: UsuarioSucursalesComponent },
            { path: 'grupo-accesos/:proceso', component: GrupoAccesosComponent },
            { path: 'usuario-accesos/:proceso', component: UsuarioAccesosComponent },
            { path: 'unauthorized', component: UnauthorizedComponent }
        ]
    },
];
var SecurityRoutingModule = /** @class */ (function () {
    function SecurityRoutingModule() {
    }
    SecurityRoutingModule = __decorate([
        NgModule({
            imports: [
                RouterModule.forChild(routes)
            ],
            exports: [
                RouterModule
            ]
        })
    ], SecurityRoutingModule);
    return SecurityRoutingModule;
}());
export { SecurityRoutingModule };
