var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewChild } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import * as moment from 'moment';
import { CollectionView } from 'wijmo/wijmo';
import { ModalDirective } from 'ngx-bootstrap';
//
import { Context } from '../../core/services/context';
import { AlertsBarComponent } from '../../controls/components/alerts-bar.component';
//
import { EventLogService } from '../services/event-log.service';
import { EventLogEntry } from '../models/event-log-entry';
var EventLogComponent = /** @class */ (function () {
    function EventLogComponent(context, router, route, eventService) {
        this.context = context;
        this.router = router;
        this.route = route;
        this.eventService = eventService;
        this.origen = '';
        this.tipo = '';
        this.logCollection = new CollectionView();
        this.currentEntry = new EventLogEntry();
        this.fechaInicial = moment().subtract(1, 'day').toDate();
        this.fechaFinal = moment().add(1, 'day').toDate();
    }
    /////////////////////// METODOS ////////////////////////////////////////////////
    EventLogComponent.prototype.loadLog = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.eventService.load(this.fechaInicial, this.fechaFinal, this.origen, this.tipo)
            .then(function (log) {
            _this.logCollection.sourceCollection = log;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////// HANDLERS ///////////////////////////////////////////////
    EventLogComponent.prototype.mainToolbarClick = function (button) {
        if (button.name == 'REFRESH') {
            this.loadLog();
        }
    };
    EventLogComponent.prototype.onRowView = function (entry) {
        this.currentEntry = entry;
        this.detailsDialog.config.backdrop = false;
        this.detailsDialog.show();
    };
    EventLogComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        ViewChild(AlertsBarComponent),
        __metadata("design:type", AlertsBarComponent)
    ], EventLogComponent.prototype, "alerts", void 0);
    __decorate([
        ViewChild('detailsDialog'),
        __metadata("design:type", ModalDirective)
    ], EventLogComponent.prototype, "detailsDialog", void 0);
    EventLogComponent = __decorate([
        Component({
            selector: 'tracing-event-log',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <alerts-bar></alerts-bar>\n          </div>\n      </div>\n      <div class=\"row\">\n          <div class=\"col-12 col-lg-3\">\n              <az-panel [header]=\"'Visor de sucesos del sistema'\">            \n                  <az-panel [header]=\"'Filtros'\">\n                      <!--Fecha Inicial-->\n                      <label class=\"form-control-label\">Fecha inicial:</label>\n                      <az-input-date-time [(ngModel)]=\"fechaInicial\"></az-input-date-time>\n                      <!--Fecha final-->\n                      <label class=\"form-control-label\">Fecha final:</label>\n                      <az-input-date-time [(ngModel)]=\"fechaFinal\"></az-input-date-time>\n                      <!--Origen-->\n                      <label class=\"form-control-label\">Or\u00EDgen:</label>\n                      <az-textbox [(ngModel)]=\"origen\"></az-textbox>\n                      <!--Tipo-->\n                      <label class=\"form-control-label\">Tipo:</label>\n\n                      <br />\n\n                      <az-toolbar (buttonClick)=\"mainToolbarClick($event)\">\n                          <az-toolbar-button [name]=\"'REFRESH'\" [type]=\"'primary'\" [text]=\"'Actualizar lista'\" [icon]=\"'glyphicon glyphicon-refresh'\"></az-toolbar-button>\n                      </az-toolbar>\n\n                  </az-panel>\n              </az-panel>\n          </div>\n          <div class=\"col-12 col-lg-9\">\n              <az-panel [header]=\"'Registros'\">\n\n                  <wj-flex-grid style=\"height:550px\" [itemsSource]=\"logCollection\" [isReadOnly]=\"true\">\n\n                      <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                      <wj-flex-grid-column [header]=\"''\" [width]=\"60\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowView(cell.item)\">\n                                  <span class=\"glyphicon glyphicon-search\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>\n\n                      <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'time'\" [width]=\"200\" [format]=\"'dd/MM/yyyy hh:mm tt'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Mensaje'\" [binding]=\"'message'\" [width]=\"'50*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Origen'\" [binding]=\"'source'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'type'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n\n\n              </az-panel>\n          </div>\n      </div>\n\n\n      <div bsModal #detailsDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Detalles del error</h4>\n                      <button type=\"button\" class=\"close pull-right\" (click)=\"detailsDialog.hide()\" aria-label=\"Close\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <textarea readonly style=\"height: 500px;\" class=\"form-control\" [value]=\"currentEntry.message\"></textarea>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"detailsDialog.hide()\">Cerrar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [Context, Router, ActivatedRoute,
            EventLogService])
    ], EventLogComponent);
    return EventLogComponent;
}());
export { EventLogComponent };
