var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import * as moment from 'moment';
import { map } from 'rxjs/operators';
//
import { Context } from '../../core/services/context';
import { BaseService } from '../../core/services/base-service';
var EventLogService = /** @class */ (function (_super) {
    __extends(EventLogService, _super);
    function EventLogService(http, context) {
        var _this = _super.call(this, http, context, 'api/kernel/tracing/event-log') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    EventLogService.prototype.load = function (startDate, endDate, source, type) {
        var params = new HttpParams()
            .set('startDate', moment(startDate).format())
            .set('endDate', moment(endDate).format())
            .set('source', source)
            .set('type', type);
        //
        var item = this.apiService.get('load', params);
        return item.pipe(map(function (log) {
            log.forEach(function (entry) {
                entry.date = moment(entry.date).toDate();
                entry.time = moment(entry.time).toDate();
            });
            return log;
        })).toPromise();
    };
    EventLogService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HttpClient, Context])
    ], EventLogService);
    return EventLogService;
}(BaseService));
export { EventLogService };
